<!--
		 Copyright (c) SWsoft, 1999-2007
		 All rights reserved.
   -->
<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred func action"
	xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl		="http://exslt.org/common"
	xmlns:sw		="http://www.swsoft.com/xsl/cp"
	xmlns:action	="http://www.swsoft.com/xsl/cp/action"
	xmlns:local		="http://www.swsoft.com/xsl/cp/local"
	xmlns:cred  	="http://www.swsoft.com/xsl/cp/cred"
	xmlns:func		="http://exslt.org/functions"	
	xmlns:hn		="http://www.swsoft.com/xsl/cp/hn"
	xmlns:env		="http://www.swsoft.com/xsl/cp/env"
	xmlns:licensem	="http://www.swsoft.com/xsl/cp/licensem"
>

	<sw:include href="/lib/common.xsl"/>
	<sw:include href="/lib/core/action-funcs.xsl"/>	
	<sw:include href="/lib/vt/hn-core.xsl"/>
	<sw:include href="/lib/vt/env-core.xsl"/>
	<sw:include href="/lib/swa/licensem.xsl"/>

	<xsl:output method="xml"/>
	
	<!--
		/data
			/eid
	-->

	<xsl:template match="/">
		<xsl:if test="action:start('lic.groupchange.update')"/>

		<xsl:for-each select="/data/eid">
			<!-- Apply VE Sample -->
			<xsl:if
				test="action:run-child(
					local:update-license(.), 
					concat('Refresh license for ', env:env2title(env:get-env(.)/env)), 
					'licensem.update'
				)" />
		</xsl:for-each>
		
		<xsl:copy-of select="action:complete('lic.groupchange.update')"/>
	</xsl:template>

	<func:function name="local:update-license">
		<xsl:param name="eid"/>
		
		<xsl:variable name="licenses" select="licensem:filter('VZSRV', licensem:get($eid))" />
		<func:result>
			<xsl:call-template name="licensem:update-packet">
				<xsl:with-param name="serial" select="$licenses[1]/parameter[name='serial']/value" />
				<xsl:with-param name="hn-eid" select="$eid" />
			</xsl:call-template>
		</func:result>
	</func:function>
</xsl:stylesheet>