<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred func action env vzenv"
	xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl		="http://exslt.org/common"
	xmlns:sw			="http://www.swsoft.com/xsl/cp"
	xmlns:action	="http://www.swsoft.com/xsl/cp/action"
	xmlns:local		="http://www.swsoft.com/xsl/cp/local"
	xmlns:cred  	="http://www.swsoft.com/xsl/cp/cred"
	xmlns:func		="http://exslt.org/functions"	
	xmlns:vt			="http://www.swsoft.com/xsl/cp/vt"		
	xmlns:env	  	="http://www.swsoft.com/xsl/cp/env"	
	xmlns:ve	  	="http://www.swsoft.com/xsl/cp/ve"		
	xmlns:vzenv	  ="http://www.swsoft.com/xsl/cp/vzenv"			
>
	<sw:include href="/lib/core/action-funcs.xsl"/>
	<sw:include href="/lib/vt/core.xsl"/>
	<sw:include href="/lib/vt/ve-core.xsl"/>
	<sw:include href="/lib/vz/vzenv-core.xsl"/>
	
	<xsl:output method="xml"/>
	
	<!--
		/data
			/env
				/eid
				/hostname				
				/num-id
			/config
				/*
	-->
	<xsl:template match="/">
		
		<xsl:variable name="env-list" select="/data/env"/>
		<xsl:variable name="data" select="/data"/>
	
		<xsl:if test="action:start('ve.groupchange.config', $env-list/eid)"/>

		<xsl:for-each select="$env-list">
			<xsl:variable name="env" select="env:get-env(eid)/env"/>
			<xsl:choose>
				<!-- Configure VE(s) -->
				<xsl:when test="not(
					action:run-child(local:set($data,$env),concat('Set Container ',env:env2title($env)),'vzaenvm.set',eid)
				)"/>	
			</xsl:choose>
		</xsl:for-each>
		<xsl:copy-of select="action:complete('ve.groupchange.config', $env-list/eid)"/>

	</xsl:template>
	
	<func:function name="local:set">
		<xsl:param name="data"/>
		<xsl:param name="env"/>
		<func:result>
			<packet log="on">
				<target>vzaenvm</target>
				<xsl:copy-of select="sw:hn-dst($env/eid)"/>
        <cookie>
          <operation>xsl-child.set_ve</operation>
        </cookie>			
				<data>
					<vzaenvm>
						<set>
							<eid><xsl:value-of select="$env/eid"/></eid>
							<config>
								<xsl:if test="$data/config/start!=''">
									<on_boot><xsl:value-of select="$data/config/start"/></on_boot>
								</xsl:if>
								<xsl:if test="$data/config/offline!=''">
									<offline_management><xsl:value-of select="$data/config/offline"/></offline_management>
								</xsl:if>
								<xsl:if test="vt:is-platform-linux(ve:ve2platform($env))">
									<xsl:if test="$data/config/enabled!=''">
										<disabled><xsl:value-of select="sw:if($data/config/enabled='1','0','1')"/></disabled>
									</xsl:if>
								</xsl:if>
							</config>
						</set>
					</vzaenvm>
				</data>
			</packet>
		</func:result>
	</func:function>
	
	<sw:include href="/lib/common.xsl"/>
</xsl:stylesheet>