<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred hwm env func action"
	xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl		="http://exslt.org/common"
	xmlns:sw			="http://www.swsoft.com/xsl/cp"
	xmlns:action	="http://www.swsoft.com/xsl/cp/action"
	xmlns:hwm			="http://www.swsoft.com/xsl/cp/hwm"
	xmlns:env			="http://www.swsoft.com/xsl/cp/env"
	xmlns:local		="http://www.swsoft.com/xsl/cp/local"
	xmlns:cred  	="http://www.swsoft.com/xsl/cp/cred"
	xmlns:func		="http://exslt.org/functions"	
>
	<sw:include href="/lib/core/action-funcs.xsl"/>
	<sw:include href="/lib/vt/env-core.xsl"/>

	<xsl:output method="xml"/>
	
	<!--
		/data/cmd ('stop-repair'/'start-repair')
		/data/eid
	-->
	<xsl:template match="/">
	
		<xsl:variable name="ve-list" select="/data/eid"/>
		<xsl:variable name="cmd" select="/data/cmd"/>
	
		<xsl:if test="action:start('vzaenvm.stop_repair', $ve-list)"/>
		
		<xsl:for-each select="$ve-list">
			<xsl:variable name="eid" select="."/>
			<xsl:choose>
				<xsl:when test="$cmd='stop-repair'">
					<xsl:if test="action:run-child(local:stop-repair($eid),'Finish Container Repair','vzaenvm.stop_repair',$eid)"/>	
					<xsl:if test="action:run-child(local:start-ve($eid),'Start Container','vzaenvm.start',$eid)"/>	
				</xsl:when>
			</xsl:choose>
		</xsl:for-each>
	
		<xsl:copy-of select="action:complete('vzaenvm.stop_repair', $ve-list)"/>
		
	</xsl:template>

	<func:function name="local:stop-repair">
		<xsl:param name="eid"/>
		<func:result>
			<packet log="on">
				<target>vzaenvm</target>
				<xsl:copy-of select="sw:hn-dst($eid)"/>
				<data>
					<vzaenvm>
						<stop_repair>
							<eid><xsl:value-of select="$eid"/></eid>
						</stop_repair>
					</vzaenvm>
				</data>
			</packet>
		</func:result>
	</func:function>
	
	<func:function name="local:start-ve">
		<xsl:param name="eid"/>
		<func:result>
			<packet log="on">
				<target>vzaenvm</target>
				<xsl:copy-of select="sw:hn-dst($eid)"/>
				<data>
					<vzaenvm>
						<start>
							<eid><xsl:value-of select="$eid"/></eid>
						</start>
					</vzaenvm>
				</data>
			</packet>
		</func:result>
	</func:function>

	<sw:include href="/lib/vza/hwm.xsl"/>
	<sw:include href="/lib/common.xsl"/>
</xsl:stylesheet>