<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	extension-element-prefixes="sw exsl action func networkm" 
	xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp" 
	xmlns:action="http://www.swsoft.com/xsl/cp/action"
	xmlns:networkm="http://www.swsoft.com/xsl/cp/networkm"
	xmlns:local="http://www.swsoft.com/xsl/cp/local"
	xmlns:func="http://exslt.org/functions"
>

	<sw:include href="/lib/common.xsl"/>
	<sw:include href="/lib/core/action-funcs.xsl"/>	
	<sw:include href="/lib/vza/networkm.xsl"/>

	<!--
        /data
            /hw_id
            /net_devices
                /net_vlan or /net_bridge or /net_nic
                    /id
                    /...
    -->
	<xsl:template match="/">
		<xsl:variable name="dev-list" select="/data/net_devices/*/id"/>
		<xsl:variable name="hw_id" select="/data/hw_id"/>

		<xsl:if test="action:start('net_device.set', $dev-list)"/>
		<xsl:for-each select="/data/net_devices/*">
			<xsl:variable name="id" select="id"/>
			<xsl:if
				test="action:run-child(local:set-device($hw_id,.),concat('Update network interface #',$id),'networkm.set',$id)"
			/>
		</xsl:for-each>
		<xsl:copy-of select="action:complete('net_device.set', $hw_id)"/>
	</xsl:template>

	<func:function name="local:set-device">
		<xsl:param name="hw_id"/>
		<xsl:param name="device"/>
		<func:result select="exsl:node-set(networkm:cmd-set($hw_id,$device))"/>
	</func:function>
</xsl:stylesheet>
