<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred hwm vem func action"
	xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl		="http://exslt.org/common"
	xmlns:sw			="http://www.swsoft.com/xsl/cp"
	xmlns:action	="http://www.swsoft.com/xsl/cp/action"
	xmlns:hwm			="http://www.swsoft.com/xsl/cp/hwm"
	xmlns:vem			="http://www.swsoft.com/xsl/cp/vem"
	xmlns:local		="http://www.swsoft.com/xsl/cp/local"
	xmlns:cred  	="http://www.swsoft.com/xsl/cp/cred"
	xmlns:vzapackagem  	="http://www.swsoft.com/xsl/cp/vzapackagem"
	xmlns:func		="http://exslt.org/functions"
>
	<sw:include href="/lib/core/action-funcs.xsl"/>
	<sw:include href="/lib/vza/vzapackagem.xsl"/>
	
	<xsl:output method="xml"/>

	<!--
		/data
			/hw
			/local_path
			/remote_path

	-->
	<xsl:template match="/">
		<xsl:variable name="data" select="/data"/>

		<xsl:if test="sw:putfile($data/local_path, $data/remote_path)"/>

		<xsl:if test="action:start('hw.apps.app-add')"/>

		<xsl:variable name="res" select="
			action:run-child(local:set($data),'Install Application Template','vzapackagem.install')
		"/>

		<xsl:copy-of select="action:complete('hw.apps.app-add')"/>
	</xsl:template>


	<func:function name="local:set">
		<xsl:param name="data"/>

		<func:result>
			<packet log="on">
				<target>vzatem</target>
				<xsl:copy-of select="sw:hn-dst($data/hw)"/>
				<data>
					<vzatem>
						<set>
							<path><xsl:value-of select="$data/remote_path"/></path>
							<force>1</force>
						</set>
					</vzatem>
				</data>
				<vzcpauth/>
			</packet>
		</func:result>
	</func:function>


	<func:function name="local:cache-tem">
		<xsl:param name="data"/>
		<func:result>
			<packet log="on">
				<target>vzatem</target>
				<xsl:copy-of select="sw:hn-dst($data/hw)"/>
				<data>
					<vzatem>
						<cache/>
					</vzatem>
				</data>
				<vzcpauth/>
			</packet>
		</func:result>
	</func:function>

	<func:function name="local:cache-pkgm">
		<xsl:param name="data"/>
		<func:result>
			<packet log="on">
				<target>snapshotm</target>
				<xsl:copy-of select="sw:hn-dst($data/hw)"/>
				<data>
					<snapshotm>
						<create>
							<package>
								<type>vztemplate</type>
							</package>
						</create>
					</snapshotm>
				</data>
				<vzcpauth/>
			</packet>
		</func:result>
	</func:function>


	<sw:include href="/lib/common.xsl"/>
</xsl:stylesheet>