<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func wiz cred local show voc vzenv env vzhn"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl="http://exslt.org/common"
  xmlns:sw="http://www.swsoft.com/xsl/cp"
  xmlns:error="http://www.swsoft.com/xsl/cp/error"
  xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz"
  xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
  xmlns:func="http://exslt.org/functions"
	xmlns:cred  ="http://www.swsoft.com/xsl/cp/cred"
	xmlns:local	="http://www.swsoft.com/xsl/cp/local"
	xmlns:browse="http://www.swsoft.com/xsl/cp/browse"   
	xmlns:show	="http://www.swsoft.com/xsl/cp/show"   
	xmlns:voc		="http://www.swsoft.com/xsl/cp/voc"   	
	
	xmlns:env	="http://www.swsoft.com/xsl/cp/env"   	
	xmlns:vzenv	="http://www.swsoft.com/xsl/cp/vzenv"   	
	xmlns:vzhn		="http://www.swsoft.com/xsl/cp/vzhn"   	
 >
 
 	<!-- Import required modules -->
 	<sw:include href="/lib/vt/env-core.xsl"/>
 	<sw:include href="/lib/vz/vzenv-core.xsl"/> 	
 	<sw:include href="/lib/vz/vzhn-core.xsl"/>
 	<!-- /Import required modules -->

		
	<xsl:template name="local:post-chosen-vzhns">
		<xsl:param name="size" select="'20'"/>
		<xsl:param name="control-id" select="'envs'"/>
		
		<xsl:variable name="envs" select="env:get-env($form/vzhns/eid)/env"/>
		
		<ui:row>
			<ui:cell-list-picker id="{$control-id}" size="{$size}" style="width:400px;"
				script-add="open_details('{$baseurl}/vzdir/infrman/hns/select-popup?id={$control-id}&amp;mode=list');"
			>
				<xsl:copy-of select="vzhn:envs2ui-items($envs)"/>
			</ui:cell-list-picker>
		</ui:row>	
	</xsl:template>
	
	<!-- UI modules -->
	<sw:include href="/lib/wizard.xsl"/>
	
	<!-- System modules -->
	<sw:include href="/lib/common.xsl"/>			

		
</xsl:stylesheet>
