<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func"
  xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl		="http://exslt.org/common"
  xmlns:sw			="http://www.swsoft.com/xsl/cp"
  xmlns:process	="http://www.swsoft.com/xsl/cp/process"
	xmlns:func		="http://exslt.org/functions"
  >

  <!-- execute prog in VE -->
  <func:function name="process:exec">
    <xsl:param name="args"/>
    <xsl:param name="eid" select="sw:ve-eid()"/>
    <xsl:variable name="req">
      <packet>
        <target>processm</target>
        <xsl:copy-of select="sw:env-dst($eid)"/>
        <data>
          <processm>
            <execute>
              <xsl:copy-of select="$args"/>
            </execute>
          </processm>
        </data>
        <vzcpauth/>
      </packet>
    </xsl:variable>
		<xsl:variable name="exec-rc" select="sw:xchg($req)/packet/data"/>
    <!-- wrap here -->
			<xsl:variable name="rc">
			<process>
				<xsl:choose>
					<xsl:when test="$exec-rc/processm/error">
						<error>
							<xsl:if test="$exec-rc/processm/error/code = '3600'">
								<file_not_found/>
							</xsl:if>
							<code><xsl:value-of select="$exec-rc/processm/error/code"/></code>
							<message><xsl:value-of select="$exec-rc/processm/error/message"/></message>
							<type>exec</type>
						</error>
					</xsl:when>
					<xsl:when test="$exec-rc/error">
						<!-- handel error from agent transport level, need use base64-enocde this -->
						<error>
							<code><xsl:value-of select="$exec-rc/error/code"/></code>
							<message><xsl:value-of select="sw:base64-encode($exec-rc/error/message)"/></message>
							<type>agent</type>
						</error>
					</xsl:when>					
					<xsl:when test="$exec-rc/processm/exec/status != 0">
						<error>
							<code><xsl:value-of select="$exec-rc/processm/exec/status"/></code>
							<message>
								<xsl:variable name="std-output" select="$exec-rc/processm/exec/output"/>								
								<xsl:variable name="std-error"  select="$exec-rc/processm/exec/error"/>
								<xsl:if test="not($std-output = '')">
									<xsl:value-of select="$std-output"/>
								</xsl:if>
								<xsl:if test="not($std-error = '') and ($std-error != $std-output)">
									<xsl:value-of select="$std-error"/> 
								</xsl:if>
							</message>
							<type>native</type>
						</error>
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy-of select="$exec-rc/processm/exec/output"/>
					</xsl:otherwise>					
				</xsl:choose>
			</process>
			</xsl:variable>
		<func:result select="exsl:node-set($rc)"/>
	</func:function>

</xsl:stylesheet>
