<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl	="http://exslt.org/common"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
	xmlns:func	="http://exslt.org/functions"
	xmlns:reg32	="http://www.swsoft.com/xsl/cp/reg32"
	xmlns:process	="http://www.swsoft.com/xsl/cp/process"
  >

	<sw:include href="/lib/progm.xsl"/>
	<sw:include href="/lib/common.xsl"/>	

  <!-- 
			 Win32 only.
       Get data from registry
    -->

  <func:function name="reg32:get">
		<xsl:param name="reg-path"/>
    <xsl:param name="req-data-rtf"/>
		<xsl:param name="eid" select="sw:ve-eid()"/>
		<xsl:variable name="veid" select="sw:envinfo($eid)/packet/env/virtual_config/veid"/>
  	<xsl:variable name="path" select="sw:if($veid &gt; 0,concat('HKEY_LOCAL_MACHINE\vz',$veid,'\machine\',$reg-path),$reg-path)"/>
		<!-- to hard for CPU, need rewrite to vzagent implementation for registry -->
		<xsl:variable name="reg" select="'reg.exe'"/>
		<xsl:variable name="exec-arg">
      <cred>
        <user>Administrator</user>
      </cred>
      <argv><xsl:value-of select="sw:base64-encode($reg)"/></argv>
      <argv><xsl:value-of select="sw:base64-encode('QUERY')"/></argv>
      <argv><xsl:value-of select="sw:base64-encode($path)"/></argv>
			<stdio>
				<output/>
			</stdio>
		</xsl:variable>
    <xsl:variable name="check-registry" select="process:exec($exec-arg,sw:hn-dst($eid))"/>
		<xsl:choose>
			<xsl:when test="$check-registry/process/error[type != 'native']">
				<xsl:variable name="error-rc">
					<error/>
				</xsl:variable>
				<func:result select="exsl:node-set($error-rc)"/>
			</xsl:when>
			<xsl:when test="$check-registry/process/error[type = 'native' and code = 1]">
				<xsl:variable name="empty-rc">
					<output/>
				</xsl:variable>
				<func:result select="exsl:node-set($empty-rc)"/>
			</xsl:when>
			<xsl:otherwise>
        <xsl:variable name="raw-reg-output" select="sw:base64-decode($check-registry/process/output)"/>
        <xsl:variable name="raw-reg-splited" select="sw:split($raw-reg-output,'&#13;','one')"/>
        <xsl:variable name="status-rtf">
					<output>
            <xsl:for-each select="$raw-reg-splited">
              <xsl:variable name="one-string" select="(.)"/>
              <xsl:for-each select="exsl:node-set($req-data-rtf)/*">
                <xsl:variable name="node-name" select="name()"/>
                <xsl:if test="contains(normalize-space($one-string),pattern)">
                  <xsl:element name="{$node-name}">
                    <xsl:value-of select="normalize-space(substring-after($one-string,'REG_SZ'))"/>
                  </xsl:element>						
                </xsl:if>
              </xsl:for-each>
            </xsl:for-each>
					</output>
        </xsl:variable>
        <func:result select="exsl:node-set($status-rtf)"/>
			</xsl:otherwise>
		</xsl:choose>
  </func:function>

</xsl:stylesheet>
