<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl ts func"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl	="http://exslt.org/common"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
	xmlns:func	="http://exslt.org/functions"
	xmlns:ts		="http://www.swsoft.com/xsl/cp/ts"
	xmlns:form  ="http://www.swsoft.com/xsl/cp/form"
	xmlns:ui		="http://www.swsoft.com/xsl/cp/ui"
	xmlns:check	="http://www.swsoft.com/xsl/cp/check"
	xmlns:error	="http://www.swsoft.com/xsl/cp/error"
  >

	<sw:include href="/layout/forms-list.xsl"/>
	<sw:include href="/lib/common.xsl"/>	
	<sw:include href="/lib/core/check-funcs.xsl"/>	
	
	<xsl:variable name="tsmodes-rtf">
		<mode>
			<value>
				<xsl:value-of select="0"/>
			</value>
			<title>
				<xsl:value-of select="sw:text('Terminal Server')"/>
			</title>
			<default/>
		</mode>
		<mode>
			<value>
				<xsl:value-of select="1"/>
			</value>
			<title>
				<xsl:value-of select="sw:text('Remote Desktop for Administration')"/>
			</title>
		</mode>
	</xsl:variable>
	<xsl:variable name="tsmodes" select="exsl:node-set($tsmodes-rtf)"/>

	<func:function name="ts:restore-lic-servers">
		<func:result>
			<xsl:call-template name="form:restore-list">
				<xsl:with-param name="code" select="'tslicserver'"/>
				<xsl:with-param name="row-node-name" select="''"/>
			</xsl:call-template>
		</func:result>
	</func:function>
		
	<func:function name="ts:show-lic-servers">
		<xsl:param name="tslicservers"/>
		<xsl:param name="code" select="'tslicserver'"/>
		<xsl:param name="offset" select="''"/>
		<!--|-->
		<xsl:variable name="required" select="false()"/>
		<func:result>
			<xsl:if test="$required">
				<ui:row required="true">
					<ui:cell offset="{$offset}">
						<sw:text>License Server Address (please type at least one address)</sw:text>
					</ui:cell>
				</ui:row>
			</xsl:if>
			<xsl:call-template name="form:show-list">
 				<xsl:with-param name="config">
					<code><xsl:value-of select="$code"/></code>
					<xsl:if test="$required">
						<required>true</required>
					</xsl:if>
					<add_label><sw:text>Add a new license server address.</sw:text></add_label>
					<remove_label><sw:text>Remove this license server address.</sw:text></remove_label>
					<xsl:for-each select="$tslicservers/tslicserver">
						<ui:row>
							<ui:cell-label offset="{$offset}">
								<nobr><sw:text>License Server Address</sw:text></nobr>
							</ui:cell-label>
							<ui:cell-input maxlength="15" id="tslicserver" value="{.}"/>
						</ui:row>
					</xsl:for-each>
					<ui:new-row>
						<ui:cell-label offset="{$offset}">
							<nobr><sw:text>License Server Address</sw:text></nobr>
						</ui:cell-label>
						<ui:cell-input maxlength="15" id="tslicserver"/>
					</ui:new-row>
				</xsl:with-param>
			</xsl:call-template>
		</func:result>
	</func:function>

</xsl:stylesheet>
