<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred func voc vz dirm"
  xmlns:xsl				="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl			="http://exslt.org/common"
  xmlns:func			="http://exslt.org/functions"
  xmlns:sw				="http://www.swsoft.com/xsl/cp"
	xmlns:cred			="http://www.swsoft.com/xsl/cp/cred"
	xmlns:voc				="http://www.swsoft.com/xsl/cp/voc"	
	xmlns:vz				="http://www.swsoft.com/xsl/cp/vz"	
	xmlns:dirm				="http://www.swsoft.com/xsl/cp/dirm"
>

	<sw:include href="/lib/swa/dirm.xsl"/>	

	<func:function name="vz:get-slm-modes">
		<xsl:variable name="modes-rtf">
			<mode>
				<id>ubc</id>
				<pos>0</pos>
				<title><sw:text>Old-style UBC resource management</sw:text></title>
			</mode>
			<mode>
				<id>slm</id>
				<pos>1</pos>
				<title><sw:text>SLM resource management</sw:text></title>
			</mode>
			<mode>
				<id>all</id>
				<pos>2</pos>
				<title><sw:text>Use both UBC and SLM simultaneously</sw:text></title>
			</mode>
		</xsl:variable>
		<func:result select="exsl:node-set($modes-rtf)/mode"/>
	</func:function>	
	
	
	<func:function name="vz:defenvsamples-dn">
		<func:result select="concat('cn=vz,',$def-defenvsamples-dn)"/>
	</func:function>
	
	<func:function name="vz:default-samples">
		<func:result select="dirm:search( vz:defenvsamples-dn() )/obj"/>
	</func:function>		


</xsl:stylesheet>
