<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw env"
  xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
  xmlns:sw			="http://www.swsoft.com/xsl/cp"
  xmlns:env			="http://www.swsoft.com/xsl/cp/env"
>

	<sw:include href="/lib/vt/env-core.xsl"/>	
	
	<xsl:template name="env:rdp-activex">
    <xsl:param name="eid"/>
	  <xsl:variable name="env-config" select="env:get-env($eid)/env"/>
		<xsl:variable name="rdp-resource-rtf">
			<screen-title>
				<sw:text>
					<xsl:with-param name="env-title"	select="env:env2title($env-config)"/>
					%{env-title} Remote Desktop Connection Client
				</sw:text>			
			</screen-title>
			<xsl:choose>
				<xsl:when test="$env-config/config/type='generic'">
					<!-- HN case -->
					<hostname>
						<xsl:value-of select="$env-config/config/hostname"/>
					</hostname>
					<ip-address>
						<xsl:value-of select="$env-config/config/address/ip[1]"/>
					</ip-address>
				</xsl:when>
				<xsl:otherwise>
					<!-- VE case -->
					<hostname>
						<xsl:value-of select="$env-config/virtual_config/hostname"/>
					</hostname>
					<ip-address>
						<xsl:value-of select="$env-config/virtual_config/address/ip[1]"/>
					</ip-address>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="rdp-resource" select="exsl:node-set($rdp-resource-rtf)"/>

    <html>
			<head>
				<title><xsl:value-of select="$rdp-resource/screen-title"/></title>
			</head>
			<body onload="ConnectTerminal();" style="margin:0">
				<OBJECT language="javascript" id="MsRdpClient" codeBase="/vz/rdp/msrdp.cab#version=5,1,2600,1094" classid="CLSID:9059f30f-4eb1-4bd2-9fdc-36f43a218f4a" name="MsRdpClient" height="600" width="800" viewastext="viewastext"></OBJECT>
				<SCRIPT language="javascript" event="OnConnected" for="MsRdpClient">
					return;
				</SCRIPT>
				<SCRIPT language="javascript" event="OnDisconnected(disconnectCode)" for="MsRdpClient">
					top.close();
					return;
				</SCRIPT>
				<script language="javascript">
					function ConnectTerminal()
					{
						var ClientObj = document.MsRdpClient;
						if (ClientObj == null)
							return false;
						ClientObj.FullScreen = false;
						ClientObj.DesktopWidth = ClientObj.width;
						ClientObj.DesktopHeight = ClientObj.height;
						ClientObj.Server = '<xsl:value-of select="$rdp-resource/ip-address"/>';
						ClientObj.Connect();
						return true;
					}
				</script>
        <noscript>
					<sw:text>The web-based Remote Desktop client requires JavaScript to be enabled.</sw:text>
        </noscript>
			</body>
    </html>
	</xsl:template>	

	
</xsl:stylesheet>
