<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw env"
  xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
  xmlns:sw			="http://www.swsoft.com/xsl/cp"
  xmlns:env			="http://www.swsoft.com/xsl/cp/env"
  xmlns:redirect="http://www.swsoft.com/xsl/cp/redirect"
>

	<sw:include href="/lib/vz/vzhn-redirects.xsl"/>
	
	<xsl:template name="env:ssh-java">
    <xsl:param name="eid"/>
	  <xsl:variable name="env-config" select="env:get-env($eid)/env"/>
		<xsl:variable name="ssh-resource-rtf">
			<screen-title>
				<sw:text>
						<xsl:with-param name="env-title"	select="env:env2title($env-config)"/>
							%{env-title} SSH Client
				</sw:text>			
			</screen-title>
			<xsl:choose>
				<xsl:when test="$env-config/config/type='generic'">
					<!-- HN case -->
					<hostname>
						<xsl:value-of select="$env-config/config/hostname"/>
					</hostname>
					<ip-address>
						<xsl:value-of select="$env-config/config/address/ip[1]"/>
					</ip-address>
					<codebase>
				 		<xsl:value-of name="codebase" select="concat('https://',$env-config/config/address/ip[1],':',$request/http_request/env/parameter[name = 'SERVER_PORT']/value,'/vz/ssh')"/>
					</codebase>					
				</xsl:when>
				<xsl:otherwise>
					<!-- VE case -->
					<hostname>
						<xsl:value-of select="$env-config/virtual_config/hostname"/>
					</hostname>
					<ip-address>
						<xsl:value-of select="$env-config/virtual_config/address/ip[1]"/>
					</ip-address>
					<!-- all check for offline management must be done before it -->
					<xsl:variable name="vzpp-port" select="redirect:load($env-config/parent_eid)/service[id = 'vzpp']/port"/>
					<codebase>
				 		<xsl:value-of name="codebase" select="concat('https://',$env-config/virtual_config/address/ip[1],':',$vzpp-port,'/vz/ssh')"/>
					</codebase>					
					<codebase>
						<xsl:value-of select="concat('https://',$env-config/virtual_config/address/ip[1],':',$vzpp-port,'/vz/ssh')"/>					
					</codebase>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="ssh-resource" select="exsl:node-set($ssh-resource-rtf)"/>

    <html>
      <head>
        <title><xsl:value-of select="$ssh-resource/screen-title"/></title>
      </head>
      <body>
      <script language="javascript" type="text/javascript">
        codebase='<xsl:value-of select="$ssh-resource/codebase"/>';
        host='<xsl:value-of select="$ssh-resource/ip-address"/>';
        <![CDATA[
        document.write('<applet width="680" height="480"  archive="jsch.jar,jta26.jar"	code="de.mud.jta.Applet"'+
          'codebase='+codebase+' style="border-style: solid; border-width: 1; padding-left: 4; padding-right: 4; padding-top: 1; padding-bottom: 1">'+
          '<param name="config" value="ssh.conf"/>'+'<param name="Socket.host" value="'+host+'"/>');
        document.write('<param name="SSH.user" value="'+window.opener.top.sshPopupLogin+'">');
        document.write('<param name="SSH.password" value="'+window.opener.top.sshPopupPassword+'">');
        document.write('<param name="Terminal.font" value="Monospaced"/>'+
          '<param name="Terminal.fontStyle" value="plain"/>'+
          '<param name="Terminal.fontSize" value="10"/>'+
          '<param name="Terminal.foreground" value="#ffffff"/>'+
          '<param name="Terminal.background" value="#000000"/>'+
          '<param name="Terminal.id" value="vt100"/>'+
          '<param name="Applet.detach.immediately" value="true"/>'+
          '<param name="Applet.disconnect" value="true"/>'+
          '</applet>');
        document.close();
    ]]></script>
			</body>
		</html>
	</xsl:template>	


	<xsl:template name="env:ssh-activex">	
    <xsl:param name="eid"/>
  	<xsl:variable name="env-config" select="env:get-env($eid)/env"/>
		<xsl:variable name="ssh-resource-rtf">
			<screen-title>
				<sw:text>
						<xsl:with-param name="env-title"	select="env:env2title($env-config)"/>
							%{env-title} SSH Client
				</sw:text>			
			</screen-title>
			<xsl:choose>
				<xsl:when test="$env-config/config/type='generic'">
					<!-- HN case -->
					<hostname>
						<xsl:value-of select="$env-config/config/hostname"/>
					</hostname>
					<ip-address>
						<xsl:value-of select="$env-config/config/address/ip[1]"/>
					</ip-address>
					<return-url>
						<xsl:value-of select="concat($baseurl,'/vzdir/infrman/hns/services/ssh')"/>
					</return-url>					
				</xsl:when>
				<xsl:otherwise>
					<!-- VE case -->
					<hostname>
						<xsl:value-of select="$env-config/virtual_config/hostname"/>
					</hostname>
					<ip-address>
						<xsl:value-of select="$env-config/virtual_config/address/ip[1]"/>
					</ip-address>
					<return-url>
						<xsl:value-of select="concat($baseurl,'/vzdir/infrman/envs/services/ssh')"/>
					</return-url>					
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="ssh-resource" select="exsl:node-set($ssh-resource-rtf)"/>
    <html>
      <head>
        <title><xsl:value-of select="$ssh-resource/screen-title"/></title>
      </head>      
      <body onload="doMux();" onKeyPress="return catchKeyPress();" onkeyDown="return catchKeyDown()">
        <object classid="clsid:5220cb21-c88d-11cf-b347-00aa00a28331" viewastext="viewastext">
          <param name="LPKPath" value="/vz/ssh/wodTelnetDLX.lpk"/>
        </object>

        <object name="telnetdlx" classid="clsid:B7039D87-D648-4431-BA87-C3A04E6111DA" 
          codebase="/vz/ssh/wodTelnetDLX.cab#version=1.0.0.2" id="telnedWindow">
        </object>

        <script language="javascript">
          self.was_connected_flag = false;
          self.was_resized_flag = false;          
           with (telnetdlx) {
               TerminalEmulation = 2; // use VT100 Emulation
               AutoSize          = true; // resize to fit
               TerminalType = "linux"; 
               BorderVisible = false;
           }
           
           function doMux(){
           	if (typeof(telnetdlx.Connect) == 'undefined'){
             	return false;
               }
		doLogin();
		doResize();              
           }

           function doConnect(_login, _password) {
             with (telnetdlx) {
               Login    = _login;
               Password =  _password;
               Connect ('<xsl:value-of select="$ssh-resource/ip-address"/>', 22, 4);
             }
           }
           
          function doResize(){
             var el = document.getElementById('telnedWindow');
             var iWidth = el.clientWidth+35;
             var iHeight = el.clientHeight+55;
             window.resizeTo(iWidth,iHeight);
             window.focus();
             telnetdlx.focus(); 
             self.was_resized_flag = true;
          }

          function doLogin() {
            _login    = window.opener.top.sshPopupLogin;
            _password =  window.opener.top.sshPopupPassword;
            doConnect(_login, _password);
            return false;
          }
          function catchKeyPress(){
            telnetdlx.focus();
            telnetdlx.Send(String.fromCharCode(window.event.keyCode));
          }
<![CDATA[
          function catchKeyDown(){
            if (window.event.ctrlKey){
              var kc = window.event.keyCode;
              if(kc >= 65 && kc <= 90){
                var charCode = key2Char(kc);
                telnetdlx.focus();
                telnetdlx.Send(String.fromCharCode(charCode));
                return false;
              }
            }
          return true;
          }
          
          function key2Char(keyCode){
            var codeA = 65;
            return keyCode - codeA + 1;
          }
          
]]>             
        </script>

        <script for="telnetdlx" event="statechange()" language="JavaScript">
<![CDATA[           
          if (telnetdlx.State >= 3)
            self.was_connected_flag = true;
            
          if (!self.was_resized_flag){
            doResize();
          }
]]>       
          if (telnetdlx.State == 0){
            if(self.was_connected_flag){
              if(confirm('<sw:text>The connection has been terminated. Click OK to reconnect.</sw:text>')){
                window.location.reload();
              }else{
                window.close();
              }
            }else{
              alert('SSH Error: '+telnetdlx.ErrorText(telnetdlx.LastError));
              window.opener.location = '<xsl:value-of select="$ssh-resource/return-url"/>';
              window.close();
            }
          }
        </script>
        <noscript>
          <sw:text>The web-based Secure Shell client requires JavaScript to be enabled.</sw:text>
        </noscript>
      </body>
    </html>
	</xsl:template>
	
</xsl:stylesheet>
