<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw func form check  vzenv voc env vznet xsi vt exsl server_group vzenv vzsample request cred"
	xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl	="http://exslt.org/common"
	xmlns:func	="http://exslt.org/functions"
	xmlns:xsi		="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:vzat	="http://www.swsoft.com/webservices/vza/4.0.0/vzatypes"
	xmlns:sw		="http://www.swsoft.com/xsl/cp"
	xmlns:error	="http://www.swsoft.com/xsl/cp/error"
	xmlns:ui		="http://www.swsoft.com/xsl/cp/ui"
	xmlns:request		="http://www.swsoft.com/xsl/cp/request"
	xmlns:vt			="http://www.swsoft.com/xsl/cp/vt"
	xmlns:ve			="http://www.swsoft.com/xsl/cp/ve"
	xmlns:env		="http://www.swsoft.com/xsl/cp/env"
	xmlns:vzenv		="http://www.swsoft.com/xsl/cp/vzenv"
  xmlns:sample ="http://www.swsoft.com/xsl/cp/sample"	
	xmlns:vzsample		="http://www.swsoft.com/xsl/cp/vzsample"
	xmlns:form	="http://www.swsoft.com/xsl/cp/form"	
	xmlns:check	="http://www.swsoft.com/xsl/cp/check"
	xmlns:local	="http://www.swsoft.com/xsl/cp/local"
	xmlns:voc		="http://www.swsoft.com/xsl/cp/voc"
	xmlns:vznet	="http://www.swsoft.com/xsl/cp/vznet" 
	xmlns:server_group="http://www.swsoft.com/xsl/cp/server_group"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
>
 	<sw:include href="/lib/vocabulary.xsl"/>
	<sw:include href="../../layout/forms-list.xsl"/> 
 	
 	<sw:include href="/lib/swa/server-group.xsl"/>

	<sw:include href="/lib/vt/core.xsl"/>
 	<sw:include href="/lib/vt/env-core.xsl"/>
 	
 	<sw:include href="/lib/vz/env-net-core-ui.xsl"/>
 	<sw:include href="/lib/vz/vzenv-core.xsl"/>
 	<sw:include href="/lib/vz/vzenv-net.xsl"/>
	
	<sw:include href="/lib/vz/vznet-adaptor.xsl"/>
	<sw:include href="/lib/vz/vznet-switch.xsl"/>
	
	<!-- Transform VE net config from VZA env/config nodes to internal format -->
	<xsl:template name="vzsample:ve-config2net">
		<xsl:param name="config"/>
		<!--|-->
		<xsl:variable name="sample-platform" select="ve:ve2platform($config)"/>
		<xsl:variable name="win" select="vt:is-platform-windows($sample-platform)"/>
		<xsl:variable name="linux" select="vt:is-platform-linux($sample-platform)"/>		
		<!-- INTERNAL DATA -->
		<platform><xsl:value-of select="$sample-platform"/></platform>
		<!-- GLOBAL -->
		<xsl:copy-of select="local:search-config2net($config/virtual_config)"/>
		<xsl:if test="$linux">
			<xsl:copy-of select="local:dns-config2net($config/virtual_config)"/>				
		</xsl:if>
		<!-- ROUTED -->
		<xsl:if test="true()">
			<xsl:variable name="device" select="$config/virtual_config/net_device[contains(@xsi:type,':net_vethType') and host_routed]"/>
			<xsl:choose>
				<xsl:when test="$device">
					<routed>
						<id><xsl:value-of select="$device/id"/></id>
						<enabled>true</enabled>
						<xsl:if test="$win">
							<xsl:copy-of select="local:dns-config2net($device)"/>
							<xsl:copy-of select="local:wins-config2net($device)"/>
							<!--<xsl:copy-of select="local:gateway-config2net($device)"/>-->
							<xsl:copy-of select="local:search-config2net($device)"/>								
						</xsl:if>
					</routed>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="vzsample:init-net-ifaces">
						<xsl:with-param name="only-routed" select="true()"/>
						<xsl:with-param name="sample-platform" select="$sample-platform"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<!-- BRIDGED -->
		<xsl:variable name="bridged-devices" select="$config/virtual_config/net_device[contains(@xsi:type,':net_vethType') and not(host_routed)]"/>
		<xsl:choose>
			<xsl:when test="$bridged-devices">
				<bridged>
					<enabled>true</enabled>
					<xsl:for-each select="$bridged-devices">
						<xsl:sort select="id"/>
						<xsl:variable name="device" select="."/>
						<iface>
							<id><xsl:value-of select="id"/></id>
							<net-id><xsl:value-of select="sw:base64-decode(network_id)"/></net-id>
							<xsl:choose>
								<xsl:when test="dhcp">
									<ips-method>dhcp</ips-method>
								</xsl:when>
								<xsl:otherwise>
									<ips-method>ippool</ips-method>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:if test="$win">
								<xsl:copy-of select="local:dns-config2net($device)"/>
								<xsl:copy-of select="local:wins-config2net($device)"/>
							</xsl:if>
							<xsl:copy-of select="local:gateway-config2net($device)"/>
							<xsl:if test="$win">							
								<xsl:copy-of select="local:search-config2net($device)"/>																
							</xsl:if>
						</iface>
					</xsl:for-each>
				</bridged>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="vzsample:init-net-ifaces">
					<xsl:with-param name="only-bridged" select="true()"/>
					<xsl:with-param name="sample-platform" select="$sample-platform"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Transform Sample net config from VZA env/config nodes to internal format -->
	<xsl:template name="vzsample:config2net">
		<xsl:param name="config"/>
		<!--|-->
		<xsl:variable name="sample-platform" select="sample:sample2platform($config)"/>
		<xsl:variable name="win" select="vt:is-platform-windows($sample-platform)"/>
		<xsl:variable name="linux" select="vt:is-platform-linux($sample-platform)"/>		
		<!-- INTERNAL DATA -->
		<platform><xsl:value-of select="$sample-platform"/></platform>
		<!-- GLOBAL -->
		<xsl:copy-of select="local:search-config2net($config/env_config)"/>
		<xsl:if test="$linux">
			<xsl:copy-of select="local:dns-config2net($config/env_config)"/>			
		</xsl:if>
		<!-- ROUTED -->
		<xsl:if test="true()">
			<xsl:variable name="device" select="$config/env_config/net_device[contains(@xsi:type,':net_vethType') and host_routed]"/>
			<xsl:choose>
				<xsl:when test="$device">
					<routed>
						<id><xsl:value-of select="$device/id"/></id>
						<enabled>true</enabled>
						<xsl:if test="$win">
							<xsl:copy-of select="local:dns-config2net($device)"/>
							<xsl:copy-of select="local:wins-config2net($device)"/>
							<!--<xsl:copy-of select="local:gateway-config2net($device)"/>-->
						</xsl:if>
					</routed>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="vzsample:init-net-ifaces">
						<xsl:with-param name="only-routed" select="true()"/>
						<xsl:with-param name="sample-platform" select="$sample-platform"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<!-- BRIDGED -->
		<xsl:variable name="bridged-devices" select="$config/env_config/net_device[contains(@xsi:type,':net_vethType') and not(host_routed)]"/>
		<xsl:choose>
			<xsl:when test="$bridged-devices">
				<bridged>
					<enabled>true</enabled>
					<xsl:for-each select="$bridged-devices">
						<xsl:sort select="id"/>
						<xsl:variable name="device" select="."/>
						<iface>
							<id><xsl:value-of select="id"/></id>
							<net-id><xsl:value-of select="sw:base64-decode(network_id)"/></net-id>
							<xsl:choose>
								<xsl:when test="dhcp">
									<ips-method>dhcp</ips-method>
								</xsl:when>
								<xsl:otherwise>
									<ips-method>ippool</ips-method>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:if test="$win">
								<xsl:copy-of select="local:dns-config2net($device)"/>
								<xsl:copy-of select="local:wins-config2net($device)"/>
							</xsl:if>
							<xsl:copy-of select="local:gateway-config2net($device)"/>					
						</iface>
					</xsl:for-each>
				</bridged>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="vzsample:init-net-ifaces">
					<xsl:with-param name="only-bridged" select="true()"/>
					<xsl:with-param name="sample-platform" select="$sample-platform"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
		
	<func:function name="local:dns-config2net">
		<xsl:param name="device"/>
		<func:result>
			<dns_ips>
				<xsl:for-each select="$device/nameserver">
					<ip><xsl:value-of select="."/></ip>
				</xsl:for-each>
			</dns_ips>
		</func:result>
	</func:function>
	
	<func:function name="local:search-config2net">
		<xsl:param name="device"/>
		<func:result>
			<search_domains>
				<xsl:for-each select="$device/search_domain">
					<dom><xsl:value-of select="."/></dom>
				</xsl:for-each>
			</search_domains>
		</func:result>
	</func:function>	
	
	<func:function name="local:wins-config2net">
		<xsl:param name="device"/>
		<func:result>
			<wins_servers>
				<xsl:for-each select="$device/wins_server">
					<ip><xsl:value-of select="."/></ip>
				</xsl:for-each>
			</wins_servers>
		</func:result>
	</func:function>	
	
	<func:function name="local:gateway-config2net">
		<xsl:param name="device"/>
		<func:result>
			<default_gateway>
				<xsl:value-of select="$device/default_gateway"/>
			</default_gateway>
		</func:result>
	</func:function>			
	
	<!-- Transform Sample net config from internal format to VZA env/config/ nodes -->
	<func:function name="vzsample:net2config">
		<xsl:param name="net"/>
		<!--|-->
		<xsl:variable name="sample-platform" select="$net/platform"/>
		<xsl:variable name="win" select="vt:is-platform-windows($sample-platform)"/>
		<xsl:variable name="linux" select="vt:is-platform-linux($sample-platform)"/>

		<xsl:variable name="res-rtf">
			<!-- Global -->
			<xsl:copy-of select="local:post-search($net/search_domains)"/>
			<xsl:if test="$linux">
				<xsl:copy-of select="local:post-dns($net/dns_ips)"/>			
			</xsl:if>
			<!-- ROUTED -->
			<xsl:if test="true()">
				<xsl:variable name="iface" select="$net/routed"/>
				<xsl:if test="$iface/enabled='true'">	
					<vzat:net_device xsi:type="vzat:net_vethType">
						<id><xsl:value-of select="$iface/id"/></id>
						<ip_address>
							<ip><xsl:value-of select="$def-ip-auto-vza"/></ip>
						</ip_address>
						<xsl:if test="$win">
							<xsl:copy-of select="local:post-dns($iface/dns_ips)"/>
							<xsl:copy-of select="local:post-wins($iface/wins_servers)"/>
							<!--<xsl:copy-of select="local:post-gateway($iface/default_gateway)"/>-->
    				</xsl:if>
						<host_routed/>
					</vzat:net_device>
				</xsl:if>
			</xsl:if>
			<!-- BRIDGED -->
			<xsl:variable name="bridged" select="$net/bridged"/>
			<xsl:if test="$bridged/enabled='true'">
				<xsl:for-each select="$bridged/iface">
					<xsl:sort select="id"/>
					<xsl:variable name="iface" select="."/>
					<vzat:net_device xsi:type="vzat:net_vethType">
						<id><xsl:value-of select="$iface/id"/></id>
						<network_id><xsl:value-of select="sw:base64-encode($iface/net-id)"/></network_id>
						<xsl:choose>
							<xsl:when test="$iface/ips-method='dhcp'">
								<dhcp/>
							</xsl:when>
							<xsl:otherwise>
								<ip_address>
									<ip><xsl:value-of select="$def-ip-auto-vza"/></ip>
								</ip_address>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:if test="$win">
							<xsl:copy-of select="local:post-dns($iface/dns_ips)"/>
							<xsl:copy-of select="local:post-wins($iface/wins_servers)"/>
						</xsl:if>
						<xsl:copy-of select="local:post-gateway($iface/default_gateway)"/>		
					</vzat:net_device>
				</xsl:for-each>
			</xsl:if>	
		</xsl:variable>
		<!--|-->
		<func:result select="$res-rtf"/>
	</func:function>
	
	
	<!-- Prepare part of ve/set packet with DNS Server IPs -->
	<func:function name="local:post-dns">
		<xsl:param name="dns"/>
		<func:result>
			<xsl:for-each select="$dns/ip">
				<nameserver><xsl:value-of select="."/></nameserver>
			</xsl:for-each>
		</func:result>
	</func:function>
	
	<!-- Prepare part of ve/set packet with Search Domains -->
	<func:function name="local:post-search">
		<xsl:param name="domains"/>
		<func:result>
			<xsl:for-each select="$domains/dom">
				<search_domain><xsl:value-of select="."/></search_domain>
			</xsl:for-each>
		</func:result>
	</func:function>
	
	<!-- Prepare part of ve/set packet with WINS Servers -->
	<func:function name="local:post-wins">
		<xsl:param name="servers"/>
		<func:result>
			<xsl:for-each select="$servers/ip">
				<wins_server><xsl:value-of select="."/></wins_server>
			</xsl:for-each>
		</func:result>
	</func:function>
	
	<!-- Prepare part of ve/set packet with default_gateway -->
	<func:function name="local:post-gateway">
		<xsl:param name="value"/>
		<func:result>
			<default_gateway><xsl:value-of select="$value"/></default_gateway>
		</func:result>
	</func:function>	
	
	<!--===================================================== Init UI data ============================================-->
	<xsl:template name="vzsample:init-net-ifaces">
		<xsl:param name="sample-platform"/>
		<xsl:param name="only-routed" select="false()"/>
		<xsl:param name="only-bridged" select="false()"/>		
		
		<xsl:if test="not($only-bridged or $only-routed)">
			<platform><xsl:value-of select="$sample-platform"/></platform>
		</xsl:if>
		<xsl:if test="not($only-bridged)">
			<routed>
				<id>venet0</id>
				<enabled>false</enabled>
			</routed>
		</xsl:if>
		<xsl:if test="not($only-routed)">
			<bridged>
				<inited/>
				<enabled>false</enabled>
				<iface>
					<id>eth0</id>
					<ips-method>dhcp</ips-method>
				</iface>
			</bridged>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="vzsample:new-interface">
		<xsl:param name="bridged-ifaces"/>
		<iface>
			<id><xsl:value-of select="vzenv:new-iface-index($bridged-ifaces/id)"/></id>
			<ips-method>dhcp</ips-method>
		</iface>
	</xsl:template>
	
	<!--===================================================== Check UI data ============================================-->
	
	<!-- Check Data for VE Net Inferfaces UI -->
	<xsl:template name="vzsample:check-net">
		<xsl:param name="net"/>
		<xsl:variable name="platform-ref" select="env:make-platform-ref('',$net/platform)"/>
		<xsl:variable name="win" select="vt:is-platform-windows($net/platform)"/>
		<xsl:variable name="linux" select="vt:is-platform-linux($net/platform)"/>
		<!-- GLOBAL -->
		<xsl:if test="$linux">
			<xsl:if test="vzenv:check-net-dns($net/dns_ips/ip)"/>			
		</xsl:if>
		<xsl:if test="vzenv:check-net-search($platform-ref,$net/search_domains/dom)"/>
		<!-- ROUTED -->
		<xsl:variable name="routed" select="$net/routed"/>
		<xsl:if test="$routed/enabled='true'">
			<xsl:if test="$win">
				<xsl:if test="vzenv:check-net-dns($routed/dns_ips/ip,'routed_dns_ips')"/>
				<xsl:if test="vzenv:check-net-wins($routed/wins_servers/ip,'routed_wins_servers')"/>
				<!--<xsl:if test="vzenv:check-net-gateway($routed/default_gateway,'routed_default_gateway')"/>-->
			</xsl:if>
		</xsl:if>
		<!--BRIDGED-->
		<xsl:variable name="bridged" select="$net/bridged"/>
		<xsl:if test="$bridged/enabled='true'">
			<xsl:for-each select="$bridged/iface">
				<xsl:variable name="index" select="position()-1"/>
			 	<xsl:if test="not(net-id!='' or $linux)">
					<xsl:if test="error:put(sw:text('Please select a virtual network.'),'',concat('bridged_net_id',$index))"/>
			 	</xsl:if>
			 	<xsl:if test="$win">
					<xsl:if test="vzenv:check-net-dns(dns_ips/ip,concat('bridged_dns_ips',$index))"/>
					<xsl:if test="vzenv:check-net-wins(wins_servers/ip,concat('bridged_wins_servers',$index))"/>		
				</xsl:if>
				<xsl:if test="vzenv:check-net-gateway(default_gateway,concat('bridged_default_gateway',$index))"/>	
			 </xsl:for-each>
		</xsl:if>
		<!-- Common -->
		<xsl:if test="$win and not($routed/enabled='true') and not($bridged/enabled='true')">
			<xsl:if test="error:put(sw:text('The Windows Container sample should have at least one network interface enabled.'),'')"/>
		</xsl:if>
		<!--|-->
	</xsl:template>
	<!-- /Restore VE Net Inferfaces UI -->
	
	<!--===================================================== Restore UI data ============================================-->
	
	<!-- Restore Data for VE Net Inferfaces UI -->
	<xsl:template name="vzsample:restore-net">
		<xsl:param name="net"/>
		<xsl:variable name="win" select="vt:is-platform-windows($net/platform)"/>
		<xsl:variable name="linux" select="vt:is-platform-linux($net/platform)"/>
			
		<!-- Copy platform -->
		<xsl:copy-of select="$net/platform"/>
		<!-- GLOBAL -->
		<search_domains>
			<xsl:copy-of select="vzenv:restore-net-search()"/>
		</search_domains>		
		<xsl:if test="$linux">
			<dns_ips>
				<xsl:copy-of select="vzenv:restore-net-dns()"/>
			</dns_ips>
		</xsl:if>
		<!-- ROUTED -->
		<routed>
			<xsl:choose>
				<xsl:when test="sw:param('routed_enabled')='1'">
					<!-- enabled -->
					<enabled>true</enabled>
					<xsl:copy-of select="$net/routed/id"/>
					<xsl:if test="$win">
						<dns_ips>
							<xsl:copy-of select="vzenv:restore-net-dns('routed_dns_ips')"/>
						</dns_ips>
						<wins_servers>
							<xsl:copy-of select="vzenv:restore-net-wins('routed_wins_servers')"/>
						</wins_servers>					
						<!--<default_gateway>
							<xsl:copy-of select="sw:param('routed_default_gateway')"/>
						</default_gateway>-->
					</xsl:if>
				</xsl:when>
				<xsl:otherwise>
					<!-- disabled -->
					<enabled>false</enabled>
					<xsl:copy-of select="$net/routed/*[not(self::enabled)]"/>
				</xsl:otherwise>
			</xsl:choose>
		</routed>
		<!-- BRIDGED -->		
		<xsl:variable name="remove-id" select="string(sw:param('bridged_removed'))"/>
		<xsl:choose>
			<!-- Remove last interface, reset bridged interface -->
			<xsl:when test="$remove-id!='' and count($net/bridged/iface)=1">
				<xsl:call-template name="vzsample:init-net-ifaces">
					<xsl:with-param name="sample-platform" select="vt:local-platform()"/>
					<xsl:with-param name="net" select="$net"/>
					<xsl:with-param name="only-bridged" select="true()"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="sw:param('bridged_enabled')='1'">
				<bridged>
					<!-- enabled -->
					<enabled>true</enabled>
					<xsl:for-each select="$net/bridged/iface">
						<xsl:variable name="index" select="position()-1"/>
						<xsl:if test="id!=$remove-id">
							<iface>
								<xsl:copy-of select="id"/>
								<net-id><xsl:value-of select="sw:param(concat('bridged_net_id',$index))"/></net-id>
								<ips-method><xsl:value-of select="sw:param(concat('bridged_ips_method',$index))"/></ips-method>
								<xsl:if test="$win">
									<dns_ips>
										<xsl:copy-of select="vzenv:restore-net-dns(concat('bridged_dns_ips',$index))"/>
									</dns_ips>
									<wins_servers>
										<xsl:copy-of select="vzenv:restore-net-wins(concat('bridged_wins_servers',$index))"/>
									</wins_servers>		
								</xsl:if>
								<default_gateway>
									<xsl:copy-of select="sw:param(concat('bridged_default_gateway',$index))"/>
								</default_gateway>
							</iface>
						</xsl:if>
					</xsl:for-each>
					<!-- Add new interface -->
					<xsl:if test="sw:param('new_iface')!=''">
						<xsl:call-template name="vzsample:new-interface">
							<xsl:with-param name="bridged-ifaces" select="$net/bridged/iface"/>
						</xsl:call-template>
					</xsl:if>
				</bridged>
			</xsl:when>
			<xsl:otherwise>
				<!-- disabled -->
				<bridged>
					<enabled>false</enabled>
					<xsl:copy-of select="$net/bridged/*[not(self::enabled)]"/>
				</bridged>
			</xsl:otherwise>
		</xsl:choose>
		<!--|-->
	</xsl:template>
	<!-- /Restore VE Net Inferfaces UI -->
	
	<!--===================================================== Edit UI ============================================-->


	<!-- Show VE Net Inferfaces UI -->
	<xsl:template name="vzsample:edit-net">
		<xsl:param name="net"/>
		
		<!-- Preload some data -->
		<xsl:variable name="platform" select="$net/platform"/>
		<xsl:variable name="net-config" select="local:load-net-config()"/>
		<!-- /Preload some data -->
		
		<xsl:call-template name="local:show-global">
			<xsl:with-param name="net-config" select="$net-config"/>
			<xsl:with-param name="net" select="$net"/>
		</xsl:call-template>
		
		<ui:rows separate-tables="true">
			<xsl:call-template name="local:edit-routed">
				<xsl:with-param name="net" select="$net"/>
				<xsl:with-param name="net-config" select="$net-config"/>
			</xsl:call-template>		
		</ui:rows>
		
		<ui:rows separate-tables="true">
			<xsl:choose>
				<xsl:when test="$net-config/net">
					<xsl:call-template name="local:edit-bridged">
						<xsl:with-param name="net" select="$net"/>
						<xsl:with-param name="net-config" select="$net-config"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="local:edit-bridged-disabled">
						<xsl:with-param name="net" select="$net"/>
						<xsl:with-param name="net-config" select="$net-config"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</ui:rows>
		
		<xsl:call-template name="local:post-js-code">
			<xsl:with-param name="net-config" select="$net-config"/>
			<xsl:with-param name="net" select="$net"/>
		</xsl:call-template>
		
	</xsl:template>
	<!-- /Show VE Net Inferfaces UI -->

	<!-- Show routed iface -->
	<xsl:template name="local:edit-routed">
		<xsl:param name="net-config"/>
		<xsl:param name="net"/>
		<!--|-->		
		<xsl:variable name="iface" select="$net/routed"/>
		
		<ui:rows-title>
			<ui:text><sw:text>Routed Network</sw:text>&#160;</ui:text>
			<input type="checkbox" id="routed_enabled" name="routed_enabled" onclick="routedEnabledChanged(this.checked)" 
				value="1"
			>
				<xsl:if test="$net/routed/enabled='true'">
					<xsl:attribute name="checked">1</xsl:attribute>
				</xsl:if>
			</input>
		</ui:rows-title>
		
		<ui:row>
			<ui:cell-text>
				<img src="/{$theme}/icons/networkadapter_16.gif" width="16" height="16"/>&#160;
				<sw:text>
					<xsl:with-param name="id" select="$iface/id"/>
					Virtual Network Interface %{id}
				</sw:text>
			</ui:cell-text>
		</ui:row>
		
		<ui:row>
			<ui:cell-label offset="3">
				<sw:text>				
					The Container will have one IP address leased from the IP address pool and assigned to its routed network interface.
				</sw:text>
			</ui:cell-label>
		</ui:row>

		<xsl:if test="vt:is-platform-windows($net/platform)">
			<xsl:copy-of select="vzenv:show-net-dns($iface/dns_ips,$net/platform,'routed_dns_ips',3)"/> 
			<xsl:copy-of select="vzenv:show-net-wins($iface/wins_servers,'routed_wins_servers',3)"/> 
			<!--<xsl:copy-of select="vzenv:show-net-gateway($iface/default_gateway,'routed_default_gateway',3)"/>-->
		</xsl:if>
		
	</xsl:template>
	<!-- /Show routed iface -->
	
	<!-- Show routed iface -->
	<xsl:template name="local:edit-bridged">
		<xsl:param name="net-config"/>
		<xsl:param name="net"/>
		<!--|-->				
		<xsl:variable name="no-nets" select="boolean($net-config/net)"/>
		<!--|-->
		<ui:rows-title>
			<ui:text><sw:text>Bridged Network</sw:text>&#160;</ui:text>
			<input type="checkbox" id="bridged_enabled" name="bridged_enabled"  onclick="bridgedEnabledChanged(this.checked)" value="1">
				<xsl:if test="$net/bridged/enabled='true'">
					<xsl:attribute name="checked">1</xsl:attribute>
				</xsl:if>
			</input>
		</ui:rows-title>
		
		<xsl:for-each select="$net/bridged/iface">
			<xsl:variable name="index" select="position()-1"/>
			<xsl:variable name="iface" select="."/>
			
			<xsl:call-template name="vzenv:show-bridged-iface-header">
				<xsl:with-param name="index" select="$index"/>
				<xsl:with-param name="iface" select="$iface"/>
				<xsl:with-param name="networks" select="$net-config/net"/>
				<xsl:with-param name="env-platform" select="$net/platform"/>
			</xsl:call-template>
		
			<ui:row>
				<ui:cell-label offset="3">
					<sw:text>IP Address Allocation</sw:text>
				</ui:cell-label>
				<ui:cell-list id="bridged_ips_method{$index}" value="{$iface/ips-method}" style="width:200px">
						<ui:list-item id="dhcp" title="{sw:text('Using DHCP Server')}"/>
						<ui:list-item id="ippool" title="{sw:text('Using IP Address Pool')}"/>
				</ui:cell-list>
			</ui:row>	
			
			<xsl:call-template name="vzenv:show-bridged-iface-footer">
				<xsl:with-param name="index" select="$index"/>
				<xsl:with-param name="iface" select="$iface"/>
				<xsl:with-param name="env-platform" select="$net/platform"/>
				<xsl:with-param name="is-last" select="position()=last()"/>
			</xsl:call-template>	
			
		</xsl:for-each>
		
	</xsl:template>
	<!-- /Show routed iface -->

	
	<!-- Show routed network in disabled state -->
	<xsl:template name="local:edit-bridged-disabled">
		<xsl:param name="net-config"/>
		<xsl:param name="net"/>
		<!--|-->				
		<xsl:variable name="no-nets" select="boolean($net-config/net)"/>
		<!--|-->
		<ui:rows-title>
			<ui:text><sw:text>Bridged Network</sw:text>&#160;</ui:text>
			<input type="checkbox" disabled="1" id="bridged_enabled" name="bridged_enabled" value=""/>
		</ui:rows-title>
		<ui:row>
			<ui:cell-text>
				<img src="/{$theme}/icons/alert_yellow.gif" width="16" height="16"/>
			</ui:cell-text>
			<ui:cell-text>
				<xsl:choose>
					<xsl:when test="cred:check('vzcp.virtuozzo_group.network.vnets')">
						<sw:text>
							<xsl:with-param name="aopen">&lt;a href="/vz/cp/vzdir/infrman/networks/index"&gt;</xsl:with-param>
							<xsl:with-param name="aclose">&lt;/a&gt;</xsl:with-param>            					
							The bridged network mode is not available because no virtual network is configured. %{aopen}Click here%{aclose} to configure virtual networks.
						</sw:text>						
					</xsl:when>
					<xsl:otherwise>
						<sw:text>
							The bridged network mode is not available because no virtual network is configured.
						</sw:text>
					</xsl:otherwise>
				</xsl:choose>
			</ui:cell-text>
		</ui:row>
		<!--|-->
	</xsl:template>
	<!-- /Show routed network in disabled state -->
	
	<!-- Show VE Global network settings -->
	<xsl:template name="local:show-global">
		<xsl:param name="net-config"/>
		<xsl:param name="net"/>
		
		<ui:rows title="{sw:text('Global Network')}" separate-tables="true">
			
			<ui:row>
				<ui:cell-text>
					<img src="/{$theme}/icons/network_16.gif" width="16" height="16"/>
					&#160;<sw:text>All Interfaces</sw:text>
				</ui:cell-text>
			</ui:row>

			<xsl:if test="vt:is-platform-linux($net/platform)">
				<xsl:copy-of select="vzenv:show-net-dns($net/dns_ips,$net/platform,'dns_ips',3)"/> 							
			</xsl:if>
			
			<xsl:copy-of select="vzenv:show-net-search($net/search_domains,'search_domains',3)"/>
						
		</ui:rows>
		
	</xsl:template>
	<!-- /Show VE Global network settings -->

	<!-- Post JS-code for iface selection -->
	<xsl:template name="local:post-js-code">
		<xsl:param name="net-config"/>
		<xsl:param name="net"/>
		<!--|-->
		<xsl:variable name="linux" select="vt:is-platform-linux($net/platform)"/>
		<ui:raw>
			<xsl:call-template name="vzenv:post-net-core-js"/>
			
		<script type="text/javascript">	
			function routedEnabledChanged(enabled){
				<xsl:if test="not($linux)">
					disable_routed_dns_ips(!enabled);
					disable_routed_wins_servers(!enabled);
					//document.getElementById('routed_default_gateway').disabled = !enabled;
				</xsl:if>
			}
			function bridgedEnabledChanged(enabled){
				var disabled = !enabled;
				<xsl:for-each select="$net/bridged/iface">
					<xsl:variable name="index" select="position()-1"/>
					<xsl:if test="not($linux)">
						disable_bridged_dns_ips<xsl:value-of select="$index"/>(disabled);
						disable_bridged_wins_servers<xsl:value-of select="$index"/>(disabled);
					</xsl:if>
					document.getElementById('bridged_default_gateway<xsl:value-of select="$index"/>').disabled = !enabled;
					document.getElementById('bridged_ips_method<xsl:value-of select="$index"/>').disabled = disabled;
					document.getElementById('bridged_net_id<xsl:value-of select="$index"/>').disabled = disabled;
					showObjExt('div_bridged_iface_remove<xsl:value-of select="$index"/>',enabled);
				</xsl:for-each>
			}
			v = document.getElementById('routed_enabled');
			if(v){
				routedEnabledChanged(v.checked);
			}
			v = document.getElementById('bridged_enabled');
			if(v  &amp;&amp; v.value!=''){
				bridgedEnabledChanged(v.checked);
				//bridgedDHCPChanged();
			}
		</script>
		</ui:raw>
	</xsl:template>
	<!-- /Post JS-code for iface selection -->
	
	<!--===================================================== Load funcs ============================================-->

	
	<!-- Load all nets available for new VE  -->
	<func:function name="local:list-nets">
		<xsl:variable name="nets-src" select="server_group:get-config()"/>
		<xsl:variable name="nets-rtf">
			<xsl:for-each select="$nets-src/networks/network">
				<xsl:sort select="id"/>
				<net>
					<id><xsl:value-of select="sw:base64-decode(id)"/></id>
					<title><xsl:value-of select="sw:base64-decode(id)"/></title>
				</net>
			</xsl:for-each>
			<xsl:if test="$nets-src/errors">
				<xsl:if test="error:put(concat('VZA error #',$nets-src/error/code,' occured during virtual networks listing'),$nets-src/error/message)"/>
				<net>
					<error/>
					<id/>
					<title><sw:text>Cannot list virtual networks.</sw:text></title>
				</net>
			</xsl:if>
		</xsl:variable>
		<func:result select="exsl:node-set($nets-rtf)/net"/>
	</func:function>
	<!-- /Load all nets available for new VE  -->


	<func:function name="local:load-net-config">
		<xsl:variable name="res-rtf">
			<xsl:copy-of select="local:list-nets()"/>
		</xsl:variable>
		<func:result select="exsl:node-set($res-rtf)"/>
	</func:function>
	
	<!--===================================================== View UI data ============================================-->
	
	<!-- Review Data for VE Net Inferfaces UI -->
	<xsl:template name="vzsample:view-net">
		<xsl:param name="net"/>
		<!--|-->
		<xsl:variable name="linux" select="vt:is-platform-linux($net/platform)"/>
		
		<!--======== Global Network =============-->
		<xsl:if test="($net/dns_ips/ip or $net/search_domains/dom)">
			<ui:rows title="{sw:text('Global Network')}">
				<xsl:if test="$linux">
					<xsl:call-template name="local:view-net-dns">
						<xsl:with-param name="net" select="$net"/>
						<xsl:with-param name="iface" select="$net"/>
					</xsl:call-template>
				</xsl:if>
				<xsl:call-template name="local:view-net-search">
					<xsl:with-param name="net" select="$net"/>
					<xsl:with-param name="iface" select="$net"/>
				</xsl:call-template>
			</ui:rows>
		</xsl:if>

		<!--======== Routed Network =============-->
		<xsl:if test="true()">
			<xsl:variable name="iface" select="$net/routed"/>
			<ui:rows title="{sw:text('Routed Network')}">
				<ui:row>
					<ui:cell-label>
						<sw:text>Status</sw:text>
					</ui:cell-label>
					<ui:cell-text>
						<xsl:value-of select="sw:if($iface/enabled='true',sw:text('Enabled'),sw:text('Disabled'))"/>
					</ui:cell-text>
				</ui:row>
				<xsl:if test="$iface/enabled='true'">
					<xsl:if test="not($linux)">
						<xsl:call-template name="local:view-net-dns">
							<xsl:with-param name="net" select="$net"/>
							<xsl:with-param name="iface" select="$iface"/>
						</xsl:call-template>
						<xsl:call-template name="local:view-net-search">
							<xsl:with-param name="net" select="$net"/>
							<xsl:with-param name="iface" select="$iface"/>
						</xsl:call-template>
					</xsl:if>
				</xsl:if>
			</ui:rows>
		</xsl:if>
		
		<!--======== Bridged Network =============-->
		<xsl:variable name="bridged" select="$net/bridged"/>
		<ui:rows title="{sw:text('Bridged Network')}">

			<ui:row>
				<ui:cell-label>
					<sw:text>Status</sw:text>
				</ui:cell-label>
				<ui:cell-text>
					<xsl:value-of select="sw:if($bridged/enabled='true',sw:text('Enabled'),sw:text('Disabled'))"/>
				</ui:cell-text>
			</ui:row>
			<xsl:if test="$bridged/enabled='true'">
				<xsl:variable name="offset" select="sw:if(count($bridged/iface)=1,'','1')"/>
				<xsl:for-each select="$bridged/iface">
					<xsl:variable name="iface" select="."/>
	
					<xsl:if test="$offset!=''">
						<ui:row>
							<ui:cell-label>
								<sw:text>
									<xsl:with-param name="id" select="$iface/id"/>
									Virtual Ethernet Interface %{id}
								</sw:text>
							</ui:cell-label>
							<ui:cell-text/>
						</ui:row>
					</xsl:if>
				
					<ui:row>
						<ui:cell-label offset="{$offset}">
							<sw:text>Virtual Network</sw:text>
						</ui:cell-label>
						<ui:cell-text>
							<xsl:value-of select="$iface/net-id"/>
						</ui:cell-text>
					</ui:row>
					<ui:row>
						<ui:cell-label offset="{$offset}">
							<sw:text>IP Allocation</sw:text>
						</ui:cell-label>
						<ui:cell-text>
							<xsl:value-of select="sw:if($iface/ips-method='dhcp',sw:text('Using DHCP Server'),sw:text('Using IP Address Pool'))"/>
						</ui:cell-text>
					</ui:row>
					<xsl:if test="not($linux)">
						<xsl:call-template name="local:view-net-dns">
							<xsl:with-param name="net" select="net"/>
							<xsl:with-param name="iface" select="$iface"/>
							<xsl:with-param name="offset" select="$offset"/>				
						</xsl:call-template>
						<xsl:call-template name="local:view-net-search">
							<xsl:with-param name="net" select="$net"/>
							<xsl:with-param name="iface" select="$iface"/>
							<xsl:with-param name="offset" select="$offset"/>				
						</xsl:call-template>
					</xsl:if>
				</xsl:for-each>
			</xsl:if>
		</ui:rows>
	</xsl:template>
	
	
	
	
	<!-- View DNS Data -->
	<xsl:template name="local:view-net-dns">
		<xsl:param name="net"/>
		<xsl:param name="iface"/>
		<xsl:param name="offset" select="''"/>
		
		<xsl:if test="$iface/dns_ips/ip">
			<ui:row>
				<ui:cell-label offset="{$offset}"><sw:text>DNS Servers</sw:text></ui:cell-label>
				<ui:cell>
					<xsl:for-each select="$iface/dns_ips/ip">
						<xsl:sort select="sw:ip2number(.)" data-type="number"/>
						<xsl:value-of select="."/>
						<xsl:if test="position()!=last()">,&#160;</xsl:if>
					</xsl:for-each>
				</ui:cell>
			</ui:row>
		</xsl:if>
	</xsl:template>
	
	<!-- View Search Domains Data -->
	<xsl:template name="local:view-net-search">
		<xsl:param name="net"/>
		<xsl:param name="iface"/>
		<xsl:param name="offset" select="''"/>
		
		<xsl:if test="$iface/search_domains/dom">
			<ui:row>
				<ui:cell-label offset="{$offset}"><sw:text>Search Domains</sw:text></ui:cell-label>
				<ui:cell>
					<xsl:for-each select="$iface/search_domains/dom">
						<xsl:sort select="sw:ip2number(.)" data-type="number"/>
						<xsl:value-of select="."/>
						<xsl:if test="position()!=last()">,&#160;</xsl:if>
					</xsl:for-each>
				</ui:cell>
			</ui:row>
		</xsl:if>
	</xsl:template>

		
</xsl:stylesheet>
