<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl sw func ubcs"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:exsl	="http://exslt.org/common"
	xmlns:func	="http://exslt.org/functions"
	xmlns:check	="http://www.swsoft.com/xsl/cp/check"
	xmlns:envm	="http://www.swsoft.com/xsl/cp/envm"
	xmlns:vt		="http://www.swsoft.com/xsl/cp/vt"
	xmlns:ve		="http://www.swsoft.com/xsl/cp/ve"
	xmlns:alertm="http://www.swsoft.com/xsl/cp/alertm"
	xmlns:ubcs	="http://www.swsoft.com/xsl/cp/ubcs"
>

	<sw:include href="/lib/vt/env-core.xsl"/>
	<sw:include href="/lib/swa/envm.xsl"/>
	<sw:include href="/lib/vt/core.xsl"/>
	<sw:include	href="/lib/swa/alertm.xsl"/>

  <xsl:template name="ubcs:get">
		<xsl:variable name="eid" select="sw:ve-eid()"/>
		<xsl:variable name="req">
			<packet>
				<xsl:copy-of select="sw:hn-dst($eid)"/>
				<target>perf_mon</target>
				<data>
					<perf_mon>
						<get>
							<eid_list>
								<eid><xsl:value-of select="$eid"/></eid>
							</eid_list>
							<class>
								<name>counters_vz_ubc</name>   
							</class>
							<class>
								<name>counters_vz_slm</name>   
							</class>                
						</get>
					</perf_mon>
				</data>
			</packet>
		</xsl:variable>

		<!-- wrapper here -->
		<xsl:variable name="ubcs-new-format" select="sw:xchg($req)/packet/data/perf_mon/data/class/instance"/>
		<xsl:variable name="ubcs-old-format-rtf">
			<xsl:for-each select="$ubcs-new-format/counter[not(starts-with(name,'counter_slm_'))]">
				<ubc>
					<id><xsl:value-of select="name"/></id>
					<cur><xsl:value-of select="value/cur"/></cur>
				</ubc>
			</xsl:for-each>
			<xsl:variable name="ubcs-slm" select="$ubcs-new-format/counter[name = 'counter_slm_memory_inst_usage']"/>  	   
			<xsl:if test="$ubcs-slm">
				<ubc>
					<id><xsl:value-of select="'slmmemorylimit'"/></id>
					<cur><xsl:value-of select="$ubcs-slm/value/cur"/></cur>
				</ubc>
			</xsl:if>
		</xsl:variable>
		<xsl:copy-of select="exsl:node-set($ubcs-old-format-rtf)"/>
  </xsl:template>

  <!-- request current ubcs alerts -->
  <xsl:template name="ubcs:get-alerts">
		<xsl:variable name="alertm-raw" select="alertm:get(sw:ve-eid())"/>
		<alerts>
			<xsl:for-each select="$alertm-raw/alert">
				<alert>
					<xsl:copy-of select="."/>
					<id>
						<xsl:value-of select="./data/event_data/counter"/>
					</id>
					<type>
						<xsl:value-of select="./data/event_data/type"/>			      
					</type>
				</alert>
			</xsl:for-each>
		</alerts>
	</xsl:template>

</xsl:stylesheet>
