<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw func env vzenv"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:ui		="http://www.swsoft.com/xsl/cp/ui"
  xmlns:func	="http://exslt.org/functions"
  xmlns:vzenv   ="http://www.swsoft.com/xsl/cp/vzenv"
  xmlns:env   ="http://www.swsoft.com/xsl/cp/env"
  xmlns:vt    ="http://www.swsoft.com/xsl/cp/vt"
>

	<!-- Check, is offline management can be enabled for ve with specified network config -->
	<func:function name="vzenv:are-offline-services-allowed">
		<xsl:param name="ve-net"/>
		<xsl:param name="src-ve-net"/>
		<xsl:param name="ve-offline-type"/>
		<xsl:param name="ve-offline-services"/>
		<xsl:param name="hn-offline-services"/>	
		
		<xsl:variable name="src-ips" select="
			$src-ve-net/routed[enabled='true']/ips/ip/address[.!='' and .!=$def-ip-auto-vzcp]
			|
			$src-ve-net/bridged[enabled='true']/iface[not(dhcp='true')]/ips/ip/address[.!='' and .!=$def-ip-auto-vzcp]
		"/>
					
		<func:result select="not(
			($ve-net/routed[enabled='true']/ips/ip/address[.!='' and .!=$def-ip-auto-vzcp and .=$src-ips]
				or
			 $ve-net/bridged[enabled='true']/iface[not(dhcp='true')]/ips/ip/address[.!='' and .!=$def-ip-auto-vzcp and .=$src-ips]
			) 
				and
			(
				($ve-offline-type = 'default' and $hn-offline-services/service[default = 1])
					or
				($ve-offline-type = 'custom' and $ve-offline-services/value)
			)
		)"/>
	</func:function>
 
</xsl:stylesheet>
