<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func vzenv"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl	="http://exslt.org/common"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:vzenv	="http://www.swsoft.com/xsl/cp/vzenv"
  xmlns:func	="http://exslt.org/functions"
	xmlns:env		="http://www.swsoft.com/xsl/cp/env"
>

	<sw:include href="/lib/vt/ve-core.xsl"/>
	<sw:include href="/lib/vt/env-ctl.xsl"/>	
	

	<func:function name="vzenv:cmd-stop">
  	<xsl:param name="eid"/>
  	<xsl:param name="fast" select="false()"/>
  	<func:result select="env:cmd-stop($eid,$fast)"/>
  </func:function>

  
  <func:function name="vzenv:cmd-start">
  	<xsl:param name="eid"/>  	
  	<xsl:variable name="status" select="env:get-env($eid)/env/status/state"/>  	
  	<func:result select="sw:if($status=$env-state/suspended, vzenv:cmd-resume($eid), vzenv:cmd-start-no-resume($eid))"/>
  </func:function>
  

  <func:function name="vzenv:cmd-start-no-resume">
  	<xsl:param name="eid"/>
  	<func:result select="env:cmd-start($eid)"/>
  </func:function>


  <func:function name="vzenv:cmd-suspend">
  	<xsl:param name="eid"/>
  	<func:result>
  		<packet log="on" progress="on">
  			<target>vzaenvm</target>
  			<xsl:copy-of select="sw:hn-dst($eid)"/>
  			<cookie>
  				<msg>
  					<sched>
  						<sw:text>The Container has been scheduled to be suspended.</sw:text>
  					</sched>
  					<error>
  						<sw:text>Failed to suspend the Container.</sw:text>
  					</error>
  				</msg>
  				<operation>suspend_ve</operation>
  				<redirect-last />
  			</cookie>
  			<data>
  				<vzaenvm>
  					<suspend>
  						<eid>
  							<xsl:value-of select="$eid"/>
  						</eid>
  					</suspend>
  				</vzaenvm>
  			</data>
  		</packet>
  	</func:result>
  </func:function>


  <func:function name="vzenv:cmd-resume">
  	<xsl:param name="eid" />
  	<func:result>
  		<packet log="on" progress="on">
  			<target>vzaenvm</target>
  			<xsl:copy-of select="sw:hn-dst($eid)" />
  			<cookie>
  				<msg>
  					<sched>
  						<sw:text>The Container has been scheduled to be restored from the suspended state.</sw:text>
  					</sched>
  					<error>
  						<sw:text>Failed to restore the Container from the suspended state.</sw:text>
  					</error>
  				</msg>
  				<operation>resume_ve</operation>
  				<redirect-last />
  			</cookie>
  			<data>
  				<vzaenvm>
  					<resume>
  						<eid>
  							<xsl:value-of select="$eid" />
  						</eid>
  					</resume>
  				</vzaenvm>
  			</data>
  		</packet>
  	</func:result>
  </func:function>
  

  <func:function name="vzenv:cmd-restart">
  	<xsl:param name="eid"/>  	
		<func:result select="env:cmd-restart($eid)"/>
  </func:function>
	

</xsl:stylesheet>
