<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0"
	extension-element-prefixes="sw exsl func vzhn"
	xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl	="http://exslt.org/common"
	xmlns:func	="http://exslt.org/functions"
	xmlns:sw		="http://www.swsoft.com/xsl/cp"
	xmlns:vzhn	="http://www.swsoft.com/xsl/cp/vzhn"
	xmlns:vzenv	="http://www.swsoft.com/xsl/cp/vzenv"
	xmlns:hn		="http://www.swsoft.com/xsl/cp/hn"	
>
	
	<!-- Imports -->
	<sw:include href="/lib/vz/vzenv-core.xsl"/>
	<sw:include href="/lib/vt/hn-info.xsl"/>
	<!-- /Imports -->

	<!-- 
		Load HN information for summary
	-->
	<func:function name="vzhn:load-summary-info">
		<xsl:param name="eid"/>
		<xsl:param name="return-as-rtf" select="false()"/>

		<xsl:variable name="result-rtf">
			<!-- Resources -->
			<resources>
				<group>
					<id>vz</id>
					<title>
						<sw:text>Virtuozzo Server</sw:text>
					</title>
					<!-- Virtuozzo details -->
					<resource>
						<id>virtuozzo</id>
						<name>
							<sw:text>Virtuozzo</sw:text>
						</name>
						<xsl:variable name="vt-info" select="vzenv:get-vt-info($eid)"/>
						<version>
							<xsl:value-of select="$vt-info/version"/>
						</version>
						<release>
							<xsl:value-of select="$vt-info/release"/>
						</release>						
					</resource>
				</group>
				<!-- add hn common info -->
				<xsl:copy-of select="hn:load-summary-info($eid)/group"/>
			</resources>
		</xsl:variable>
		<!-- Return result -->
		<xsl:choose>
			<xsl:when test="$return-as-rtf">
				<func:result select="$result-rtf"/>
			</xsl:when>
			<xsl:otherwise>
				<func:result select="exsl:node-set($result-rtf)/resources"/>
			</xsl:otherwise>
			<!-- Return result -->
		</xsl:choose>
		<!-- /Return result -->

	</func:function>


</xsl:stylesheet>
