<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func dev cred"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl	="http://exslt.org/common"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:func	="http://exslt.org/functions"
	xmlns:dev		="http://www.swsoft.com/xsl/cp/dev"
	xmlns:cred	="http://www.swsoft.com/xsl/cp/cred"
>
	<sw:include href="../common.xsl"/>
  <sw:include href="../cred.xsl"/>
  
	<!-- list volumes -->
	<func:function name="dev:get-mounts">
		<xsl:param name="eid"/>
		<!--|-->
		<xsl:variable name="req">
			<packet>
				<target>vzadevm</target>
				<xsl:copy-of select="sw:hn-dst($eid)"/>
				<data>
					<vzadevm>
						<get_mounts>
							<eid>
								<xsl:value-of select="$eid"/>
							</eid>							
						</get_mounts>
					</vzadevm>
				</data>
				<xsl:if test="cred:check-env('vzcp.env.manage.properties.hardware',$eid)">
					<vzcpauth/>
				</xsl:if>
			</packet>
		</xsl:variable>
		<!--|-->
		<xsl:variable name="rc" select="sw:xchg($req)" />
		<func:result select="$rc/packet/data"/>
		<!--|-->
	</func:function>
	
	<!-- list HW devices -->
	<func:function name="dev:get-devices">
		<xsl:param name="hn-eid"/>
		<!--|-->
		<xsl:variable name="req">
			<packet>
				<target>vzadevm</target>
				<xsl:copy-of select="sw:hn-dst($hn-eid)"/>
				<data>
					<vzadevm>
						<get_info/>
					</vzadevm>
				</data>
			</packet>
		</xsl:variable>
		<!--|-->
		<xsl:variable name="rc" select="sw:xchg($req)"/>
		<func:result select="$rc/packet/data"/>
		<!--|-->
	</func:function>
	
</xsl:stylesheet>
