<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func dyn local licensem"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl	="http://exslt.org/common"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:func	="http://exslt.org/functions"
  xmlns:dyn		="http://exslt.org/dynamic"
  xmlns:hwm		="http://www.swsoft.com/xsl/cp/hwm"
  xmlns:computerm	="http://www.swsoft.com/xsl/cp/computerm"
  xmlns:licensem	="http://www.swsoft.com/xsl/cp/licensem"
  xmlns:local			="http://www.swsoft.com/xsl/cp/local"
  xmlns:env   		="http://www.swsoft.com/xsl/cp/env"
>  
	<sw:include href="/lib/swa/computerm.xsl"/>
	<sw:include href="/lib/swa/licensem.xsl"/>
	<sw:include href="/lib/vt/env-core.xsl"/>
 
  <!-- get count of VEs on HN, used condition -->
  <func:function name="hwm:count-ve">
		<xsl:param name="where" select="''"/>
    <xsl:variable name="req">
			<packet>
				<target>sql</target>
				<data>
					<sql>
						<select>
							<field>pager.ve_info.veid</field>
								<xsl:if test="$where">
									<where>
										<xsl:value-of select="sw:base64-encode(normalize-space($where))"/>
									</where>
								</xsl:if>
							<count>0</count>
						</select>
					</sql>
				</data>
				<vzcpauth/>
			</packet> 
    </xsl:variable>
    <func:result select="sw:xchg($req)/packet/data/sql/row_set/count"/>
	</func:function>	   	 
	
	 <!-- get Hardware Node ID  -->
	<func:function name="hwm:get-hwid">
		<xsl:param name="hn-eid"/>
		<func:result select="licensem:get-hwid($hn-eid)"/>
	</func:function>

  <!-- get VZ license  -->
	<func:function name="hwm:get-lic">
		<xsl:param name="hn-eid"/>
		<func:result select="licensem:get($hn-eid)"/>
	</func:function>

 
	<!-- get HW network  info -->
	<func:function name="hwm:get-network">
		<xsl:param name="hn-eid" />
		<func:result select="computerm:get-network($hn-eid)"/>
	</func:function>

	<!-- get HW node informattion, collected by vzlicreq utility -->
	<func:function name="hwm:gen-request">
		<xsl:param name="data"/>
		<xsl:variable name="req">
			<packet>
				<target>lim</target>
				<cookie>
					<msg>
						<ok><sw:text>Ok</sw:text></ok>
						<error><sw:text>Failed to send the request for a new license: cannot collect information about the Hardware Node</sw:text></error>
					</msg>
					<operation>gw_hw_node_info</operation>
					<redirect><xsl:value-of select="$backurl"/></redirect>
				</cookie>
				<data>
      		<lim>
        		<gen_request>
          		<company><xsl:value-of select="$data/request/company-name"/></company>
	          	<customer><xsl:value-of select="$data/request/customer-name"/></customer>
							<cpu_power>0</cpu_power><!-- for compatibility -->
  	          <nr_cpus><xsl:value-of select="$data/request/nr-cpus"/></nr_cpus>
	    	      <email><xsl:value-of select="$data/request/customer-email"/></email>
  	    	    <unlimited_ve><xsl:value-of select="$data/request/number-unlim-ve"/></unlimited_ve>
	    	    	<light_ve>0</light_ve>
	  	    	  <expiration><xsl:value-of select="$data/request/expiration-time-format"/></expiration>
						</gen_request>
					</lim>
		  	</data>
				<vzcpauth/>
			</packet>
		</xsl:variable>
		<func:result select="sw:xchg($req)/packet/data/lim/request"/>
	</func:function>

 	<!-- get HW data -->
 	<!--
 		input argument:
 			get-vznet/
 			get-network/
 			get-redirect/
 	-->
  <func:function name="hwm:ask-data">
  	<xsl:param name="input-rtf"/>
  	
  	<xsl:variable name="input" select="exsl:node-set($input-rtf)"/>
    
    <xsl:variable name="req">
			<packet>
				<target>hwm</target>
				<data>
					<hwm>
						<xsl:if test="$input/get-vznet">
							<get_vznet/>
						</xsl:if>
						<xsl:if test="$input/get-network">
							<get_network/>
						</xsl:if>
						<xsl:if test="$input/get-redirect">
							<get_redirect/>
						</xsl:if>
					</hwm>
				</data>
				<vzcpauth/>
      </packet>
    </xsl:variable>
    <func:result select="sw:xchg($req)/packet/data/hwm"/>
	</func:function>


</xsl:stylesheet>
