<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func local"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp" xmlns:local="http://www.swsoft.com/xsl/cp/local"
	xmlns:func="http://exslt.org/functions" xmlns:dyn="http://exslt.org/dynamic"
	xmlns:nbh="http://www.swsoft.com/xsl/cp/nbh">

	<func:function name="nbh:get-status">
		<xsl:param name="hw-id" select="sw:hn-eid()" />
		<func:result select="nbh:command($hw-id, 'get_status', 'status')" />
	</func:function>
	
	<func:function name="nbh:get-services">
		<xsl:param name="hw-id" select="sw:hn-eid()" />
		<func:result select="nbh:command($hw-id, 'get', 'service')" />
	</func:function>
	
	<func:function name="nbh:start">
		<xsl:param name="hw-id" select="sw:hn-eid()" />
		<func:result select="nbh:command($hw-id, 'start')" />
	</func:function>
	
	<func:function name="nbh:stop">
		<xsl:param name="hw-id" select="sw:hn-eid()" />
		<func:result select="nbh:command($hw-id, 'stop')" />
	</func:function>

	<func:function name="nbh:command">
		<xsl:param name="hw-id" />
		<xsl:param name="command" />
		<xsl:param name="select" select="false()" />

		<xsl:variable name="req">
			<packet>
				<target>nbh</target>
				<!-- TODO fix when agent bugs fixed -->
				<!--<xsl:copy-of select="sw:hn-dst($hw-id)" />-->
				<data>
					<nbh>
						<xsl:copy-of select="local:node-set($command)" />
					</nbh>
				</data>
			</packet>
		</xsl:variable>
		<xsl:variable name="res" select="sw:xchg($req)/packet/data" />
		<xsl:variable name="errors" select="$res/error|$res/nbh/error" />
		
		<xsl:variable name="data"
			select="sw:if($select, dyn:evaluate(concat('$res/nbh/', $select)), $res/nbh)" />
		<func:result select="$data|$errors" />
	</func:function>
	
	<func:function name="local:node-set">
		<xsl:param name="value" />
		<xsl:variable name="rtf">
			<xsl:choose>
				<xsl:when test="exsl:object-type($value) = 'node-set'">
					<xsl:copy-of select="$value" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:element name="{$value}" />
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<func:result select="exsl:node-set($rtf)" />
	</func:function>
</xsl:stylesheet>
