<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func tem"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl	="http://exslt.org/common"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:func	="http://exslt.org/functions"
  xmlns:tem		="http://www.swsoft.com/xsl/cp/tem"
>
	
	<!-- List HN templates -->
  <func:function name="tem:list">        
    <xsl:param name="type" select="''"/><!-- os=OSses app=Applications ''=All -->
    <xsl:param name="hn-eid" select="/.."/><!-- optional HN EID -->

    <xsl:variable name="req">
      <packet>
        <target>tem</target>
        <xsl:if test="$hn-eid">
        	<xsl:copy-of select="sw:hn-dst($hn-eid)"/>
        </xsl:if>
        <data>
          <tem>
            <ls>
	          	<xsl:if test="$type!='' and $type!='all'">
	            	<type><xsl:value-of select="$type"/></type>
	            </xsl:if>              
          	</ls>
          </tem>
        </data>
      </packet>
    </xsl:variable>
    <func:result select="sw:xchg($req)"/>
  </func:function>
  
  <!-- List ENV templates -->
  <func:function name="tem:list4env">    
    <xsl:param name="env-eid"/>
    <xsl:param name="type" select="''"/><!-- os=OSses app=Applications ''=All -->
    
    <xsl:variable name="req">
      <packet>
        <target>tem</target>
        <xsl:copy-of select="sw:hn-dst($env-eid)"/>
        <data>
          <tem>
            <ls>
            	<eid><xsl:value-of select="$env-eid"/></eid>
            	<xsl:if test="$type!='' and $type!='all'">
              	<type><xsl:value-of select="$type"/></type>
              </xsl:if>                           	
            </ls>
          </tem>
        </data>
      </packet>
    </xsl:variable>
    <func:result select="sw:xchg($req)"/>
  </func:function>
  
  <!-- Get Template Info -->
  <func:function name="tem:get-template">
    <xsl:param name="id"/>
    <xsl:param name="hn-eid" select="/.."/>
    
    <xsl:variable name="req">
      <packet>
        <target>tem</target>
        <xsl:if test="$hn-eid">
        	<xsl:copy-of select="sw:hn-dst($hn-eid)"/>
        </xsl:if>
        <data>
          <tem>
            <ls>  
            	<!-- todo: filter template by ID -->          	
            </ls>
          </tem>
        </data>
				<vzcpauth/>	
      </packet>
    </xsl:variable>    
    <func:result select="sw:xchg($req)//tem/package[name=$id]"/>
  </func:function>
  
	<!-- List distributions -->
  <func:function name="tem:get-distributions">
 		<xsl:param name="hn-eid"/>			 
    <xsl:variable name="req">
      <packet>
        <target>tem</target>
        <xsl:copy-of select="sw:env-dst($hn-eid)"/>
        <data>
        	<tem>
        		<get_distribution/>
          </tem>
        </data>
      </packet>
    </xsl:variable>
    <func:result select="sw:xchg($req)"/>
  </func:function>


  <!-- Get Template Info -->
  <func:function name="tem:get-config">
    <xsl:param name="conf-name"/>
    <xsl:param name="conf-ver"/>
    <xsl:param name="hn-eid"/>
    
    <xsl:variable name="req">
      <packet>
        <target>tem</target>
        <xsl:if test="$hn-eid">
        	<xsl:copy-of select="sw:hn-dst($hn-eid)"/>
        </xsl:if>
        <data>
          <tem>
            <get_config>  
            	<package>
            		<name><xsl:value-of select="$conf-name"/></name>
            		<version><xsl:value-of select="$conf-ver"/></version>
            	</package>
            </get_config>
          </tem>
        </data>				
      </packet>
    </xsl:variable>    
    <func:result select="sw:xchg($req)//tem/config"/>
  </func:function>
  
  <!-- Get Template Info -->
  <func:function name="tem:get-hspc-configs">
    <xsl:param name="packages"/>
    <xsl:param name="hn-eid"/>
    <xsl:param name="auth" select="false()"/>
    
    <xsl:variable name="req">
      <packet>
        <target>tem</target>
        <xsl:if test="$hn-eid">
        	<xsl:copy-of select="sw:hn-dst($hn-eid)"/>
        </xsl:if>
        <data>
          <tem>
						<xsl:for-each select="$packages">
							<get_config>  						
								<meta/>
		          	<package>
	            		<name><xsl:value-of select="name"/></name>
	            		<version><xsl:value-of select="version"/></version>
	  						</package>
							</get_config>	  					
	          </xsl:for-each>
          </tem>
        </data>
        <xsl:if test="$auth">
        	<vzcpauth/>
        </xsl:if>
      </packet>
    </xsl:variable>    
    <xsl:variable name="meta-config-all" select="sw:xchg($req)/packet/data/tem"/>
		<xsl:variable name="dependence-rtf">
			<dependences>
		    <xsl:for-each select="$meta-config-all/meta_config">
  		  	<xsl:copy-of select="sw:node-set(sw:base64-decode(.))/Template"/>
    		</xsl:for-each>
    	</dependences>
		</xsl:variable>
		<func:result select="exsl:node-set($dependence-rtf)/dependences/*"/>
  </func:function>

  <!-- ve need upgrade -->
  <func:function name="tem:check-for-ve-upgrade">
    <xsl:param name="ve-eid"/>
    <xsl:param name="type" select="'os'"/>
		<!-- 
				0:	no upgrade available
				1:	available
		 --> 
    <func:result select="0"/>
  </func:function>


</xsl:stylesheet>
