<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:error="http://www.swsoft.com/xsl/cp/error"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
>

	<xsl:output method="xml"/>

	<!-- check permissions to process request -->
	<xsl:variable name="cr-sb-login"
		select="cred:detail-check-env('vzcp.env.manage.services.sb_login',sw:ve-eid())"/>

	<xsl:template match="/">
		<xsl:choose>
			<xsl:when test="not($cr-sb-login)">
				<!-- no creds, on screen would be terminating -->
				<packet/>
			</xsl:when>
			<xsl:when test="cred:is-demo-mode()">
				<packet>
					<target>progm</target>
					<cookie>
						<operation>login_to_sb</operation>
						<redirect-last/>
					</cookie>
				</packet>
				<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>
			</xsl:when>
			<xsl:otherwise>
				<!-- creds present -->
				<packet/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- credentials -->
	<sw:include href="/lib/common.xsl"/>
	<sw:include href="/lib/cred.xsl"/>

</xsl:stylesheet>
