<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred func"
  xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl		="http://exslt.org/common"
  xmlns:sw			="http://www.swsoft.com/xsl/cp"  
  xmlns:error		="http://www.swsoft.com/xsl/cp/error"	  
	xmlns:cred 		="http://www.swsoft.com/xsl/cp/cred"
	xmlns:vzenv		="http://www.swsoft.com/xsl/cp/vzenv"
	xmlns:hwm			="http://www.swsoft.com/xsl/cp/hwm"
	xmlns:func		="http://exslt.org/functions"
>
	<xsl:output method="xml"/>

	<xsl:template match="/">
	  <xsl:variable name="service-allowed" select="vzenv:vzpp-service-allowed(sw:ve-eid())"/>
		<xsl:choose>
			<xsl:when test="not($service-allowed)">
				<xsl:choose>
					<xsl:when test="error:is-empty()">
						<packet/>			
					</xsl:when>
					<xsl:otherwise>
						<packet>
							<cookie>
								<redirect-last/>
							</cookie>
						</packet>
						<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>	
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<!-- allowed, no need screen -->
				<packet>
					<cookie>
						<redirect><xsl:value-of select="$baseurl"/>/vzdir/infrman/envs/env</redirect>
					</cookie>				
				</packet>
				<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>					
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- credentials -->
	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/common.xsl"/>	
	<sw:include href="/lib/vz/vzenv-offline.xsl"/>	
	<sw:include href="/lib/vza/hwm.xsl"/>

</xsl:stylesheet>
