<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl sw func cred local units"
	xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl		="http://exslt.org/common"
	xmlns:sw			="http://www.swsoft.com/xsl/cp"
	xmlns:units		="http://www.swsoft.com/xsl/cp/units"
	xmlns:error			="http://www.swsoft.com/xsl/cp/error"
	xmlns:func		="http://exslt.org/functions"
	xmlns:cred 		="http://www.swsoft.com/xsl/cp/cred"
	xmlns:local		="http://www.swsoft.com/xsl/cp/local"
>
	<sw:include href="/lib/core/units-core.xsl"/>

	<xsl:output method="xml"/>

	<xsl:variable name="redirect"	select="units:tab-redirect('hn.vz.vt','envs')"/>
  
	<xsl:template match="/">
		<sw:noauth-redirect select="not(cred:check-hw('vzcp.hn.view', sw:hn-eid()))"/>
		<xsl:choose>
			<xsl:when test="$redirect=''">
				<packet />
			</xsl:when>			
			<xsl:otherwise>
				<xsl:copy-of select="$redirect"/>
				<xsl:if test="sw:response('lib/opredirect.xsl')" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

  
  <!-- credentials -->
  <sw:include href="/lib/common.xsl"/>
  <sw:include href="/lib/cred.xsl"/>  
 
</xsl:stylesheet>
