<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl sw func env vzenv units"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:hwm="http://www.swsoft.com/xsl/cp/hwm"
	xmlns:env="http://www.swsoft.com/xsl/cp/env"
	xmlns:vzenv="http://www.swsoft.com/xsl/cp/vzenv"
	xmlns:func="http://exslt.org/functions"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
  xmlns:units		="http://www.swsoft.com/xsl/cp/units"
  
>

	<sw:include href="/lib/common.xsl"/> 
	<sw:include href="/lib/vocabulary.xsl"/>
	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/core/units-core.xsl"/>
	<sw:include href="/lib/vz/vzenv-core.xsl"/>


	<xsl:output method="xml"/>
	
	<xsl:template match="/">

		<xsl:variable name="eid-get" select="sw:base64-decode(sw:param('eid'))"/>

		<!-- change current vzenv -->
		<xsl:variable name="backup-eid">
			<xsl:choose>
				<xsl:when test="$eid-get!=''">
					<xsl:variable name="now-env" select="vzenv:set-current($eid-get,true())"/>
					<xsl:value-of select="sw:if($now-env,$eid-get,'')"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="sw:ve-eid()"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- /change current vzenv -->

		<xsl:choose>
			<!-- Backuped VE exists -->
			<xsl:when test="$backup-eid!=''">
				<!-- Check tabs autoredirect -->
				<xsl:variable name="redirect"	select="units:tab-redirect('ve.vz.vt','backups')"/>
				<xsl:choose>
					<xsl:when test="$redirect=''">
						<packet />
					</xsl:when>			
					<xsl:otherwise>
						<xsl:copy-of select="$redirect"/>
						<xsl:if test="sw:response('lib/opredirect.xsl')" />
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<!-- Backuped VE does not exists -->
			<xsl:otherwise>
				<sw:die test="$eid-get=''">
					Unknown env.
				</sw:die>
				<!-- Redirect to sandbox -->
				<packet>
					<cookie>
						<redirect><xsl:value-of select="concat($baseurl,'/vz/ves/backups/index-deleted?ve-eid=',sw:escape($eid-get))"/></redirect>
					</cookie>
				</packet>
				<xsl:if test="sw:response('lib/opredirect.xsl')" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


</xsl:stylesheet>
