<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl sw func cred"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:error="http://www.swsoft.com/xsl/cp/error"
	xmlns:func="http://exslt.org/functions"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:env="http://www.swsoft.com/xsl/cp/env"
	xmlns:vzenv="http://www.swsoft.com/xsl/cp/vzenv"
	xmlns:vzapackagem="http://www.swsoft.com/xsl/cp/vzapackagem"
	>
	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/vt/env-core.xsl"/>
	<sw:include href="/lib/vza/vzapackagem.xsl"/>
	<sw:include href="/lib/vz/vzenv-apps.xsl"/>

	<xsl:output method="xml"/>
	

	<xsl:template match="/">
		<xsl:variable name="eid" select="sw:ve-eid()"/>
		<sw:noauth-redirect 
			select="not(cred:check-env('vzcp.env.manage.properties.application', $eid))"/>	
		<xsl:variable name="pid" select="sw:if(sw:param('pid'), string(sw:param('pid')), sw:sesget('ve-app-action-id'))"/>
		
		<xsl:choose>
			<xsl:when test="sw:param('manage')">
				<packet>
					<cookie>
						<redirect><xsl:value-of select="$baseurl"/>/vzdir/infrman/envs/manage?tab=apps</redirect>
					</cookie>
				</packet>
				<xsl:if test="sw:response('lib/opredirect.xsl')"/>
			</xsl:when>
			<xsl:when test="vzenv:is-ve-updating($eid) or not(string($pid)='')">
				<!-- Store schedule and errors messages -->
				<xsl:variable name="sched" select="sw:sesget('sched')"/>
				<xsl:variable name="errors" select="sw:sesget('errors')"/>
				<xsl:if test="sw:sesput('ve-apps-sched', $sched)"/>
				<xsl:if test="sw:sesput('ve-apps-errors', $errors)"/>
				
				<packet/>
			</xsl:when>
			<xsl:otherwise>
				<!-- Restore schedule and errors messages after AJAX refresh (when needed) -->
				<xsl:variable name="sched" select="sw:sesget('sched')"/>
				<xsl:variable name="errors" select="sw:sesget('errors')"/>
				<xsl:variable name="ve-sched" select="sw:sesget('ve-apps-sched')"/>
				<xsl:variable name="ve-errors" select="sw:sesget('ve-apps-errors')"/>
				
				<xsl:if test="string($sched)='' and not(string($ve-sched)='')">
					<xsl:if test="sw:sesput('sched', sw:sesget('ve-apps-sched'))"/>
				</xsl:if>
				<xsl:if test="string($errors)='' and not(string($ve-errors)='')">
					<xsl:if test="sw:sesput('errors', sw:sesget('ve-apps-errors'))"/>
				</xsl:if>
				<!-- Clear stored state -->
				<xsl:if test="sw:sesput('ve-apps-sched', '')"/>
				<xsl:if test="sw:sesput('ve-apps-errors', '')"/>
				<xsl:if test="sw:sesput('ve-app-action-id', '')"/>
				
				<packet>
					<cookie>
						<list>1</list>
					</cookie>
					<info>
						<xsl:copy-of select="vzapackagem:ve-apps-summary($eid)"/>
					</info>
				</packet>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- credentials -->
	<sw:include href="/lib/common.xsl"/>
	<sw:include href="/lib/cred.xsl"/>

</xsl:stylesheet>
