<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->
<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func wiz vzenv tem cred voc action local error env-samplem check envm ips vt system hn vz request env"
	xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl	="http://exslt.org/common"
	xmlns:sw		="http://www.swsoft.com/xsl/cp"
	xmlns:error	="http://www.swsoft.com/xsl/cp/error"
	xmlns:env-samplem 		="http://www.swsoft.com/xsl/cp/env-samplem"
	xmlns:wiz		="http://www.swsoft.com/xsl/cp/wiz"
	xmlns:env		="http://www.swsoft.com/xsl/cp/env"
	xmlns:vzenv		="http://www.swsoft.com/xsl/cp/vzenv"
	xmlns:hn		="http://www.swsoft.com/xsl/cp/hn"
	xmlns:tem		="http://www.swsoft.com/xsl/cp/tem"
	xmlns:envm		="http://www.swsoft.com/xsl/cp/envm"
	xmlns:local	="http://www.swsoft.com/xsl/cp/local"
	xmlns:check	="http://www.swsoft.com/xsl/cp/check"
  xmlns:func	="http://exslt.org/functions"	
	xmlns:cred  ="http://www.swsoft.com/xsl/cp/cred"
	xmlns:voc		="http://www.swsoft.com/xsl/cp/voc"
	xmlns:action	="http://www.swsoft.com/xsl/cp/action"
	xmlns:ips	="http://www.swsoft.com/xsl/cp/ips"
	xmlns:vt	="http://www.swsoft.com/xsl/cp/vt"
	xmlns:vz	="http://www.swsoft.com/xsl/cp/vz"
	xmlns:request	="http://www.swsoft.com/xsl/cp/request"
	xmlns:system	="http://www.swsoft.com/xsl/cp/system"
	xmlns:redirect	="http://www.swsoft.com/xsl/cp/redirect"
	xmlns:requests  ="http://www.swsoft.com/xsl/cp/requests"
	xmlns:ts 				="http://www.swsoft.com/xsl/cp/ts"
	xmlns:permissions	="http://www.swsoft.com/xsl/cp/permissions"		
>
	<!-- Import required modules -->
	<sw:include href="/lib/core/check-funcs.xsl"/>	
	<sw:include href="/lib/vocabulary.xsl"/>		
	<sw:include href="/lib/swa/system.xsl"/>
	<sw:include href="/lib/swa/envm.xsl"/>
	<sw:include href="/lib/swa/env-samplem.xsl"/>
 	<sw:include href="/lib/core/permissions/core-ui.xsl"/>
 	<sw:include href="/lib/utils/action.xsl"/>	
	<sw:include href="/lib/vt/envrequests.xsl"/>  	
	<sw:include href="/lib/vt/core.xsl"/>
	<sw:include href="/lib/vt/env-core.xsl"/>
	<sw:include href="/lib/vz/core.xsl"/>
	<sw:include href="/lib/vz/vzenv-apps.xsl"/>
	<sw:include href="/lib/vz/vzenv-net-core.xsl"/>
	<sw:include href="/lib/vz/vzenv-net-ui.xsl"/>
	<sw:include href="/lib/vz/ips.xsl"/>
	<sw:include href="/lib/vz/vzenv-net.xsl"/>
	<sw:include href="/lib/vz/vzenv-qos.xsl"/>
	<sw:include href="/lib/vz/vzenv-os.xsl"/>	
	<sw:include href="/lib/vt/hn-list.xsl"/>	
	<sw:include href="/lib/ts.xsl"/>
	<sw:include href="/lib/vz/vzhn-redirects.xsl"/>
	
	<!-- Import required modules -->

	<xsl:output method="xml"/>
	<xsl:param name="wiz_code" select="'vzdir_envs_create'"/> 
	<xsl:variable name="step" select="wiz:processing-step-id()"/>
	<xsl:variable name="form" select="local:init-form()"/>	


	<xsl:template match="node()|@*">
		
		<xsl:choose>
					
			<!-- Step "General Settings" -->
			<xsl:when test="$step='gen'">
			
					<!-- todo: cache it ! -->
					<xsl:variable name="routed-rule" select="string(sw:param('multiple_net_routed_rule'))"/>					
					<xsl:variable name="bridged-rule" select="string(sw:param('multiple_net_bridged_rule'))"/>
					<xsl:variable name="config-selected" select="sw:param('config')"/>
					<xsl:variable name="sample_config" select="env-samplem:get-sample($config-selected)"/>
					<!-- /todo: cache it ! -->
					<!-- handle QoS -->
					<xsl:variable name="changed_config" select="not($form/gen/config) or ($form/gen/config!=$config-selected)"/>
					<xsl:variable name="changed-net" select="$changed_config or 
						string($form/multiple/net-routed-rule)!=$routed-rule or string($form/multiple/net-bridged-rule)!=$bridged-rule
					"/>
					<!-- /handle QoS -->	
					
					<xsl:variable name="new_form_">
						<xsl:for-each select="$form/*">
							<xsl:choose>
								<xsl:when test="name()=$step or self::permissions"></xsl:when>
								<xsl:when test="name()='multiple' and $form/envs-count!=1"></xsl:when>								
								<xsl:when test="name()='capabilities'"></xsl:when>
								<xsl:when test="$changed_config and self::qos"></xsl:when>
								<xsl:when test="self::net"></xsl:when>
								<xsl:when test="name()='os_template'"></xsl:when>
								<xsl:when test="$changed_config and name()='apps'"></xsl:when>
								<xsl:when test="$changed_config and name()='ve-template-descr'"></xsl:when>
								<xsl:otherwise>
									<xsl:copy-of select="."/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
						<xsl:if test="$form/envs-count!=1">
							<xsl:variable name="count" select="$form/envs-count"/>
							<multiple>
								<ids-rule><xsl:value-of select="sw:param('multiple_ids_rule')"/></ids-rule>
								<ips-rule><xsl:value-of select="sw:param('multiple_ips_rule')"/></ips-rule>
								<hostnames-rule><xsl:value-of select="sw:param('multiple_hostnames_rule')"/></hostnames-rule>
								<net-routed-rule><xsl:value-of select="$routed-rule"/></net-routed-rule>
								<net-bridged-rule><xsl:value-of select="$bridged-rule"/></net-bridged-rule>
								<names-rule><xsl:value-of select="sw:param('multiple_names_rule')"/></names-rule>
								<xsl:if test="$count!='' and check:num($count)">
									<xsl:call-template name="local:generate-ve-items">
										<xsl:with-param name="index" select="1"/>
										<xsl:with-param name="total" select="$count"/>
									</xsl:call-template>
								</xsl:if>
							</multiple>
						</xsl:if>
						<gen>
							<description>
								<xsl:value-of select="sw:param('description')"/>
							</description>
							<config><xsl:value-of select="sw:param('config')"/></config>
							<root_pwd><xsl:value-of select="sw:param('root_pwd')"/></root_pwd>
							<root_pwd_re><xsl:value-of select="sw:param('root_pwd_re')"/></root_pwd_re>
							<xsl:if test="$form/envs-count=1">
								<name>
									<xsl:value-of select="sw:param('name')"/>
								</name>
								<ask_veid><xsl:value-of select="sw:param('ask_veid')"/></ask_veid>	
								<ve_id><xsl:value-of select="normalize-space(sw:param('ve_id'))"/></ve_id>	
							</xsl:if>
							<start_after_boot><xsl:value-of select="sw:param('start_after_boot')"/></start_after_boot>
							<start_after_create><xsl:value-of select="sw:param('start_after_create')"/></start_after_create>
							<offline_type><xsl:value-of select="sw:param('offline_type')"/></offline_type>
							<xsl:variable name="selected-services" select="sw:param('selected_offline_service')"/>
							<selected_offline_service>
								<xsl:for-each select="$selected-services">
									<value>
										<xsl:value-of select="."/>
									</value>
								</xsl:for-each>
							</selected_offline_service>
							<show_adv><xsl:value-of select="sw:param('show_adv')"/></show_adv>
							<show_permissions><xsl:value-of select="sw:param('show_permissions')"/></show_permissions>
							<xsl:if test="$form/hn/windows">
								<tsmode>
									<xsl:value-of 
										select="sw:param('tsmode')"/>
								</tsmode>
								<tslicservers>
									<xsl:copy-of select="ts:restore-lic-servers()"/>
								</tslicservers>
							</xsl:if>												
							<show_offline><xsl:value-of select="sw:param('show_offline')"/></show_offline>
							<!-- precalc sample config dats -->
							<old_config><xsl:value-of select="$form/gen/config"/></old_config>
						</gen>
						<permissions>
							<xsl:call-template name="permissions:restore"/>
						</permissions>
						<capabilities>
							<xsl:copy-of select="vzenv:restore-net-capabilities($form/def/voc-capabilities)"/>
						</capabilities>
						<xsl:variable name="os-rtf" select="vzenv:restore-os()"/>
						<xsl:variable name="os" select="exsl:node-set($os-rtf)"/>
						<xsl:copy-of select="$os"/>
						<net>
							<!-- Handle hostname -->
							<xsl:choose>
								<!-- hostname already was touched/viewed by user -->
								<xsl:when test="$form/net/hostname-taken">
									<xsl:copy-of select="$form/net/*[self::hostname-taken or self::hostname]"/>									
								</xsl:when>
								<!-- copy hostname from VE request -->																	
								<xsl:when test="$form/def/request/hostname">
									<hostname-taken/>
									<hostname>
										<xsl:if test="$form/def/request/hostname">
											<xsl:value-of select="$form/def/request/hostname"/>
										</xsl:if>
									</hostname>
								</xsl:when>			
								<!-- copy from name -->																	
								<xsl:otherwise>
									<hostname>
										<xsl:value-of select="sw:param('name')"/>
									</hostname>
								</xsl:otherwise>		
							</xsl:choose>
							<!-- Handle Ifaces -->
							<xsl:choose>
								<xsl:when test="$changed-net">
									<xsl:call-template name="vzenv:sample2net">
										<xsl:with-param name="config" select="$sample_config"/>
										<xsl:with-param name="hn-platform" select="$form/hn/platform"/>
										<xsl:with-param name="routed-ip-rule" select="$routed-rule"/>
										<xsl:with-param name="bridged-ip-rule" select="$bridged-rule"/>
										<xsl:with-param name="ves-count" select="$form/envs-count"/>
									</xsl:call-template>
								</xsl:when>
								<xsl:otherwise>
									<xsl:copy-of select="$form/net/*[not(self::hostname or self::hostname-taken)]"/>
								</xsl:otherwise>
							</xsl:choose>
						</net>
						<xsl:if test="$changed_config">							
							<ve-template-descr>
								<xsl:value-of select="sw:base64-decode($sample_config/comment)"/>
							</ve-template-descr>
							<!-- Copy QoS from sample config -->
							<qos>
								<slm-mode>
									<xsl:value-of select="$sample_config/env_config/slm_mode"/>
								</slm-mode>
								<xsl:for-each select="$sample_config//qos">
			  					<res>
			  						<xsl:copy-of select="node()"/>
			  						<soft_src><xsl:value-of select="soft"/></soft_src>
			  						<hard_src><xsl:value-of select="hard"/></hard_src>
			  					</res>
			  				</xsl:for-each>
							</qos>
							<!-- Copy Application Templates from sample config -->
							<!-- Only if OS name from sample equal selected OS from interface -->
							<xsl:if test="local:same-os-template($sample_config/env_config/os_template/name, 
																	$os/os_template/name, $form/hn)">
								<apps>
									<xsl:for-each select="$sample_config/env_config/template[*]">
										<app>
											<name><xsl:value-of select="name"/></name>
											<xsl:if test="version">
												<xsl:copy-of select="version"/>
											</xsl:if>
										</app>
									</xsl:for-each>
								</apps>
								<!-- /Copy Application Templates from sample config -->
							</xsl:if>
						</xsl:if>
						<!-- always calc os_sample -->
						<os_in_sample>
							<xsl:copy-of select="$sample_config/env_config/os_template/*"/>
						</os_in_sample>
					</xsl:variable>
					
					<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>
					<xsl:variable name="platform-ref" select="env:make-platform-ref($new_form/hn/eid)"/>			      					
							
					<xsl:if test="sw:param('next') or sw:param('ok')">
						<!-- Check data -->			
						<!-- check name presence -->
					  <xsl:if test="$form/envs-count=1">
					  	<xsl:if test="vzenv:check-ve-name($new_form/gen/name,$form/hn/eid)"/>
						</xsl:if>
						<!-- Check password -->
						<xsl:choose>
				      <xsl:when test="string($new_form/gen/root_pwd) != string($new_form/gen/root_pwd_re)">
				        <!-- check password presence -->
				        <xsl:value-of select="error:put(sw:text('The passwords do not match.'),'','root_pwd')"/>
				        <xsl:value-of select="error:add-control('root_pwd_re')"/>
				      </xsl:when>
			      </xsl:choose>
			      <!-- Check offline management -->
						<xsl:choose>
				      <xsl:when test="$new_form/gen/offline_type = 'custom' and count($new_form/gen/selected_offline_service/value) = 0">
				        <xsl:if test="error:put(sw:text('Select at least one service for custom offline management.'),'','selected_offline_service')"/>
							</xsl:when>
			      </xsl:choose>
			      <xsl:if test="$form/envs-count=1">
				      <!-- Check VE ID-->
				      <xsl:if test="string($new_form/gen/ask_veid)!=''">
				      	<xsl:if test="vzenv:check-ve-id( 
				      		$new_form/gen/ve_id,$new_form/hn/eid,
				      		$new_form/def/end_veid 
				      	)"/>
				      </xsl:if>
				   	</xsl:if>
			      <!-- Check DNS -->
			      <xsl:if test="vzenv:check-net-dns($new_form/dns_ips/ip)"/>
			      <!-- Check Search Domains -->
						<xsl:if test="vzenv:check-net-search($platform-ref,$new_form/search_domains/dom)"/>
			      <!-- Check OS -->
			      <xsl:if test="vzenv:check-os($new_form/os_template)"/>			
			      <!-- Check permissions -->
			      <xsl:if test="permissions:check($new_form/permissions)"/>
			      
			      <!-- Check hostname if user click Create -->
			      <xsl:if test="sw:param('ok') and error:is-empty() and $new_form/net/hostname!=''">
							<xsl:variable name="error-info" select="check:hostname-ext($platform-ref,$new_form/net/hostname)"/>
							<xsl:if test="$error-info">
								<xsl:if test="error:put(sw:text('The specified Container name cannot be used as the Container hostname. Please click Next and correct the hostname on the next step.'))"/>
							</xsl:if>
						</xsl:if>
					</xsl:if>
					
				<xsl:choose>
					<!-- Return to prev. wizard -->
					<xsl:when test="sw:param('back')">
						<xsl:if test="sw:sesputtree($wiz_data,$new_form)"/>					
						<packet>
							<cookie>	        
								<redirect> 
									<xsl:value-of select="concat($baseurl,'/vt/envs/new?step=restart')"/>
								</redirect>
							</cookie>					
						</packet>			
						<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>	
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="local:completeFormHandling">
							<xsl:with-param name="data" select="$new_form"/>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>	
																															
			</xsl:when>
				
			<!-- Step "Custom" -->
			<xsl:when test="$step='custom'">
			
				<xsl:variable name="platform-ref" select="env:make-platform-ref($form/hn/eid,$form/hn/platform)"/>
			
				<!-- Restore form's data  -->
				<xsl:variable name="qos" select="exsl:node-set(sw:restoreQoS($platform-ref,$form/qos))"/>
				<xsl:variable name="new-form-rtf">
					<xsl:copy-of select="$form/*[not(self::qos)]"/>
					<qos>
						<xsl:copy-of select="$qos"/>
					</qos>
				</xsl:variable>
				<!-- /Restore form's data  -->
				<xsl:variable name="new-form" select="exsl:node-set($new-form-rtf)"/>
				
				<xsl:choose>
					<xsl:when test="sw:param('validate')">
						<!-- Validate QoS -->
						<xsl:if test="sw:checkQoS($platform-ref,$qos)"/>						
					</xsl:when>								
					<xsl:when test="sw:param('next') or sw:param('ok')">
						<!-- Check data -->
						<xsl:if test="sw:checkQoS($platform-ref,$qos)"/>
					</xsl:when>
				</xsl:choose>
				
				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$new-form"/>
				</xsl:call-template>
					
			</xsl:when>		
			
			<!-- Step "Multiplay" -->
			<xsl:when test="$step='multiple'">
			
				<!-- Restore form's data  -->
				<xsl:variable name="new-form-rtf">
					<xsl:copy-of select="$form/*[not(self::multiple-set or self::net)]"/>
					<net>
						<xsl:call-template name="vzenv:restore-net-ifaces">
							<xsl:with-param name="env-form" select="$form"/>
						</xsl:call-template>
					</net>
					<multiple-set>
						<xsl:if test="$form/multiple/ids-rule='from'">
							<ids-from>
								<xsl:value-of select="normalize-space(sw:param('ids_from'))"/>
							</ids-from>
						</xsl:if>
						<xsl:if test="$form/multiple/hostnames-rule='mask'">
							<hostname>
								<xsl:value-of select="normalize-space(sw:param('hostname'))"/>
							</hostname>
						</xsl:if>
						<xsl:if test="$form/multiple/names-rule='mask'">
							<name>
								<xsl:value-of select="normalize-space(sw:param('name'))"/>
							</name>
						</xsl:if>
						<xsl:for-each select="$form/multiple/item">
							<xsl:variable name="index" select="position()"/>
							<ve>
								<xsl:if test="$form/multiple/ids-rule='set'">		 
									<id>
										<xsl:value-of select="normalize-space(sw:param(concat('id_',$index)))"/>
									</id>
								</xsl:if>
								<xsl:if test="$form/multiple/names-rule='set'">
									<name>
										<xsl:value-of select="normalize-space(sw:param(concat('name_',$index)))"/>
									</name>
								</xsl:if>
								<xsl:if test="$form/multiple/hostnames-rule='set'">
									<hostname>
										<xsl:value-of select="normalize-space(sw:param(concat('hostname_',$index)))"/>
									</hostname>
								</xsl:if>
							</ve>
						</xsl:for-each>
					</multiple-set>				
				</xsl:variable>
				<xsl:variable name="new-form" select="exsl:node-set($new-form-rtf)"/>
				<!-- /Restore form's data  -->
				
				<xsl:choose>					
					<xsl:when test="sw:param('next') or sw:param('ok')">
						<xsl:variable name="platform-ref" select="env:make-platform-ref($form/hn/eid,$form/hn/platform)"/>
					
						<!-- Check data -->
						<!-- Check initial VE ID -->
						<xsl:if test="$new-form/multiple/ids-rule='from'">
							<xsl:choose>
								<xsl:when test="$new-form/multiple-set/ids-from=''">
									<xsl:if test="error:put(sw:text('You should specify the first Container ID.'),'','ids_from')"/>
								</xsl:when>
								<xsl:when test="not(check:num($new-form/multiple-set/ids-from))">
									<xsl:if test="error:put(sw:text('The Initial Container ID field should contain a valid integer number.'),'','ids_from')"/>
								</xsl:when>
								<xsl:otherwise>
									<!-- Check VE ID for assigned alredy -->
									<!-- Prepare VE List -->
									<xsl:variable name="ve-list-rtf">									
										<xsl:for-each select="$new-form/multiple-set/ve">
											<xsl:variable name="ve-id" select="$new-form/multiple-set/ids-from + position() - 1"/>
											<ve-id><xsl:value-of select="$ve-id"/></ve-id>
										</xsl:for-each>
									</xsl:variable>
									<xsl:variable name="ve-list" select="exsl:node-set($ve-list-rtf)/eid"/>	
									<!-- /Prepare VE List -->									
									<xsl:for-each select="$ve-list">
										<xsl:variable name="ve-id" select="ve-id"/>
										<xsl:variable name="eid" select="vzenv:veid-to-eid($ve-id,$form/hn/eid)"/>
										<xsl:variable name="env-info" select="env:get-env($eid)"/>
										<xsl:variable name="ve-existed" select="$env-info/env[eid=$eid]"/>
										<xsl:if test="($ve-existed)">
											<xsl:variable name="error">
												<sw:text>
													<xsl:with-param name="id" select="$ve-id"/>
													<xsl:with-param name="hostname" select="$ve-existed/config/hostname"/>
													ID %{id} has already been assigned to the '%{hostname}' Container.
												</sw:text>
											</xsl:variable>
											<xsl:if test="error:put($error,'','ids_from')"/>
										</xsl:if>
									</xsl:for-each>
									<!-- /Check VE ID for assigned alredy -->
								</xsl:otherwise>								
							</xsl:choose>
						</xsl:if>
						<!-- /Check initial VE ID -->
						<!-- Check name -->
						<xsl:if test="$new-form/multiple/names-rule='mask'">
							<xsl:variable name="name" select="$new-form/multiple-set/name"/>
							<xsl:variable name="mask" select="'&lt;veid&gt;'"/>
							<xsl:choose>
								<xsl:when test="$name=''">
									<xsl:if test="error:put(sw:text('You should specify a name.'),'','name')"/>
								</xsl:when>
								<xsl:when test="not(contains($name,$mask))">
									<xsl:if test="error:put(sw:text('The name should contain the &lt;veid&gt; tag inside.'),'','name')"/>
								</xsl:when>
								<xsl:when test="not(
									check:env-name(
										$platform-ref,
										concat(
											substring-before($name,$mask),'123',
											substring-after($name,$mask)	
										)
									)
								)">
									<xsl:if test="error:put(sw:text('The name contains invalid characters.'),'','name')"/>
								</xsl:when>
							</xsl:choose>
						</xsl:if>
						<!-- /Check name -->
						<!-- Check hostname -->
						<xsl:if test="$new-form/multiple/hostnames-rule='mask'">
							<xsl:variable name="hostname" select="$new-form/multiple-set/hostname"/>
							<xsl:if test="$hostname!=''">
								<xsl:variable name="mask" select="'&lt;veid&gt;'"/>
								<xsl:choose>
									<xsl:when test="$hostname=''">
									</xsl:when>
									<xsl:when test="not(contains($hostname,$mask))">
										<xsl:if test="error:put(sw:text('The hostname should contain the &lt;veid&gt; tag inside.'),'','hostname')"/>
									</xsl:when>
									<xsl:when test="not(
										check:hostname(
											$platform-ref,
											concat(
												substring-before($hostname,$mask),'123',
												substring-after($hostname,$mask)	
											)
										)
									)">
										<xsl:if test="error:put(sw:text('The hostname contains invalid characters.'),'','hostname')"/>
									</xsl:when>
								</xsl:choose>
							</xsl:if>
						</xsl:if>
						<!-- /Check hostname -->
						<!-- Check VE list -->
						<xsl:for-each select="$new-form/multiple-set/ve">
      				<xsl:variable name="index" select="position()"/>
      				<xsl:variable name="ve" select="."/>
      				<!-- Check ID -->
		      		<xsl:if test="$new-form/multiple/ids-rule='set'">		  
		      			<xsl:if test="vzenv:check-ve-id($ve/id,$new-form/hn/eid,$new-form/hn/eid,concat('id_',$index))"/>
		      		</xsl:if>
		      		<!-- /Check ID -->
		      		<!-- Check name -->
							<xsl:if test="$new-form/multiple/names-rule='set'">
								<xsl:if test="vzenv:check-ves-name(
									$new-form/hn/eid,
									$ve,$index,$index
								)"/>
							</xsl:if>
							<!-- /Check name -->
		      		<!-- Check hostname -->
							<xsl:if test="$new-form/multiple/hostnames-rule='set'">
								<xsl:if test="vzenv:check-ves-hostname(
									$platform-ref,
									$ve,$index,$index
								)"/>
							</xsl:if>
							<!-- /Check hostname -->
      			</xsl:for-each>
      			<!-- /Check VE list -->			
      			<xsl:call-template name="vzenv:check-net-ifaces">
							<xsl:with-param name="env-form" select="$new-form"/>
						</xsl:call-template>
					</xsl:when>
				</xsl:choose>
				
				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$new-form"/>
				</xsl:call-template>
					
			</xsl:when>				
			
			<!-- Step "Network Interfaes" -->
			<xsl:when test="$step='net'">
			
				<!-- Restore form's data  -->
				<xsl:variable name="new-form-rtf">
					<xsl:for-each select="$form/*">
						<xsl:choose>
							<xsl:when test="name()='net'"></xsl:when>
							<xsl:otherwise>
								<xsl:copy-of select="."/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					<net>
						<xsl:if test="$form/net/hostname-taken or sw:param('next') or sw:param('ok') or $form/net/hostname!=string(sw:param('hostname'))">
							<hostname-taken/>
						</xsl:if>
						<xsl:call-template name="vzenv:restore-net-ifaces">
							<xsl:with-param name="env-form" select="$form"/>
						</xsl:call-template>
					</net>
				</xsl:variable>
				<!-- /Restore form's data  -->					
				
				<xsl:variable name="new-form" select="exsl:node-set($new-form-rtf)"/>
				
				<!-- Check data -->
				<xsl:choose>					
					<xsl:when test="sw:param('next') or sw:param('ok')">
						<xsl:call-template name="vzenv:check-net-ifaces">
							<xsl:with-param name="env-form" select="$new-form"/>
						</xsl:call-template>
					</xsl:when>
				</xsl:choose>
					
				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$new-form"/>
				</xsl:call-template>
					
			</xsl:when>
			
			<!-- Step "Apps" -->
			<xsl:when test="$step='apps'">
			
				<!-- Restore form's data  -->
				<xsl:variable name="new-form-rtf">
					<xsl:for-each select="$form/*">
						<xsl:choose>
							<xsl:when test="name()=$step"></xsl:when>
							<xsl:otherwise>
								<xsl:copy-of select="."/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					<apps>
						<xsl:copy-of select="vzenv:restore-apps()"/>
					</apps>
				</xsl:variable>
				<!-- /Restore form's data  -->					
				
				<xsl:variable name="new-form" select="exsl:node-set($new-form-rtf)"/>
					
				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$new-form"/>
				</xsl:call-template>
					
			</xsl:when>
			
			<!-- Step "Review" -->
			<xsl:when test="$step='review'">
				
				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$form"/>
				</xsl:call-template>
								
			</xsl:when>
			
		</xsl:choose>
		
		<xsl:copy/>
	</xsl:template>
	
	<func:function name="local:same-os-template">
		<xsl:param name="sample-os-name"/>
		<xsl:param name="selected-os-name"/>
		<xsl:param name="hn"/>
		<xsl:choose>
			<xsl:when test="$hn/linux">
				<func:result select="string($sample-os-name)=string($selected-os-name)"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:variable name="platform-ref" select="env:make-platform-ref($hn/eid, $hn/platform)"/>
				<xsl:variable name="is-old-w2k3" select="vz:is-old-win-os-name($sample-os-name, $platform-ref)"/>
				
				<func:result select="$is-old-w2k3 or string($sample-os-name)=string($selected-os-name)"/>					
			</xsl:otherwise>
		</xsl:choose>
	</func:function>
	
	<xsl:template name="local:completeFormHandling">
		<xsl:param name="data"/>		
		<!--|-->				
		<xsl:choose>
			<xsl:when test="(sw:param('next') or sw:param('ok')) and error:is-empty()">
				<!-- Handle "Next" Button -->
				<xsl:choose>
					<xsl:when test="wiz:isLastStep() or sw:param('ok')">
    				<xsl:choose>
							<xsl:when test="error:is-empty()">
								<xsl:if test="sw:sesputtree($wiz_data,$data)"/>
								<xsl:copy-of select="local:create-env($data)"/>
								<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>	
							</xsl:when>
		          <xsl:otherwise>
              	<packet/>
            	</xsl:otherwise>
          	</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="wiz:goNext()"/>
						<xsl:if test="sw:sesputtree($wiz_data,$data)"/>
					</xsl:otherwise>
				</xsl:choose>
				<!-- /Handle "Next" Button -->
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="sw:param('back')">
						<xsl:if test="wiz:goBack()"/>
					</xsl:when>
				</xsl:choose>
				<xsl:if test="sw:sesputtree($wiz_data,$data)"/>
			</xsl:otherwise>
		</xsl:choose>
					
	</xsl:template>
	
	
	<xsl:template name="local:generate-ve-items">
		<xsl:param name="index"/>
		<xsl:param name="total"/>
		
		<item/>
		<xsl:if test="$index &lt; $total">
			<xsl:call-template name="local:generate-ve-items">
				<xsl:with-param name="index" select="$index+1"/>
				<xsl:with-param name="total" select="$total"/>
			</xsl:call-template>
		</xsl:if>
		
	</xsl:template>
	
	<!-- Init wizard -->
	<func:function name="local:init-form">		
		<xsl:choose>
			<xsl:when test="$step = ''">
		
				<xsl:variable name="parent-wizard" select="sw:sesgettree('envs-new_wiz_data')"/>
				<xsl:variable name="old-form" select="sw:sesgettree($wiz_data)"/>
					
				<!-- Check, should we reset wizard data or use old data -->
				<xsl:if test="not($old-form) or string($old-form/wizard-id) ='' or $parent-wizard/wizard-id!=$old-form/wizard-id 
					or $parent-wizard/hn/eid!=$old-form/hn/eid
					or $parent-wizard/envs-count!=$old-form/envs-count
				">
			
					<!-- Init default data -->
					<xsl:variable name="hn-eid" select="$parent-wizard/hn/eid"/>			
					<xsl:variable name="envrequest-id" select="$parent-wizard/envrequest-id"/>
					<xsl:variable name="envrequest" select="requests:find-request($envrequest-id)"/>
					<xsl:variable name="vt-settings" select="envm:get-vt-settings($hn-eid)"/>			
					<xsl:variable name="system-settings" select="system:get-configuration($hn-eid)"/>			
					<xsl:variable name="voc-args">
						<category>capabilities</category>            
					</xsl:variable>
					<xsl:variable name="voc" select="voc:get($voc-args, env:make-platform-ref($hn-eid) )"/>
					<!-- /Init default data -->									
				
					<xsl:variable name="all-offline-service"  select="redirect:load($hn-eid)"/>
					
					<xsl:variable name="new_form">			
						<!-- copy data from common new code -->
						<xsl:copy-of select="$parent-wizard/wizard-id"/>					
						<xsl:copy-of select="$parent-wizard/hn-select"/>	
						<xsl:copy-of select="$parent-wizard/hn"/>	
						<xsl:copy-of select="$parent-wizard/envs-count"/>	
						<xsl:copy-of select="$parent-wizard/parent-folder"/>	
						<!-- /copy data from common new code -->
						<gen>
							<!-- Copy name from Request -->
							<xsl:if test="$envrequest">
								<name>
									<xsl:value-of select="$envrequest/requestEnvName"/>
								</name>
							</xsl:if>
							<!-- /Copy hostname from Request -->
							<start_after_create>1</start_after_create>
							<selected_offline_service/>
							<offline_type>default</offline_type>
							<!-- Copy password from Request -->
							<xsl:if test="$envrequest">
								<xsl:variable name="request-root-pasword" select="$envrequest/requestEnvPassword"/>
								<xsl:if test="$request-root-pasword!=''">
									<root_pwd>
										<xsl:value-of select="$request-root-pasword"/>
									</root_pwd>
									<root_pwd_re>
										<xsl:value-of select="$request-root-pasword"/>
									</root_pwd_re>
								</xsl:if>
							</xsl:if>
							<!-- /Copy password from Request -->
						</gen>
						<data>
						</data>
						<multiple>
							<names-rule>mask</names-rule>
							<hostnames-rule>mask</hostnames-rule>
							<ids-rule>auto</ids-rule>
						</multiple>
						<multiple-set>					
							<name>CT &lt;veid&gt;</name>
							<hostname>ct&lt;veid&gt;</hostname>
						</multiple-set>
						<permissions>
							<xsl:if test="$envrequest-id!=''">
								<xsl:variable name="ordering" select="requests:get-config()"/>
								<xsl:if test="$ordering/default-role!=''">
									<permission>
										<role><xsl:value-of select="$ordering/default-role"/></role>
										<user><xsl:value-of select="$envrequest/ownerSid"/></user>
									</permission>
								</xsl:if>
							</xsl:if>
						</permissions>
						<def>
							<xsl:if test="ips:pool-enabled()">
								<ips-pool-enabled/>	
							</xsl:if>
							<xsl:if test="$envrequest-id!=''">
								<order-id><xsl:value-of select="$envrequest-id"/></order-id>
								<request>
									<sample-id><xsl:value-of select="$envrequest/requestSampleId"/></sample-id>
									<hostname>
										<xsl:value-of select="$envrequest/requestEnvHostname"/>
									</hostname>									
								</request>
								<name>
									<xsl:value-of select="$envrequest/requestEnvName"/>
								</name>
							</xsl:if>
							<xsl:if test="$vt-settings/parameter[id='slm']/value='yes'">
								<slm-hn-enabled/>
							</xsl:if>
							<all_offline_service><xsl:copy-of select="$all-offline-service/service"/></all_offline_service>
							<voc-capabilities>
								<xsl:copy-of select="$voc"/>
							</voc-capabilities>
							<disk-quota-enabled><xsl:value-of select="sw:if($vt-settings/parameter[id='disk_quota']/value='yes','true','false')"/></disk-quota-enabled>
							<samples>
								<xsl:choose>
									<xsl:when test="$envrequest!=''">
										 <xsl:value-of select="$envrequest/requestSampleId"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:copy-of select="vz:default-samples()"/>
									</xsl:otherwise>
								</xsl:choose>
							</samples>
							<os_template>
								<xsl:copy-of select="exsl:node-set(vt:split-baseset($vt-settings/def_ostemplate))"/>
							</os_template>
							<xsl:variable name="first_ve_id" select="$vt-settings/vzprivrange"/>
							<ve_id>
								<xsl:choose>
									<xsl:when test="$first_ve_id!=''">
										<xsl:value-of select="number(substring-after($first_ve_id,' ')+1)"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="$system-settings/packet/data/global/configuration/pool/user_veid_range/end_veid"/>
									</xsl:otherwise>
								</xsl:choose>
							</ve_id>
							<end_veid><xsl:value-of select="$system-settings/packet/data/global/configuration/pool/user_veid_range/end_veid"/></end_veid>
						</def>
					</xsl:variable>
					<!-- Init steps -->
					<xsl:variable name="new-steps-rtf">						
						<step id="gen" 		screen-id="03.02.01.02.00"/>
						<step id="multiple" screen-id="03.02.01.02.01" enabled="{sw:if($parent-wizard/envs-count=1,'0','1')}"/>
						<step id="net" 		screen-id="03.02.01.02.05" enabled="{sw:if($parent-wizard/envs-count=1,'1','0')}"/>
						<step id="custom" 	screen-id="03.02.01.02.02"/>
						<step id="apps" 	screen-id="03.02.01.02.03"/>
						<step id="review" 	screen-id="03.02.01.02.04"/>
					</xsl:variable>
					<xsl:variable name="new-steps" select="exsl:node-set($new-steps-rtf)"/>
					<!-- Save wizard initial settings -->
					<xsl:if test="error:is-empty()">
						<xsl:variable name="new_step"		select="string($new-steps/step[1]/@id)"/>
						<xsl:variable name="s" select="sw:sesput($wiz_data,$new_form)"/>
						<xsl:variable name="s1" select="sw:sesput($wiz_steps,$new-steps)"/>
					</xsl:if>	
				</xsl:if>
				<!-- We should set first step in any case -->
				<xsl:if test="sw:sesput($wiz_step,'gen')"/>				
			</xsl:when>
		</xsl:choose>
		<func:result select="wiz:init-data()"/>
	</func:function>
	
	<!-- *********************************************************** -->
	
	<func:function name="local:create-env">
		<xsl:param name="data"/>
		<!--|-->
		<xsl:variable name="sample" select="env-samplem:get-sample($data/gen/config)"/>
		<!--|-->
		<xsl:choose>
			<!-- Create multiple VE -->
			<xsl:when test="$data/envs-count!=1">
				<func:result>
					<xsl:call-template name="action:make-packet">
						<xsl:with-param name="path" select="'actions//vzdir/infrman/envs/multicreate.xsl'"/>
						<xsl:with-param name="cookie">
							<msg>
								<sched><sw:text>The creation of the Container(s) has been scheduled.</sw:text></sched>
								<error><sw:text>Failed to create the Containers.</sw:text></error>
							</msg>
							<operation>ve_create</operation>
							<redirect-prev/>
						</xsl:with-param>
						<xsl:with-param name="input">
							<data>
								<xsl:copy-of select="$data/*"/>								
								<!-- Durty hacks to send email notifications -->
								<env>
									<vzcc-host>
										<xsl:value-of select="$request/http_request/env/parameter[name = 'HTTP_HOST']/value"/>
									</vzcc-host>
									<client-ip>
										<xsl:value-of select="$request/http_request/env/parameter[name = 'REMOTE_ADDR']/value"/>
									</client-ip>
									<ticket><xsl:value-of select="$ticket"/></ticket>
								</env>
								<!-- /Durty hacks to send email notifications -->
							</data>
						</xsl:with-param>
					</xsl:call-template>
				</func:result>
			</xsl:when>
			<!-- /Create multiple VE -->
			<!-- Create ONE VE -->
			<xsl:otherwise>
				<func:result>
					<xsl:call-template name="action:make-packet">
						<xsl:with-param name="path" select="'actions/vzdir/infrman/envs/create.xsl'"/>
						<xsl:with-param name="cookie">
							<msg>
								<sched><sw:text>The Containers have been scheduled for creation.</sw:text></sched>
								<error><sw:text>Failed to create the Container.</sw:text></error>
							</msg>
							<operation>ve_create</operation>
							<redirect-prev/>
						</xsl:with-param>
						<xsl:with-param name="input">
							<data>
								<xsl:copy-of select="$data/*"/>
								<!-- Durty hacks to send email notifications -->
								<env>
									<vzcc-host>
										<xsl:value-of select="$request/http_request/env/parameter[name = 'HTTP_HOST']/value"/>
									</vzcc-host>
								</env>
								<!-- /Durty hacks to send email notifications -->
							</data>
						</xsl:with-param>
					</xsl:call-template>
				</func:result>
			</xsl:otherwise>
			<!-- /Create ONE VE -->
		</xsl:choose>
		
	</func:function>
  <!-- credentials -->
  <sw:include href="/lib/cred.xsl"/>
		
	<sw:include href="/lib/wizard.xsl"/>
	<sw:include href="/lib/common.xsl"/>
	
	<sw:include href="/lib/vocabulary.xsl"/>		
	<sw:include href="/lib/vza/tem.xsl"/>	
	<sw:include href="/lib/vz/ubcs.xsl"/>	
	<sw:include href="/lib/vt/env-private.xsl"/> 
	<sw:include href="/lib/globals.xsl"/>
		
	
</xsl:stylesheet>
