<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred vzenv"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:vzenv="http://www.swsoft.com/xsl/cp/vzenv"
	xmlns:error="http://www.swsoft.com/xsl/cp/error"
>

	<xsl:output method="xml"/>

	<xsl:template match="/">

		<xsl:variable name="get-eid"
			select="sw:base64-decode(sw:param('id'))"/>
		<xsl:variable name="eid">
			<xsl:choose>
				<xsl:when test="$get-eid!=''">
					<xsl:value-of select="$get-eid"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="sw:ve-eid()"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="action-start"		select="sw:param('start_ve')"/>
		<xsl:variable name="action-suspend"		select="sw:param('suspend_ve')"/>
		<xsl:variable name="action-stop"		select="sw:param('stop_ve')"/>
		<xsl:variable name="action-fast-stop"	select="sw:param('fast_stop_ve')"/>
		<xsl:variable name="action-restart"		select="sw:param('restart_ve')"/>

		<xsl:if test="$action-start or $action-stop or $action-fast-stop or $action-restart or $action-suspend">
			<xsl:if test="cred:detail-check-env('vzcp.env.manage.start_stop',$eid)"/>
		</xsl:if>

		<!-- check premissions before execute request -->
		<xsl:if test="error:is-empty()">
			<xsl:choose>
				<xsl:when test="$action-start">
					<xsl:copy-of select="vzenv:cmd-start($eid)"/>
					<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>
				</xsl:when>

				<xsl:when test="$action-suspend">
					<xsl:copy-of select="vzenv:cmd-suspend($eid)"/>
					<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>
				</xsl:when>

				<xsl:when test="$action-stop | $action-fast-stop">
					<xsl:copy-of select="vzenv:cmd-stop($eid,$action-fast-stop)"/>
					<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>
				</xsl:when>

				<xsl:when test="$action-restart">
					<xsl:copy-of select="vzenv:cmd-restart($eid)"/>
					<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>
				</xsl:when>
			</xsl:choose>
		</xsl:if>
	</xsl:template>

	<!-- credentials -->

	<sw:include href="/lib/vz/vzenv-ctl.xsl"/>

	<sw:include href="/lib/cred.xsl"/>

	<sw:include href="/lib/common.xsl"/>
	<sw:include href="/lib/globals.xsl"/>

</xsl:stylesheet>
