<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->
<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func wiz cred error local check str env"
	xmlns:xsl				="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl			="http://exslt.org/common"
	xmlns:sw				="http://www.swsoft.com/xsl/cp"
	xmlns:error			="http://www.swsoft.com/xsl/cp/error"
	xmlns:wiz				="http://www.swsoft.com/xsl/cp/wiz"
  xmlns:func			="http://exslt.org/functions"	
	xmlns:cred			="http://www.swsoft.com/xsl/cp/cred"
	xmlns:local     ="http://www.swsoft.com/xsl/cp/local"
	xmlns:fwm				="http://www.swsoft.com/xsl/cp/fwm"
	xmlns:check     ="http://www.swsoft.com/xsl/cp/check"
	xmlns:str				="http://exslt.org/strings"
	xmlns:env				="http://www.swsoft.com/xsl/cp/env"	
>
	<sw:include href="/lib/vt/env-core.xsl"/>  

 <xsl:output method="xml"/>
	<xsl:variable name="eid" select="sw:ve-eid()"/>
 	<xsl:variable name="env" select="env:get-env($eid)"/>
	
	<!-- Load data -->
	<xsl:variable name="fwm-simple-rule-uniq-id-rtf">
		<xsl:for-each	select="sw:param('fwm-simple-rule-uniq-id')">
			<value>
				<xsl:value-of select="."/>
			</value>
		</xsl:for-each>
	</xsl:variable>
	<xsl:variable name="fwm-simple-rule-uniq-id" select="exsl:node-set($fwm-simple-rule-uniq-id-rtf)"/>

	<xsl:variable name="fwm-simple-rules" select="sw:sesget('fwm-simple-rules')"/>
	<xsl:variable name="fwm-rules" select="sw:sesget('fwm-rules')"/>
	
	<xsl:variable name="step" select="wiz:processing-step-id()"/>

	<xsl:param name="wiz_code" select="'ve-fwm-simple-rule'"/>
 	<xsl:variable name="form" select="local:init-form()"/>

	<xsl:template match="node()|@*">
		<xsl:choose>
			<!-- Step "Add" and "New" -->
			<xsl:when test="$step='edit' or $step='add'">
				<xsl:variable name="new_form_">
					<fwm-simple-rule-uniq-id>
						<xsl:copy-of select="$fwm-simple-rule-uniq-id"/>
					</fwm-simple-rule-uniq-id>
				</xsl:variable>

				<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>
				<xsl:if test="sw:param('next')">
					<!-- NO CHECK DATA, because no allowed edit user -->
				</xsl:if>

				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$new_form"/>
				</xsl:call-template>
			</xsl:when>			
		</xsl:choose>
		
		<xsl:copy/>
	</xsl:template>
	
	<xsl:template name="local:completeFormHandling">
		<xsl:param name="data"/>
		<!--|-->		
		<xsl:choose>
			<xsl:when test="sw:param('next') and error:is-empty()">
				<!-- Handle "Next" Button -->
				<xsl:choose>
					<xsl:when test="wiz:isLastStep()">
    				<xsl:choose>
							<xsl:when test="error:is-empty()">
								<xsl:if test="sw:sesputtree($wiz_data,$data)"/>
								<xsl:copy-of select="local:final($data)"/>
								<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>	
							</xsl:when>
		          <xsl:otherwise>
              	<packet/>
            	</xsl:otherwise>
          	</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="wiz:goNext()"/>
						<xsl:if test="sw:sesputtree($wiz_data,$data)"/>
					</xsl:otherwise>
				</xsl:choose>
				<!-- /Handle "Next" Button -->
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="sw:param('back')">
						<xsl:if test="wiz:goBack()"/>
					</xsl:when>
				</xsl:choose>
				<xsl:if test="sw:sesputtree($wiz_data,$data)"/>
			</xsl:otherwise>
		</xsl:choose>
					
	</xsl:template>
	
	<func:function name="local:init-form">
		<xsl:if test="$step = ''">
			<xsl:call-template name="local:init-new"/>				
 		</xsl:if>
		<func:result select="wiz:init-data()"/>
	</func:function>
 	
	<xsl:template name="local:init-new">
		<xsl:variable name="new_form" select="/.."/>
		<!-- Init steps -->
		<xsl:variable name="new_steps_">
			<step id="add" screen-id="03.02.01.18.08"	cred="vzcp.env.manage.services_and_files" security-obj-type="ve.vz.vt" screen-title="{sw:text('Add Rule')}"/>
		</xsl:variable>
		<!-- Save wizard initial settings -->
		<xsl:if test="error:is-empty()">
			<xsl:variable name="new_steps_filtered">
					<xsl:copy-of	select="exsl:node-set($new_steps_)/step[(not(@cred) or cred:check-env(@cred,$eid)) and (not(@platform) or (@platform = $platform))]"/>
			</xsl:variable>
			<xsl:variable name="new_steps" select="exsl:node-set($new_steps_filtered)"/>
			<xsl:variable name="new_step" select="string($new_steps/step[1]/@id)"/>
			<xsl:if test="sw:sesput($wiz_data,exsl:node-set($new_form))"/>
			<xsl:if test="sw:sesput($wiz_steps,$new_steps)"/>
			<xsl:if test="sw:sesput($wiz_step,$new_step)"/>
		</xsl:if>
	</xsl:template>
	
	<!-- *********************************************************** -->
	<func:function name="local:final">
		<xsl:param name="data"/>
		<!-- prepare form data to rule structure -->
		<func:result>
			<xsl:if test="error:is-empty()">
				<xsl:if test="cred:detail-check-env('vzcp.env.manage.services_and_files',$eid)"/>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="error:is-empty()">
					<xsl:copy-of select="fwm:simple-rule-add($fwm-rules,$fwm-simple-rules,$data/fwm-simple-rule-uniq-id)"/>
				</xsl:when>
				<xsl:otherwise>
					<packet/>
				</xsl:otherwise>
			</xsl:choose>
		</func:result>
	</func:function>

  <!-- credentials -->	
  <sw:include href="/lib/cred.xsl"/>
	
  <sw:include href="/lib/wizard.xsl"/>
  <sw:include href="/lib/common.xsl"/>
  <sw:include href="/lib/fwm.xsl"/>
  <sw:include href="/lib/vza/fwm.xsl"/>
  <sw:include href="/lib/vocabulary.xsl"/>				
	
</xsl:stylesheet>
