<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->
<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func wiz cred check local error action vzenv envm env hwm ips system vzapackagem"
	xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl			="http://exslt.org/common"
	xmlns:sw			="http://www.swsoft.com/xsl/cp"
	xmlns:error			="http://www.swsoft.com/xsl/cp/error"
	xmlns:check			="http://www.swsoft.com/xsl/cp/check"
	xmlns:wiz			="http://www.swsoft.com/xsl/cp/wiz"
	xmlns:local			="http://www.swsoft.com/xsl/cp/local"
	xmlns:func			="http://exslt.org/functions"	
	xmlns:cred			="http://www.swsoft.com/xsl/cp/cred"
	xmlns:action		="http://www.swsoft.com/xsl/cp/action"	
	xmlns:env			="http://www.swsoft.com/xsl/cp/env" 
	xmlns:ve			="http://www.swsoft.com/xsl/cp/ve" 
	xmlns:vzve			="http://www.swsoft.com/xsl/cp/vzve" 	
	xmlns:vzenv			="http://www.swsoft.com/xsl/cp/vzenv"	
	xmlns:envm			="http://www.swsoft.com/xsl/cp/envm"	
	xmlns:hwm			="http://www.swsoft.com/xsl/cp/hwm"	
	xmlns:env-samplem	="http://www.swsoft.com/xsl/cp/env-samplem"	
	xmlns:vzaconfig		="http://www.swsoft.com/xsl/cp/vzaconfig"
	xmlns:ips			="http://www.swsoft.com/xsl/cp/ips"
	xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
	xmlns:system		="http://www.swsoft.com/xsl/cp/system"
	xmlns:format="http://www.swsoft.com/xsl/cp/format"	
	xmlns:vzapackagem		="http://www.swsoft.com/xsl/cp/vzapackagem"
	xmlns:math			="http://exslt.org/math"
	xmlns:set			="http://exslt.org/sets" 
>
	<!-- UI modules -->
	<sw:include href="/lib/core/check-funcs.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>
	
	<!-- System modules -->
	
	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/common.xsl"/>
	<sw:include href="/lib/vocabulary.xsl"/>
	<sw:include href="/lib/utils/action.xsl"/>
	<sw:include href="/lib/utils/format-number.xsl"/>	
	
	<!-- VZA functionality modules -->	
	<sw:include href="/lib/swa/env-samplem.xsl"/>	
	<sw:include href="/lib/vzaconfig.xsl"/>

	<!-- Import required modules -->
	<sw:include href="/lib/swa/envm.xsl"/>
	<sw:include href="/lib/swa/system.xsl"/>
	<sw:include href="/lib/vt/ve-core.xsl"/>
	<sw:include href="/lib/vt/env-core.xsl"/>
	<sw:include href="/lib/vz/ips.xsl"/>
	<sw:include href="/lib/vz/vzenv-qos.xsl"/>	
	<sw:include href="/lib/vz/vzenv-net.xsl"/>
	<sw:include href="/lib/vza/vzapackagem.xsl"/>
	<!-- Import required modules -->

	<xsl:output method="xml"/>
	
	<xsl:param	  name="wiz_code"		select="'ve_change'"/>	
	<xsl:variable name="step"			select="wiz:processing-step-id()"/>
 	<xsl:variable name="form"			select="local:init-form()"/>

	<xsl:template match="node()|@*">
		<xsl:choose>
			<!-- Step "Start" -->
			<xsl:when test="$step='start'">
						
				<xsl:variable name="new_form_">
					<xsl:for-each select="$form/*">
						<xsl:choose>
							<xsl:when test="name()='action'"></xsl:when>
							<xsl:otherwise>
								<xsl:copy-of select="."/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					<action><xsl:value-of select="sw:param('_action')"/></action>
					<xsl:if test="sw:param('_action')='add_apps' and not($form/updates)">
						<updates>
							<xsl:for-each select="$form/def/env">
								<env>
									<xsl:copy-of select="eid|hn-eid|title" />
									<xsl:variable name="apps" select="vzapackagem:vztemplate-packages(apps/id)" />
									<xsl:copy-of
											select="vzapackagem:list-compatible4env(
													eid, 'app', true()
												)/packet/data/vzapackagem/packages/package[
														not(vzapackagem:is-os(.) or name=$apps/name)
													]" />


								</env>
							</xsl:for-each>
						</updates>
					</xsl:if>
				</xsl:variable>
				<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>
					
				<xsl:if test="sw:param('next')">
					<!-- CHECK DATA -->
					<!-- Check action -->
					<xsl:choose>
 					<!-- check presence -->
					<xsl:when test="string($new_form/action)=''">
						<xsl:value-of select="error:put(sw:text('You should specify some action.'),'','action')"/>
					</xsl:when>
					</xsl:choose>
					<!-- /Check action -->
					<!-- /CHECK DATA -->
				</xsl:if>
					
				<xsl:if test="wiz:setStepsEnabledExcept('start',false())"/>
				<xsl:choose>
					<xsl:when test="$new_form/action='apply'">
						<xsl:if test="wiz:setStepEnabled('apply',true())"/>
						<xsl:if test="wiz:setStepEnabled('apply_qos',true())"/>
					</xsl:when>
					<xsl:when test="$new_form/action='config'">
						<xsl:if test="wiz:setStepEnabled('config',true())"/>
					</xsl:when>
					<xsl:when test="$new_form/action='apps'">
						<xsl:if test="wiz:setStepEnabled('apps',true())"/>
					</xsl:when>
					<xsl:when test="$new_form/action='add_apps'">
						<xsl:if test="wiz:setStepEnabled('add_apps',true())"/>
						<xsl:if test="wiz:setStepEnabled('add_apps_review',true())"/>
					</xsl:when>
					<xsl:when test="$new_form/action='del_apps'">
						<xsl:if test="wiz:setStepEnabled('del_apps',true())"/>
					</xsl:when>
						<xsl:when test="$new_form/action='autoupgrade'">
						<xsl:if test="wiz:setStepEnabled('autoupgrade',true())"/>
					</xsl:when>
					<xsl:when test="$new_form/action='disk'">
						<xsl:if test="wiz:setStepEnabled('disk',true())"/>
					</xsl:when>
					<xsl:when test="$new_form/action='res'">
						<xsl:if test="wiz:setStepEnabled('res',true())"/>
					</xsl:when>
					<xsl:when test="$new_form/action='res'">
						<xsl:if test="wiz:setStepEnabled('res',true())"/>
					</xsl:when>
					<xsl:when test="$new_form/action='res'">
						<xsl:if test="wiz:setStepEnabled('res',true())"/>
					</xsl:when>
				</xsl:choose>
									
				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$new_form"/>
				</xsl:call-template>
					
			</xsl:when>
			
			<!-- Step "Apply" -->
			<xsl:when test="$step='apply'">
				<xsl:variable name="new-sample-id" select="sw:param('sample-id')"/>
				<xsl:variable name="new_form_">
					<xsl:choose>
						<!-- Copy non-changed options -->
						<xsl:when test="$new-sample-id='' or $new-sample-id=$form/apply/sample-id">
							<xsl:copy-of select="$form/*"/>
						</xsl:when>
						<!-- Sample was chaned, fill options -->
						<xsl:otherwise>
							<xsl:copy-of select="$form/*[not(self::apply)]"/>
							<xsl:variable name="sample" select="env-samplem:get-sample($new-sample-id)"/>
							<apply>
								<sample-id><xsl:value-of select="$new-sample-id"/></sample-id>
								<slm-mode>
									<xsl:value-of select="$sample/env_config/slm_mode"/>
								</slm-mode>
								<!-- copy olf restart value -->
								<xsl:copy-of select="$form/apply/*[self::restart]"/>
							</apply>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>
				<xsl:if test="sw:param('next')">
					<!-- CHECK DATA -->
					<!-- Check action -->
					<xsl:choose>
						<!-- check presence -->
						<xsl:when test="$new_form/apply/sample-id=''">
						<xsl:value-of select="error:put(sw:text('You should specify some Container sample.'),'','sample-id')"/>
					</xsl:when>
					</xsl:choose>
					<!-- /Check action -->
					<!-- /CHECK DATA -->
				</xsl:if>

				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$new_form"/>
				</xsl:call-template>

			</xsl:when>
			
			<!-- Step "Apply/QoS" -->
			<xsl:when test="$step='apply_qos'">
				<xsl:variable name="new_form_">
					<xsl:copy-of select="$form/*[not(self::apply)]"/>
					<apply>
						<xsl:copy-of select="$form/apply/*[not(self::selected-res or self::restart)]"/>
						<restart><xsl:value-of select="sw:param('restart')"/></restart>
						<selected-res>
							<xsl:call-template name="vzve:restore-qos-selector">
								<xsl:with-param name="platform-ref" select="env:make-platform-ref('',$form/def/platform)"/>	
								<xsl:with-param name="slm-mode" select="$form/apply/slm-mode"/>
							</xsl:call-template>
						</selected-res>
					</apply>
				</xsl:variable>
				<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>
				<xsl:if test="sw:param('next')">
					<!-- CHECK DATA -->
					<!-- Check qos -->
					<xsl:if test="not($new_form/apply/selected-res/*)">
						<xsl:value-of select="error:put(sw:text('You should select at least one resource.'))"/>
					</xsl:if>
					<!-- /Check qos -->
					<!-- /CHECK DATA -->
				</xsl:if>

				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$new_form"/>
				</xsl:call-template>

			</xsl:when>
			
			<!-- Step "Configure" -->
			<xsl:when test="$step='config'">

					<xsl:variable name="new_form_">
						<xsl:for-each select="$form/*">
							<xsl:choose>
								<xsl:when test="name()='config'"></xsl:when>
								<xsl:otherwise>
									<xsl:copy-of select="."/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
						<config>
							<start><xsl:value-of select="sw:param('start')"/></start>
							<offline><xsl:value-of select="sw:param('offline')"/></offline>
							<enabled><xsl:value-of select="sw:param('enabled')"/></enabled>
						</config>
					</xsl:variable>
					<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>

					<xsl:if test="sw:param('next')">
						<!-- CHECK DATA -->
						<xsl:if test="count($new_form/config/*[.!=''])=0">
							<xsl:if test="error:put(sw:text('You should change at least one parameter.'),'','')"/>	
						</xsl:if>
						<!-- /CHECK DATA -->
					</xsl:if>

					<xsl:call-template name="local:completeFormHandling">
						<xsl:with-param name="data" select="$new_form"/>
					</xsl:call-template>

			</xsl:when>

			<!-- Step "Apps" -->
			<xsl:when test="$step='apps'">

				<xsl:variable name="data" select="$request/http_request/*[self::post or self::get]/parameter[starts-with(name,'__')]"/>
				<xsl:variable name="new_form_">
					<xsl:for-each select="$form/*">
						<xsl:choose>
							<xsl:when test="name()='apps'"></xsl:when>
							<xsl:otherwise>
								<xsl:copy-of select="."/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					<apps>
						<xsl:for-each select="$data[name= '__app']/value[.!='']">
							<xsl:variable name="pos" select="."/>
								<app>
									<pos><xsl:value-of select="$pos"/></pos>
									<os><xsl:value-of select="$data[name = concat('__app_os_',$pos)]/value"/></os>
									<name><xsl:value-of select="$data[name = concat('__app_name_',$pos)]/value"/></name>
									<version><xsl:value-of select="$data[name = concat('__app_ver_',$pos)]/value"/></version>
									<ve>
										<id><xsl:value-of select="$data[name = concat('__app_ve_',$pos)]/value"/></id>
										<hw><xsl:value-of select="$data[name = concat('__app_hw_',$pos)]/value"/></hw>
									</ve>
								</app>
						</xsl:for-each>
						<xsl:for-each select="$data[name = '__ve_up']">
							<ve-up>
								<id><xsl:value-of select="substring-before(value,'|')"/></id>
								<hw><xsl:value-of select="substring-after(value,'|')"/></hw>
							</ve-up>
						</xsl:for-each>
						<force><xsl:value-of select="sw:param('force')"/></force>
						<jump><xsl:value-of select="sw:param('jump')"/></jump>
						<options><xsl:value-of select="sw:param('options')"/></options>
					</apps>
				</xsl:variable>
				<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>

					<xsl:if test="sw:param('next')">
						<!-- CHECK DATA -->
						<!--
						<xsl:if test="not($new_form/apps/app[version!=''])">
							<xsl:if test="error:put(sw:text('You should specify at least one upgrade.'),'','')"/>	
						</xsl:if>
						-->
						<!-- /CHECK DATA -->
					</xsl:if>
					
					<xsl:call-template name="local:completeFormHandling">
						<xsl:with-param name="data" select="$new_form"/>
					</xsl:call-template>

			</xsl:when>
			
			<!-- Step "Change VEs Resources settings" -->
			<xsl:when test="$step='res'">

				<!-- Prepare data -->
				<xsl:variable name="platform-ref" select="env:make-platform-ref($form/def/hn[1]/eid)"/>
				<xsl:variable name="conv-data-rtf">	
					<slm-mode>all</slm-mode>
				</xsl:variable>
				<xsl:variable name="qos-rtf">
					<xsl:call-template name="vzenv:conv-qos-data">
						<xsl:with-param name="platform-ref" select="$platform-ref"/>
						<xsl:with-param name="data" select="exsl:node-set($conv-data-rtf)"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:variable name="qos" select="exsl:node-set($qos-rtf)/ui:qos-data"/>
				<!-- /Prepare data -->

				<xsl:variable name="new_form_">
					<xsl:copy-of select="$form/*[not(self::res)]"/>
					<res>
						<slm-mode><xsl:value-of select="sw:param('slm')"/></slm-mode>
						<!-- Process all resources with non-empty action -->
						<data>
							<!-- slm for vzenv-qos functions -->
							<slm-mode>all</slm-mode>
							<xsl:for-each select="$qos/ui:qos-category/ui:qos-param[sw:param(concat('at_',@id))!='']">
								<xsl:variable name="res" select="."/>
								<xsl:variable name="id" select="@id"/>
								<xsl:variable name="real-id" select="@real-id"/>
	
								<xsl:variable name="action" select="sw:param(concat('at_',$id))"/>										
								<xsl:variable name="factor" select="sw:param(concat('m_',$id))"/>		
								
								<res>
									<id><xsl:value-of select="$real-id"/></id>
									<action><xsl:value-of select="$action"/></action>
									<xsl:choose>
										<xsl:when test="$action='unlimited'">
											<xsl:if test="$qos/platform-linux and not(@soft-off='true')">
												<soft><xsl:value-of select="@hard-unlimited"/></soft>										
											</xsl:if>
											<hard><xsl:value-of select="@hard-unlimited"/></hard>
										</xsl:when>
										<xsl:otherwise>
											<xsl:if test="$qos/platform-linux and not(@soft-off='true')">
												<soft>
													<xsl:value-of select="format:str2int(sw:param(concat('s_',$id)), $factor)"/>
												</soft>
											</xsl:if>
											<hard>
												<xsl:value-of select="format:str2int(sw:param(concat('h_',$id)), $factor)"/>
											</hard>
										</xsl:otherwise>
									</xsl:choose>
									<!-- Set special flag for sw:checkQoS()  -->
									<xsl:if test="$action!='limited'">
										<check-only-number/>
									</xsl:if>
								</res>
							</xsl:for-each>
						</data>
					</res>
				</xsl:variable>
				<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>

				<xsl:if test="sw:param('next')">
					<!-- CHECK DATA -->
					<xsl:if test="sw:checkQoS($platform-ref,$new_form/res/data,'all')"/>
					<xsl:if test="not($new_form/res/slm-mode!='') and not($new_form/res/data/res)">
						<xsl:if test="error:put(sw:text('You should change at least one parameter.'),'','')"/>	
					</xsl:if>
					<!-- /CHECK DATA -->					
				</xsl:if>
					
				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$new_form"/>
				</xsl:call-template>

			</xsl:when>

			<!-- Step "autoupgrade" -->
			<xsl:when test="$step='autoupgrade'">

					<xsl:variable name="data" select="$request/http_request/*[self::post or self::get]/parameter[starts-with(name,'__')]"/>
					<xsl:variable name="new_form_">
						<xsl:for-each select="$form/*">
							<xsl:choose>
								<xsl:when test="name()='autoupgrade'"></xsl:when>
								<xsl:otherwise>
									<xsl:copy-of select="."/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
						<autoupgrade>
							<confirm><xsl:value-of select="boolean(sw:param('confirm')='1')"/></confirm>
							<start><xsl:value-of select="boolean(sw:param('start')='1')"/></start>
							<force><xsl:value-of select="boolean(sw:param('force')='1')"/></force>
							<options><xsl:value-of select="sw:param('options')"/></options>
						</autoupgrade>
					</xsl:variable>
					<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>
					
					<xsl:if test="sw:param('next')">
						<!-- CHECK DATA -->
						<xsl:if test="not($new_form/autoupgrade/confirm='true')">
							<xsl:if test="error:put(sw:text('You should confirm the Containers upgrading.'),'','')"/>	
						</xsl:if>
						<!-- /CHECK DATA -->
					</xsl:if>
					
					<xsl:call-template name="local:completeFormHandling">
						<xsl:with-param name="data" select="$new_form"/>
					</xsl:call-template>

			</xsl:when>	
			
			<!-- Step "Disk" -->
			<xsl:when test="$step='disk'">
						
				<xsl:variable name="new_form_">
					<xsl:for-each select="$form/*">
						<xsl:choose>
							<xsl:when test="name()='disk'"></xsl:when>
							<xsl:otherwise>
								<xsl:copy-of select="."/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					<disk>						
						<stat-simple><xsl:value-of select="sw:param('stat_sample')"/></stat-simple>
						<show-stat><xsl:value-of select="sw:param('show_stat')"/></show-stat>
						<quota>
							<method><xsl:value-of select="sw:param('quota')"/></method>
							<set>
								<value><xsl:value-of select="sw:param('quota_set_value')"/></value>
								<unit><xsl:value-of select="sw:param('quota_set_unit')"/></unit>
							</set>
							<add>
								<value><xsl:value-of select="sw:param('quota_add_value')"/></value>
								<unit><xsl:value-of select="sw:param('quota_add_unit')"/></unit>
							</add>
							<dec>
								<value><xsl:value-of select="sw:param('quota_dec_value')"/></value>
								<unit><xsl:value-of select="sw:param('quota_dec_unit')"/></unit>
							</dec>
						</quota>
						<inodes>
							<method><xsl:value-of select="sw:param('inodes')"/></method>
							<newdelta>
								<value><xsl:value-of select="sw:param('inodes_newdelta_value')"/></value>
							</newdelta>
							<set>
								<value><xsl:value-of select="sw:param('inodes_set_value')"/></value>
							</set>
						</inodes>
					</disk>
				</xsl:variable>
				<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>
				
				<xsl:if test="sw:param('next')">
					<!-- CHECK DATA -->
					<xsl:choose>
						<!-- Check Disk Quota Controls -->
						<xsl:when test="$new_form/disk/quota/method='set'">
							<xsl:choose>
								<xsl:when test="$new_form/disk/quota/set/value=''">
									<xsl:if test="error:put(sw:text('The Disk Quota field cannot be blank.'),'','quota_set_value')"/>	
								</xsl:when>
								<xsl:when test="not(check:res($new_form/disk/quota/set/value,'',true()))">
									<xsl:if test="error:put(sw:text('The Disk Quota field can only contain a number or a soft:hard value.'),'','quota_set_value')"/>	
								</xsl:when>
							</xsl:choose>
						</xsl:when>
						<xsl:when test="$new_form/disk/quota/method='add'">
							<xsl:choose>
								<xsl:when test="$new_form/disk/quota/add/value=''">
									<xsl:if test="error:put(sw:text('The Disk Quota field cannot be blank.'),'','quota_add_value')"/>	
								</xsl:when>
								<xsl:when test="not(check:res($new_form/disk/quota/add/value,'',true()))">
									<xsl:if test="error:put(sw:text('The Disk Quota field can only contain a number or a soft:hard value.'),'','quota_add_value')"/>	
								</xsl:when>
							</xsl:choose>
						</xsl:when>
						<xsl:when test="$new_form/disk/quota/method='dec'">
							<xsl:choose>
								<xsl:when test="$new_form/disk/quota/dec/value=''">
									<xsl:if test="error:put(sw:text('The Disk Quota field cannot be blank.'),'','quota_dec_value')"/>	
								</xsl:when>
								<xsl:when test="not(check:res($new_form/disk/quota/dec/value,'',true()))">
									<xsl:if test="error:put(sw:text('The Disk Quota field can only contain a number or a soft:hard value.'),'','quota_dec_value')"/>	
								</xsl:when>
							</xsl:choose>
						</xsl:when>
						<!-- /Check Disk Quota Controls -->
					</xsl:choose>
					<xsl:if test="$form/def/linux">
						<xsl:choose>
							<!-- Check Disk Inodes Controls -->
							<xsl:when test="$new_form/disk/inodes/method='newdelta'">
								<xsl:choose>
									<xsl:when test="$new_form/disk/inodes/newdelta/value=''">
										<xsl:if test="error:put(sw:text('An inodes density should be specified.'),'','inodes_newdelta_value')"/>	
									</xsl:when>
								</xsl:choose>
							</xsl:when>
							<xsl:when test="$new_form/disk/inodes/method='set'">
								<xsl:choose>
									<xsl:when test="$new_form/disk/inodes/set/value=''">
										<xsl:if test="error:put(sw:text('The Disk Inodes field cannot be blank.'),'','inodes_set_value')"/>	
									</xsl:when>
									<xsl:when test="not(check:res($new_form/disk/inodes/set/value,'',true()))">
										<xsl:if 
											test="error:put(sw:text('The Disk Inodes field can only contain a number or a soft:hard value.'),'','inodes_set_value')"/>
									</xsl:when>
								</xsl:choose>
							</xsl:when>
							<!-- /Check Disk Inodes Controls -->
						</xsl:choose>
					</xsl:if>
					<!-- /CHECK DATA -->
				</xsl:if>
				
				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$new_form"/>
				</xsl:call-template>
					
			</xsl:when>						
			<!-- /Step "Disk" -->
			
			<!-- Step "Add Apps" -->
			<xsl:when test="$step='add_apps'">
				<xsl:variable name="new_form_">
					<xsl:for-each select="$form/*">
						<xsl:choose>
							<xsl:when test="name()='add_apps'"></xsl:when>
							<xsl:otherwise>
								<xsl:copy-of select="."/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					
					<xsl:variable name="apps" select="sw:param('apps')"/>
					<add_apps>
						<nodes>
							<xsl:apply-templates select="$apps" mode="local:selected-nodes"/>
						</nodes>
						<updates>
							<xsl:apply-templates select="$apps" mode="local:parse-apps"/>
						</updates>
						<start><xsl:value-of select="sw:param('start')"/></start>
					</add_apps>	
				</xsl:variable>
				<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>

					<xsl:if test="sw:param('next')">
						<!-- CHECK DATA -->
						<xsl:if test="not($new_form/add_apps/updates/update)">
							<xsl:if test="error:put(sw:text('You should specify at least one application.'),'','')"/>	
						</xsl:if>
						<!-- /CHECK DATA -->
					</xsl:if>
					
					<xsl:call-template name="local:completeFormHandling">
						<xsl:with-param name="data" select="$new_form"/>
					</xsl:call-template>

			</xsl:when>
			
			<xsl:when test="$step='add_apps_review'">
				<xsl:variable name="new_form_">
					<xsl:for-each select="$form/*">
						<xsl:choose>
							<xsl:when test="name()='add_apps_review'"></xsl:when>
							<xsl:otherwise>
								<xsl:copy-of select="."/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
				</xsl:variable>
				<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>

				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$new_form"/>
				</xsl:call-template>

			</xsl:when>
			
						
			<!-- Step "Del Apps" -->
			<xsl:when test="$step='del_apps'">

				<xsl:variable name="data" select="$request/http_request/*[self::post or self::get]/parameter[starts-with(name,'__')]"/>
				<xsl:variable name="new_form_">
					<xsl:for-each select="$form/*">
						<xsl:choose>
							<xsl:when test="name()='del_apps'"></xsl:when>
							<xsl:otherwise>
								<xsl:copy-of select="."/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					<del_apps>
						<start><xsl:value-of select="sw:param('start')"/></start>
						<xsl:variable name="apps" select="sw:param('apps')"/>
						<nodes>
							<xsl:apply-templates select="$apps" mode="local:selected-nodes"/>
						</nodes>
						<updates>
							<xsl:apply-templates select="$apps" mode="local:parse-apps"/>
						</updates>
					</del_apps>
				</xsl:variable>
				<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>

				<xsl:call-template name="local:completeFormHandling">
					<xsl:with-param name="data" select="$new_form"/>
				</xsl:call-template>

			</xsl:when>
			
			
		</xsl:choose>
		
		<xsl:copy/>
	</xsl:template>
	
	<xsl:template match="get" mode="local:selected-nodes">
		<node-id><xsl:value-of select="."/></node-id>
	</xsl:template>

	<xsl:template match="get[contains(substring-after(., '/'), '/') and $form/action='add_apps']" mode="local:parse-apps">
		<xsl:variable name="id" select="substring-after(., '/')"/>
		<xsl:variable name="name" select="substring-before($id, '/')"/>
		<xsl:variable name="eid" select="substring-after($id, '/')"/>
		<xsl:variable name="env" select="$form/updates/env[eid=$eid]"/>
		
		<xsl:variable name="versions" select="$env/package[name=$name]"/> 
		<xsl:variable name="pkg" 
						select="$versions[not(version) or version=math:max($versions/version)]"/>
		<xsl:if test="$pkg">
			<update>
				<eid><xsl:value-of select="$eid"/></eid>
				<hn-eid><xsl:value-of select="$env/hn-eid"/></hn-eid>
				<xsl:copy-of select="$pkg"/>
			</update>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="get[contains(substring-after(., '/'), '/') and $form/action='del_apps']" mode="local:parse-apps">
		<xsl:variable name="id" select="substring-after(., '/')"/>
		<xsl:variable name="name" select="substring-before($id, '/')"/>
		<xsl:variable name="eid" select="substring-after($id, '/')"/>
		<xsl:variable name="env" select="$form/def/env[eid=$eid]"/>

		<xsl:variable name="versions" select="vzapackagem:vztemplate-packages($env/apps/id)[name=$name]"/>
		<xsl:variable name="pkg" 
						select="$versions[not(version) or version=math:max($versions/version)]"/>
		<xsl:if test="$pkg">
			<update>
				<eid><xsl:value-of select="$eid"/></eid>
				<hn-eid><xsl:value-of select="$env/hn-eid"/></hn-eid>
				<xsl:copy-of select="$pkg"/>
			</update>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="local:completeFormHandling">
		<xsl:param name="data"/>
		<!--|-->		
		<xsl:if test="sw:sesputtree($wiz_data,$data)"/>	
		<!--|-->				
		<xsl:choose>
			<xsl:when test="sw:param('next') and error:is-empty()">
				<!-- Handle "Next" Button -->
				<xsl:choose>
					<xsl:when test="wiz:isLastStep()">
    				<xsl:choose>
							<xsl:when test="error:is-empty()">
								<xsl:copy-of select="local:get-final-packet($data)"/>
								<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>	
							</xsl:when>
		          <xsl:otherwise>
								<packet/>
            	</xsl:otherwise>
          	</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="wiz:goNext()"/>
					</xsl:otherwise>
				</xsl:choose>
				<!-- /Handle "Next" Button -->
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="sw:param('back')">
						<xsl:if test="wiz:goBack()"/>
					</xsl:when>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
					
	</xsl:template>
	
	<func:function name="local:init-form">
		<xsl:if test="$step = ''">
			<xsl:call-template name="local:init-new"/>				
 		</xsl:if>
		<func:result select="wiz:init-data()"/>
	</func:function>
 	
	<func:function name="local:eid2node">
		<xsl:variable name="rtf">
			<eid><xsl:value-of select="sw:ve-eid()"/></eid>
		</xsl:variable>
		<func:result select="exsl:node-set($rtf)/eid"/>
	</func:function>
	
	<xsl:template name="local:env-info">
		<xsl:param name="eid"/>
		<xsl:variable name="env" select="env:get-env($eid)/env"/>
		<xsl:variable name="info" select="env:env2info($env)"/>
		<xsl:variable name="apps" select="vzapackagem:generate-ids(
				vzapackagem:get-env-templates($env)[not(vzapackagem:is-os(.))])"/>
		<env>
			<xsl:copy-of select="$info"/>
			<apps>
				<xsl:copy-of select="$apps"/>
			</apps>
		</env>
	</xsl:template>
	
	<func:function name="local:eids2envs">
		<xsl:param name="eids"/>
		<xsl:variable name="res">
			<xsl:for-each select="$eids">
				<xsl:call-template name="local:env-info">
					<xsl:with-param name="eid" select="."/>
				</xsl:call-template>
			</xsl:for-each>
		</xsl:variable>
		<func:result select="exsl:node-set($res)/env"/>
	</func:function>
	
	<xsl:template name="local:init-new">
		<!-- Init default data -->

		<xsl:variable name="vt-settings" select="envm:get-vt-settings(sw:master-eid())"/>		
		<xsl:variable name="vzaconfig" select="system:get-configuration()"/>			
		<xsl:variable name="in-cluster" select="$vzaconfig/packet/data/global/configuration/master"/>			
		
		<xsl:variable name="start-tab" select="sw:param('tab')"/>
		<xsl:variable name="eids" select="sw:if(
			$start-tab='apps',
			local:eid2node(),
			ve:post2eids()
		)"/>
		
		<xsl:variable name="envs" select="local:eids2envs($eids)"/>
		<xsl:variable name="new_form">
		
			<!-- Upgrade on current VE -->
			<xsl:if test="$start-tab!=''">
				<start-tab><xsl:value-of select="$start-tab"/></start-tab>
				<action><xsl:value-of select="$start-tab"/></action>
			</xsl:if>
			<def>
				<xsl:for-each select="$envs">
					<xsl:if test="not(preceding-sibling::node()/platform=current()/platform)">
						<xsl:copy-of select="*[self::platform or self::linux or self::windows]"/>
					</xsl:if>
				</xsl:for-each>
				<xsl:copy-of select="$envs"/>
				<xsl:if test="ips:pool-enabled()">
					<ips-pool-enabled/>
				</xsl:if>
				<ve_id>
					<xsl:variable name="first_ve_id" select="$vt-settings/parameter[id='vzprivrange']/value"/>
					<xsl:choose>
						<xsl:when test="$first_ve_id!=''">
							<xsl:value-of select="number(substring-after($first_ve_id,' ')+1)"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$vzaconfig/packet/data/global/configuration/pool/user_veid_range/end_veid"/>
						</xsl:otherwise>
					</xsl:choose>
				</ve_id>
				<xsl:variable name="hns" select="env:get-env(ve:group-by-hn($envs))/env"/>
				<xsl:for-each select="$hns">
					<hn>
						<eid><xsl:value-of select="eid"/></eid>
						<hostname><xsl:value-of select="config/hostname"/></hostname>
					</hn>
				</xsl:for-each>
			</def>
			<apply>
				<copy-slm>1</copy-slm>
			</apply>
			<disk>
				<stat-simple>1</stat-simple>
				<inodes>
					<newdelta>
						<value><xsl:value-of select="$config/vzcpcon/defines/inodes-density"/></value>
					</newdelta>
				</inodes>
				<quota>
					<set>
						<unit>1024</unit><!-- MB by default -->
					</set>
					<add>
						<unit>1024</unit><!-- MB by default -->					
					</add>
					<dec>
						<unit>1024</unit><!-- MB by default -->					
					</dec>
				</quota>
			</disk>
			<res>
				<data>
					<slm-mode>all</slm-mode>
				</data>
			</res>
		</xsl:variable>
		<!-- Init steps -->
		<xsl:variable name="new_steps_">
			<xsl:choose>
				<xsl:when test="$start-tab='apps'">
					<step id="apps" screen-id="03.02.01.31.05" screen-title="{sw:text('Update Software')}"/>
				</xsl:when>
				<xsl:otherwise>
					<step id="start"	screen-id="03.02.01.31.01"/>
					<step id="apply"	screen-id="03.02.01.31.03"/>
					<step id="apply_qos"	screen-id="03.02.01.31.09"/>					
					<step id="config"	screen-id="03.02.01.31.04"/>
					<step id="apps"		screen-id="03.02.01.31.05"/>
					<step id="res"		screen-id="03.02.01.31.10"/>	
					<step id="disk"		screen-id="03.02.01.31.06"/>
					<step id="autoupgrade" screen-id="03.02.01.31.07"/>
					<step id="add_apps" screen-id="03.02.01.31.11"/>
					<step id="add_apps_review" screen-id="03.02.01.31.12"/>
					<step id="del_apps" screen-id="03.02.01.31.13"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Save wizard initial settings -->
		<xsl:if test="error:is-empty()">
			<xsl:variable name="new_steps" select="exsl:node-set($new_steps_)"/>
			<xsl:variable name="new_step" select="string($new_steps/step[1]/@id)"/>
			<xsl:if test="sw:sesput($wiz_data,exsl:node-set($new_form))"/>
			<xsl:if test="sw:sesput($wiz_steps,$new_steps)"/>
			<xsl:if test="sw:sesput($wiz_step,$new_step)"/>
		</xsl:if>
	</xsl:template>
	
	<!-- *********************************************************** -->
	<func:function name="local:get-final-packet">
		<xsl:param name="data"/>
		<!--|-->
		<func:result>
			<xsl:choose>
				<xsl:when test="$data/action='apply'">
					<xsl:call-template name="action:make-packet">
						<xsl:with-param name="path" select="'actions/vzdir/infrman/envs/group-change/apply.xsl'"/>
						<xsl:with-param name="cookie">
							<msg>
								<sched><sw:text>Applying the Container sample has been scheduled.</sw:text></sched>
								<error><sw:text>Failed to apply the Container sample to the Containers.</sw:text></error>
							</msg>
							<operation>ve_groupchange_apply</operation>
							<redirect-prev/>
						</xsl:with-param>
						<xsl:with-param name="input">
							<data>
								<xsl:copy-of select="$data/def/env"/>
								<xsl:copy-of select="$data/def/platform"/>	
								<xsl:copy-of select="$data/apply"/>
							</data>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="$data/action='config'">
					<xsl:call-template name="action:make-packet">
						<xsl:with-param name="path" select="'actions/vzdir/infrman/envs/group-change/config.xsl'"/>
						<xsl:with-param name="cookie">
							<msg>
								<sched><sw:text>Configuring the Containers has been scheduled.</sw:text></sched>
								<error><sw:text>Failed to configure the Containers.</sw:text></error>
							</msg>
							<operation>ve_groupchange_config</operation>
							<redirect-prev/>
						</xsl:with-param>
						<xsl:with-param name="input">
							<data>
								<xsl:copy-of select="$data/def/env"/>	
								<xsl:copy-of select="$data/def/platform"/>	
								<xsl:copy-of select="$data/config"/>
							</data>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="$data/action='disk'">
					<xsl:call-template name="action:make-packet">
						<xsl:with-param name="path" select="'actions/vzdir/infrman/envs/group-change/disk.xsl'"/>
						<xsl:with-param name="cookie">
							<msg>
								<sched><sw:text>The Containers have been scheduled for configuring.</sw:text></sched>
								<error><sw:text>Failed to configure the Containers.</sw:text></error>
							</msg>
							<operation>ve_groupchange_disk</operation>
							<redirect-prev/>
						</xsl:with-param>
						<xsl:with-param name="input">
							<data>
								<xsl:copy-of select="$data/def/env"/>	
								<xsl:copy-of select="$data/def/platform"/>	
								<xsl:copy-of select="$data/disk/*"/>
							</data>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="$data/action='apps'">
					<xsl:choose>
						<xsl:when test="$data/apps/app">
							<xsl:call-template name="action:make-packet">
								<xsl:with-param name="path" select="'actions/vzdir/infrman/envs/group-change/apps.xsl'"/>
								<xsl:with-param name="cookie">
									<msg>
										<sched><sw:text>Updating the Containers software has been scheduled.</sw:text></sched>
										<error><sw:text>Failed to update the Containers.</sw:text></error>
									</msg>
									<operation>ve_groupchange_apps</operation>
									<redirect-prev/>
								</xsl:with-param>
								<xsl:with-param name="input">
									<data>
										<xsl:copy-of select="$data/def/env"/>	
										<xsl:copy-of select="$data/def/platform"/>	
										<xsl:copy-of select="$data/apps"/>
									</data>
								</xsl:with-param>
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<packet>
								<cookie>
									<redirect-prev/>
								</cookie>
							</packet>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:when test="$data/action='res'">
					<xsl:call-template name="action:make-packet">
						<xsl:with-param name="path" select="'actions/vzdir/infrman/envs/group-change/res.xsl'"/>
						<xsl:with-param name="cookie">
							<msg>
								<sched><sw:text>Updating the Containers resource settings has been scheduled.</sw:text></sched>
								<error><sw:text>Failed to update the Containers.</sw:text></error>
							</msg>
							<operation>ve_groupchange_es</operation>
							<redirect-prev/>
						</xsl:with-param>
						<xsl:with-param name="input">
							<data>
								<xsl:copy-of select="$data/def/env"/>	
								<xsl:copy-of select="$data/def/platform"/>	
								<xsl:copy-of select="$data/res"/>
							</data>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="$data/action='add_apps'">
					<xsl:choose>
						<xsl:when test="$data/add_apps/updates/update">
							<xsl:call-template name="action:make-packet">
								<xsl:with-param name="path" select="'actions/vzdir/infrman/templates/mass-app-install.xsl'"/>
								<xsl:with-param name="cookie">
									<msg>
										<sched><sw:text>Adding the application templates to the Containers has been scheduled.</sw:text></sched>
										<error><sw:text>Failed to add the application templates to the Containers.</sw:text></error>
									</msg>
									<operation>ve_groupchange_add_apps</operation>
									<redirect-prev/>
								</xsl:with-param>
								<xsl:with-param name="input">
									<data>
										<xsl:if test="$data/add_apps/start='1'">
											<start/>
										</xsl:if>
										<xsl:for-each select="set:distinct($data/add_apps/updates/update/eid)">
											<xsl:variable name="eid" select="."/>
											<env>
												<eid><xsl:value-of select="."/></eid>
												<hn-eid><xsl:value-of select="$data/def/env[eid=$eid]/hn-eid"/></hn-eid>
												<xsl:copy-of select="vzapackagem:generate-ids($data/add_apps/updates/update[
																			eid=$eid
																		]/package, 'app-id')"/>
											</env>
										</xsl:for-each>
									</data>
								</xsl:with-param>
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<packet>
								<cookie>
									<redirect-prev/>
								</cookie>
							</packet>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:when test="$data/action='del_apps'">
					<xsl:choose>
						<xsl:when test="$data/del_apps/updates/update">
							<xsl:call-template name="action:make-packet">
								<xsl:with-param name="path" select="'actions/vzdir/infrman/templates/mass-app-uninstall.xsl'"/>
								<xsl:with-param name="cookie">
									<msg>
										<sched><sw:text>Removing the application templates from the Containers has been scheduled.</sw:text></sched>
										<error><sw:text>Failed to remove the application templates from the Containers.</sw:text></error>
									</msg>
									<operation>ve_groupchange_del_apps</operation>
									<redirect-prev/>
								</xsl:with-param>
								<xsl:with-param name="input">
									<data>
										<xsl:if test="$data/del_apps/start='1'">
											<start/>
										</xsl:if>
										<xsl:for-each select="set:distinct($data/del_apps/updates/update/eid)">
											<xsl:variable name="eid" select="."/>
											<env>
												<eid><xsl:value-of select="."/></eid>
												<hn-eid><xsl:value-of select="$data/def/env[eid=$eid]/hn-eid"/></hn-eid>
												<xsl:copy-of select="vzapackagem:generate-ids($data/del_apps/updates/update[
																			eid=$eid
																		]/package, 'app-id')"/>
											</env>
										</xsl:for-each>
									</data>
								</xsl:with-param>
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<packet>
								<cookie>
									<redirect-prev/>
								</cookie>
							</packet>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:when test="$data/action='autoupgrade'">
					<xsl:call-template name="action:make-packet">
						<xsl:with-param name="path" select="'actions/vzdir/infrman/envs/group-change/autoupgrade.xsl'"/>
						<xsl:with-param name="cookie">
							<msg>
								<sched><sw:text>The Containers have been scheduled for upgrading.</sw:text></sched>
								<error><sw:text>Failed to update the Container(s).</sw:text></error>
							</msg>
							<operation>ve_groupchange_autoupgrade</operation>
							<redirect-prev/>
						</xsl:with-param>
						<xsl:with-param name="input">
							<data>
								<xsl:copy-of select="$data/def/env"/>	
								<xsl:copy-of select="$data/def/platform"/>	
								<xsl:copy-of select="$data/autoupgrade/*"/>	
							</data>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:when>

			</xsl:choose>
		</func:result>
	</func:function>

</xsl:stylesheet>
