<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl sw func vzapackagem cred local"
	exclude-result-prefixes="sw exsl sw func cred local"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp" 
	xmlns:func="http://exslt.org/functions"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred" 
	xmlns:vzapackagem="http://www.swsoft.com/xsl/cp/vzapackagem" 
	xmlns:local="http://www.swsoft.com/xsl/cp/local"
	xmlns:error="http://www.swsoft.com/xsl/cp/error">
	
	<sw:include href="/lib/common.xsl" />
	<sw:include href="/lib/vt/env-core.xsl" />
	<sw:include href="/lib/vza/vzapackagem.xsl" />
	
	<xsl:output method="xml" />

	<!-- Init wizard data -->
	<xsl:template match="node()|@*">
		<xsl:variable name="eid" select="sw:ve-eid()"/>
		<xsl:choose>
			<xsl:when test="sw:param('ve_upgrade')">
				<xsl:call-template name="local:packet-template">
					<xsl:with-param name="command" select="'update'" />
					<xsl:with-param name="rpms" select="/.." />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="sw:param('upgrade')">
				<xsl:variable name="rpms" select="sw:param('id')" />

				<xsl:call-template name="local:packet-template">
					<xsl:with-param name="command" select="'update'" />
					<xsl:with-param name="rpms" select="$rpms" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="sw:param('uninstall')">
				<xsl:variable name="rpms" select="sw:param('id')" />

				<xsl:call-template name="local:packet-template">
					<xsl:with-param name="command" select="'remove'" />
					<xsl:with-param name="rpms" select="$rpms" />
				</xsl:call-template>
			</xsl:when>
		</xsl:choose>
		<packet>
			<cookie>
				<redirect-last/>
			</cookie>
		</packet>
		<xsl:if test="sw:response('lib/opredirect.xsl')"/>
	</xsl:template>
	
	<xsl:template name="local:packet-template">
		<xsl:param name="rpms" />
		<xsl:param name="command" />
		
		<xsl:variable name="eid" select="sw:ve-eid()"/>
		<xsl:variable name="packet-id" select="sw:generate-id()"/>
		
		<xsl:if test="vzapackagem:clear-rpms-cache($eid)" />
		
		<xsl:if test="sw:sesput(concat('ve-update-action-id.', $eid), $packet-id)"/>
		<xsl:if test="sw:sesput(concat('ve-update-action-report.', $eid), $packet-id)"/>
		<xsl:if test="sw:sesput(concat('ve-update-action-type.', $eid), $command)"/>
		
		<xsl:variable name="msg">
			<xsl:choose>
				<xsl:when test="$command='update'">
					<sw:text>The software packages have been successfully scheduled for update.</sw:text>
				</xsl:when>
				<xsl:when test="$command='remove'">
					<sw:text>The software packages have been successfully scheduled for removal.</sw:text>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		
		<xsl:if test="sw:sesput('sched', $msg)"/>
		<xsl:if test="sw:sesput('operation_id', $packet-id)"/>
		
		<xsl:variable name="data">
			<xsl:call-template name="vzapackagem:action-packet">
				<xsl:with-param name="packet-id" select="$packet-id" />
				<xsl:with-param name="hn-eid" select="sw:ve-parent($eid)" />
				<xsl:with-param name="target-eid" select="$eid" />
				<xsl:with-param name="command" select="$command" />
				<xsl:with-param name="progress" select="true()	" />
				<xsl:with-param name="app-id" select="$rpms"/>
			</xsl:call-template>
		</xsl:variable>
		
		<xsl:variable name="res" select="sw:send($data, $packet-id)"/>
	</xsl:template>
	
</xsl:stylesheet>
