<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred vzenv"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl	="http://exslt.org/common"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:error	="http://www.swsoft.com/xsl/cp/error"
	xmlns:cred	="http://www.swsoft.com/xsl/cp/cred"
	xmlns:env		="http://www.swsoft.com/xsl/cp/env"	
	xmlns:vzenv	="http://www.swsoft.com/xsl/cp/vzenv"
  >

	<xsl:output method="xml"/>

	<sw:include href="/lib/vt/env-core.xsl"/>
	<sw:include href="/lib/vz/vzenv-core.xsl"/>

	<xsl:template match="/">
		<!-- Detect VE ID -->
		<xsl:variable name="eid">
			<xsl:choose>
				<xsl:when test="sw:param('id')">
					<xsl:value-of select="string(sw:param('id'))"/>
				</xsl:when>
				<xsl:otherwise>
					<sw:die>
						VE ID is not specified.
					</sw:die>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:if test="cred:detail-check-env('vzcp.env.manage.services.login',$eid)"/>
		
		<xsl:variable name="env-info" select="env:eid2info($eid)"/>

		<xsl:variable name="now-env" select="vzenv:set-current($eid,true())"/>

		<xsl:choose>
			<xsl:when test="$env-info/linux">
				<packet>
					<cookie>
						<redirect><xsl:value-of select="concat($baseurl,'/vzdir/infrman/envs/services/ssh')"/></redirect>
					</cookie>
				</packet>
				<xsl:if test="sw:response('lib/opredirect.xsl')"/>
			</xsl:when>
			<xsl:when test="$env-info/windows">
				<packet>
					<cookie>
						<redirect><xsl:value-of select="concat($baseurl,'/vzdir/infrman/envs/services/rdp')"/></redirect>
					</cookie>
				</packet>
				<xsl:if test="sw:response('lib/opredirect.xsl')"/>			
			</xsl:when>
			<xsl:otherwise>
				<packet>
					<cookie>
						<error>
							<sw:text>
								<xsl:with-param name="platform" select="$env-info/platform"/>								
								Cannot log in to the selected Container, the %{platform} OS is not supported
							</sw:text>
						</error>
					</cookie>
				</packet>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- credentials -->
	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/common.xsl"/>

</xsl:stylesheet>
