<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred func vzenv servicem"
	xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl	="http://exslt.org/common"
	xmlns:sw		="http://www.swsoft.com/xsl/cp"
	xmlns:error	="http://www.swsoft.com/xsl/cp/error"
	xmlns:cred	="http://www.swsoft.com/xsl/cp/cred"
	xmlns:servicem   ="http://www.swsoft.com/xsl/cp/servicem"
	xmlns:func	="http://exslt.org/functions"	
	xmlns:vzenv		="http://www.swsoft.com/xsl/cp/vzenv"
>
	<sw:include href="/lib/swa/servicem.xsl"/>
	<sw:include href="/lib/vz/vzenv-core.xsl"/>

	<xsl:output method="xml"/>

	<xsl:variable name="eid" select="sw:ve-eid()" />	
	<xsl:variable name="returl"	select="$requesturl"/>
	
	<xsl:template match="/">		
		<packet/>
		<!-- all action put in lib -->

		<xsl:variable name="name" select="sw:param('name')"/>
		<xsl:variable name="services-rtf">
				<xsl:for-each select="$name">
					<service>
						<xsl:variable name="one-name-info" select="sw:split(sw:base64-decode(.),'|')"/>
						<name>
							<xsl:value-of select="$one-name-info[1]"/>
						</name>
						<display-name>
							<xsl:value-of select="$one-name-info[2]"/>	
						</display-name>
					</service>
				</xsl:for-each>
		</xsl:variable>
		<xsl:variable name="services" select="exsl:node-set($services-rtf)"/>

		<xsl:choose>
			<xsl:when test="not(sw:param('start') or sw:param('stop') or sw:param('restart') )">
				<!-- no action specified -->
			</xsl:when>
			<xsl:when test="count($services/service) = 0">
				<xsl:if test="error:put(sw:text('Please select at least one service.'),'')"/>
			</xsl:when>

			<xsl:when test="sw:param('start')">
				<xsl:if test="error:is-empty()">
					<xsl:if test="cred:detail-check-env('vzcp.env.manage.services_and_files',$eid)"/>
				</xsl:if>
				<xsl:if test="error:is-empty()">
					<xsl:copy-of select="servicem:win-service-start($eid,$services)"/>
					<xsl:if test="sw:response('lib/opredirect.xsl')"/>	
				</xsl:if>
			</xsl:when>

			<xsl:when test="sw:param('restart')">
				<xsl:if test="error:is-empty()">
					<xsl:if test="cred:detail-check-env('vzcp.env.manage.services_and_files',$eid)"/>
				</xsl:if>
				<xsl:if test="error:is-empty()">
					<xsl:copy-of select="servicem:win-service-restart($eid,$services)"/>
					<xsl:if test="sw:response('lib/opredirect.xsl')"/>	
				</xsl:if>
			</xsl:when>

			<xsl:when test="sw:param('stop')">
				<xsl:if test="error:is-empty()">
					<xsl:if test="cred:detail-check-env('vzcp.env.manage.services_and_files',$eid)"/>
				</xsl:if>
				<xsl:if test="error:is-empty()">
					<xsl:copy-of select="servicem:win-service-stop($eid,$services)"/>
					<xsl:if test="sw:response('lib/opredirect.xsl')"/>	
				</xsl:if>
			</xsl:when>

		</xsl:choose>
	</xsl:template>
	
	<!-- creds  -->
	<sw:include href="/lib/cred.xsl"/>	
	<sw:include href="/lib/common.xsl"/>		
		
</xsl:stylesheet>
