<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet
	version="1.0"
	extension-element-prefixes="sw exsl cred vzenv"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:vzenv="http://www.swsoft.com/xsl/cp/vzenv"
	xmlns:vzapackagem="http://www.swsoft.com/xsl/cp/vzapackagem"
	xmlns:error="http://www.swsoft.com/xsl/cp/error"
>

	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/common.xsl"/>
	<sw:include href="/lib/vza/vzapackagem.xsl"/>
	
	<xsl:template match="/">
		<sw:noauth-redirect select="not(cred:check-env('vzcp.env.manage.properties.application', sw:ve-eid()))"/>
		<xsl:variable name="updates" select="sw:sesget('vzapackagem-list-ve-updates')"/> 
		<xsl:choose>
			<xsl:when test="sw:param('list')='1'">
				<packet>
					<cookie><list/></cookie>
					<xsl:if test="not($updates='')">
						<has-updates>
							<xsl:copy-of select="$updates"/>
						</has-updates>
					</xsl:if>
					<autoupgrade>
						<confirm>false</confirm>
						<force>false</force>
						<options>0</options>
					</autoupgrade>
				</packet>	
			</xsl:when>
			<xsl:when test="sw:param('next') and sw:param('confirm')='1'">
				<xsl:if test="vzapackagem:clear-rpms-cache(sw:ve-eid())"/>
				<xsl:call-template name="vzapackagem:update-ve-packet">
					<xsl:with-param name="eid" select="sw:ve-eid()"/>
					<xsl:with-param name="cookie">
						<cookie>
							<msg>
								<sched>
									<sw:text>The upgrade of the Container software has been scheduled.</sw:text>
								</sched>
								<error>
									<sw:text>Failed to upgrade the Container software.</sw:text>
								</error>
							</msg>
							<operation>upgrade_ve</operation>
							<redirect-prev/>
						</cookie>
					</xsl:with-param>
					<xsl:with-param name="log" select="true()"/>
					<xsl:with-param name="progress" select="true()"/>
					<xsl:with-param name="force" select="sw:param('force')='1'"/>
				</xsl:call-template>
				<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>
			</xsl:when>
			<xsl:when test="sw:param('next')">
				<xsl:if test="error:put(sw:text('You should confirm the Containers upgrading.'),'','confirm')"/>
				<packet>
					<cookie><list/></cookie>
					<xsl:if test="not($updates='')">
						<has-updates>
							<xsl:copy-of select="$updates[not(self::empty)]"/>
						</has-updates>
					</xsl:if>
					<autoupgrade>
						<confirm><xsl:value-of select="boolean(sw:param('confirm')='1')"/></confirm>
						<force><xsl:value-of select="boolean(sw:param('force')='1')"/></force>
						<options><xsl:value-of select="sw:param('options')"/></options>
					</autoupgrade>
				</packet>	
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="vzapackagem:clear-rpms-cache(sw:ve-eid())"/>
				<xsl:if test="sw:sesput('vzapackagem-list-ve-updates', /..)"/>
				<packet/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
