<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->
<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func wiz env envtmpl tem cred check xsi local env-samplem error envm hwm system voc vt vzenv vz"
	xmlns:xsl				="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl			="http://exslt.org/common"
	xmlns:xsi			="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:sw				="http://www.swsoft.com/xsl/cp"
	xmlns:error			="http://www.swsoft.com/xsl/cp/error"
	xmlns:check			="http://www.swsoft.com/xsl/cp/check"
	xmlns:wiz				="http://www.swsoft.com/xsl/cp/wiz"
	xmlns:env				="http://www.swsoft.com/xsl/cp/env"
	xmlns:envtmpl		="http://www.swsoft.com/xsl/cp/envtmpl"
	xmlns:local			="http://www.swsoft.com/xsl/cp/local"
	xmlns:tem				="http://www.swsoft.com/xsl/cp/tem"
	xmlns:hwm				="http://www.swsoft.com/xsl/cp/hwm"
	xmlns:envm			="http://www.swsoft.com/xsl/cp/envm"
	xmlns:env-samplem		="http://www.swsoft.com/xsl/cp/env-samplem"
  xmlns:func			="http://exslt.org/functions"	
	xmlns:cred			="http://www.swsoft.com/xsl/cp/cred"
	xmlns:voc				="http://www.swsoft.com/xsl/cp/voc"
	xmlns:system		="http://www.swsoft.com/xsl/cp/system"
	xmlns:vzenv			="http://www.swsoft.com/xsl/cp/vzenv"
	xmlns:sample		="http://www.swsoft.com/xsl/cp/sample"	
	xmlns:vzsample	="http://www.swsoft.com/xsl/cp/vzsample"
	xmlns:vt				="http://www.swsoft.com/xsl/cp/vt"
	xmlns:hn				="http://www.swsoft.com/xsl/cp/hn"	
	xmlns:ve				="http://www.swsoft.com/xsl/cp/ve"	
	xmlns:vz				="http://www.swsoft.com/xsl/cp/vz"
>	
  <!-- Includes -->	
	<!-- UI modules -->
	<sw:include href="/lib/swa/system.xsl"/>
	<sw:include href="/lib/swa/envm.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>
	
	<!-- System modules -->	
  <sw:include href="/lib/cred.xsl"/>
  <sw:include href="/lib/common.xsl"/>
 	<sw:include href="/lib/core/check-funcs.xsl"/> 
  <sw:include href="/lib/vocabulary.xsl"/>				
  
  <!-- VZCC functionality modules -->	
  <sw:include href="/lib/vt/core.xsl"/>
  <sw:include href="/lib/vt/ve-core.xsl"/>
  <sw:include href="/lib/vt/hn-core.xsl"/> 
  
	<sw:include href="/lib/vz/core.xsl"/>
	<sw:include href="/lib/vz/vzenv-apps.xsl"/>
	<sw:include href="/lib/vz/vzenv-os.xsl"/>	
	<sw:include href="/lib/vz/vzenv-qos.xsl"/>
	<sw:include href="/lib/vz/vzenv-offline.xsl"/>
	
	<sw:include href="/lib/vz/sample-net-ui.xsl"/>

	
	<!-- SWA functionality modules -->	
	<sw:include href="/lib/swa/env-samplem.xsl"/>
	<sw:include href="/lib/swa/envm.xsl"/>	
	
	<!-- VZA functionality modules -->	
	<sw:include href="/lib/vza/hwm.xsl"/>	
			
	<!-- /Includes -->	
	
	<xsl:output method="xml"/>
	<xsl:param name="wiz_code" select="'envsamples-manage'"/>

  <xsl:variable name="step" select="wiz:processing-step-id()"/>	
  <xsl:variable name="form" select="local:init-form()"/>		
	<xsl:variable name="edit-mode" select="$form/sample-id"/>	

	<xsl:template match="node()|@*">
		<xsl:choose>
		
			<!-- Step "Start" -->
			<xsl:when test="$step='start'">

					<!-- init src variables -->
					<xsl:variable name="src-type" select="sw:param('src_type')"/>
					<xsl:variable name="src-env-eid" select="sw:param('src_env_eid')"/>					
					<xsl:variable name="src-sample-id" select="sw:param('src_sample_id')"/>
					<xsl:variable name="src-zero-platform" select="sw:param('src_zero_platform')"/>
					
					<xsl:variable name="src-changed" select="
						not($form/gen/*) or 
						$src-type!=$form/src-select/type or
						($src-type='sample' and $src-sample-id!=$form/src-select/sample-id)  or
						($src-type='env' and $src-env-eid!=$form/src-select/env-eid)  or
						($src-type='zero' and $src-zero-platform!=$form/src-select/platform)
					"/>
					
					<xsl:variable name="new_form_">
						<xsl:for-each select="$form/*">
							<xsl:choose>
								<xsl:when test="name()='src-select'"></xsl:when>
								<xsl:when test="$src-changed and (
									self::gen or self::platform or self::net or
									self::qos or self::os_template or 
									self::apps or self::other or self::other_env_config
								)"></xsl:when>	
								<xsl:otherwise>
									<xsl:copy-of select="."/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
						<src-select>
							<type><xsl:value-of select="$src-type"/></type>
							<env-eid><xsl:value-of select="$src-env-eid"/></env-eid>
							<sample-id><xsl:value-of select="$src-sample-id"/></sample-id>
							<platform><xsl:value-of select="$src-zero-platform"/></platform>
						</src-select>											
						<!-- Copy data from source -->
						<xsl:if test="$src-changed">							
							<xsl:choose>
								<!-- Copy data from Src Sample -->
								<xsl:when test="$src-type='sample' and $src-sample-id!=''">
									<xsl:variable name="sample" select="env-samplem:get-sample($src-sample-id)"/>
									<xsl:variable name="sample-platform" select="sample:sample2platform($sample)"/>
									<xsl:variable name="template-offline-service"  select="$sample/env_config/offline_service"/>
									<xsl:variable name="offline-type" select="vzenv:get-offline-type($sample/env_config/offline_management,$template-offline-service)"/>
									<gen>
										<name>
											<xsl:value-of select="concat('CreatedFrom',$sample/name)"/>
										</name>
										<comment><xsl:value-of select="sw:base64-decode($sample/comment)"/></comment>
										<start_after_boot><xsl:value-of select="$sample/env_config/on_boot"/></start_after_boot>
										<selected_offline_service>
											<xsl:for-each select="$template-offline-service">
												<value>
													<xsl:value-of select="."/>
												</value>
											</xsl:for-each>
										</selected_offline_service>
										<offline_type><xsl:value-of select="$offline-type"/></offline_type>
									</gen>
									<platform>
										<xsl:value-of select="$sample-platform"/>
									</platform>		
									<net>
										<xsl:call-template name="vzsample:config2net">
											<xsl:with-param name="config" select="$sample"/>
										</xsl:call-template>
									</net>
									<xsl:copy-of select="$sample/env_config/os_template"/>
									<!-- Copy QoS from  -->
									<qos>
										<slm-mode>
											<xsl:value-of select="$sample/env_config/slm_mode"/>										
										</slm-mode>										
										<xsl:for-each select="$sample/env_config/qos">
					  					<res>
					  						<xsl:copy-of select="node()"/>
					  						<soft_src><xsl:value-of select="soft"/></soft_src>
					  						<hard_src><xsl:value-of select="hard"/></hard_src>
					  					</res>
					  				</xsl:for-each>
					  			</qos>
					  			<!-- Copy Application Samples from sample config -->
									<apps>
										<xsl:for-each select="$sample/env_config/template[*]">
											<app>
												<name><xsl:value-of select="name"/></name>
												<xsl:if test="version">
													<xsl:copy-of select="version"/>
												</xsl:if>
											</app>
										</xsl:for-each>
									</apps>
									<!-- /Copy Application Samples from sample config -->
									<!-- Copy Other Data from sample config -->
									<xsl:call-template name="local:copy-config">
										<xsl:with-param name="sample" select="$sample"/>
									</xsl:call-template>									
				  			</xsl:when>
				  			<!-- /Copy data from Src Sample -->
				  			<!-- Copy data from Src Env -->
				  			<xsl:when test="$src-type='env' and $src-env-eid!=''">	
									<xsl:variable name="env" select="env:get-env($src-env-eid)/env"/>
									<xsl:variable name="src-platform" select="ve:ve2platform($env)"/>									
									<gen>
										<start_after_boot><xsl:value-of select="$env/virtual_config/on_boot"/></start_after_boot>
										<name>
											<xsl:value-of select="concat('CreatedFromCT',
												sw:if($env/virtual_config/name!='',$env/virtual_config/name,$env/virtual_config/hostname)
											)"/>
										</name>						
										<config/>
									</gen>
									<platform>
										<xsl:value-of select="$src-platform"/>
									</platform>
									<net>
										<xsl:call-template name="vzsample:ve-config2net">
											<xsl:with-param name="config" select="$env"/>
										</xsl:call-template>
									</net>
									<xsl:copy-of select="$env/virtual_config/os_template"/>
									<qos>
										<slm-mode>
											<xsl:value-of select="$env/virtual_config/slm_mode"/>
										</slm-mode>										
										<xsl:for-each select="$env/virtual_config/qos">
					  					<res>
					  						<xsl:copy-of select="node()"/>
					  						<soft_src><xsl:value-of select="soft"/></soft_src>
					  						<hard_src><xsl:value-of select="hard"/></hard_src>
					  					</res>
					  				</xsl:for-each>
					  			</qos>
					  			<other_env_config>
					  				<type>virtuozzo</type>
					  				<os>
					  					<platform><xsl:value-of select="sample:platform2vza($src-platform)"/></platform>
					  				</os>
										<architecture><xsl:value-of select="vt:platform2vza-architecture($src-platform)"/></architecture>														  				
					  			</other_env_config>
					  			<other>
					  				<vt_version>
											<platform><xsl:value-of select="vt:platform2vza($src-platform)"/></platform>
											<architecture><xsl:value-of select="vt:platform2vza-architecture($src-platform)"/></architecture>									
											<vt_technology>virtuozzo</vt_technology>
										</vt_version>
					  			</other>
				  			</xsl:when>
				  			<!-- /Copy data from Src Env -->	
				  			<!-- Init data for platform -->
				  			<xsl:when test="$src-type='zero'">	
									<xsl:variable name="env" select="env:get-env($src-env-eid)/env"/>
									<gen>
										<name>
											<xsl:value-of select="concat('CreatedFromCT',
												sw:if($env/virtual_config/name!='',$env/virtual_config/name,$env/virtual_config/hostname)
											)"/>
										</name>
										<config/>
									</gen>
									<platform><xsl:value-of select="$src-zero-platform"/></platform>
									<net>
										<xsl:call-template name="vzsample:init-net-ifaces">
											<xsl:with-param name="sample-platform" select="$src-zero-platform"/>
										</xsl:call-template>
									</net>
									<other_env_config>
					  				<type>virtuozzo</type>
									</other_env_config>
				  			</xsl:when>
				  			<!-- /Init data for platform -->
		  				</xsl:choose>							
						</xsl:if>
						<!-- /Copy data from source -->
					</xsl:variable>					
					<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>
					
					<xsl:if test="sw:param('next')">
						<!-- Check data -->
						<!-- check src sample  -->
			      <xsl:choose>
				      <xsl:when test="$new_form/src-select/type='sample' and $new_form/src-select/sample-id=''">
				      	<xsl:value-of select="error:put(sw:text('You should specify the original configuration sample.'),'','src_sample_id')"/>
				      </xsl:when>
				    </xsl:choose>
				    <!-- check src env -->
			      <xsl:choose>
				      <xsl:when test="$new_form/src-select/type='env' and $new_form/src-select/env-eid=''">
				      	<xsl:value-of select="error:put(sw:text('You should specify a source.'),'','src_env_eid')"/>
				      </xsl:when>
				    </xsl:choose>
				    <!-- check src platform -->
			      <xsl:choose>
				      <xsl:when test="$new_form/src-select/type='zero' and $new_form/src-select/platform=''">
				      	<xsl:value-of select="error:put(sw:text('You should specify a platform.'),'','src_platform')"/>
				      </xsl:when>
				    </xsl:choose>
					</xsl:if>
					
					<xsl:call-template name="local:complete-form-handling">
						<xsl:with-param name="data" select="$new_form"/>
					</xsl:call-template>
					
			</xsl:when>
		
			<!-- Step "General Settings" -->
			<xsl:when test="$step='gen'">


					<xsl:variable name="new_form_">
						<xsl:for-each select="$form/*">
							<xsl:choose>
								<xsl:when test="self::gen or self::os_template or self::slm"></xsl:when>
								<xsl:otherwise>
									<xsl:copy-of select="."/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
						<gen>
							<name><xsl:value-of select="sw:param('name')"/></name>
							<comment><xsl:value-of select="sw:param('comment')"/></comment>
							<start_after_boot><xsl:value-of select="sw:param('start_after_boot')"/></start_after_boot>
							<offline_type><xsl:value-of select="sw:param('offline_type')"/></offline_type>
							<selected_offline_service>
								<xsl:variable name="selected-services" select="sw:param('selected_offline_service')"/>
								<xsl:for-each select="$selected-services">
									<value><xsl:value-of select="string(.)"/></value>
								</xsl:for-each>
							</selected_offline_service>
							<show_adv><xsl:value-of select="sw:param('show_adv')"/></show_adv>
							<show_offline><xsl:value-of select="sw:param('show_offline')"/></show_offline>
						</gen>
						<xsl:copy-of select="vzenv:restore-os()"/>
					</xsl:variable>					
					<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>
					
					<xsl:if test="sw:param('next')">
						<!-- Check data -->
						<!-- check name -->						
						<xsl:variable name="name-pattern" select="voc:get-pattern(
							env:make-platform-ref('',$form/platform)
							,'pattern.vesampleconfig')" />
						<xsl:variable name="name-error" select="check:get-voc-pattern-match-error(
							env:make-platform-ref('',$form/platform),$new_form/gen/name, 'pattern.vesampleconfig'
						)" />
						
			      <xsl:choose>
 				      <!-- check name presence -->
				      <xsl:when test="$name-error and $name-error[name()='short']">
				      	<xsl:value-of select="error:put(sw:text('You should specify a name.'),'','name')"/>
				      </xsl:when>
				      <!-- check name for max.length -->
				      <xsl:when test="$name-error and $name-error[name()='long']">
				      	<xsl:variable name="err-msg">
				      		<sw:text>
				      			<xsl:with-param name="max" select="$name-pattern/max" />
				      			The sample name cannot be longer than %max characters.
				      		</sw:text>
				      	</xsl:variable>
				      	<xsl:value-of select="error:put($err-msg,'','name')"/>
				      </xsl:when>
				      <!-- check name for valid chars -->
				      <xsl:when test="$name-error">
				      	<xsl:value-of select="error:put(sw:text('The specifed name contains a white space or other invalid characters.'),'','name')"/>
				      </xsl:when>				      
				      <xsl:when test="$new_form/gen/offline_type = 'custom' and count($new_form/gen/selected_offline_service/value) = 0">
				        <xsl:if test="error:put(sw:text('Select at least one service for custom offline management.'),'','selected_offline_service')"/>
							</xsl:when>
						</xsl:choose>
					</xsl:if>
					
					<xsl:call-template name="local:complete-form-handling">
						<xsl:with-param name="data" select="$new_form"/>
					</xsl:call-template>
					
			</xsl:when>
				
			<!-- Step "QoS" -->
			<xsl:when test="$step='qos'">

				<xsl:variable name="platform-ref" select="env:make-platform-ref('',$form/platform)"/>
			
				<!-- Restore form's data  -->
				<xsl:variable name="qos" select="exsl:node-set(sw:restoreQoS($platform-ref,$form/qos))"/>
				
				<xsl:variable name="new_form_">
					<xsl:for-each select="$form/*">
						<xsl:choose>
							<xsl:when test="name()='qos'"></xsl:when>
							<xsl:otherwise>
								<xsl:copy-of select="."/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					<qos>
						<xsl:copy-of select="$qos"/>
					</qos>
				</xsl:variable>
				<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>
				<!-- /Restore form's data  -->
			
				<xsl:choose>
					<xsl:when test="sw:param('validate')">
						<!-- Validate QoS -->
						<xsl:if test="sw:checkQoS($platform-ref,$qos)"/>
					</xsl:when>	
					<xsl:when test="sw:param('next')">
						<!-- Check data -->
						<xsl:if test="sw:checkQoS($platform-ref,$qos)"/>						
					</xsl:when>
				</xsl:choose>
				
				<!-- Complete Form Handling -->
				<xsl:call-template name="local:complete-form-handling">
					<xsl:with-param name="data" select="$new_form"/>
				</xsl:call-template>				
				
			</xsl:when>
	
			<!-- Step "Apps" -->
			<xsl:when test="$step='apps'">
			
					<!-- Restore form's data  -->
					<xsl:variable name="new_form_">
						<xsl:for-each select="$form/*">
							<xsl:choose>
								<xsl:when test="name()=$step"></xsl:when>
								<xsl:otherwise>
									<xsl:copy-of select="."/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
						<apps>
							<xsl:copy-of select="vzenv:restore-apps()"/>
						</apps>
					</xsl:variable>
					<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>
					<!-- /Restore form's data  -->
					
					<!-- Complete Form Handling -->
					<xsl:call-template name="local:complete-form-handling">
						<xsl:with-param name="data" select="$new_form"/>
					</xsl:call-template>					
					
			</xsl:when>
			
			<!-- Step "Nets" -->
			<xsl:when test="$step='net'">
			
					<!-- Restore form's data  -->
					<xsl:variable name="new_form_">
						<xsl:for-each select="$form/*">
							<xsl:choose>
								<xsl:when test="name()=$step"></xsl:when>
								<xsl:otherwise>
									<xsl:copy-of select="."/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
						<net>
							<xsl:call-template name="vzsample:restore-net">
								<xsl:with-param name="net" select="$form/net"/>
							</xsl:call-template>
						</net>
					</xsl:variable>
					<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>
					<!-- /Restore form's data  -->

					<!-- Check data -->					
					<xsl:if test="sw:param('next')">
						<xsl:call-template name="vzsample:check-net">
							<xsl:with-param name="net" select="$new_form/net"/>
						</xsl:call-template>
					</xsl:if>
					
					<!-- Complete Form Handling -->
					<xsl:call-template name="local:complete-form-handling">
						<xsl:with-param name="data" select="$new_form"/>
					</xsl:call-template>					
					
			</xsl:when>
			
			<!-- Step "Review" -->
			<xsl:when test="$step='review'">

					<xsl:variable name="new_form_"><!-- session bug workarround -->
						<xsl:for-each select="$form/*">							
							<xsl:copy-of select="."/>							
						</xsl:for-each>
					</xsl:variable>	
					<xsl:variable name="new_form" select="exsl:node-set($new_form_)"/>

					<!-- Complete Form Handling -->
					<xsl:call-template name="local:complete-form-handling">
						<xsl:with-param name="data" select="$new_form"/>
					</xsl:call-template>	
					
			</xsl:when>
			
		</xsl:choose>
		
		<xsl:copy/>
	</xsl:template>
	
	<xsl:template name="local:complete-form-handling">
		<xsl:param name="data"/>
		<!--|-->		
		<xsl:choose>
			<xsl:when test="sw:param('next') and error:is-empty()">
				<!-- Handle "Next" Button -->
				<xsl:choose>
					<xsl:when test="wiz:isLastStep()">
						<xsl:if test="error:is-empty()">
							<xsl:if test="cred:detail-check('vzcp.envsamples')"/>
        		</xsl:if>

    				<xsl:choose>
							<xsl:when test="error:is-empty()">
								<xsl:copy-of select="local:get-final-packet($data)"/>
								<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>	
							</xsl:when>
		          <xsl:otherwise>
              	<packet/>
            	</xsl:otherwise>
          	</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="wiz:goNext()"/>
						<xsl:if test="sw:sesputtree($wiz_data,$data)"/>
					</xsl:otherwise>
				</xsl:choose>
				<!-- /Handle "Next" Button -->
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="sw:param('back')">
						<xsl:if test="wiz:goBack()"/>
					</xsl:when>
				</xsl:choose>
				<xsl:if test="sw:sesputtree($wiz_data,$data)"/>
			</xsl:otherwise>
		</xsl:choose>
					
	</xsl:template>
	
	<func:function name="local:init-form">
		<sw:noauth-redirect select="not(cred:check('vzcp.envsamples'))"/>
		<xsl:if test="$step = ''">
			<xsl:choose>
				<xsl:when test="sw:param('tab') != '' and sw:sesget('envsample-id')!=''">
					<xsl:call-template name="local:init-edit">
						<xsl:with-param name="id" select="sw:sesget('envsample-id')"/>
						<xsl:with-param name="step" select="sw:param('tab')"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="local:init-create"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<func:result select="wiz:init-data()"/>
	</func:function>
	
	<xsl:template name="local:init-create">
		<!-- Prepare some data -->
		<xsl:variable name="def-samples" 	select="vz:default-samples()"/>			  

		<!-- Init default data -->
		<xsl:variable name="new_form">		
			<src-select>
				<type>sample</type>
				<sample-id><xsl:value-of select="$def-samples[1]/objectId"/></sample-id>
				<env-eid/>
				<platform><xsl:value-of select="vt:local-platform()"/></platform>
			</src-select>
			<gen/>				
			<def>				
	  		<xsl:variable name="all-offline-service"  select="vzenv:get-predefined-redirect()"/>
		  	<all_offline_service><xsl:copy-of select="$all-offline-service"/></all_offline_service>
		  </def>
		</xsl:variable>
		<!-- Init steps -->
		<xsl:variable name="new_steps_">			
			<step id="start" screenid="03.02.01.24.04"/>
			<step id="gen" screenid="03.02.01.24.00"/>
			<step id="net" screenid="03.02.01.24.05"/>			
			<step id="qos" screenid="03.02.01.24.01"/>
			<step id="apps" screenid="03.02.01.24.02"/>
			<step id="review" screenid="03.02.01.24.03"/>
		</xsl:variable>
		<!-- Save wizard initial settings -->
		<xsl:if test="error:is-empty()">
			<xsl:variable name="new_steps" select="exsl:node-set($new_steps_)"/>
			<xsl:variable name="new_step" select="string($new_steps/step[1]/@id)"/>
			<xsl:variable name="s" select="sw:sesput($wiz_data,exsl:node-set($new_form))"/>
			<xsl:variable name="s1" select="sw:sesput($wiz_steps,$new_steps)"/>
			<xsl:variable name="s2" select="sw:sesput($wiz_step,$new_step)"/>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="local:init-edit">
		<xsl:param name="step"/>
		<xsl:param name="id"/>
		<!-- Init steps -->
		<xsl:variable name="all_steps_">
			<xsl:choose>
				<xsl:when test="$step='gen'">
					<step id="gen" 	screenid="03.02.01.25.00"/>
				</xsl:when>
				<xsl:when test="$step='qos'">
					<step id="qos" 	screenid="03.02.01.25.01"/>
				</xsl:when>
				<xsl:when test="$step='apps'">
					<step id="apps" screenid="03.02.01.25.02"/>
				</xsl:when>
				<xsl:when test="$step='net'">
					<step id="net" 	screenid="03.02.01.25.04"/>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<!-- Init Step -->
		<xsl:variable name="new_step">
			<xsl:choose>
				<xsl:when test="string(sw:param('tab')) != ''"><xsl:value-of select="string(sw:param('tab'))"/></xsl:when>
				<xsl:otherwise>gen</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="new_steps" select="exsl:node-set($all_steps_)/step[@id=$new_step]"/>
		<!-- Check startup conditions -->
		<xsl:variable name="new_form">
			<xsl:choose>
				<xsl:when test="count($new_steps)=0">
					<xsl:message terminate="yes">
						Requested tab '<xsl:value-of select="$new_step"/>' is unknown for Sample Management code.
					</xsl:message>
				</xsl:when>
				<xsl:when test="not($id)">
					<xsl:message terminate="yes">
					 	Sample ID should be specified.
					</xsl:message>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="local:init-edit-data">
						<xsl:with-param name="step" select="$step"/>
						<xsl:with-param name="id" select="$id"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Save wizard initial settings -->
		<xsl:if test="error:is-empty()">
			<xsl:if test="sw:sesput($wiz_data,exsl:node-set($new_form))"/>
			<xsl:if test="sw:sesput($wiz_steps,$new_steps)"/>
			<xsl:if test="sw:sesput($wiz_step,$new_step)"/>
		</xsl:if>
	</xsl:template>	
	
	<xsl:template name="local:init-edit-data">
		<xsl:param name="step"/>
		<xsl:param name="id"/>
		<!-- Load data -->	
		<xsl:variable name="vt-settings" select="envm:get-vt-settings(sw:master-eid())"/>
		<xsl:variable name="sample" select="env-samplem:get-sample($id)"/>
		<xsl:variable name="sample-platform" select="sample:sample2platform($sample)"/>
		<xsl:variable name="template-offline-service"  select="$sample/env_config/offline_service"/>
		<xsl:variable name="offline-type" select="vzenv:get-offline-type($sample/env_config/offline_management,$template-offline-service)"/>
		<def>
			<step><xsl:value-of select="$step"/></step>
			<xsl:variable name="vza-config" select="system:get-configuration()/packet/data/system"/>
	  	<xsl:variable name="all-offline-service"  select="vzenv:get-predefined-redirect()"/>
		  <all_offline_service><xsl:copy-of select="$all-offline-service"/></all_offline_service>
			<slm><xsl:value-of select="$sample/env_config/slm_mode"/></slm>			
		</def>
		<platform>
			<xsl:value-of select="$sample-platform"/>
		</platform>	
		<gen>
			<name><xsl:value-of select="$sample/name"/></name>
			<comment><xsl:value-of select="sw:base64-decode($sample/comment)"/></comment>			
			<start_after_boot><xsl:value-of select="$sample/env_config/on_boot"/></start_after_boot>
			<selected_offline_service>
      	<xsl:for-each select="$template-offline-service">
	        <value>
  					<xsl:value-of select="."/>
					</value>
				</xsl:for-each>
			</selected_offline_service>
			<offline_type><xsl:value-of select="$offline-type"/></offline_type>
		</gen>
		<name_src><xsl:value-of select="$sample/name"/></name_src>
		<xsl:copy-of select="$sample/env_config/*[
			self::os_template
		]"/>
		<qos>
			<slm-mode><xsl:value-of select="$sample/env_config/slm_mode"/></slm-mode>		
			<xsl:for-each select="$sample/env_config/qos">
				<res>
					<xsl:copy-of select="node()"/>
					<soft_src><xsl:value-of select="soft"/></soft_src>
					<hard_src><xsl:value-of select="hard"/></hard_src>
				</res>
			</xsl:for-each>
		</qos>
		<net>
			<xsl:call-template name="vzsample:config2net">
				<xsl:with-param name="config" select="$sample"/>
			</xsl:call-template>
		</net>
		<apps>
			<xsl:for-each select="$sample/env_config/template[*]">
				<app>
					<name><xsl:value-of select="name"/></name>
					<version><xsl:value-of select="version"/></version>
				</app>
			</xsl:for-each>
		</apps>
		<apps_src>
			<xsl:for-each select="$sample/env_config/template[*]">
				<app>
					<name><xsl:value-of select="name"/></name>
					<version><xsl:value-of select="version"/></version>
				</app>
			</xsl:for-each>
		</apps_src>
		<sample-id><xsl:value-of select="$id"/></sample-id>		
		<xsl:call-template name="local:copy-config">
			<xsl:with-param name="sample" select="$sample"/>
		</xsl:call-template>									
	</xsl:template>
	
	<!-- *********************************************************** -->
	<func:function name="local:get-final-packet">
		<xsl:param name="data"/>
		<!--|-->
		<xsl:variable name="create" select="not($data/sample-id)"/>
		<xsl:variable name="step" select="$data/def/step"/>
		<xsl:variable name="is-linux" select="vt:is-platform-linux($data/platform)"/>  	
		<!--|-->
		<func:result>
			<packet log="on">
				<target>env_samplem</target>
        <cookie>
        	<xsl:if test="$create">
	          <msg>
	            <ok><sw:text>The sample has been successfully created.</sw:text></ok>
	            <error><sw:text>Failed to create the sample.</sw:text></error>
	          </msg>
	          <operation>create_envtmpl</operation>
	          <redirect-prev/>
          </xsl:if>
          <xsl:if test="not($create)">
          	<msg>
	            <ok><sw:text>The sample has been successfully updated.</sw:text></ok>
	            <error><sw:text>Failed to update the sample.</sw:text></error>
	          </msg>
	          <operation>update_envsample</operation>
	          <xsl:if test="$step='gen' or true()">
		          <redirect-last/>
		      </xsl:if>
          </xsl:if>
        </cookie>			
				<data>				
					<!-- Create/Update -->
					<env_samplem>
						<set_sample_conf>
							<!-- General Config -->
							<xsl:if test="not($create)">
								<force>1</force>
							</xsl:if>							
							<sample_conf>								
								<xsl:if test="$data/sample-id!=''">
									<id><xsl:value-of select="$data/sample-id"/></id>
								</xsl:if>			
								<!-- General Config -->
								<name><xsl:value-of select="$data/gen/name"/></name>
								<comment><xsl:value-of select="sw:base64-encode($data/gen/comment)"/></comment>
								<xsl:copy-of select="$data/other/*"/>
								<!-- Env Config -->
								<env_config>					
									<xsl:copy-of select="$data/other_env_config/*"/>
									<!-- VT-specific data -->
									<xsl:copy-of select="vzsample:net2config($data/net)"/>
									<xsl:if test="$is-linux">											
										<slm_mode><xsl:value-of select="$data/qos/slm-mode"/></slm_mode>
									</xsl:if>									
									<offline_management>
										<!-- don't change to "not 'disable'" - will break windows compat -->
										<xsl:value-of select="sw:if(($data/gen/offline_type = 'default') or ($data/gen/offline_type = 'custom'),'1','0')"/>
									</offline_management>
									<xsl:if test="$data/gen/offline_type = 'custom'">
										<xsl:for-each select="$data/gen/selected_offline_service/value">
											<offline_service>
												<xsl:value-of select="string(.)"/>
											</offline_service>
										</xsl:for-each>
									</xsl:if>
									<!-- /VT-specific data -->
									<on_boot>
										<xsl:value-of select="sw:if(string($data/gen/start_after_boot)='1','1','0')"/>
									</on_boot>			
									<os_template>
										<name><xsl:value-of select="$data/os_template/name"/></name>
										<xsl:if test="$data/os_template/version!=''">
											<version><xsl:value-of select="$data/os_template/version"/></version>
										</xsl:if>
									</os_template>
									<xsl:for-each select="$data/qos/res">
										<xsl:if test="soft!='' or hard!=''">
											<qos>
												<xsl:copy-of select="id"/>
												<xsl:if test="soft!=''">
													<xsl:copy-of select="soft"/>
												</xsl:if>
												<xsl:if test="hard!=''">
													<xsl:copy-of select="hard"/>
												</xsl:if>
											</qos>
										</xsl:if>
									</xsl:for-each>
									<xsl:for-each select="$data/apps/app">
										<template>
											<xsl:copy-of select="name"/>
											<xsl:copy-of select="version"/>
										</template>
									</xsl:for-each>
								</env_config>
								<!-- /Env Config -->
							</sample_conf>
						</set_sample_conf>
					</env_samplem>				
				</data>
				<vzcpauth/>
			</packet>
		</func:result>
	</func:function>
	
	<xsl:template name="local:copy-config">
		<xsl:param name="sample"/>
		<other>
			<xsl:copy-of select="$sample/*[not(
				self::name or self::comment or
				self::env_config or self::slm_mode or
				self::id											
			)]"/>
		</other>
		<other_env_config>
			<xsl:copy-of select="$sample/env_config/*[not(
				self::os_template or self::net_device or 
				self::on_boot or self::qos or self::ip or self::template or
				self::offline_management or self::offline_service or self::slm_mode or self::nameserver or self::search_domain
			)]"/>
		</other_env_config>
	</xsl:template>
		
</xsl:stylesheet>
