<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl sw func  cred"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl="http://exslt.org/common"
	xmlns:str="http://exslt.org/strings"    
  xmlns:sw="http://www.swsoft.com/xsl/cp"  
  xmlns:cred="http://www.swsoft.com/xsl/cp/cred"  
  xmlns:hwm="http://www.swsoft.com/xsl/cp/hwm"
  xmlns:func="http://exslt.org/functions"
  >
  <xsl:output method="xml"/>
	<sw:include href="/lib/common.xsl"/>  

	<xsl:template match="/">
		<sw:noauth-redirect select="not(cred:check('vzcp.envsamples'))"/>

		<xsl:variable name="sample-id" select="
				sw:if(
					string( sw:param('id') ) != ''
					,sw:base64-decode( sw:param('id') )
					,sw:sesget('envsample-id' )
				)"/>

    	<xsl:if test="sw:param('id')!='' and not($sample-id=sw:sesget('envsample-id'))">
	      	<xsl:if test="sw:sesput('envsample-id',$sample-id)"/>      	
	    </xsl:if>

		<packet/>
	</xsl:template>
  
  <sw:include href="/lib/cred.xsl"/>

</xsl:stylesheet>
