<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl sw func cred local units vzhn"
	xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl		="http://exslt.org/common"
	xmlns:sw			="http://www.swsoft.com/xsl/cp"
	xmlns:units		="http://www.swsoft.com/xsl/cp/units"
	xmlns:error		="http://www.swsoft.com/xsl/cp/error"
	xmlns:func		="http://exslt.org/functions"
	xmlns:cred 		="http://www.swsoft.com/xsl/cp/cred"
	xmlns:local		="http://www.swsoft.com/xsl/cp/local"
	xmlns:vzhn		="http://www.swsoft.com/xsl/cp/vzhn"
	xmlns:env     ="http://www.swsoft.com/xsl/cp/env"
	xmlns:hn			="http://www.swsoft.com/xsl/cp/hn"
>

	<sw:include href="/lib/vz/vzhn-core.xsl"/>
	<sw:include href="/lib/core/units-core.xsl"/>
	<sw:include href="/lib/vt/env-core.xsl"/>
	<sw:include href="/lib/vt/hn-core.xsl"/>

	<xsl:output method="xml"/>
	<xsl:variable name="redirect"	select="units:tab-redirect('hn.vz.vt','summary')"/>

	<xsl:template match="/">
		<!-- Check for change current HN -->
		<xsl:variable name="hn-eid" select="vzhn:set-hn-from-req()"/>
		<xsl:variable name="hn-state" select="env:get-env($hn-eid)/env/status/state"/>
		<xsl:choose>
			<xsl:when test="$hn-eid=''">
				<!-- can't set hn-eid from req, show error -->
				<packet>
        	<cookie> 
          	<msg>
              <set-error>
              	<short-desc>
              		<sw:text>
										The Hardware Node does not exist.
									</sw:text>
              	</short-desc>
            	</set-error>
          	</msg>
						<redirect>
							<xsl:value-of select="concat($baseurl,'/vt/hns/index')"/>
						</redirect>
        	</cookie>
      	</packet>
				<xsl:if test="sw:response('lib/opredirect.xsl')"/>
			</xsl:when>
			<xsl:when test="($hn-state = $env-state/unknown) or ($hn-state = $env-state/unexist) or ($hn-state = $env-state/nolicense)">
				<!-- can't set hn-eid from req, show error -->
				<xsl:variable name="hn-state-in-locale" select="hn:state2info($hn-state)/text"/>
				<packet>
        	<cookie> 
          	<msg>
              <set-error>
              	<short-desc>
              		<sw:text>
										<xsl:with-param name="hn-state" select="$hn-state-in-locale"/>
										The Hardware Node with the "%{hn-state}" status is unavailable for management.
									</sw:text>
              	</short-desc>
            	</set-error>
          	</msg>
						<redirect>
							<xsl:value-of select="concat($baseurl,'/vt/hns/index')"/>
						</redirect>
        	</cookie>
      	</packet>
				<xsl:if test="sw:response('lib/opredirect.xsl')"/>
			</xsl:when>
			<xsl:when test="$redirect=''">
				<packet/>
			</xsl:when>			
			<xsl:otherwise>
				<xsl:copy-of select="$redirect"/>
				<xsl:if test="sw:response('lib/opredirect.xsl')"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

  
  <!-- credentials -->
  <sw:include href="/lib/common.xsl"/>
  <sw:include href="/lib/cred.xsl"/>  
 
</xsl:stylesheet>
