<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="cred sw exsl func"
	xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl  	="http://exslt.org/common"
	xmlns:cred		="http://www.swsoft.com/xsl/cp/cred"
	xmlns:sw			="http://www.swsoft.com/xsl/cp"
	xmlns:error		="http://www.swsoft.com/xsl/cp/error"
	xmlns:func  	="http://exslt.org/functions"
	xmlns:redirect="http://www.swsoft.com/xsl/cp/redirect"	
>

	<sw:include href="/lib/vz/vzhn-redirects.xsl"/>

	<xsl:output method="xml"/>

	<xsl:variable name="hn-eid" select="sw:hn-eid()"/>
	<xsl:template match="/">
		<xsl:variable name="redirect-ids" select="sw:param('id')"/>
		<xsl:choose>
			<xsl:when test="not(cred:check-hw('vzcp.hn.manage.config.network',$hn-eid))">
				<packet/>
			</xsl:when>
			<xsl:when test="not($redirect-ids)">
				<xsl:if test="error:put(sw:text('Please select at least one offline service.'),'')"/>
				<packet/>
			</xsl:when>
			<xsl:when test="sw:param('redirect-delete')">
				<xsl:choose>
					<xsl:when test="error:is-empty()">
						<xsl:copy-of select="redirect:delete($hn-eid,$redirect-ids)"/>
						<xsl:if test="sw:response('lib/opredirect.xsl')"/>
					</xsl:when>
					<xsl:otherwise>
						<packet/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:when test="sw:param('redirect-set-default')">
				<xsl:choose>
					<xsl:when test="error:is-empty()">
						<xsl:copy-of select="redirect:set-default($hn-eid,$redirect-ids)"/>
						<xsl:if test="sw:response('lib/opredirect.xsl')"/>
					</xsl:when>
					<xsl:otherwise>
						<packet/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:when test="sw:param('redirect-unset-default')">
				<xsl:choose>
					<xsl:when test="error:is-empty()">
						<xsl:copy-of select="redirect:unset-default($hn-eid,$redirect-ids)"/>
						<xsl:if test="sw:response('lib/opredirect.xsl')"/>
					</xsl:when>
					<xsl:otherwise>
						<packet/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>			
			<xsl:otherwise>
				<packet/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/common.xsl"/>
</xsl:stylesheet>
