<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl	="http://exslt.org/common"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:error	="http://www.swsoft.com/xsl/cp/error"
	xmlns:cred	="http://www.swsoft.com/xsl/cp/cred"
  >

	<xsl:output method="xml"/>

	<xsl:template match="/">
		<packet>
			<!-- check premissions before execute request -->
			<xsl:if test="cred:check-hw('vzcp.hn.view',sw:hn-eid())">
				<target>vzaenvm</target>
				<xsl:choose>
					<xsl:when test="not(sw:param('_submit'))">
						<!-- no form post - clean session -->
						<xsl:value-of select="sw:sesput('hn-ssh-login','')"/>
						<xsl:value-of select="sw:sesput('hn-ssh-password','')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="not(string(sw:param('login') )) or not(string(sw:param('password') ))">
							<xsl:value-of select="error:put(sw:text('The Login field or the Password field is empty'))"/>
						</xsl:if>
						<xsl:if test="error:is-empty()">
							<xsl:value-of select="sw:sesputstr('hn-ssh-login',string(sw:param('login') ))"/>
							<xsl:value-of select="sw:sesputstr('hn-ssh-password',string(sw:param('password') ))"/>
						</xsl:if>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
		</packet>
	</xsl:template>

	<!-- credentials -->
	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/common.xsl"/>

</xsl:stylesheet>
