<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->
<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func cred"
	xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl	="http://exslt.org/common"
	xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:func	="http://exslt.org/functions"
  xmlns:cred  ="http://www.swsoft.com/xsl/cp/cred"
>
	<xsl:output method="xml"/>
	
	<xsl:variable name="hn-eid"						select="sw:hn-eid()"/>		

	<xsl:template match="/">
		<sw:noauth-redirect select="not(cred:check-hw('vzcp.support.troubleshooting', $hn-eid))"/>	
		<xsl:choose>
			<xsl:when test="sw:param('enable_channel')">
				<!-- Establish Channel -->
				<packet>
	        <target>vzasupport</target>
	        <xsl:copy-of select="sw:env-dst($hn-eid)"/>
	        <cookie>
        		<msg>
	            <ok><sw:text>The support channel has been established.</sw:text></ok>
	            <error><sw:text>Failed to establish the support channel.</sw:text></error>
	          </msg>
	          <operation>enable_channel</operation>
	          <redirect-last/>
	        </cookie>	
	        <data>
	          <vzasupport>
	          	<start_channel/>
	          </vzasupport>
	        </data>
					<vzcpauth/>	
	      </packet>
	      <xsl:if test="sw:response('lib/opredirect.xsl')"/>	
	      <!--/-->
			</xsl:when>
			<xsl:when test="sw:param('remove_key')">
				<!-- Remove Key -->
				<packet>
	        <target>vzasupport</target>
	        <xsl:copy-of select="sw:env-dst($hn-eid)"/>	        
	        <cookie>
        		<msg>
	            <ok><sw:text>The support certificate has been removed.</sw:text></ok>
	            <error><sw:text>Failed to remove the support certificate.</sw:text></error>
	          </msg>
	          <operation>remove_key</operation>
	          <redirect-last/>
	        </cookie>	
	        <data>
	          <vzasupport>
          		<remove_key/>
	          </vzasupport>
	        </data>
					<vzcpauth/>
	      </packet>
	      <xsl:if test="sw:response('lib/opredirect.xsl')"/>	
	      <!--/-->
			</xsl:when>
			<xsl:when test="sw:param('disable_channel')">
				<!-- Cancel Channel -->
				<packet>
	        <target>vzasupport</target>
	        <xsl:copy-of select="sw:env-dst($hn-eid)"/>	        
	        <cookie>
        		<msg>
	            <ok><sw:text>The support channel has been closed.</sw:text></ok>
	            <error><sw:text>Failed to close the support channel.</sw:text></error>
	          </msg>
	          <operation>cancel_channel</operation>
	          <redirect-last/>
	        </cookie>	
	        <data>
	          <vzasupport>
	          	<stop_channel/>
	          </vzasupport>
	        </data>
					<vzcpauth/>	
	      </packet>
	      <xsl:if test="sw:response('lib/opredirect.xsl')"/>	
	      <!--/-->
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy-of select="/"/>
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
	
	<!-- credentials -->
	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/common.xsl"/>

</xsl:stylesheet>
