<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	extension-element-prefixes="sw exsl cred"
	xmlns:exsl="http://exslt.org/common" xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:request="http://www.swsoft.com/xsl/cp/request"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
>

	<xsl:template match="/">
		<sw:noauth-redirect select="not(cred:check-hw('vzcp.hn.manage.config.network', sw:hn-eid()))"/>
		<xsl:variable name="get-adaptor-id"
			select="sw:base64-decode(sw:param('id'))"/>
		<xsl:variable name="curr-adaptor-id" select="sw:sesget('adaptor-id')"/>
		<xsl:choose>
			<xsl:when test="$get-adaptor-id='' and $curr-adaptor-id=''">
				<sw:die> No Physical interface selected. </sw:die>
			</xsl:when>
			<xsl:when test="$get-adaptor-id!='' and $get-adaptor-id!=string($curr-adaptor-id)">
				<xsl:if test="sw:sesput('adaptor-id',$get-adaptor-id)"/>
			</xsl:when>
		</xsl:choose>
		<packet/>
	</xsl:template>

	<!-- credentials -->
	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/common.xsl"/>
</xsl:stylesheet>
