<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	extension-element-prefixes="cred sw vznet" xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:vznet="http://www.swsoft.com/xsl/cp/vznet" xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:error="http://www.swsoft.com/xsl/cp/error">

	<sw:include href="/lib/vz/vznet-vlan.xsl"/>

	<xsl:output method="xml"/>

	<xsl:template match="/">
		<xsl:variable name="bids" select="sw:param('id')"/>
		<xsl:choose>
			<xsl:when test="not(cred:check-hw('vzcp.hn.manage.config.network',sw:hn-eid()))">
				<packet/>
			</xsl:when>
			<xsl:when test="not($bids)">
				<xsl:if test="error:put(sw:text('Please select at least one VLAN.'),'')"/>
				<packet/>
			</xsl:when>
			<xsl:when test="sw:param('delete')">
				<xsl:choose>
					<xsl:when test="error:is-empty()">
						<xsl:copy-of select="vznet:action-delete-vlans(sw:hn-eid(),$bids)"/>
						<xsl:if test="sw:response('lib/opredirect.xsl')"/>
					</xsl:when>
					<xsl:otherwise>
						<packet/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<packet/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/common.xsl"/>
</xsl:stylesheet>
