<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	extension-element-prefixes="sw exsl vznet" xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp" xmlns:vznet="http://www.swsoft.com/xsl/cp/vznet">

	<xsl:template match="/">
		<xsl:variable name="id-base64" select="sw:param('id')"/>
		<xsl:variable name="type"
			select="sw:base64-decode(string(sw:param('type')))"/>
		<xsl:variable name="redirect_url">
			<xsl:choose>
				<xsl:when test="string($type) = 'net_bridgeType'">
					<xsl:value-of
						select="concat($baseurl,'/vzdir/infrman/hns/vznet/switches/manage?id=',$id-base64)"/>
				</xsl:when>
				<xsl:when test="string($type) = 'net_nicType'">
					<xsl:value-of
						select="concat($baseurl,'/vzdir/infrman/hns/vznet/adaptors/adaptor?id=',$id-base64)"/>
				</xsl:when>
				<xsl:when test="string($type) = 'net_vlanType'">
					<xsl:value-of
						select="concat($baseurl,'/vzdir/infrman/hns/vznet/vlans/manage?id=',$id-base64)"/>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<packet>
			<cookie>
				<redirect>
					<xsl:value-of select="$redirect_url"/>
				</redirect>
			</cookie>
		</packet>
		<xsl:value-of select="sw:response('lib/opredirect.xsl')"/>
	</xsl:template>

	<sw:include href="/lib/common.xsl"/>
</xsl:stylesheet>
