<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	extension-element-prefixes="exsl cred sw vznet" xmlns:exsl="http://exslt.org/common"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:vza_networkm="http://www.swsoft.com/webservices/vzl/4.0.0/networkm"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred" xmlns:vznet="http://www.swsoft.com/xsl/cp/vznet"
	xmlns:sw="http://www.swsoft.com/xsl/cp" xmlns:error="http://www.swsoft.com/xsl/cp/error">

	<sw:include href="/lib/vz/vznet-core.xsl"/>
	<sw:include href="/lib/vz/vznet-switch.xsl"/>

	<xsl:output method="xml"/>

	<xsl:template match="/">
		<xsl:variable name="devices" select="sw:param('id')"/>
		<xsl:choose>
			<xsl:when test="not(cred:check-hw('vzcp.hn.manage.config.network',sw:hn-eid()))">
				<packet/>
			</xsl:when>
			<xsl:when test="sw:param('cancel')">
				<packet/>
			</xsl:when>
			<xsl:when test="not($devices)">
				<xsl:if test="error:put(sw:text('Please select at least one interface.'),'')"/>
				<packet/>
			</xsl:when>
			<xsl:when test="sw:param('attach')">
				<xsl:variable name="switch"
					select="vznet:get-switch(sw:hn-eid(),sw:sesget('vznet-switch-id'))"/>
				<xsl:choose>
					<xsl:when test="error:is-empty()">
						<xsl:variable name="data">
							<xsl:for-each select="$devices">
								<xsl:variable name="id_type" select="sw:split(value,'|')"/>
								<vza_networkm:net_device xsi:type="vza_networkm:{$id_type[2]}">
									<id>
										<xsl:value-of select="$id_type[1]"/>
									</id>
									<network_id>
										<xsl:value-of select="sw:base64-decode($switch/network_id)"/>
									</network_id>
								</vza_networkm:net_device>
							</xsl:for-each>
						</xsl:variable>
						<xsl:copy-of select="vznet:action-set(sw:hn-eid(),exsl:node-set($data))"/>
						<xsl:if test="sw:response('lib/opredirect.xsl')"/>
					</xsl:when>
					<xsl:otherwise>
						<packet/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<packet/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/common.xsl"/>
</xsl:stylesheet>
