<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
    xmlns:exsl="http://exslt.org/common" xmlns:sw="http://www.swsoft.com/xsl/cp">

    <xsl:template match="/">
        <xsl:variable name="get-switch-id"
            select="sw:base64-decode(sw:param('id'))"/>
        <xsl:variable name="curr-switch-id" select="sw:sesget('vznet-switch-id')"/>
        <xsl:choose>
            <xsl:when test="$get-switch-id='' and $curr-switch-id=''">
                <sw:die> Switch ID should be specified. </sw:die>
            </xsl:when>
            <xsl:when test="$get-switch-id!='' and $get-switch-id!=string($curr-switch-id)">
                <xsl:if test="sw:sesput('vznet-switch-id',$get-switch-id)"/>
            </xsl:when>
        </xsl:choose>
        <packet/>
    </xsl:template>

    <!-- credentials -->
    <sw:include href="/lib/cred.xsl"/>
    <sw:include href="/lib/common.xsl"/>
</xsl:stylesheet>
