<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl sw func cred server_group vznet"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp" xmlns:func="http://exslt.org/functions"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred" xmlns:vznet="http://www.swsoft.com/xsl/cp/vznet"
	xmlns:server_group="http://www.swsoft.com/xsl/cp/server_group">

	<sw:include href="/lib/common.xsl"/>
	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/swa/server-group.xsl"/>
	<sw:include href="/lib/vz/vznet-vn.xsl"/>

	<xsl:output method="xml"/>

	<xsl:template match="/">
		<xsl:variable name="nid" select="sw:param('id')"/>
		<xsl:choose>
			<xsl:when test="not(cred:check('vzcp.virtuozzo_group.network.vnets'))">
				<packet/>
			</xsl:when>
			<xsl:when test="sw:param('connect')">
				<xsl:variable name="master-eid" select="sw:master-eid()"/>
				<xsl:variable name="config" select="server_group:get-config()"/>
				<xsl:choose>
					<xsl:when test="not($nid)">
						<xsl:if test="error:put(sw:text('No virtual network selected.'),'')"/>
						<packet/>
					</xsl:when>
					<xsl:otherwise>
						<packet>
							<cookie>
								<redirect>
									<xsl:value-of
										select="concat($baseurl,'/vzdir/infrman/hns/vznet/vns/connect?id=',sw:base64-encode($nid))"
									/>
								</redirect>
							</cookie>
						</packet>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:if test="sw:response('lib/opredirect.xsl')"/>
			</xsl:when>
			<xsl:when test="sw:param('disconnect')">
				<xsl:choose>
					<xsl:when test="not($nid)">
						<xsl:if test="error:put(sw:text('No virtual networks selected.'),'')"/>
						<packet/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy-of select="vznet:action-vns-disconnect(sw:hn-eid(),$nid)"/>
						<xsl:if test="sw:response('lib/opredirect.xsl')"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<packet/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<sw:include href="/lib/common.xsl"/>

</xsl:stylesheet>
