<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	extension-element-prefixes="sw exsl cred"
	xmlns:exsl="http://exslt.org/common" xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:request="http://www.swsoft.com/xsl/cp/request"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
>


	<xsl:template match="/">
		<sw:noauth-redirect select="not(cred:check-hw('vzcp.hn.manage.config.network', sw:hn-eid()))"/>
		<xsl:variable name="get-vn-id"
			select="sw:base64-decode(sw:param('id'))"/>
		<xsl:variable name="curr-vn-id" select="sw:sesget('vn-id')"/>
		<xsl:choose>
			<xsl:when test="$get-vn-id='' and $curr-vn-id=''">
				<sw:die> No Virtual Network selected. </sw:die>
			</xsl:when>
			<xsl:when test="$get-vn-id!='' and $get-vn-id!=string($curr-vn-id)">
				<xsl:if test="sw:sesput('vn-id',$get-vn-id)"/>
			</xsl:when>
		</xsl:choose>
		<packet/>
	</xsl:template>

	<!-- credentials -->
	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/common.xsl"/>
</xsl:stylesheet>
