<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->
<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred"
	xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:voc="http://www.swsoft.com/xsl/cp/voc"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
>

	<!-- check permissions to show this page -->
	<xsl:variable name="eid" select="sw:ve-eid()"/>
	<xsl:param name="access-denied"
		select="not(cred:check-env('vzcp.env.manage.services.confixx_control_panel',$eid))"/>

	<xsl:template mode="screen" match="/">

		<xsl:variable name="oper-problem" select="voc:check-operation('confixx')"/>

		<ui:screen id="03.02.01.17.01">
			<ui:properties>
				<ui:width value="fixed"/>
				<ui:description>
					<sw:text>
            Fill in the form and click the button below to open the Confixx Control Panel window.
          </sw:text>
				</ui:description>
				<ui:form id="loginForm" name="loginForm" action="http://{sw:sesget('hostname')}/login.php"
					target="_blank"/>
			</ui:properties>
			
			<ui:content>
				<xsl:choose>
					<xsl:when test="$oper-problem!=''">
						<ui:block>
							<ui:operation-problem>
								<xsl:copy-of select="$oper-problem"/>
								<ui:descr>
									<sw:text>Cannot log in to the Confixx control panel.</sw:text>
								</ui:descr>
							</ui:operation-problem>
						</ui:block>
					</xsl:when>
					<xsl:otherwise>

						<ui:block mode="edit">
							<ui:rows>
								<ui:row>
									<ui:cell-label>
										<sw:text>Login</sw:text>
									</ui:cell-label>
									<ui:cell-input id="username"/>
								</ui:row>
								<ui:row>
									<ui:cell-label>
										<sw:text>Password</sw:text>
									</ui:cell-label>
									<ui:cell-input mode-password="true" id="password"/>
								</ui:row>
							</ui:rows>
							<ui:buttons>
								<ui:button tip="open_confixx" name="_submit" sandclock="false" width="150">
									<sw:text>Log in to Confixx</sw:text>
								</ui:button>
							</ui:buttons>
						</ui:block>

					</xsl:otherwise>
				</xsl:choose>
				<ui:java-script>
					<xsl:call-template name="panel-login-js">
						<xsl:with-param name="id" select="concat('Confixx-', $eid)"/>
						<xsl:with-param name="login" select="'username'"/>
						<xsl:with-param name="passwd" select="'password'"/>
					</xsl:call-template>
				</ui:java-script>
			</ui:content>
		</ui:screen>
	</xsl:template>

	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/panels.xsl"/>
	<sw:include href="/lib/vocabulary.xsl"/>

</xsl:stylesheet>
