<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl sw func local cred show"
  xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl		="http://exslt.org/common"
  xmlns:sw			="http://www.swsoft.com/xsl/cp"
  xmlns:local		="http://www.swsoft.com/xsl/cp/local"
  xmlns:func		="http://exslt.org/functions"
	xmlns:cred		="http://www.swsoft.com/xsl/cp/cred"
	xmlns:env			="http://www.swsoft.com/xsl/cp/env"	
	xmlns:ui			="http://www.swsoft.com/xsl/cp/ui"
	xmlns:show		="http://www.swsoft.com/xsl/cp/show"
	xmlns:wiz			="http://www.swsoft.com/xsl/cp/wiz"
	xmlns:res			="http://www.swsoft.com/xsl/cp/res"		
 	xmlns:vzve	="http://www.swsoft.com/xsl/cp/vzve"			
>
  
	<!-- includes -->	
  <sw:include href="/lib/screen.xsl"/>
  <sw:include href="/lib/vocabulary.xsl"/> 
	<sw:include href="/lib/wizard.xsl"/>
	<sw:include href="/lib/vt/env-core.xsl"/>
	<sw:include href="/lib/vz/res-funcs.xsl"/>		
	<sw:include href="/lib/vz/vzenv-core.xsl"/>	
	
	<xsl:param name="wiz_code" select="'ve_change'"/>
	<xsl:variable name="form" 			select="sw:sesget($wiz_data)"/>	

	<xsl:variable name="res-id" select="sw:param('res_id')"/>		

	<xsl:template mode="screen" match="/">
		<ui:body-screen>
			<ui:content>
				<ui:raw>
					<xsl:choose>
						<xsl:when test="not($res-id!='') or not($form)">
							||<xsl:value-of select="$res-id"/>||Wrong context
						</xsl:when>
						<xsl:otherwise>
							||<xsl:value-of select="$res-id"/>||
							<xsl:call-template name="local:post-res"/>
						</xsl:otherwise>
					</xsl:choose>
				</ui:raw>
			</ui:content>
		</ui:body-screen>
										
  </xsl:template>
  
  <xsl:template name="local:post-res">
		<xsl:variable name="env-list" select="env:get-env($form/def/env/eid)/env"/>
		<xsl:variable name="is-linux" select="boolean($form/def/linux)"/>
			
		<table cellpadding="3" cellspacing="0" border="0" class="none" width="100%" style="background-color:#DFDFDF;" >

			<xsl:for-each select="$env-list">		

				<xsl:variable name="res-rtf">
					<xsl:call-template name="res:extend-info">
						<xsl:with-param name="is-linux" select="$is-linux"/>							
						<xsl:with-param name="voc-res" select="local:get-voc(parent_eid)[id=$res-id]"/>
						<xsl:with-param name="ve-res" select="virtual_config/qos[id=$res-id]"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:variable name="res" select="exsl:node-set($res-rtf)/ui:qos-param"/>
			

				<tr>
					<!-- title + action -->
					<td colspan="2" align="left">
						<img src="/{$theme}/images/1x1.gif" width="10" height="0"/>
						<img src="/vz/skins/winxp.new/icons/platform_vz_16.gif"/>
						<img src="/{$theme}/images/1x1.gif" width="5" height="0"/>
						<xsl:value-of select="env:env2title(.)"/>
						<br/><img src="/{$theme}/images/1x1.gif" width="{150+120+10}" height="0"/>
					</td>
					<!-- soft -->
					<xsl:if test="$is-linux">
						<td align="right">
							<xsl:choose>
								<xsl:when test="$res/@soft-off='true'">
								</xsl:when>
								<xsl:when test="$res/@unlimited='true'">
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="$res/@soft"/>
								</xsl:otherwise>
							</xsl:choose>
							<br/><img src="/{$theme}/images/1x1.gif" width="90" height="0"/>
						</td>
					</xsl:if>
					<!-- hard -->
					<td align="right">
						<xsl:choose>
							<xsl:when test="$res/@unlimited='true'">
								<xsl:value-of select="$res/@unlimited-label"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$res/@hard"/>
							</xsl:otherwise>
						</xsl:choose>
						<br/><img src="/{$theme}/images/1x1.gif" width="90" height="0"/>
					</td>
					<!-- unit -->
					<td align="center">
						<xsl:value-of select="$res/@unit-label"/>
						<br/><img src="/{$theme}/images/1x1.gif" width="50" height="0"/>
					</td>
					<td width="100%"/>
					<td align="right">
						<br/><img src="/{$theme}/images/1x1.gif" width="20" height="0"/>
					</td>
				</tr>
			</xsl:for-each>
		</table>
  </xsl:template>


	<func:function name="local:get-voc"> 		
		<xsl:param name="hn-eid"/>
		<func:result select="vzve:voc-qos(env:make-platform-ref($hn-eid))"/>
 	</func:function>  


</xsl:stylesheet>
