<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred vzapackagem dynamic local func voc"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:exsl="http://exslt.org/common"
	xmlns:func="http://exslt.org/functions" 
	xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:ui="http://www.swsoft.com/xsl/cp/ui" 
	xmlns:dynamic="http://www.swsoft.com/xsl/cp/dynamic"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:voc="http://www.swsoft.com/xsl/cp/voc" 
	xmlns:local="http://www.swsoft.com/xsl/cp/local" 
	xmlns:error="http://www.swsoft.com/xsl/cp/error" 
	xmlns:env="http://www.swsoft.com/xsl/cp/env"
	xmlns:vzenv="http://www.swsoft.com/xsl/cp/vzenv"
	xmlns:vzapackagem="http://www.swsoft.com/xsl/cp/vzapackagem"
	xmlns:task="http://www.swsoft.com/xsl/cp/task"
	>

	<sw:include href="/lib/swa/op_log.xsl"/>
	<sw:include href="/lib/common.xsl"/>
	<sw:include href="/lib/vt/env-core.xsl"/>
	<sw:include href="/lib/swa/op_log.xsl"/>
	<sw:include href="/lib/vz/vzenv-apps.xsl"/>
	<sw:include href="/lib/dynamic.xsl"/>
	<sw:include href="/lib/screen.xsl"/>

	<!-- check permissions to show this page -->
	<xsl:param name="access-denied" select="not(cred:check-env('vzcp.env.manage.properties.application', sw:ve-eid()))" />

	<xsl:template mode="screen" match="/">
		<xsl:call-template name="dynamic:create-ajax-handler">
			<xsl:with-param name="request-handler" select="'local:wait-for-installation'" />
		</xsl:call-template>
	</xsl:template>

	<func:function name="local:wait-for-installation">
		<xsl:variable name="eid" select="sw:ve-eid()"/>
		<xsl:variable name="id" select="sw:param('pid')"/>
		
		<xsl:variable name="task">
			<xsl:if test="string($id)!=''">
				<xsl:value-of select="task:is-running(task:get(string($id)))"/>
			</xsl:if>
		</xsl:variable>
		
		<func:result>
			<xsl:choose>
				<xsl:when test="vzenv:is-ve-updating($eid) or $task='true'">
					<result>
						<sw:text>Setting up the Container software...</sw:text>
					</result>
					<status>retry</status>
				</xsl:when>
				<xsl:otherwise>
					<result>
						<sw:text>Getting the updated status on the installed applications...</sw:text>
					</result>
					<status>ok</status>
				</xsl:otherwise>
			</xsl:choose>
		</func:result>
	</func:function>
	
</xsl:stylesheet>
