<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func error wiz vzenv tem cred hwm env-samplem voc local hn env vz html"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl	="http://exslt.org/common"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:error	="http://www.swsoft.com/xsl/cp/error"
  xmlns:wiz		="http://www.swsoft.com/xsl/cp/wiz"
  xmlns:vz		="http://www.swsoft.com/xsl/cp/vz"
  xmlns:vt				="http://www.swsoft.com/xsl/cp/vt"
  xmlns:hn		="http://www.swsoft.com/xsl/cp/hn"
  xmlns:env		="http://www.swsoft.com/xsl/cp/env"
  xmlns:vzenv		="http://www.swsoft.com/xsl/cp/vzenv"
  xmlns:tem		="http://www.swsoft.com/xsl/cp/tem"
  xmlns:hwm		="http://www.swsoft.com/xsl/cp/hwm"
  xmlns:env-samplem		="http://www.swsoft.com/xsl/cp/env-samplem"
  xmlns:ui		="http://www.swsoft.com/xsl/cp/ui"
  xmlns:func	="http://exslt.org/functions"
	xmlns:cred	="http://www.swsoft.com/xsl/cp/cred"
	xmlns:voc		="http://www.swsoft.com/xsl/cp/voc"
	xmlns:local	="http://www.swsoft.com/xsl/cp/local"
	xmlns:browse="http://www.swsoft.com/xsl/cp/browse"
	xmlns:ts="http://www.swsoft.com/xsl/cp/ts"
	xmlns:permissions	="http://www.swsoft.com/xsl/cp/permissions"
	xmlns:html="http://www.swsoft.com/xsl/cp/html"
 >
 	<sw:include href="/lib/core/permissions/core-ui.xsl"/>
 	<sw:include href="/lib/swa/env-samplem.xsl"/>
 	<sw:include href="/layout/lib/html.xsl"/>
 	<sw:include href="/lib/vt/core.xsl"/>
 	<sw:include href="/lib/vt/env-core.xsl"/>
 	<sw:include href="/lib/vt/hn-list.xsl"/>
	<sw:include href="/lib/vt/hn-core.xsl"/>
 	<sw:include href="/lib/vz/core.xsl"/>
	<sw:include href="/lib/vz/vzenv-apps.xsl"/>
	<sw:include href="/lib/vz/vzenv-core.xsl"/>
	<sw:include href="/lib/vz/vzenv-qos.xsl"/>
	<sw:include href="/lib/vz/vzenv-net.xsl"/>
	<sw:include href="/lib/vz/vzenv-net-ui.xsl"/>
	<sw:include href="/lib/vz/vzenv-os.xsl"/>
	<sw:include href="/lib/vz/vzenv-offline.xsl"/>
	<sw:include href="/lib/ts.xsl"/>


  <xsl:param 		name="wiz_code"				select="'vzdir_envs_create'"/>
	<xsl:variable name="step_data"		select="wiz:getStep()"/>
	<xsl:variable name="step"					select="$step_data/@id"/>
	<xsl:variable name="step-cred"		select="$step_data/@cred"/>
	<xsl:variable name="screen-id"			select="$step_data/@screen-id"/>
	<xsl:variable name="screen-title"	select="$step_data/@title"/>
	<xsl:variable name="path-id"			select="string(wiz:getSteps()/step[1]/@screen-id)"/>

  <xsl:variable name="form" select="sw:sesget($wiz_data)"/>

  <xsl:variable name="func-validate-qos"	select="$form/hn/linux"/>

  <!-- Reinstall Wizard, Step 'General Settings' -->
  <xsl:template name="step_gen">
  
  	<ui:screen id="{$screen-id}" title="{$screen-title}">

  	<!-- Load some VZ data -->
  	<xsl:variable name="os_templates" select="vzenv:list-oses($form/hn/platform,$form/hn/eid)"/>
  	<xsl:variable name="sample_configs" select="env-samplem:list-samples('virtuozzo','',$form/hn/platform)"/>


  	<xsl:variable name="config_id">
  		<xsl:choose>
	  		<xsl:when test="$form/gen/config">
	  			<xsl:value-of select="$form/gen/config"/>
	  		</xsl:when>
	  		<xsl:when test="$form/def/request/sample-id">
	  			<xsl:value-of select="$form/def/request/sample-id"/>
	  		</xsl:when>
	  		<xsl:otherwise>
	  			<xsl:value-of select="$form/def/samples/obj[platform=$form/hn/platform]/objectId"/>
	  		</xsl:otherwise>
	  	</xsl:choose>
  	</xsl:variable>
  	<!-- /Load some VZ data -->

    <ui:properties>
      <ui:form-get/>
    	<ui:description  mandatory="yes">
        <sw:text>
          On this screen you can set up the configuration of the Container you are creating.<br/> Click "Next" to proceed with or "Create" to complete the creation process.
        </sw:text>
      </ui:description>
      <ui:refresh-type>none</ui:refresh-type>
      <xsl:if test="count($os_templates) &gt; 0 and count($sample_configs) &gt; 0">
	      <ui:js-tail>
	      	<xsl:copy-of select="vzenv:getConfigJS($form,$sample_configs,$os_templates,$form/gen/old_config,false(),false(),$form/def/ips-pool-enabled)"/>
	      </ui:js-tail>
			</xsl:if>
    </ui:properties>

	<ui:content>
    <ui:hidden name="step" value="gen"/>	
		<xsl:choose>
			<xsl:when test="count($os_templates) &gt; 0 and count($sample_configs) &gt; 0">
				<xsl:call-template name="local:show-form">
					<xsl:with-param name="os_templates" select="$os_templates"/>
					<xsl:with-param name="sample_configs" select="$sample_configs"/>
					<xsl:with-param name="config_id" select="$config_id"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="local:show-error">
					<xsl:with-param name="os_templates" select="$os_templates"/>
					<xsl:with-param name="sample_configs" select="$sample_configs"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	    </ui:content>
    </ui:screen>
  </xsl:template>

	<!--
	Show Op.Error screen if its not possible to create VEs on this platform
	Arguments
		os_templates - list of OS templates to describe a broblem
		sample_configs - list of Sample Configs  to describe a broblem
	-->
	<xsl:template name="local:show-error">
		<xsl:param name="os_templates"/>
		<xsl:param name="sample_configs"/>

		<ui:block width="max">
			<ui:operation-problem>
				<ui:type>custom</ui:type>
				<ui:descr>
					<sw:text>
						<xsl:with-param name="platform" select="$form/hn/platform"/>
						Cannot create Containers on the "%{platform}" platform as no suitable Hardware Nodes are available.
					</sw:text>
				</ui:descr>
				<ui:solution>
					<sw:text>Try again and select another platform or Hardware Node.</sw:text>
				</ui:solution>
				<ui:reason>
					<sw:text>All compatible Hardware Nodes are offline.</sw:text>
				</ui:reason>
				<xsl:if test="count($os_templates) = 0">
					<ui:reason>
						<sw:text>No OS templates found.</sw:text>
					</ui:reason>
					<ui:solution>
						<sw:text>
							<xsl:with-param name="aopen">&lt;a onmouseover="callTip('install_ostmpl',event)" onmouseout="callTip()"  href="<xsl:value-of select="$baseurl"/>/vzdir/infrman/templates/standard/add" &gt;
							</xsl:with-param>
							<xsl:with-param name="aclose">&lt;/a&gt;</xsl:with-param>
							%{aopen}Install%{aclose} at least one OS template for this platform.
						</sw:text>
					</ui:solution>
				</xsl:if>
				<xsl:if test="count($sample_configs) = 0">
					<ui:reason>
						<sw:text>No Container samples found.</sw:text>
					</ui:reason>
					<ui:solution>
						<sw:text>
							<xsl:with-param name="aopen">&lt;a onmouseover="callTip('sample_create',event)" onmouseout="callTip()"  href="<xsl:value-of select="$baseurl"/>/vzdir/infrman/envsamples/manage" &gt;
							</xsl:with-param>
							<xsl:with-param name="aclose">&lt;/a&gt;</xsl:with-param>
							%{aopen}Create%{aclose} at least one Container sample for this platform.
						</sw:text>
					</ui:solution>
				</xsl:if>
			</ui:operation-problem>
			
		 <xsl:call-template name="local:show-gen-buttons">
		 	<xsl:with-param name="disable-ok" select="true()"/>
		 </xsl:call-template>
		
		</ui:block>
	</xsl:template>

	<!--
	Show General Configuration form if its possible to create VEs on this platform
	Arguments
		os_templates - list of OS templates to draw a combo-box
		sample_configs - list of Sample Configs to draw a combo-box
		config_id - ID of pre-selected Sample Config
	-->
	<xsl:template name="local:show-form">
		<xsl:param name="os_templates"/>
		<xsl:param name="sample_configs"/>
		<xsl:param name="config_id"/>

	      <ui:block mode="edit">
	      	<ui:rows title="{sw:text('General Configuration')}">
	      		<xsl:if test="$form/envs-count=1">
		      		<ui:row>
		   					<ui:cell-label><sw:text>Name</sw:text></ui:cell-label>
								<ui:cell-input id="name" maxlength="255" value="{$form/gen/name}" required="true"/>
							</ui:row>
							<ui:row>
		   					<ui:cell-label><sw:text>Description</sw:text></ui:cell-label>
								<ui:cell-input id="description" maxlength="1000" value="{$form/gen/description}" width="42"/>
							</ui:row>
						</xsl:if>
	      		<!-- VE Sample Selector -->
	      		<ui:row>
	      		 	<ui:cell-label>
		        		<sw:text>Select Container Sample</sw:text>
		        	</ui:cell-label>
			        <ui:cell-list id="config" value="{$config_id}" close="false">
			        	<xsl:attribute name="onchange">changedConfig(true)</xsl:attribute>
								<xsl:for-each select="$sample_configs">
									<xsl:sort select="name"/>
									<ui:list-item id="{id}" title="{name}"/>
								</xsl:for-each>
							</ui:cell-list>
							<ui:cell-value open="false">
									<xsl:call-template name="local:show-sample-alerts"/>
								</ui:cell-value>
						</ui:row>
						<!-- /VE Sample Selector -->
						<ui:row>
							<xsl:variable name="setup">
								<xsl:copy-of select="$form/hn/platform"/>
								<xsl:copy-of select="$form/os_template"/>
								<os_templates><xsl:copy-of select="$os_templates"/></os_templates>
								<init_on_start/>
								<xsl:if test="count($os_templates/package)&gt;1">
									<empty_os_text><xsl:value-of select="sw:text('-- Select OS --')"/></empty_os_text>
								</xsl:if>
								<required/>
							</xsl:variable>
							<xsl:copy-of select="vzenv:show-os(exsl:node-set($setup))"/>
						</ui:row>

	        </ui:rows>

	   			<xsl:if test="$form/envs-count!=1">
	   				<ui:rows title="{sw:text('Multiple Container Configuration')}">
							<!-- IDs Rule -->
							<ui:row>
		   					<ui:cell-label>
			        		<sw:text>Container IDs</sw:text>
			        	</ui:cell-label>
								<ui:cell-list id="multiple_ids_rule" value="{$form/multiple/ids-rule}" style="width:300px">
									<xsl:copy-of select="local:get-id-rules()"/>
								</ui:cell-list>
							</ui:row>
							<!-- /IDs Rule -->
							<!-- Names Rule -->
							<ui:row>
		   					<ui:cell-label>
			        		<sw:text>Names</sw:text>
			        	</ui:cell-label>
								<ui:cell-list id="multiple_names_rule" value="{$form/multiple/names-rule}" style="width:300px">
									<xsl:copy-of select="local:get-name-rules()"/>
								</ui:cell-list>
							</ui:row>
							<!-- /Names Rule -->
							<!-- Hostnames Rule -->
							<ui:row>
		   					<ui:cell-label>
			        		<sw:text>Hostnames</sw:text>
			        	</ui:cell-label>
								<ui:cell-list id="multiple_hostnames_rule" value="{$form/multiple/hostnames-rule}" style="width:300px">
									<xsl:copy-of select="local:get-hostname-rules()"/>
								</ui:cell-list>
							</ui:row>
							<!-- /Hostnames Rule -->
							<!-- Routed Network Interface Network Rule -->
							<ui:row>
		   					<ui:cell-label>
			        		<sw:text>Routed Interface IP Addresses</sw:text>
			        	</ui:cell-label>
								<ui:cell-list id="multiple_net_routed_rule" value="{$form/multiple/net-routed-rule}" style="width:300px">
									<xsl:copy-of select="local:get-net-routed-rules()"/>
								</ui:cell-list>
							</ui:row>
							<!-- /Routed Network Interface Network Rule -->
							<!-- Bridged Network Interface Network Rule -->
							<ui:row>
		   					<ui:cell-label>
			        		<sw:text>Bridged Interface IP Addresses</sw:text>
			        	</ui:cell-label>
								<ui:cell-list id="multiple_net_bridged_rule" value="{$form/multiple/net-bridged-rule}" style="width:300px">
									<xsl:copy-of select="local:get-net-bridged-rules()"/>
								</ui:cell-list>
							</ui:row>
							<!-- /Bridged Network Interface Network Rule -->
							<!-- Hint -->
							<ui:row>
								<ui:cell-text colspan="2">
									<ui:text-disabled>
										<sw:text>
											The following screen will allow you to manually set the Container IDs, names, and network settings, or to define custom templates/ranges, if you select the corresponding options in the fields above.
										</sw:text>
									</ui:text-disabled>
								</ui:cell-text>
							</ui:row>
							<!-- /Hint -->
	   				</ui:rows>
	   			</xsl:if>

	   			<!--<ui:rows title="{sw:text('Network Configuration')}" separate-tables="true">
	   				<xsl:if test="$form/envs-count=1">
		   				<ui:row>
		   					<ui:cell-label>
			        		<sw:text>Hostname</sw:text>
			        	</ui:cell-label>
								<ui:cell-input id="hostname" maxlength="{vzenv:get-hostname-lenght(env:make-platform-ref($form/hn/eid,$form/hn/platform))}" close="false">
									<xsl:attribute name="value"><xsl:value-of select="$form/gen/hostname"/></xsl:attribute>
								</ui:cell-input>
								<ui:cell-value open="false">
									<xsl:call-template name="local:show-sample-alerts"/>
								</ui:cell-value>
							</ui:row>
						</xsl:if>

					</ui:rows>-->

					<ui:rows>
						<xsl:attribute name="title">
					 		<sw:text>
                Administrative Password
              </sw:text>
					 	</xsl:attribute>
						<ui:row>
							<ui:cell-label>
								<sw:text>
	                Type Password
	              </sw:text>
		        	</ui:cell-label>
							<ui:cell-input id="root_pwd" maxlength="64" mode-password="true">
								<xsl:attribute name="value"><xsl:value-of select="$form/gen/root_pwd"/></xsl:attribute>
							</ui:cell-input>
						</ui:row>
						<ui:row>
							<ui:cell-label>
		        		<sw:text>Retype the password</sw:text>
		        	</ui:cell-label>
							<ui:cell-input mode-password="true" id="root_pwd_re" maxlength="64">
								<xsl:attribute name="value"><xsl:value-of select="$form/gen/root_pwd_re"/></xsl:attribute>
							</ui:cell-input>
						</ui:row>
					</ui:rows>

					<!-- Advanced -->
					<xsl:variable name="show_adv" select="$form/gen/show_adv"/>
					<ui:rows title="{sw:text('Advanced Configuration')}" id="show_adv"
						status-def="0" status="{$form/gen/show_adv}"
						closed-text="{sw:text('Click to show the advanced settings (Container ID, startup options, etc.)')}"
					>

						<xsl:if test="$form/envs-count!=1">
							<xsl:attribute name="closed-text">
								<sw:text>
									Click to show the advanced settings (startup options, etc.)
								</sw:text>
							</xsl:attribute>
						</xsl:if>

						<xsl:if test="$form/def/voc-capabilities/*">
							<ui:row>
								<ui:cell colspan="2">
									<b><sw:text>Options</sw:text></b>
								</ui:cell>
							</ui:row>
						</xsl:if>

						<xsl:if test="$form/envs-count=1">
							<ui:row>
								<ui:cell-check id="ask_veid" checked="{$form/gen/ask_veid=1}">
	                <ui:control-slave>ve_id</ui:control-slave>
	              </ui:cell-check>
								<ui:cell close="false">
			        		<nobr><sw:text>Assign Container ID</sw:text>&#160;&#160;</nobr>
			        	</ui:cell>
				         <ui:cell-input id="ve_id" maxlength="10" width="5" open="false" value="{$form/gen/ve_id}"/>
				      </ui:row>
				    </xsl:if>
			      <ui:row>
			      	<ui:cell-check id="start_after_create">
								<xsl:if test="$form/gen/start_after_create=1">
									<xsl:attribute name="checked">true</xsl:attribute>
								</xsl:if>
				      </ui:cell-check>
				      <ui:cell>
									<sw:text>Start the Container after its creation</sw:text>
				      </ui:cell>
			      </ui:row>
			      <ui:row>
			      	<ui:cell-check id="start_after_boot" checked="{$form/gen/start_after_boot=1}"/>
							<ui:cell  cell-width="100%">
								<sw:text>Start on the Hardware Node boot</sw:text>
			        </ui:cell>
			      </ui:row>

		      	<xsl:if test="$form/def/voc-capabilities/*">
							<ui:row>
								<ui:cell colspan="2">
									<b><sw:text>Capabilities</sw:text></b>
								</ui:cell>
							</ui:row>
							<xsl:copy-of select="vzenv:show-net-capabilites($form/def/voc-capabilities,$form/capabilities)"/>
						</xsl:if>
		      </ui:rows>
					<!-- /Advanced -->

					<!-- windows specific sets': TS and WINS -->
					<xsl:if test="$form/hn/windows">
						<ui:rows title="{sw:text('Terminal Services')}" separate-tables="true" >
							<ui:row>
								<ui:cell-label>
									<sw:text>Mode</sw:text>
								</ui:cell-label>
								<ui:cell-list id="tsmode" value="{$form/gen/tsmode}" width="150">
									<xsl:for-each select="$tsmodes/mode">
										<xsl:sort select="value" order="descending"/>
										<ui:list-item id="{value}" title="{title}"/>
									</xsl:for-each>
								</ui:cell-list>
							</ui:row>
							<xsl:copy-of select="ts:show-lic-servers($form/gen/tslicservers)"/>
						</ui:rows>
					</xsl:if>

					<!-- 0ffline management control -->
					<xsl:copy-of select="vzenv:show-offline-selector($form)"/>

	      	<xsl:if test="cred:check('vzcp.virtuozzo_group.security.roles')">
	      		<xsl:call-template name="local:edit-permissions"/>
	      	</xsl:if>

					<xsl:variable name="confirm-noip-message">
						<xsl:choose>
							<xsl:when test="$form/hn/linux">
								<sw:text>
									The VE will be created with no IP address assigned.\n
									\nTo create the VE, click OK.
									\nTo specify an IP address, click Cancel and use the Next button to manually specify the VE network configuration.
								</sw:text>
							</xsl:when>
							<xsl:when test="$form/hn/windows">
								<sw:text>
									The VE will be created with no IP address assigned and won't start until you assign it an IP address.\n
									\nTo create the VE, click OK.
									\nTo specify an IP address, click Cancel and use the Next button to manually specify the VE network configuration.
								</sw:text>
							</xsl:when>
						</xsl:choose>
					</xsl:variable>
					<xsl:variable name="js-confirm-noip">
						if(isObjVisible('sample_ip_alert') &amp;&amp; !confirm('<xsl:value-of select="sw:html-escape($confirm-noip-message,'escape-quote')"/>')) return false;
					</xsl:variable>

	        <xsl:call-template name="local:show-gen-buttons">
	        	<xsl:with-param name="js-confirm-noip" select="$js-confirm-noip"/>
	        </xsl:call-template>
	        
	     	</ui:block>

	</xsl:template>

	<xsl:template name="local:show-gen-buttons">
		<xsl:param name="disable-ok" select="false()"/>
   	<xsl:param name="js-confirm-noip" select="''"/>		
		
		<ui:buttons>
			<xsl:choose>
				<xsl:when test="$form/envs-count=1">
					<xsl:call-template name="local:post-buttons">
						<xsl:with-param name="disable-ok" select="$disable-ok"/>
						<xsl:with-param name="next-title" select="sw:text('Next')"/>
						<xsl:with-param name="submit-script" select="$js-confirm-noip"/>
						<xsl:with-param name="buttons-ext">
							<ui:button type="back" tip="wizard_prev_step" name="back" sandclock="false"><sw:text>Back</sw:text></ui:button>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="local:post-buttons">
						<xsl:with-param name="disable-ok" select="$disable-ok"/>					
						<xsl:with-param name="post-create" select="false()"/>
						<xsl:with-param name="buttons-ext">
							<ui:button type="back" tip="wizard_prev_step" name="back" sandclock="false"><sw:text>Back</sw:text></ui:button>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</ui:buttons>
	</xsl:template>

  <!-- Reinstall Wizard, Step 'Multiple' -->
  <xsl:template name="step_multiple">
  	<ui:screen id="{$screen-id}" title="{$screen-title}">

    <ui:properties>
      <ui:refresh-type>none</ui:refresh-type>
      <ui:form-get/>
    </ui:properties>

	    <ui:content>
	      <ui:hidden name="step" value="multiple"/>
	      <ui:block mode="edit">

	      	<!-- ID selection -->
	      	<xsl:choose>
		      	<xsl:when test="$form/multiple/ids-rule='from'">
		      		<ui:rows title="{sw:text('Container ID Selection')}">
		      			<ui:row>
		      				<ui:cell-label>
				        		<sw:text>Assign Container IDs starting from</sw:text>
				        	</ui:cell-label>
									<ui:cell-input width="10" id="ids_from" maxlength="20" required="true" value="{$form/multiple-set/ids-from}"/>
		      			</ui:row>
		      		</ui:rows>
		      	</xsl:when>
		      </xsl:choose>
	      	<!-- /ID selection -->

	      	<!-- Name selection -->
	      	<xsl:choose>
		      	<xsl:when test="$form/multiple/names-rule='mask'">
		      		<ui:rows title="{sw:text('Container Names Selection')}">
		      			<ui:row>
		      				<ui:cell-label>
				        		<sw:text>Container Name Template</sw:text>
				        	</ui:cell-label>
									<ui:cell-input id="name" maxlength="255" required="true">
										<xsl:attribute name="value"><xsl:value-of select="$form/multiple-set/name"/></xsl:attribute>
									</ui:cell-input>
		      			</ui:row>
		      			<!-- Hint -->
								<ui:row>
									<ui:cell-label/>
									<ui:cell-text>
										<ui:text-disabled>
											<sw:text>
												The Container name template you specify in this field should contain the &amp;lt;veid&amp;gt; placeholder inside. <br/>This placeholder will be replaced with the actual Container IDs in the names of the created Containers.
											</sw:text>
										</ui:text-disabled>
									</ui:cell-text>
								</ui:row>
								<!-- /Hint -->
		      		</ui:rows>
		      	</xsl:when>
		      </xsl:choose>
	      	<!-- /Name selection -->

	      	<!-- Hostname selection -->
	      	<xsl:choose>
		      	<xsl:when test="$form/multiple/hostnames-rule='mask'">
		      		<ui:rows title="{sw:text('Container Hostnames Selection')}">
		      			<ui:row>
		      				<ui:cell-label>
				        		<sw:text>Container Hostname Template</sw:text>
				        	</ui:cell-label>
									<ui:cell-input id="hostname" maxlength="{vzenv:get-hostname-lenght(env:make-platform-ref($form/hn/eid,$form/hn/platform))+6}">
										<xsl:attribute name="value"><xsl:value-of select="$form/multiple-set/hostname"/></xsl:attribute>
									</ui:cell-input>
		      			</ui:row>
		      			<!-- Hint -->
								<ui:row>
									<ui:cell-label/>
									<ui:cell-text>
										<ui:text-disabled>
											<sw:text>
												The Container hostname template you specify in this field should contain the &amp;lt;veid&amp;gt; placeholder inside.
												<br/>This placeholder will be replaced with the actual Container IDs in the hostnames of the created Containers.
											</sw:text>
										</ui:text-disabled>
									</ui:cell-text>
								</ui:row>
								<!-- /Hint -->
		      		</ui:rows>
		      	</xsl:when>
		      </xsl:choose>
	      	<!-- /Hostname selection -->

			<!--  VE Grid -->
			<xsl:if test="$form/multiple/ids-rule='set' or $form/multiple/names-rule='set'
				or $form/multiple/hostnames-rule='set'
			">
      			<xsl:for-each select="$form/multiple/item">
      				<xsl:variable name="index" select="position()"/>
      				<xsl:variable name="ve" select="$form/multiple-set/ve[$index]"/>
      				<ui:rows separate-tables="true">
      					<xsl:attribute name="title">
			        		<sw:text>
			        			<xsl:with-param name="id" select="$index"/>
			        			Container %id
			        		</sw:text>
			        	</xsl:attribute>
		      			<!-- ID -->
		      			<xsl:if test="$form/multiple/ids-rule='set'">
		      				<ui:row>
		      					<ui:cell-label>
		      						<sw:text>ID</sw:text>
		      					</ui:cell-label>
		      					<ui:cell-input width="10" id="id_{$index}" maxlength="20" required="true" value="{$ve/id}"/>
		      				</ui:row>
		      			</xsl:if>
		      			<!-- Name -->
		      			<xsl:if test="$form/multiple/names-rule='set'">
		      				<ui:row>
		      					<ui:cell-label>
		      						<sw:text>Name</sw:text>
		      					</ui:cell-label>
		      					<ui:cell-input id="name_{$index}" maxlength="255" required="true">
									<xsl:attribute name="value"><xsl:value-of select="$ve/name"/></xsl:attribute>
								</ui:cell-input>
		      				</ui:row>
		      			</xsl:if>
		      			<!-- Hostname -->
		      			<xsl:if test="$form/multiple/hostnames-rule='set'">
		      				<ui:row>
		      					<ui:cell-label>
		      						<sw:text>Hostname</sw:text>
		      					</ui:cell-label>
		      					<ui:cell-input id="hostname_{$index}" maxlength="{vzenv:get-hostname-lenght(env:make-platform-ref($form/hn/eid,$form/hn/platform))}">
									<xsl:attribute name="value"><xsl:value-of select="$ve/hostname"/></xsl:attribute>
										</ui:cell-input>
		      				</ui:row>
		      			</xsl:if>
		      		</ui:rows>
	      		</xsl:for-each>
	      	</xsl:if>

					<xsl:call-template name="vzenv:edit-net">
						<xsl:with-param name="env-form" select="$form"/>
					</xsl:call-template>

	        <ui:buttons>
	          <xsl:call-template name="local:post-buttons"/>
	        </ui:buttons>
	     	</ui:block>
	    </ui:content>
    </ui:screen>
  </xsl:template>

  <!-- Reinstall Wizard, Step 'Custom Settings' -->
  <xsl:template name="step_custom">
  	<ui:screen path-id="{$path-id}" id="{$screen-id}" title="{$screen-title}">

	  	<!-- Load some VZ data -->
	  	<xsl:variable name="qos-warns-src">
				<xsl:if test="sw:param('validate') and error:is-empty()">
					<xsl:call-template name="sw:validateQoS">
						<xsl:with-param name="hn-eid" select="$form/hn/eid"/>
						<xsl:with-param name="data" select="$form/qos"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:variable>
	  	<xsl:variable name="qos-warns" select="exsl:node-set($qos-warns-src)"/>
	  	<xsl:if test="$qos-warns//error/code">
	  		<xsl:if test="error:put(sw:text('The resources validation has failed.'),$qos-warns/packet//error/message)"/>
	  	</xsl:if>
	  	<!-- /Load some VZ data -->

			<ui:properties>
				<ui:form-post/>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description  mandatory="yes" width="full">
					<sw:text>
					On this screen you can customize the Container resources.
					</sw:text>
				</ui:description>
			</ui:properties>

			<ui:content>
				<ui:hidden name="step" value="custom"/>
				<ui:block mode="edit" width="100%">

					<!-- Show QoS warnings-->
					<xsl:call-template name="sw:getQoSValidateResults">
						<xsl:with-param name="qos" select="$form/qos"/>
						<xsl:with-param name="qos-warns" select="$qos-warns"/>
					</xsl:call-template>

					<!-- Show Form -->
					<xsl:call-template name="vzenv:edit-qos">
						<xsl:with-param name="platform-ref" select="env:make-platform-ref($form/hn/eid,$form/hn/platform)"/>
						<xsl:with-param name="data" select="$form/qos"/>
						<xsl:with-param name="qos-warns" select="$qos-warns/packet/data/vzaenvm/validation"/>
						<xsl:with-param name="mode" select="'create'"/>
						<xsl:with-param name="disk-quota-enabled" select="$form/def/disk-quota-enabled='true'"/>
						<xsl:with-param name="warn-restart" select="false()"/>
						<xsl:with-param name="slm-supported" select="$form/def/slm-hn-enabled"/>
					</xsl:call-template>
					<ui:buttons>
						<xsl:call-template name="local:post-buttons">
							<xsl:with-param name="buttons-ext">
								<xsl:if test="$func-validate-qos and $form/qos/slm-mode!='slm'">
									<ui:button tip="ve_qos_validate" name="validate" sandclock="true"><sw:text>Validate</sw:text></ui:button>
								</xsl:if>
							</xsl:with-param>
						</xsl:call-template>
					</ui:buttons>

				</ui:block>
			</ui:content>
		</ui:screen>
  </xsl:template>

  <!-- Wizard, Step 'Network Interfaces' -->
  <xsl:template name="step_net">
  	<ui:screen path-id="{$path-id}" id="{$screen-id}" title="{$screen-title}">
  	<!-- Load some VZ data -->
  	<!-- /Load some VZ data -->
    <ui:properties>
		<ui:form method="get" action="/vz/cp/vzdir/infrman/envs/create"/>
      <ui:refresh-type>none</ui:refresh-type>
      <ui:description  mandatory="yes" width="max">
        <sw:text>
			On this step you can configure the Container network interfaces.
        </sw:text>
      </ui:description>
    </ui:properties>

    <ui:content>
      <ui:hidden name="step" value="net"/>
      <ui:block mode="edit">

				<xsl:call-template name="vzenv:edit-net">
					<xsl:with-param name="env-form" select="$form"/>
				</xsl:call-template>

        <ui:buttons>
          <xsl:call-template name="local:post-buttons">
					</xsl:call-template>
        </ui:buttons>
     </ui:block>
    </ui:content>
    </ui:screen>
  </xsl:template>

  <!-- Wizard, Step 'Applications' -->
  <xsl:template name="step_apps">
  	<ui:screen path-id="{$path-id}" id="{$screen-id}" title="{$screen-title}">
  	<!-- Load some VZ data -->
  	<!-- /Load some VZ data -->
    <ui:properties>
      <ui:form-get/>
      <ui:refresh-type>none</ui:refresh-type>
      <ui:description  mandatory="yes" width="max">
        <sw:text>
			Specify the applications to be added to the Containers. To have an application installed in the Container, click its name in the left table and then the "&gt;&gt;" button to move it to the "Scheduled for Installation" table. If you do not want an application to be installed in the Container, click its name in the right table and the "&lt;&lt;" button to move it to the "Available Applications" table.
        </sw:text>
      </ui:description>
    </ui:properties>

    <ui:content>
      <ui:hidden name="step" value="apps"/>
      <ui:block mode="edit" width="max">

      	<xsl:variable name="setup">
      		<xsl:if test="$form/hn/linux">
						<ui:linux/>
					</xsl:if>
      		<ui:tips>
      			<ui:check-add>select_add_app</ui:check-add>
      			<ui:check-remove>select_remove_app</ui:check-remove>
      			<ui:add>click_install_apps</ui:add>
      			<ui:remove>click_remove_apps</ui:remove>
      		</ui:tips>
      		<ui:captions>
      			<ui:available><sw:text>Available Applications</sw:text></ui:available>
      			<ui:selected><sw:text>Scheduled for Installation</sw:text></ui:selected>
      			<ui:no-available><sw:text>No applications available.</sw:text></ui:no-available>
      			<ui:no-selected><sw:text>No applications scheduled for installation.</sw:text></ui:no-selected>
      		</ui:captions>
      	</xsl:variable>
    		<xsl:copy-of select="vzenv:prepare-new-ve-apps($form/apps,$form/os_template,exsl:node-set($setup), $form/hn/eid,$form/os_in_sample)"/>

        <ui:buttons>
          <xsl:call-template name="local:post-buttons"/>
        </ui:buttons>
     </ui:block>
    </ui:content>
    </ui:screen>
  </xsl:template>


  <!-- Wizard, Step 'Final conformation' -->
  <xsl:template name="step_review">

  	<ui:screen id="{$screen-id}" title="{$screen-title}">
    <ui:properties>
      <ui:form-get/>
      <ui:refresh-type>none</ui:refresh-type>
      <ui:description mandatory="yes">
        <table cellpadding="0" cellspacing="0" border="0">
          <tr>
            <td valign="top">
              <sw:text>
               Please review the new Container configuration.
              </sw:text>
            </td>
          </tr>
        </table>
      </ui:description>
    </ui:properties>
    <ui:content>
     	<ui:hidden name="step" value="review"/>
      <ui:block>
        <ui:rows title="{sw:text('General Configuration')}">
        	<ui:row>
        		<ui:cell-label><sw:text>Hardware Node</sw:text></ui:cell-label>
        		<ui:cell-value>
        			<xsl:value-of select="$form/hn/hostname"/>
        			<xsl:if test="not($form/hn-select/eid)">
       					&#160;<sw:text>(automatically selected)</sw:text>
       				</xsl:if>
        		</ui:cell-value>
        	</ui:row>
        	<xsl:if test="$form/envs-count=1">
        		<xsl:if test="$form/gen/name!=''">
	        		<ui:row>
		        		<ui:cell-label><sw:text>Name</sw:text></ui:cell-label>
		        		<ui:cell-value><xsl:value-of select="$form/gen/name"/></ui:cell-value>
		        	</ui:row>
		        </xsl:if>
		        <xsl:if test="$form/gen/description!=''">
		        	<ui:row>
		        		<ui:cell-label><sw:text>Description</sw:text></ui:cell-label>
		        		<ui:cell-value><sw:text select="sw:html-escape($form/gen/description)"/></ui:cell-value>
		        	</ui:row>
		        </xsl:if>
		        <xsl:if test="$form/gen/ask_veid='1'">
		        	<ui:row>
		        		<ui:cell-label><sw:text>Container ID</sw:text></ui:cell-label>
		        		<ui:cell-value><xsl:value-of select="$form/gen/ve_id"/></ui:cell-value>
		        	</ui:row>
			      </xsl:if>
			      <xsl:if test="$form/gen/ask_veid!='1'">
		        	<ui:row>
		        		<ui:cell-label><sw:text>Container ID</sw:text></ui:cell-label>
		        		<ui:cell-value>&lt;<sw:text>Automatically assigned</sw:text>&gt;</ui:cell-value>
		        	</ui:row>
		        </xsl:if>
					</xsl:if>
					<!-- Multuply VE settings -->
					<xsl:if test="$form/envs-count!=1">
						<ui:row>
	        		<ui:cell-label>
			        	<sw:text>Number of Containers to create</sw:text>
			        </ui:cell-label>
	        		<ui:cell-value>
	        			<xsl:value-of select="$form/envs-count"/>
	        		</ui:cell-value>
	        	</ui:row>
						<ui:row>
	        		<ui:cell-label><sw:text>How to assign Container IDs</sw:text></ui:cell-label>
	        		<ui:cell-value>
	        			<xsl:value-of select="exsl:node-set(local:get-id-rules())/*[
	        				@id=$form/multiple/ids-rule
	        			]/@title"/>
	        		</ui:cell-value>
	        	</ui:row>
	        	<ui:row>
	        		<ui:cell-label><sw:text>How to assign Container names</sw:text></ui:cell-label>
	        		<ui:cell-value>
	        			<xsl:value-of select="exsl:node-set(local:get-name-rules())/*[
	        				@id=$form/multiple/names-rule
	        			]/@title"/>
	        		</ui:cell-value>
	        	</ui:row>
	        	<ui:row>
	        		<ui:cell-label><sw:text>How to assign Container hostnames</sw:text></ui:cell-label>
	        		<ui:cell-value>
	        			<xsl:value-of select="exsl:node-set(local:get-hostname-rules())/*[
	        				@id=$form/multiple/hostnames-rule
	        			]/@title"/>
	        		</ui:cell-value>
	        	</ui:row>
					</xsl:if>
					<!-- /Multuply VE settings -->
						<xsl:variable name="sample" select="env-samplem:get-sample($form/gen/config)"/>
			      <ui:row>
	        		<ui:cell-label width="50%"><sw:text>Original Container Sample</sw:text></ui:cell-label>
	        		<ui:cell-value><xsl:value-of select="sw:if($sample,$sample/name,sw:text('n/a'))"/></ui:cell-value>
	        	</ui:row>
	        	<ui:row>
	        		<ui:cell-label><sw:text>OS template</sw:text></ui:cell-label>
	        		<ui:cell-value>
	        			<xsl:copy-of select="sw:app-id2title($form/os_template/name,$form/os_template/version)"/>
	        		</ui:cell-value>
	        	</ui:row>
	        	<xsl:copy-of select="vzenv:view-slm-mode($form/hn/platform,$form/qos/slm-mode)"/>
	        	<xsl:if test="$form/gen/start_after_create!='1'">
			        <ui:row>
			        	<ui:cell-label><sw:text>Start Container after creation</sw:text></ui:cell-label>
								<ui:cell-value>
									<xsl:choose>
										<xsl:when test="$form/gen/start_after_create='1'">
						        	<sw:text>Yes</sw:text>
										</xsl:when>
										<xsl:otherwise> <sw:text>No</sw:text> </xsl:otherwise>
									</xsl:choose>
								</ui:cell-value>
			        </ui:row>
			      </xsl:if>
			      <xsl:if test="$form/gen/start_after_boot!='1'">
							<ui:row>
			        	<ui:cell-label><sw:text>Start the Container on the Hardware Node boot</sw:text></ui:cell-label>
								<ui:cell-value>
									<xsl:choose>
										<xsl:when test="$form/gen/start_after_boot='1'">
						        	<sw:text>Yes</sw:text>
										</xsl:when>
										<xsl:otherwise> <sw:text>No</sw:text> </xsl:otherwise>
									</xsl:choose>
								</ui:cell-value>
							</ui:row>
						</xsl:if>
						<xsl:if test="$form/gen/offline_type != 'default'">
							<ui:row>
								<ui:cell-label><sw:text>Offline management</sw:text></ui:cell-label>
								<ui:cell-value>
									<xsl:choose>
										<xsl:when test="($form/gen/offline_type != 'default') and ($form/gen/offline_type != 'custom')">
											<sw:text>disabled</sw:text>
										</xsl:when>
										<xsl:when test="$form/gen/offline_type = 'custom'">
											<sw:text>enabled for the following services:</sw:text>
											<xsl:for-each select="$form/def/all_offline_service/service">
												<xsl:if test="$form/gen/selected_offline_service/value = string(id)">
													<br/><xsl:value-of select="string(id)"/>
												</xsl:if>
											</xsl:for-each>
										</xsl:when>
									</xsl:choose>
								</ui:cell-value>
							</ui:row>
						</xsl:if>

		        <xsl:copy-of select="vzenv:review-net-capabilites($form/def/voc-capabilities,$form/capabilities)"/>
          </ui:rows>
					<xsl:if test="not($form/envs-count!=1)">
		      	<ui:rows title="{sw:text('Network Configuration')}">
		      		<xsl:if test="$form/gen/hostname!=''">
								<ui:row>
									<ui:cell-label colspan="2"><b><sw:text>Global Network</sw:text></b></ui:cell-label>
								</ui:row>
								<ui:row>
									<ui:cell-label><sw:text>Hostname</sw:text></ui:cell-label>
									<ui:cell-value><xsl:value-of select="$form/gen/hostname"/></ui:cell-value>
								</ui:row>
							</xsl:if>
							<xsl:call-template name="vzenv:review-net-ifaces">
								<xsl:with-param name="env-form" select="$form"/>
							</xsl:call-template>
						</ui:rows>
	       </xsl:if>
		      <!-- Show QoS -->
      	<xsl:call-template name="vzenv:review-qos">
 					<xsl:with-param name="hn-eid" select="$form/hn/eid"/>
      		<xsl:with-param name="platform-ref" select="env:make-platform-ref($form/hn/eid,$form/hn/platform)"/>
					<xsl:with-param name="all-qos" select="$form/qos"/>
				</xsl:call-template>


	       <!-- Show applications -->
	       <ui:rows title="{sw:text('Applications')}">
	       	<xsl:choose>
		        <xsl:when test="$form/apps/app">
        			<xsl:for-each select="$form/apps/app">
        				<xsl:sort select="sw:uc(name)"/>
      					<ui:row>
	        				<ui:cell><xsl:value-of select="sw:app-id2title(name,version)"/></ui:cell>
      					</ui:row>
        			</xsl:for-each>
		        </xsl:when>
		        <xsl:otherwise>
			        <ui:row>
		        		<ui:cell>
		        			<sw:text>No applications will be installed.</sw:text>
		        		</ui:cell>
			        </ui:row>
		        </xsl:otherwise>
	      	</xsl:choose>
        </ui:rows>
        <!-- Show applications -->
        <ui:buttons>
          <xsl:call-template name="local:post-buttons"/>
        </ui:buttons>
     	</ui:block>
     </ui:content>
		</ui:screen>
  </xsl:template>

	<!-- Security section -->
	<xsl:template name="local:edit-permissions">
		<ui:rows title="{sw:text('Permissions')}" id="show_permissions"
			status-def="0" status="{$form/gen/show_permissions}" separate-tables="true"
			closed-text="{sw:text('Click to set up the Container permissions.')}"
		>
			<xsl:call-template name="permissions:edit">
				<xsl:with-param name="data" select="$form/permissions"/>
			</xsl:call-template>
		</ui:rows>

	</xsl:template>

  <!--
  	Show ui:cell content with different Sample Selector alert divs.
  -->
  <xsl:template name="local:show-sample-alerts">
	  <!-- IP Misconfiguration -->
		<ui:text-disabled>
			<div id="sample_ip_alert" style="display: none;">
				<xsl:choose>
					<xsl:when test="$form/hn/linux">
						<sw:text>
							The Container will be created with no IP address assigned. Click the Next button and specify the network configuration manually.
						</sw:text>
					</xsl:when>
					<xsl:when test="$form/hn/windows">
						<sw:text>
							The Container will be created with no IP address assigned and won't start. Click the Next button and specify the network configuration manually.
						</sw:text>
					</xsl:when>
				</xsl:choose>
			</div>
		</ui:text-disabled>
	  <!-- /IP Misconfiguration -->
	</xsl:template>

	<!-- Review Data for VE Net Inferfaces UI -->
	<xsl:template name="vzenv:review-net-ifaces">
		<xsl:param name="env-form"/>

		<!--======== Global Network =============-->
		<xsl:if test="($env-form/hn/linux)">
			<xsl:call-template name="local:review-net-dns">
				<xsl:with-param name="env-form" select="$env-form"/>
				<xsl:with-param name="iface" select="$env-form/net"/>
			</xsl:call-template>
			<xsl:call-template name="local:review-net-search">
				<xsl:with-param name="env-form" select="$env-form"/>
				<xsl:with-param name="iface" select="$env-form/net"/>
			</xsl:call-template>
		</xsl:if>


		<!--======== Routed Network =============-->
		<xsl:if test="true()">
			<xsl:variable name="iface" select="$env-form/net/routed"/>
			<ui:row>
				<ui:cell-label>
					<b><sw:text>Routed Network</sw:text></b>
				</ui:cell-label>
				<ui:cell-text>
					<xsl:value-of select="sw:if($iface/enabled='true',sw:text('Enabled'),sw:text('Disabled'))"/>
				</ui:cell-text>
			</ui:row>
			<xsl:if test="$iface/enabled='true'">
				<xsl:call-template name="local:review-net-ips">
					<xsl:with-param name="env-form" select="$env-form"/>
					<xsl:with-param name="iface" select="$iface"/>
				</xsl:call-template>
				<xsl:if test="not($env-form/hn/linux)">
					<xsl:call-template name="local:review-net-dns">
						<xsl:with-param name="env-form" select="$env-form"/>
						<xsl:with-param name="iface" select="$iface"/>
					</xsl:call-template>
					<xsl:call-template name="local:review-net-wins">
						<xsl:with-param name="env-form" select="$env-form"/>
						<xsl:with-param name="iface" select="$iface"/>
					</xsl:call-template>
					<!--
					<xsl:call-template name="local:review-net-gateway">
						<xsl:with-param name="env-form" select="$env-form"/>
						<xsl:with-param name="iface" select="$iface"/>
					</xsl:call-template>
					-->
					<xsl:call-template name="local:review-net-search">
						<xsl:with-param name="env-form" select="$env-form"/>
						<xsl:with-param name="iface" select="$iface"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:if>
		</xsl:if>

		<!--======== Bridged Network =============-->
		<xsl:variable name="bridged" select="$env-form/net/bridged"/>
		<ui:row>
			<ui:cell-label>
				<b><sw:text>Bridged Network</sw:text></b>
			</ui:cell-label>
			<ui:cell-text>
				<xsl:value-of select="sw:if($bridged/enabled='true',sw:text('Enabled'),sw:text('Disabled'))"/>
			</ui:cell-text>
		</ui:row>
		<xsl:if test="$bridged/enabled='true'">
			<xsl:variable name="offset" select="sw:if(count($bridged/iface)=1,'','1')"/>
			<xsl:for-each select="$bridged/iface">
				<xsl:variable name="iface" select="."/>

				<xsl:if test="$offset!=''">
					<ui:row>
						<ui:cell-label>
							<sw:text>
								<xsl:with-param name="id" select="$iface/id"/>
								Virtual Ethernet Interface %{id}
							</sw:text>
						</ui:cell-label>
						<ui:cell-text/>
					</ui:row>
				</xsl:if>
				<ui:row>
					<ui:cell-label offset="{$offset}">
						<sw:text>Virtual Network</sw:text>
					</ui:cell-label>
					<ui:cell-text>
						<xsl:value-of select="net-id"/>
					</ui:cell-text>
				</ui:row>
				<xsl:call-template name="local:review-net-ips">
					<xsl:with-param name="env-form" select="$env-form"/>
					<xsl:with-param name="iface" select="$iface"/>
					<xsl:with-param name="offset" select="$offset"/>
				</xsl:call-template>
				<xsl:if test="not($env-form/hn/linux)">
					<xsl:call-template name="local:review-net-dns">
						<xsl:with-param name="env-form" select="env-form"/>
						<xsl:with-param name="iface" select="$iface"/>
						<xsl:with-param name="offset" select="$offset"/>
					</xsl:call-template>
					<xsl:call-template name="local:review-net-wins">
						<xsl:with-param name="env-form" select="$env-form"/>
						<xsl:with-param name="iface" select="$iface"/>
						<xsl:with-param name="offset" select="$offset"/>
					</xsl:call-template>
				</xsl:if>
				<xsl:call-template name="local:review-net-gateway">
					<xsl:with-param name="env-form" select="$env-form"/>
					<xsl:with-param name="iface" select="$iface"/>
					<xsl:with-param name="offset" select="$offset"/>
				</xsl:call-template>
				<xsl:if test="not($env-form/hn/linux)">
					<xsl:call-template name="local:review-net-search">
						<xsl:with-param name="env-form" select="$env-form"/>
						<xsl:with-param name="iface" select="$iface"/>
						<xsl:with-param name="offset" select="$offset"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:for-each>
		</xsl:if>

	</xsl:template>

	<!-- Review IPs Data -->
	<xsl:template name="local:review-net-ips">
		<xsl:param name="env-form"/>
		<xsl:param name="iface"/>
		<xsl:param name="offset" select="''"/>

		<ui:row>
			<ui:cell-label offset="{$offset}"><sw:text>IP Addresses</sw:text></ui:cell-label>
			<ui:cell>
				<xsl:choose>
					<xsl:when test="$iface/dhcp='true'">
						<sw:text>The IP address will be received from the DHCP server.</sw:text>
					</xsl:when>
					<xsl:when test="$iface/ips/ip">
						<xsl:for-each select="$iface/ips/ip">
							<xsl:sort select="sw:ip2number(address)" data-type="number"/>
							<xsl:value-of select="address"/><xsl:if test="vt:is-platform-windows($env-form/hn/platform)"> / <xsl:value-of select="netmask"/></xsl:if>
							<xsl:if test="position()!=last()">,&#160;</xsl:if>
						</xsl:for-each>
				   </xsl:when>
				   <xsl:otherwise>
						<sw:text>No IP address will be assigned.</sw:text>
				   </xsl:otherwise>
				 </xsl:choose>
			</ui:cell>
		</ui:row>
	</xsl:template>

	<!-- Review DNS Data -->
	<xsl:template name="local:review-net-dns">
		<xsl:param name="env-form"/>
		<xsl:param name="iface"/>
		<xsl:param name="offset" select="''"/>

		<xsl:if test="$iface/dns_ips/ip">
			<ui:row>
				<ui:cell-label offset="{$offset}"><sw:text>DNS Servers</sw:text></ui:cell-label>
				<ui:cell>
					<xsl:for-each select="$iface/dns_ips/ip">
						<xsl:sort select="sw:ip2number(.)" data-type="number"/>
						<xsl:value-of select="."/>
						<xsl:if test="position()!=last()">,&#160;</xsl:if>
					</xsl:for-each>
				</ui:cell>
			</ui:row>
		</xsl:if>
	</xsl:template>

	<!-- Review Search Domains Data -->
	<xsl:template name="local:review-net-search">
		<xsl:param name="env-form"/>
		<xsl:param name="iface"/>
		<xsl:param name="offset" select="''"/>

		<xsl:if test="$iface/search_domains/dom">
			<ui:row>
				<ui:cell-label offset="{$offset}"><sw:text>Search Domains</sw:text></ui:cell-label>
				<ui:cell>
					<xsl:for-each select="$iface/search_domains/dom">
						<xsl:sort select="sw:ip2number(.)" data-type="text"/>
						<xsl:value-of select="."/>
						<xsl:if test="position()!=last()">,&#160;</xsl:if>
					</xsl:for-each>
				</ui:cell>
			</ui:row>
		</xsl:if>
	</xsl:template>

	<!-- Review WINS Data -->
	<xsl:template name="local:review-net-wins">
		<xsl:param name="env-form"/>
		<xsl:param name="iface"/>
		<xsl:param name="offset" select="''"/>

		<xsl:if test="$iface/wins_servers/ip">
			<ui:row>
				<ui:cell-label offset="{$offset}"><sw:text>WINS Server IP Address</sw:text></ui:cell-label>
				<ui:cell>
					<xsl:for-each select="$iface/wins_servers/ip">
						<xsl:sort select="sw:ip2number(.)" data-type="number"/>
						<xsl:value-of select="."/>
						<xsl:if test="position()!=last()">,&#160;</xsl:if>
					</xsl:for-each>
				</ui:cell>
			</ui:row>
		</xsl:if>
	</xsl:template>

	<!-- Review Gateway Data -->
	<xsl:template name="local:review-net-gateway">
		<xsl:param name="env-form"/>
		<xsl:param name="iface"/>
		<xsl:param name="offset" select="''"/>

		<xsl:if test="$iface/default_gateway">
			<ui:row>
				<ui:cell-label offset="{$offset}"><sw:text>Default Gateway</sw:text></ui:cell-label>
				<ui:cell>
					<xsl:value-of select="$iface/default_gateway"/>
				</ui:cell>
			</ui:row>
		</xsl:if>
	</xsl:template>

	<func:function name="local:get-id-rules">
		<xsl:variable name="rules">
			<ui:list-item id="auto" title="{sw:text('Assign Container IDs automatically')}"/>
			<ui:list-item id="from" title="{sw:text('Assign Container IDs starting from a specified one')}"/>
			<ui:list-item id="set" title="{sw:text('Set Container IDs manually')}"/>
		</xsl:variable>
		<func:result select="$rules"/>
	</func:function>

	<func:function name="local:get-hostname-rules">
		<xsl:variable name="rules">
			<ui:list-item id="mask" title="{sw:text('Assign hostnames based on a specified template')}"/>
			<ui:list-item id="set" title="{sw:text('Set hostnames manually for every Container')}"/>
		</xsl:variable>
		<func:result select="$rules"/>
	</func:function>

	<func:function name="local:get-net-routed-rules">
		<xsl:variable name="rules">
			<ui:list-item id="sample" title="{sw:text('Assign according to the Container sample')}"/>
			<ui:list-item id="pool" title="{sw:text('Get from the global IP addresses pool')}"/>
			<ui:list-item id="range" title="{sw:text('Assign from a specified IP addresses range')}"/>
			<ui:list-item id="set" title="{sw:text('Specify manually for every Container')}"/>
		</xsl:variable>
		<func:result select="$rules"/>
	</func:function>

	<func:function name="local:get-net-bridged-rules">
		<xsl:variable name="rules">
			<ui:list-item id="sample" title="{sw:text('Assign according to the Container sample')}"/>
			<ui:list-item id="dhcp" title="{sw:text('Get from the DHCP server')}"/>
			<ui:list-item id="pool" title="{sw:text('Get from the global IP addresses pool')}"/>
			<ui:list-item id="range" title="{sw:text('Assign from a specified IP addresses range')}"/>
			<ui:list-item id="set" title="{sw:text('Specify manually for every Container')}"/>
		</xsl:variable>
		<func:result select="$rules"/>
	</func:function>

	<func:function name="local:get-name-rules">
		<xsl:variable name="rules">
			<ui:list-item id="mask" title="{sw:text('Assign names based on a specified template')}"/>
			<ui:list-item id="set" title="{sw:text('Set names manually for every Container')}"/>
		</xsl:variable>
		<func:result select="$rules"/>
	</func:function>

	<!-- main document handler -->
	<xsl:template mode="screen" match="/">

			<xsl:choose>
				<xsl:when test="$step = 'custom'">
					<xsl:call-template name="step_custom"/>
				</xsl:when>
				<xsl:when test="$step = 'net'">
					<xsl:call-template name="step_net"/>
				</xsl:when>
				<xsl:when test="$step = 'multiple'">
					<xsl:call-template name="step_multiple"/>
				</xsl:when>
				<xsl:when test="$step = 'os'">
					<xsl:call-template name="step_os"/>
				</xsl:when>
				<xsl:when test="$step = 'review'">
					<xsl:call-template name="step_review"/>
				</xsl:when>
				<xsl:when test="$step = 'apps'">
					<xsl:call-template name="step_apps"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="step_gen"/>
				</xsl:otherwise>

			</xsl:choose>

	</xsl:template>

	<xsl:template name="local:post-buttons">
		<xsl:param name="buttons-ext" select="''"/>
		<xsl:param name="next-title" select="sw:text('Next')"/>
		<xsl:param name="post-create" select="true()"/>
		<xsl:param name="submit-script" select="''"/>
		<xsl:param name="disable-ok" select="false()"/>

		<xsl:call-template name="wiz:showButtons">
			<xsl:with-param name="disable-submit" select="$disable-ok"/>
			<xsl:with-param name="disable-next" select="$disable-ok"/>
			<xsl:with-param name="force-show-submit" select="$post-create"/>
			<xsl:with-param name="submit-title" select="sw:text('Create')"/>
			<xsl:with-param name="next-title" select="$next-title"/>
			<xsl:with-param name="buttons-ext" select="$buttons-ext"/>
			<xsl:with-param name="submit-script" select="$submit-script"/>
	  </xsl:call-template>
	</xsl:template>

	<sw:include href="/lib/vz/apps.xsl"/>

	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>

	<sw:include href="/lib/vza/tem.xsl"/>
	<sw:include href="/lib/vza/vzapackagem.xsl"/>
	<sw:include href="/lib/vza/hwm.xsl"/>
	<sw:include href="/lib/vocabulary.xsl"/>

</xsl:stylesheet>
