<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func wiz vzenv local cred voc file"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl="http://exslt.org/common"
  xmlns:sw="http://www.swsoft.com/xsl/cp"
  xmlns:local="http://www.swsoft.com/xsl/cp/local"
  xmlns:error="http://www.swsoft.com/xsl/cp/error"
  xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz"
  xmlns:vzenv="http://www.swsoft.com/xsl/cp/vzenv"
  xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
  xmlns:func="http://exslt.org/functions"
	xmlns:cred  ="http://www.swsoft.com/xsl/cp/cred"
	xmlns:voc		="http://www.swsoft.com/xsl/cp/voc"
	xmlns:file="http://www.swsoft.com/xsl/cp/file"
 >

	<sw:include href="/lib/utils/file.xsl"/>

	<xsl:param 	  name="wiz_code"		select="'ve-create-folder'"/>
	<xsl:variable name="step_data"		select="wiz:getStep()"/>
	<xsl:variable name="step"			select="$step_data/@id"/>
	<xsl:variable name="step-cred"		select="$step_data/@cred"/>
	<xsl:variable name="screenid"		select="$step_data/@screenid"/>
	<xsl:variable name="screen-title"	select="sw:text('Create Folder')"/>
	<xsl:variable name="screen-icon"	select="'folder_new'"/>
	<xsl:variable name="path-id"		select="string(wiz:getSteps()/step[1]/@screenid)"/>
	
  <xsl:variable name="form" select="sw:sesget($wiz_data)"/>
  <!-- check permissions to show this page -->
	<xsl:param name="access-denied" select="$step-cred!='' and  not(cred:check-context($step-cred,$step_data/@security-obj-type))"/>

  <!-- Reinstall Wizard, Step 'General Settings' -->
  <xsl:template name="step_gen">
  	<ui:screen path-id="{$path-id}" id="{$screenid}" title="{$screen-title}" icon="{$screen-icon}">
  	
  	<!-- Load some VZ data -->  	
  	<!-- /Load some VZ data -->  	
  	
    <ui:properties>
    	<ui:form-get/>
      <ui:refresh-type>none</ui:refresh-type>
      <ui:description  mandatory="yes">
        <sw:text>
        	<xsl:with-param name="path" select="file:path4screen($form/fm-path)"/>
        	Create a new folder in <b>%{path}</b>
        </sw:text>
      </ui:description>  
    </ui:properties>
    
	    <ui:content>
	     	<xsl:copy-of select="wiz:post-form-step($form,'gen')"/> 
	      <ui:block mode="edit">

	   			<ui:rows>
	   				<ui:row>
	   					<ui:cell-label>
		        		<sw:text>Folder Name</sw:text>
		        	</ui:cell-label>
							<ui:cell-input id="folder" maxlength="256" required="true">
								<xsl:attribute name="value"><xsl:value-of select="$form/gen/folder"/></xsl:attribute>
							</ui:cell-input>
						</ui:row>
					</ui:rows>
	
	        <ui:buttons>
	          <xsl:call-template name="wiz:showButtons">
	          	<xsl:with-param name="submit-title" select="sw:text('Create')"/>
	          	<xsl:with-param name="submit-tip" select="'submit_create_folder'"/>
	          </xsl:call-template>
	        </ui:buttons>
	        
	     	</ui:block>
	    </ui:content>   
    </ui:screen>
  </xsl:template>
  

	<!-- main document handler -->
	<xsl:template mode="screen" match="/">
	
			<xsl:choose>
			
				<xsl:when test="$step = 'gen'">
					<xsl:call-template name="step_gen"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="step_gen"/>
				</xsl:otherwise>
				
			</xsl:choose>
		
	</xsl:template>
	
	
	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>
	
	<sw:include href="/lib/vocabulary.xsl"/>		
	
</xsl:stylesheet>
