<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->
<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl file"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl	="http://exslt.org/common"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:ui	="http://www.swsoft.com/xsl/cp/ui"   
	xmlns:filem	="http://www.swsoft.com/xsl/cp/filem"
	xmlns:file="http://www.swsoft.com/xsl/cp/file"
>

	<sw:include href="/lib/utils/file.xsl"/>

	<xsl:template match="/">
		<xsl:variable name="eid" select="sw:ve-eid()"/>
		<xsl:variable name="fm-name" select="sw:base64-decode(sw:param('fm-name'))"/>
		<xsl:variable name="fm-size" select="sw:param('fm-size')"/>
		<xsl:variable name="fm-path" select="sw:sesget('ve-fm-path')"/>
		<xsl:variable name="full-path-to-file" select="concat(file:path4vza($fm-path,false()),'/',$fm-name)"/>
    <ui:binary type="application/octet-stream"  file-name="{$fm-name}">
			<download>
				<path><xsl:value-of select="$full-path-to-file"/></path>
				<size><xsl:value-of select="$fm-size"/></size>
				<eid><xsl:value-of select="$eid"/></eid>	
			</download>
		</ui:binary>
	</xsl:template>

	<sw:include href="/lib/common.xsl"/>
	
</xsl:stylesheet>
