<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func wiz filem local cred voc file"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl="http://exslt.org/common"
  xmlns:sw="http://www.swsoft.com/xsl/cp"
  xmlns:local="http://www.swsoft.com/xsl/cp/local"
  xmlns:error="http://www.swsoft.com/xsl/cp/error"
  xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz"
  xmlns:filem="http://www.swsoft.com/xsl/cp/filem"
  xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
  xmlns:func="http://exslt.org/functions"
	xmlns:cred  ="http://www.swsoft.com/xsl/cp/cred"
	xmlns:voc		="http://www.swsoft.com/xsl/cp/voc"
	xmlns:file="http://www.swsoft.com/xsl/cp/file"
 >

	<sw:include href="/lib/utils/file.xsl"/>

	<xsl:param		name="wiz_code"		select="'vzenv-files-edit'"/>
	<xsl:variable	name="step_data"	select="wiz:getStep()"/>
	<xsl:variable	name="step"			select="$step_data/@id"/>
	<xsl:variable	name="step-cred"	select="$step_data/@cred"/>
	<xsl:variable	name="screenid"		select="$step_data/@screenid"/>
	<xsl:variable	name="screen-title"	select="sw:text('Edit File')"/>
	<xsl:variable	name="screen-icon"	select="'fm_edit'"/>
	<xsl:variable	name="path-id"		select="string(wiz:getSteps()/step[1]/@screenid)"/>
	
  <xsl:variable name="form" select="sw:sesget($wiz_data)"/>
  <!-- check permissions to show this page -->
	<xsl:param name="access-denied" select="$step-cred!='' and  not(cred:check-context($step-cred,$step_data/@security-obj-type))"/>

  <!-- Reinstall Wizard, Step 'General Settings' -->
  <xsl:template name="step_gen">
  	<ui:screen path-id="{$path-id}" id="{$screenid}" title="{$screen-title}" icon="{$screen-icon}">
  	
  	<!-- Load some VZ data -->  	
  	<!-- /Load some VZ data -->  	
  	
    <ui:properties>
    	<ui:form-post/>
      <ui:refresh-type>none</ui:refresh-type>
    </ui:properties>
    
	    <ui:content>
	      <ui:hidden name="step" value="gen"/>    
	      <ui:block mode="edit">

   				<xsl:for-each select="$form/file">
   					<xsl:variable name="file-name" select="."/>
   					<xsl:variable name="file-body" select="filem:get( concat(file:path4vza($form/fm-path),$file-name),$form/eid,true() )"/>
   					<xsl:variable name="file-pos" select="position()"/>
   					<ui:rows title="{$file-name}">
							<ui:row>
								<xsl:choose>
									<xsl:when test="$file-body">
										<ui:cell-inputblock style="width:600px;" id="body_{$file-pos}" maxlength="65545" rows="17" colspan="2">
											<xsl:value-of select="$file-body"/>
										</ui:cell-inputblock>
									</xsl:when>
									<xsl:otherwise>
										<ui:cell colspan="2">
											<sw:text>The file is unavailable.</sw:text>
										</ui:cell>
									</xsl:otherwise>
								</xsl:choose>
							</ui:row>   						
						</ui:rows>
					</xsl:for-each>
	
	        <ui:buttons>
	          <xsl:call-template name="wiz:showButtons">
	          	<xsl:with-param name="submit-title" select="sw:text('Submit')"/>
	          	<xsl:with-param name="submit-tip" select="'submit_edit_files'"/>
	          </xsl:call-template>
	        </ui:buttons>
	        
	     	</ui:block>
	    </ui:content>   
    </ui:screen>
  </xsl:template>
  

	<!-- main document handler -->
	<xsl:template mode="screen" match="/">
	
			<xsl:choose>
				<xsl:when test="/ui:redirect">
					<xsl:copy-of select="/"/>					
				</xsl:when>
			
				<xsl:when test="$step = 'gen'">
					<xsl:call-template name="step_gen"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="step_gen"/>
				</xsl:otherwise>
				
			</xsl:choose>
		
	</xsl:template>
	
	<sw:include href="/lib/vza/filem.xsl"/>
	
	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>
	
	<sw:include href="/lib/vocabulary.xsl"/>		
	
</xsl:stylesheet>
