<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl sw func local cred filem show file format"
  xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl		="http://exslt.org/common"
  xmlns:sw			="http://www.swsoft.com/xsl/cp"
  xmlns:local		="http://www.swsoft.com/xsl/cp/local"
  xmlns:func		="http://exslt.org/functions"
	xmlns:cred		="http://www.swsoft.com/xsl/cp/cred"
	xmlns:ui		="http://www.swsoft.com/xsl/cp/ui"
	xmlns:filem		="http://www.swsoft.com/xsl/cp/filem"
	xmlns:show		="http://www.swsoft.com/xsl/cp/show"
	xmlns:file="http://www.swsoft.com/xsl/cp/file"
	xmlns:format="http://www.swsoft.com/xsl/cp/format"
>

	<sw:include href="/lib/utils/file.xsl"/>
	<sw:include href="/lib/utils/format-resusage.xsl"/>

	<xsl:template mode="screen" match="/">
		<ui:body-screen>
			<ui:content>			
				<xsl:variable name="func" select="sw:param('func')"/>
				<xsl:choose>
					<xsl:when test="$func='size'">
						
						<xsl:variable name="path" select="sw:base64-decode(sw:param('path'))"/>
						<xsl:variable name="name" select="sw:base64-decode(sw:param('name'))"/>
						
						<xsl:variable name="fm-input">
							<usage/>
							<follow_links/>
						</xsl:variable>
					  <xsl:variable name="fm-res" select="filem:stat(file:path4vza($path),$name,sw:ve-eid(),$fm-input)"/>
					  <xsl:variable name="info" 	select="$fm-res"/>
					  <xsl:choose>
					  	<xsl:when test="$info/size">
								<ui:raw>
									|<xsl:value-of select="format:bytes2str($info/size,true(),'mb',false())"/><xsl:if test="$info/size!=0"> (<xsl:value-of select="format:bytes2str($info/size,true(),'bytes',true())"/>)</xsl:if>|
								</ui:raw>
							</xsl:when>
							<xsl:otherwise>
								<ui:raw>
									|Error cp1201 occured during calculation.|
								</ui:raw>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
				</xsl:choose>
			</ui:content>
		</ui:body-screen>
										
  </xsl:template>
  
	<!-- includes -->
	<sw:include href="/lib/vza/filem.xsl"/>		
	
  <sw:include href="/lib/screen.xsl"/>
  <sw:include href="/lib/vocabulary.xsl"/>  


</xsl:stylesheet>
