<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl browse cred vzenv-files file"
  xmlns:xsl					="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl				="http://exslt.org/common"
  xmlns:sw					="http://www.swsoft.com/xsl/cp"
  xmlns:browse			="http://www.swsoft.com/xsl/cp/browse" 
  xmlns:ui					="http://www.swsoft.com/xsl/cp/ui"   
  xmlns:env					="http://www.swsoft.com/xsl/cp/env"  
  xmlns:vzenv-files	="http://www.swsoft.com/xsl/cp/vzenv-files"
  xmlns:cred  			="http://www.swsoft.com/xsl/cp/cred"
  xmlns:file="http://www.swsoft.com/xsl/cp/file"
>

	<sw:include href="/lib/vt/env-core.xsl"/>
	<sw:include href="/lib/utils/file.xsl"/>

  <!-- check permissions to show this page -->
	<xsl:template mode="screen" match="/">
					
		<xsl:variable name="select-folders">
			<xsl:variable name="src-get" select="sw:param('select-folders')"/>		
			<xsl:choose>
				<xsl:when test="$src-get">
					<xsl:if test="sw:sesputstr('env-files-selector-select-folders',$src-get)"/>
					<xsl:value-of select="$src-get"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="sw:sesget('env-files-selector-select-folders')"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="select-files">
			<xsl:variable name="src-get" select="sw:param('select-files')"/>
			<xsl:choose>
				<xsl:when test="$src-get">
					<xsl:if test="sw:sesput('env-files-selector-select-files',$src-get)"/>
					<xsl:value-of select="$src-get"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="sw:sesget('env-files-selector-select-files')"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="dst-control">
			<xsl:variable name="src-get" select="sw:param('dst-control')"/>		
			<xsl:choose>
				<xsl:when test="$src-get">
					<xsl:if test="sw:sesputstr('env-files-selector-dst-control',$src-get)"/>
					<xsl:value-of select="$src-get"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="sw:sesget('env-files-selector-dst-control')"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="eid">
			<xsl:variable name="eid-get" select="sw:param('base')"/>		
			<xsl:choose>
				<xsl:when test="$eid-get">
					<xsl:if test="sw:sesputstr('env-files-selector-eid',$eid-get)"/>
					<xsl:value-of select="$eid-get"/>
				</xsl:when>
				<xsl:when test="sw:param('dst-control')">
					<xsl:if test="sw:sesputstr('env-files-selector-eid',sw:ve-eid())"/>
					<xsl:value-of select="sw:ve-eid()"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="sw:sesget('env-files-selector-eid')"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>		
		<xsl:variable name="env-info" select="env:eid2info($eid)"/>
		<xsl:variable name="path" select="vzenv-files:path('env-selector-path','env-files-selector')"/>
		<xsl:variable name="path-js" select="sw:html-escape(file:path4screen($path),'escape-quotes,escape-backslash')"/>

    <ui:popup-screen id="03.02.01.12.10" title="{sw:text('File Selector')}" icon="env">
	    <ui:properties>
	    	<ui:js-tail>
					<script language="JavaScript">
						function submitPath(){			
							obj = document.defaultForm.filename;
							var name='';
							for(i=0;i&lt;obj.length;i++){
								if(obj[i].checked){
									name = obj[i].value;
								}
							}	
							if(name=='' &amp;&amp; obj.checked){
								name = obj.value;
							}
							if(name==''){
								alert('<sw:text>Please select a file.</sw:text>');
								return false;
							}
							var path = '<xsl:value-of select="$path-js"/>'; 
							<xsl:choose>
								<xsl:when test="$env-info/linux">
									if(path!='/'){
										path = path + '/';
									}
									path = path + name;
								</xsl:when>
								<xsl:otherwise>
									path = path + name;
									var reg = /\//g;
									path = path.replace(reg,"\\");
								</xsl:otherwise>								
							</xsl:choose>
							parent.opener.document.getElementById('<xsl:value-of select="$dst-control"/>').value=path;
							window.close();
							return false;
						}				
					</script>
	    	</ui:js-tail>
	    </ui:properties>

	    <ui:content>
	    
	    	<ui:block width="full">
	    		<ui:rows>
	    			<ui:row>
	    				<ui:cell>
	    					<sw:text>
	    						On this screen you can choose a file by selecting its checkbox and pressing 'Select'.
	    					</sw:text>
	    				</ui:cell>
	    			</ui:row>
	    		</ui:rows>
					<xsl:call-template name="vzenv-files:browse">
						<xsl:with-param name="dst-eid" select="$eid"/>
						<xsl:with-param name="env-platform" select="$env-info/platform"/>
						<xsl:with-param name="path" select="$path"/>
						<xsl:with-param name="browse-session-key" select="'env-files-selector'"/>
						<xsl:with-param name="browse-url" select="'/vzdir/infrman/envs/files/selector-popup'"/>
						<xsl:with-param name="select-type" select="'radio'"/>
						<xsl:with-param name="select-id" select="'filename'"/>
						<xsl:with-param name="select-folders" select="$select-folders='true'"/>
						<xsl:with-param name="select-files" select="$select-files='true'"/>						
						<xsl:with-param name="height" select="300"/>
						<xsl:with-param name="screen-buttons">
							<ui:buttons>
			          <ui:button type="ok" do-submit="false" script="submitPath();" sandclock="false"  tip="select_file"><sw:text>Select</sw:text></ui:button>
							</ui:buttons>
						</xsl:with-param>
					</xsl:call-template>					
	      </ui:block>	      	    
	    </ui:content>          

    </ui:popup-screen>

  </xsl:template>  

	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/vocabulary.xsl"/>
	  
	<sw:include href="/lib/vza/filem.xsl"/>  		
  <sw:include href="/lib/vz/vzenv-files.xsl"/>  
	  
</xsl:stylesheet>
