<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0"
	extension-element-prefixes="sw exsl func wiz cred env-samplem vzenv local env tem show voc vzapackagem hn format"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl="http://exslt.org/common"
	xmlns:set="http://exslt.org/sets" 
	xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:error="http://www.swsoft.com/xsl/cp/error"
	xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz"
	xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
	xmlns:func="http://exslt.org/functions"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:env-samplem="http://www.swsoft.com/xsl/cp/env-samplem"
	xmlns:env="http://www.swsoft.com/xsl/cp/env"
	xmlns:vzenv="http://www.swsoft.com/xsl/cp/vzenv"
	xmlns:vzve="http://www.swsoft.com/xsl/cp/vzve"	
	xmlns:local="http://www.swsoft.com/xsl/cp/local"
	xmlns:tem="http://www.swsoft.com/xsl/cp/tem"
	xmlns:hn="http://www.swsoft.com/xsl/cp/hn"
	xmlns:browse	="http://www.swsoft.com/xsl/cp/browse"
	xmlns:show="http://www.swsoft.com/xsl/cp/show"
	xmlns:voc="http://www.swsoft.com/xsl/cp/voc"
	xmlns:vzapackagem="http://www.swsoft.com/xsl/cp/vzapackagem"
 	xmlns:vz		="http://www.swsoft.com/xsl/cp/vz"
 	xmlns:format="http://www.swsoft.com/xsl/cp/format"	
	xmlns:res			="http://www.swsoft.com/xsl/cp/res"		
>
	
	<sw:include href="/lib/cred-filter.xsl"/>
	<sw:include href="/lib/swa/env-samplem.xsl"/>
	<sw:include href="/lib/vt/env-core.xsl"/>
	<sw:include href="/lib/vt/hn-list.xsl"/>
	<sw:include href="/lib/vt/hn-list.xsl"/>
	<sw:include href="/lib/vz/core.xsl"/>		
	<sw:include href="/lib/vz/vzenv-core.xsl"/>
	<sw:include href="/lib/vz/vzenv-qos.xsl"/>
	<sw:include href="/lib/vz/vzenv-net.xsl"/>
	<sw:include href="/lib/utils/format-resusage.xsl"/>

	<xsl:param name="wiz_code" select="'ve_change'"/>

	<xsl:variable name="step_data" 		select="wiz:getStep()"/>
	<xsl:variable name="step" 			select="$step_data/@id"/>
	<xsl:variable name="screen-id" 		select="$step_data/@screen-id"/>
	<xsl:variable name="screen-title" 	select="$step_data/@screen-title"/>
	<xsl:variable name="form" 			select="sw:sesget($wiz_data)"/>
	<xsl:param name="access-denied" 	select="$step_data/@cred and not(cred:check($step_data/@cred))"/>

	<!-- Wizard, Step 'Start' -->
	<xsl:template name="step_start">
		<ui:screen id="{$screen-id}">

			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes">
					<sw:text>
						<xsl:with-param name="ve-count" select="count($form/def/env)"/>
						You have selected %{ve-count} Containers to perform a certain action on them simultaneously. Please specify the action that you want to run.
			        </sw:text>
				</ui:description>
				<ui:form-get/>
			</ui:properties>

			<ui:content>
				<ui:hidden name="step" value="start"/>
				<ui:block mode="view">

					<ui:rows title="{sw:text('Select Action')}">

						<!-- Configure VE -->
						<xsl:if
							test="count(cred:filter-valid-env('vzcp.env.manage.properties.preferences',$form/def/env/eid,false())) > 0">
							<ui:row>
								<ui:cell-radio name="_action" id="action_config" value="config">
									<xsl:if test="$form/action='config'">
										<xsl:attribute name="checked">true</xsl:attribute>
									</xsl:if>
								</ui:cell-radio>
								<ui:cell cell-width="100%" align="left">
									<b>
										<sw:text>Configure Containers General Settings</sw:text>
									</b>
								</ui:cell>
							</ui:row>
							<ui:row>
								<ui:cell/>
								<ui:cell cell-width="100%">
									<sw:text>
									This wizard allows you to set up such Container properties as "offline management" and "automatic boot".
								</sw:text>
								</ui:cell>
							</ui:row>
						</xsl:if>
						<!-- Set Resouces-->
						<ui:row>
							<ui:cell-radio name="_action" id="action_res" value="res"
								checked="{$form/action='res'}"/>
							<ui:cell cell-width="100%" align="left">
								<b>
									<sw:text>Configure Containers Resources</sw:text>
								</b>
							</ui:cell>
						</ui:row>
						<ui:row>
							<ui:cell/>
							<ui:cell cell-width="100%">
								<sw:text>
								Here you will be able to adjust the resources configuration for the selected Containers.
							</sw:text>
							</ui:cell>
						</ui:row>
						<!-- /Set Resources -->	
						<!-- Set Disk Quota -->
						<xsl:if
							test="count(cred:filter-valid-env('vzcp.env.manage.properties.preferences',$form/def/env/eid,false())) > 0">
							<ui:row>
								<ui:cell-radio name="_action" id="action_disk" value="disk"
									checked="{$form/action='disk'}"/>
								<ui:cell cell-width="100%" align="left">
									<b>
										<sw:text>Set Containers Disk Limits</sw:text>
									</b>
								</ui:cell>
							</ui:row>
							<ui:row>
								<ui:cell/>
								<ui:cell cell-width="100%">
									<sw:text>
									Here you will be able to adjust the disk limits for the selected Containers.
								</sw:text>
								</ui:cell>
							</ui:row>
							<!-- /Set Disk Quota -->
						</xsl:if>
						<!-- AutoUpgrade Application -->
						<xsl:if
							test="$form/def/linux and count(cred:filter-valid-env('vzcp.env.manage.properties.preferences',$form/def/env/eid,false())) > 0">
							<ui:row>
								<ui:cell-radio name="_action" id="action_autoupgrade" value="autoupgrade"
									checked="{$form/action='autoupgrade'}"/>
								<ui:cell cell-width="100%" align="left">
									<b>
										<sw:text>Update Containers Software</sw:text>
									</b>
								</ui:cell>
							</ui:row>
							<ui:row>
								<ui:cell/>
								<ui:cell cell-width="100%">
									<sw:text>
										This wizard will allow you to install the latest updates of applications and operating system to all the selected Containers at once.
									</sw:text>
								</ui:cell>
							</ui:row>
						</xsl:if>
						<!-- /Upgrade Application -->
						<!-- Apply Template -->
						<xsl:if
							test="count(cred:filter-valid-env('vzcp.env.manage.properties.preferences',$form/def/env/eid,false())) > 0">
							<ui:row>
								<ui:cell-radio name="_action" id="action_apply" value="apply">
									<xsl:if test="$form/action='apply'">
										<xsl:attribute name="checked">true</xsl:attribute>
									</xsl:if>
								</ui:cell-radio>
								<ui:cell cell-width="100%" align="left">
									<b>
										<sw:text>Apply Container Sample to Containers</sw:text>
									</b>
								</ui:cell>
							</ui:row>
							<ui:row>
								<ui:cell/>
								<ui:cell cell-width="100%">
									<sw:text>
										You can change the Container resource settings by changing the sample on which these Containers are based. The wizard will let you specify the needed sample and configure some additional parameters.
									</sw:text>
								</ui:cell>
							</ui:row>
						</xsl:if>
						<!-- /Apply Template -->
						
						<!-- Add App Templates -->
						<xsl:if
							test="count(cred:filter-valid-env('vzcp.env.manage.properties.application',$form/def/env/eid,false())) > 0">
							<ui:row>
								<ui:cell-radio name="_action" id="action_add_apps" value="add_apps">
									<xsl:if test="$form/action='add_apps'">
										<xsl:attribute name="checked">true</xsl:attribute>
									</xsl:if>
								</ui:cell-radio>
								<ui:cell cell-width="100%" align="left">
									<b>
										<sw:text>Add Software to Containers</sw:text>
									</b>
								</ui:cell>
							</ui:row>
							<ui:row>
								<ui:cell/>
								<ui:cell cell-width="100%">
									<sw:text>
										You can install certain software on the selected Containers by adding the corresponding application templates. This wizard will let you specify the needed applications.
									</sw:text>
								</ui:cell>
							</ui:row>
						</xsl:if>
						<!-- /Add App Templates -->
						
						<!-- Del App Templates -->
						<xsl:if
							test="count(cred:filter-valid-env('vzcp.env.manage.properties.application',$form/def/env/eid,false())) > 0">
							<ui:row>
								<ui:cell-radio name="_action" id="action_del_apps" value="del_apps">
									<xsl:if test="$form/action='del_apps'">
										<xsl:attribute name="checked">true</xsl:attribute>
									</xsl:if>
								</ui:cell-radio>
								<ui:cell cell-width="100%" align="left">
									<b>
										<sw:text>Remove Software From Containers</sw:text>
									</b>
								</ui:cell>
							</ui:row>
							<ui:row>
								<ui:cell/>
								<ui:cell cell-width="100%">
									<sw:text>
										You can uninstall certain software from the selected Containers by removing the corresponding application templates. The wizard will let you specify the applications that are no longer needed.
									</sw:text>
								</ui:cell>
							</ui:row>
						</xsl:if>
						<!-- /Del App Templates -->

					</ui:rows>

					<ui:buttons>
						<xsl:call-template name="wiz:showButtons">
							<xsl:with-param name="submit-title" select="sw:text('Next')"/>
							<xsl:with-param name="next-title" select="sw:text('Next')"/>
						</xsl:call-template>
					</ui:buttons>

				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>
	
	
	<xsl:template name="step_add_apps_review">
		<xsl:variable name="screen-icon"	select="'app_package'"/>
		<!-- List App templates -->
		
		<ui:screen id="{$screen-id}" icon="{$screen-icon}">
			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes">
					<sw:text>
	        	On this screen you can review the application templates that will be added to the Containers.
	        </sw:text>
				</ui:description>
				<ui:form-get/>
			</ui:properties>
			
			<ui:content>
				<ui:hidden name="step" value="add_apps_review"/>
				
				<ui:block>
					<ui:rows title="{sw:text('Selected Applications')}">
						<ui:browse >
							<ui:filter>
								<xsl:variable name="filter-rtf">
									<xsl:call-template name="browse:init-filter">
										<xsl:with-param name="browse">
											<ui:browse-setup id="tmpl_browse"
												url="/vzdir/infrman/envs/list-change?tab=add_apps_review" post-only-rows="true"/>
											<ui:cols>
												<ui:column id="name" show-url="no"
													title="{sw:text('Template Name')}" apply-template="yes"/>
												<ui:column id="version" show-url="no" title="{sw:text('Version')}" sorting="no"/>
												<ui:column id="title" show-url="no" 
													title="{sw:text('Container')}" align="center"/>
												<ui:column id="description" show-url="no"
													title="{sw:text('Description')}" sorting="no"/>
											</ui:cols>
										</xsl:with-param>
										<!--				<xsl:with-param name="no-limit" select="true()" />-->
									</xsl:call-template>
								</xsl:variable>
								<xsl:call-template name="browse:fill-filter">
									<xsl:with-param name="filter" select="exsl:node-set($filter-rtf)"/>
									<xsl:with-param name="rows">
										<ui:browse-rows>
											<xsl:for-each select="$form/add_apps/updates/update">
												<ui:row>
													<name><xsl:value-of select="sw:app-id2title(package/name)"/></name>
													<version><xsl:value-of 
														select="sw:if(package/version, package/version, sw:text('n/a'))"/></version>
													<xsl:variable name="eid" select="eid"/>
													<title><xsl:value-of select="$form/def/env[eid=$eid]/title"/></title>
													<description><xsl:value-of select="package/summary"/></description>
												</ui:row>
											</xsl:for-each>
										</ui:browse-rows>
									</xsl:with-param>
								</xsl:call-template>
							</ui:filter>
							<ui:browse-empty-msg>
								<sw:text>No applications have been selected for installation.</sw:text>
							</ui:browse-empty-msg>
						</ui:browse>
					</ui:rows>
					<ui:buttons>
						<xsl:call-template name="wiz:showButtons">
							<xsl:with-param name="submit-title" select="sw:text('Submit')"/>
							<xsl:with-param name="next-title" select="sw:text('Next')"/>
						</xsl:call-template>
					</ui:buttons>
				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>
	
	
	<!-- Wizard, Step 'Add VE software' -->
	<xsl:template name="step_add_apps">
		<xsl:variable name="screen-icon"	select="'app_package'"/>
		
		<!-- List App templates -->
		
		
		<ui:screen id="{$screen-id}" icon="{$screen-icon}">
			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes">
					<sw:text>
	        	On this screen you can install certain software on the selected Containers by adding the corresponding application templates.
	        </sw:text>
				</ui:description>
				<ui:form-get/>
			</ui:properties>
			
			
			<xsl:variable name="apps" select="set:distinct($form/updates/env/package)"/>
			
			<ui:content>
				<ui:hidden name="step" value="add_apps"/>
				<ui:block mode="edit">
					<ui:rows title="{sw:text('Select Applications to Install')}" separate-tables="true">
						<ui:tree-selector id="apps">
							<ui:nodes-selected>
								<xsl:apply-templates select="$form/add_apps/nodes/*" mode="local:selected-nodes"/>
							</ui:nodes-selected>
							<ui:nodes>
								<xsl:for-each select="set:distinct($apps/name)">
									<xsl:sort select="sw:app-id2title(.)"/>
									<xsl:variable name="group-name" select="string(.)"/>
									<xsl:variable name="group-envs" select="$form/updates/env[package/name=$group-name]"/>
									
									<xsl:if test="$group-envs">
										<ui:node>
											<ui:id>
												<xsl:value-of select="."/>
											</ui:id>
											<ui:title>
												<xsl:value-of select="sw:app-id2title(.)"/>
												<ui:raw>
													<br/>
													<span class="inactive">
														<xsl:copy-of select="$apps[name=$group-name][1]/summary"/>
													</span>
												</ui:raw>
											</ui:title>
											
											<xsl:variable name="id" select="."/>
											<xsl:for-each select="$group-envs">
												<ui:node>
													<ui:id>
														<xsl:value-of select="eid"/>
													</ui:id>
													<ui:title>
														<xsl:value-of select="title"/>
													</ui:title>
												</ui:node>
											</xsl:for-each>
										</ui:node>
									</xsl:if>
								</xsl:for-each>
							</ui:nodes>
						</ui:tree-selector>
					</ui:rows>
					
					<ui:rows title="{sw:text('Additional Actions')}">
						<ui:row>
							<ui:cell-check id="start" checked="{not($form/add_apps/start) or $form/add_apps/start='1'}" close="false"
								colspan="2"/>
							<ui:cell open="false">
								<sw:text>Start the Containers, if needed, to add the templates.</sw:text>
							</ui:cell>
						</ui:row>
					</ui:rows>
				
					<ui:buttons>
						<xsl:call-template name="wiz:showButtons">
							<xsl:with-param name="submit-title" select="sw:text('Submit')"/>
							<xsl:with-param name="next-title" select="sw:text('Next')"/>
						</xsl:call-template>
					</ui:buttons>

				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>
	
	<xsl:template match="node-id" mode="local:selected-nodes">
		<ui:node>
			<ui:id>
				<xsl:value-of select="."/>
			</ui:id>
		</ui:node>				
	</xsl:template>
	
	<!-- Wizard, Step 'Remove VE software' -->
	<xsl:template name="step_del_apps">
		<xsl:variable name="screen-icon"	select="'app_package'"/>
		
		<!-- List App templates -->
		
		
		<ui:screen id="{$screen-id}" icon="{$screen-icon}">
			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes">
					<sw:text>
	        	On this screen you can uninstall certain software from the selected Containers by removing the corresponding application templates.
	        </sw:text>
				</ui:description>
				<ui:form-get/>
			</ui:properties>
			
			<xsl:variable name="apps" select="vzapackagem:vztemplate-packages(set:distinct($form/def/env/apps/id))"/>
			
			<ui:content>
				<ui:hidden name="step" value="del_apps"/>
				<ui:block mode="edit">
					<ui:rows title="{sw:text('Select Applications to Remove')}" separate-tables="true">
						<ui:tree-selector id="apps">
							<ui:nodes-selected/>
							<ui:nodes>
								<xsl:for-each select="set:distinct($apps/name)">
									<xsl:sort select="sw:app-id2title(.)"/>
									<xsl:variable name="group-name" select="string(.)"/>
									<xsl:variable name="group" select="vzapackagem:generate-ids($apps[name=$group-name])"/>
									
									<ui:node>
										<ui:id>
											<xsl:value-of select="."/>
										</ui:id>
										<ui:title>
											<xsl:value-of select="sw:app-id2title(.)"/>
										</ui:title>
										
										<xsl:variable name="id" select="."/>
										<xsl:for-each select="$form/def/env[apps/id=$group]">
											<ui:node>
												<ui:id><xsl:value-of select="eid"/></ui:id>
												<ui:title>
													<xsl:value-of select="title"/>
												</ui:title>
											</ui:node>										
										</xsl:for-each>										
									</ui:node>
								</xsl:for-each>
							</ui:nodes>
						</ui:tree-selector>
					</ui:rows>
					
					<ui:rows title="{sw:text('Additional Actions')}">
						<ui:row>
							<ui:cell-check id="start" checked="{not($form/del_apps/start) or $form/del_apps/start='1'}" 
								close="false" colspan="2"/>
							<ui:cell open="false">
								<sw:text>Start the Containers, if needed, to remove the templates.</sw:text>
							</ui:cell>
						</ui:row>
					</ui:rows>
				
					<ui:buttons>
						<xsl:call-template name="wiz:showButtons">
							<xsl:with-param name="submit-title" select="sw:text('Submit')"/>
							<xsl:with-param name="next-title" select="sw:text('Next')"/>
						</xsl:call-template>
					</ui:buttons>

				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>

	<!-- Wizard, Step 'Apply VE Sample' -->
	<xsl:template name="step_apply">
		<xsl:variable name="sample-configs" select="env-samplem:list-samples('virtuozzo','',$form/def/platform)"/>
		<xsl:variable name="screen-icon"	select="'env_sample_apply'"/>
		
		<ui:screen id="{$screen-id}" icon="{$screen-icon}">
			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes">
					<sw:text>
	        	On this screen you can select the Container sample. On the next step you will be able to specify the required resource categories and/or individual resources.
	        </sw:text>
				</ui:description>
				<ui:form-get/>
			</ui:properties>

			<ui:content>
				<ui:hidden name="step" value="apply"/>
				<ui:block mode="edit">
				
					<!-- Prepare browse data -->
					<xsl:variable name="filter_init_">
						<xsl:call-template name="browse:init-filter">
							<xsl:with-param name="browse">
								<ui:browse-setup id="apply-envsamples" url="/vzdir/infrman/envs/list-change"
									select-type="radio" items-title="{sw:text('Container Samples')}" select-on-left="true"
									select-id="{$form/apply/sample-id}"/>
								<ui:cols sorting-col="ve-tmpl-name">
									<ui:column id="sample-id" for-url="yes" hidden="yes" for-select="yes"/>
									<ui:column id="ve-tmpl-name" show-url="no" title="{sw:text('Sample Name')}"
										filter="auto" post-apply-templates="yes"/>
									<ui:column id="comment" nav-type="title" hidden="yes"
										title="{sw:text('Description')}" filter="auto"/>
								</ui:cols>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:variable>

					<xsl:variable name="filter">
						<xsl:call-template name="browse:fill-filter">
							<xsl:with-param name="filter" select="exsl:node-set($filter_init_)"/>
							<xsl:with-param name="rows">
								<ui:browse-rows>
									<xsl:for-each select="$sample-configs">
										<ui:row>
											<sample-id>
												<xsl:value-of select="id"/>
											</sample-id>
											<ve-tmpl-name>
												<xsl:value-of select="name"/>
											</ve-tmpl-name>
											<comment>
												<xsl:value-of select="sw:base64-decode(comment)"/>
											</comment>
										</ui:row>
									</xsl:for-each>
								</ui:browse-rows>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:variable>

					<!-- /Prepare browse data -->

					<!-- Show Samples -->
					<ui:rows title="{sw:text('Container Sample Selection')}">
						<ui:browse>
							<ui:filter>
								<xsl:copy-of select="$filter"/>
							</ui:filter>
							<ui:browse-empty-msg>
								<sw:text>No Container samples available.</sw:text>
							</ui:browse-empty-msg>
						</ui:browse>
					</ui:rows>

					<ui:buttons>
						<xsl:call-template name="wiz:showButtons">
							<xsl:with-param name="submit-title" select="sw:text('Submit')"/>
							<xsl:with-param name="next-title" select="sw:text('Next')"/>
						</xsl:call-template>
					</ui:buttons>

				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>

	<!-- Wizard, Step 'Apply VE Sample/QoS' -->
	<xsl:template name="step_apply_qos">
		<xsl:variable name="screen-icon"	select="'env_sample_apply'"/>
		
		<ui:screen id="{$screen-id}" icon="{$screen-icon}">
			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes">
					<sw:text>
	        	A Container sample includes several groups of resources. On this screen you can specify the required resource categories and/or individual resources.	        	
	        </sw:text>
				</ui:description>
				<ui:form-get/>
			</ui:properties>

			<ui:content>
				<ui:hidden name="step" value="apply_qos"/>
				<ui:block mode="edit" width="full">
				
					<xsl:variable name="sample" select="env-samplem:get-sample($form/apply/sample-id)"/>
					
					<!-- Translate data into internal format -->
					<xsl:variable name="config" select="$sample/env_config"/>
					<xsl:variable name="config-res-src">
						<xsl:for-each select="$config/qos">
							<slm-mode><xsl:value-of select="$form/apply/slm-mode"/></slm-mode>
							<res>
								<xsl:copy-of select="node()"/>
								<soft_src>
									<xsl:value-of select="soft"/>
								</soft_src>
								<hard_src>
									<xsl:value-of select="hard"/>
								</hard_src>
							</res>
						</xsl:for-each>
					</xsl:variable>
					<xsl:variable name="config-res" select="exsl:node-set($config-res-src)"/>	
					<xsl:variable name="qos-src">
						<xsl:call-template name="vzenv:conv-qos-data">
							<xsl:with-param name="platform-ref" select="env:make-platform-ref('',$form/def/platform)"/>
							<xsl:with-param name="data" select="$config-res"/>
							<xsl:with-param name="default-show-cats" select="true()"/>							
						</xsl:call-template>
					</xsl:variable>
					<xsl:variable name="qos" select="exsl:node-set($qos-src)/ui:qos-data"/>
					<!-- /Translate data into internal format -->
					
					<xsl:call-template name="vzenv:view-qos">
						<xsl:with-param name="qos" select="$qos"/>			
						<xsl:with-param name="show-usage" select="false()"/>																		
						<xsl:with-param name="show-selector" select="true()"/>				
						<xsl:with-param name="selected-res" select="$form/apply/selected-res"/>											
					</xsl:call-template>
					
					<xsl:if test="$form/def/linux">
						<ui:rows title="{sw:text('Advanced Options')}" id="options"
							status="{$form/apply/options}"
							closed-text="{sw:text('Click to set up the advanced options.')}"
						>
							<ui:row>
								<ui:cell-check id="restart" checked="{$form/apply/restart='1'}" close="false"
									colspan="2"/>
								<ui:cell open="false">
									<sw:text>Restart the Container if the resources change requires a restart</sw:text>
								</ui:cell>
							</ui:row>
						</ui:rows>
					</xsl:if>

					<ui:buttons>
						<xsl:call-template name="wiz:showButtons">
							<xsl:with-param name="submit-title" select="sw:text('Apply Sample')"/>
							<xsl:with-param name="next-title" select="sw:text('Next')"/>
						</xsl:call-template>
					</ui:buttons>

				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>

	<!-- Wizard, Step 'Configure VE' -->
	<xsl:template name="step_config">
		<xsl:variable name="screen-icon"	select="'setup'"/>

		<ui:screen id="{$screen-id}" icon="{$screen-icon}">
			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes">
					<sw:text>	        	
	          On this screen you can change the Containers general configuration.
	        </sw:text>
				</ui:description>
				<ui:form-get/>
			</ui:properties>

			<ui:content>
				<ui:hidden name="step" value="config"/>
				<ui:block mode="edit">

					<ui:rows title="{sw:text('Configure Containers General Settings')}">

						<xsl:variable name="params-rtf">
							<param>
								<id>start</id>
								<title>
									<sw:text>Change "Start on Hardware Node boot" to </sw:text>
								</title>
							</param>
							<param>
								<id>offline</id>
								<title>
									<sw:text>Change "Offline Management Enabled" to</sw:text>
								</title>
							</param>
							<xsl:if test="$form/def/linux">
								<param>
									<id>enabled</id>
									<title>
										<sw:text>Change "Container Enabled" to</sw:text>
									</title>
								</param>
							</xsl:if>
						</xsl:variable>
						<xsl:variable name="params" select="exsl:node-set($params-rtf)"/>

						<!-- Show Controls -->
						<xsl:for-each select="$params/param">
							<xsl:variable name="id" select="id"/>
							<xsl:variable name="state" select="$form/config/*[name()=$id]"/>
							<ui:row>
								<ui:cell colspan="2">
									<b>
										<xsl:value-of select="title"/>
									</b>
								</ui:cell>
							</ui:row>
							<ui:row>
								<ui:cell-radio name="{$id}" id="{$id}_none" value="" checked="{not($state!='')}"/>
								<ui:cell cell-width="100%" align="left">
									<sw:text>Do not change the settings</sw:text>
								</ui:cell>
							</ui:row>
							<ui:row>
								<ui:cell-radio name="{$id}" id="{$id}_on" value="1" checked="{$state='1'}"/>
								<ui:cell cell-width="100%" align="left">
									<sw:text>On</sw:text>
								</ui:cell>
							</ui:row>
							<ui:row>
								<ui:cell-radio name="{$id}" id="{$id}_off" value="0" checked="{$state='0'}"/>
								<ui:cell cell-width="100%" align="left">
									<sw:text>Off</sw:text>
								</ui:cell>
							</ui:row>
						</xsl:for-each>
					</ui:rows>

					<ui:buttons>
						<xsl:call-template name="wiz:showButtons">
							<xsl:with-param name="submit-title" select="sw:text('Submit')"/>
							<xsl:with-param name="next-title" select="sw:text('Next')"/>
						</xsl:call-template>
					</ui:buttons>

				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>

	<!-- Wizard, Step 'Set Disk Quota' -->
	<xsl:template name="step_disk">
		<xsl:variable name="env-data"		select="env:get-env($form/def/env/eid)"/>
		<xsl:variable name="voc"			select="local:get-voc($form/def/env[1])"/>
		<xsl:variable name="voc-diskspace"	select="$voc[id='diskspace']"/>
		<xsl:variable name="voc-diskinodes"	select="$voc[id='diskinodes']"/>
		<xsl:variable name="stat-ext"		select="$form/def/linux and not($form/disk/stat-simple='1')"/>
		<xsl:variable name="screen-icon"	select="'setup'"/>
		

		<ui:screen id="{$screen-id}" icon="{$screen-icon}">

			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes" width="full">
					<sw:text>
	        	On this screen you can change the disk limits for all the selected Containers.
	        </sw:text>
				</ui:description>
				<ui:form-get/>
			</ui:properties>

			<ui:content>
				<ui:hidden name="step" value="disk"/>
				<ui:block mode="edit">
					<xsl:if test="$stat-ext">
						<xsl:attribute name="width">full</xsl:attribute>
					</xsl:if>

					<xsl:variable name="filter_init_">
						<xsl:call-template name="browse:init-filter">
							<xsl:with-param name="browse">
								<ui:browse-setup id="{sw:if($stat-ext,'ve-change-disk-ext','ve-change-disk-basic')}"
									hide-filter-controls="true" post-only-rows="true"
									url="/vzdir/infrman/envs/list-change"/>
								<ui:cols>
									<ui:column id="id" data-type="int" title="{sw:text('Container ID')}"/>
									<ui:column id="title" title="{sw:text('Title')}"/>
									<!-- Show different cols for simple and advanced modes -->
									<xsl:choose>
										<xsl:when test="$stat-ext">
											<ui:column id="used-inodes" title="{sw:text('Used Inodes')}" data-type="int"/>
											<ui:column id="inodes-soft" title="{sw:text('Inodes Soft Limit')}"
												data-type="int"/>
											<ui:column id="inodes-hard" title="{sw:text('Inodes Hard Limit')}"
												data-type="int"/>
											<ui:column id="used1kb" title="{sw:text('Used Disk, KB')}" data-type="int"/>
											<ui:column id="quota-soft-kb" title="{sw:text('Disk Quota Soft Limit, KB')}"
												data-type="int"/>
											<ui:column id="quota-hard-kb" title="{sw:text('Disk Quota Hard Limit, KB')}"
												data-type="int"/>
										</xsl:when>
										<xsl:otherwise>
											<ui:column id="quota-used-proc" title="{sw:text('Used Disk, %')}" data-type="int"
												display-type="procs"/>
											<ui:column id="used1mb" title="{sw:text('Used Disk')}" data-type="int"
												display-type="size/byte" display-unit="mbyte" show-unit="true"/>
											<ui:column id="total1mb" title="{sw:text('Current Disk Quota')}"
												data-type="int" display-type="size/byte" display-unit="mbyte"
												show-unit="true"/>
										</xsl:otherwise>
									</xsl:choose>
								</ui:cols>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:variable>

					<xsl:variable name="filter">
						<xsl:call-template name="browse:fill-filter">
							<xsl:with-param name="filter" select="exsl:node-set($filter_init_)"/>
							<xsl:with-param name="rows">
								<ui:browse-rows>
									<xsl:for-each select="$env-data/env">
										<xsl:variable name="eid" select="eid"/>
										<xsl:variable name="quota" select="env:get-quota($eid)/ve_quota"/>
										<xsl:variable name="disk-now" select="virtual_config/qos[id='diskspace']"/>
										<xsl:variable name="inodes-now" select="virtual_config/qos[id='diskinodes']"/>
																			
										<ui:row>
											<id>
												<xsl:value-of select="virtual_config/veid"/>
											</id>
											<title>
												<xsl:value-of select="env:env2title(.)"/>
											</title>
											<used-inodes>
												<xsl:value-of select="format:res2str($quota/diskinodes/cur,'',true())"/>
											</used-inodes>
											<xsl:choose>
												<!-- Check for unlimited -->
												<xsl:when test="res:param2hard($voc-diskinodes/unlimited)=$inodes-now/hard">
													<inodes-soft>
														<sw:text>Unlimited</sw:text>
													</inodes-soft>
													<inodes-hard>
														<sw:text>Unlimited</sw:text>
													</inodes-hard>
												</xsl:when>
												<xsl:otherwise>
													<inodes-soft>
														<xsl:value-of select="format:res2str($inodes-now/soft,'',true())"/>
													</inodes-soft>
													<inodes-hard>
														<xsl:value-of select="format:res2str($inodes-now/hard,'',true())"/>
													</inodes-hard>
												</xsl:otherwise>
											</xsl:choose>
											<used1kb>
												<xsl:value-of select="format:res2str($quota/diskspace/cur,'',true())"/>
											</used1kb>
											<used1mb>
												<xsl:value-of select="$quota/diskspace/cur*1024"/>
											</used1mb>
											<!-- Show disk limits -->
											<xsl:choose>
												<!-- Check for unlimited -->
												<xsl:when test="res:param2hard($voc-diskspace/unlimited)=$disk-now/hard">
													<quota-soft-kb>
														<sw:text>Unlimited</sw:text>
													</quota-soft-kb>
													<quota-hard-kb>
														<sw:text>Unlimited</sw:text>
													</quota-hard-kb>
												</xsl:when>
												<xsl:otherwise>
													<quota-soft-kb>
														<xsl:value-of select="format:res2str($disk-now/soft,'',true())"/>
													</quota-soft-kb>
													<quota-hard-kb>
														<xsl:value-of select="format:res2str($disk-now/hard,'',true())"/>
													</quota-hard-kb>
												</xsl:otherwise>
											</xsl:choose>
											<!-- Show total1mb -->
											<xsl:choose>
												<!-- Check for unlimited -->
												<xsl:when test="res:param2hard($voc-diskspace/unlimited)=$disk-now/hard">
													<total1mb>
														<sw:text>Unlimited</sw:text>
													</total1mb>
													<quota-used-proc>
														<span class="inactive">
															<sw:text>n/a</sw:text>
														</span>
													</quota-used-proc>
												</xsl:when>
												<xsl:otherwise>
													<total1mb>
														<xsl:value-of select="$disk-now/hard * 1024"/>
													</total1mb>
													<quota-used-proc>
														<nobr>
															<xsl:value-of
																select="round($quota/diskspace/cur div $disk-now/hard * 100)"/>
														</nobr>
													</quota-used-proc>
												</xsl:otherwise>
											</xsl:choose>
										</ui:row>
									</xsl:for-each>
								</ui:browse-rows>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:variable>

					<ui:rows title="{sw:text('Containers Disk Usage Current Statistics')}">
						<xsl:if test="$form/def/linux">
							<ui:rows-title>
								<span>&#160;&#160;(</span>
								<xsl:choose>
									<xsl:when test="not($stat-ext)">
										<a href="#" onclick="document.defaultForm.stat_sample.value=0;doSubmit()"
											onmouseover="callTip('ve_quota_stat_more',event)" onmouseout="callTip('')">
											<sw:text>show more</sw:text>
										</a>
									</xsl:when>
									<xsl:otherwise>
										<a href="#" onclick="document.defaultForm.stat_sample.value=1;doSubmit()"
											onmouseover="callTip('ve_quota_stat_less',event)" onmouseout="callTip('')">
											<sw:text>show less</sw:text>
										</a>
									</xsl:otherwise>
								</xsl:choose>
								<span>)</span>
								<input type="hidden" name="stat_sample" value="{$form/disk/stat-simple}"/>
								<!--
			   				<span>&#160;&#160;(<label for="stat_sample"><sw:text>Simple</sw:text></label></span>
			   				<input type="checkbox" name="stat_sample" id="stat_sample" value="1"
			   					onchange="doSubmit();"
			   				>
			   					<xsl:if test="$form/disk/stat-simple='1'">
			   						<xsl:attribute name="checked">1</xsl:attribute>
			   					</xsl:if>
			   				</input>
			   				<span>)</span>
			   				-->
							</ui:rows-title>
						</xsl:if>
						<ui:browse>
							<ui:filter>
								<xsl:copy-of select="$filter"/>
							</ui:filter>
						</ui:browse>
					</ui:rows>

					<ui:rows title="{sw:text('Change Containers Disk Quota')}">

						<xsl:variable name="units-rtf">
							<unit id="1" title="KB"/>
							<unit id="1024" title="MB"/>
							<unit id="1048576" title="GB"/>
						</xsl:variable>
						<xsl:variable name="units" select="exsl:node-set($units-rtf)"/>

						<xsl:variable name="set-off">
							<ui:control-slave inverse="true">quota_set_value</ui:control-slave>
							<ui:control-slave inverse="true">quota_set_unit</ui:control-slave>
						</xsl:variable>
						<xsl:variable name="add-off">
							<ui:control-slave inverse="true">quota_add_value</ui:control-slave>
							<ui:control-slave inverse="true">quota_add_unit</ui:control-slave>
						</xsl:variable>
						<xsl:variable name="dec-off">
							<ui:control-slave inverse="true">quota_dec_value</ui:control-slave>
							<ui:control-slave inverse="true">quota_dec_unit</ui:control-slave>
						</xsl:variable>

						<!-- Set Quota -->
						<ui:row>
							<ui:cell-radio name="quota" value="set" id="quota_set">
								<xsl:if test="$form/disk/quota/method='set' or not($form/disk/quota/method)">
									<xsl:attribute name="checked">true</xsl:attribute>
								</xsl:if>
								<ui:control-slave>quota_set_value</ui:control-slave>
								<ui:control-slave>quota_set_unit</ui:control-slave>
								<xsl:copy-of select="$add-off"/>
								<xsl:copy-of select="$dec-off"/>
								<label for="quota_set">
									<sw:text>Set Disk Quota to</sw:text>
								</label>
							</ui:cell-radio>
							<ui:cell-input width="20" maxlength="20" name="quota_set_value" id="quota_set_value"
								value="{$form/disk/quota/set/value}"/>
							<ui:cell-list name="quota_set_unit" id="quota_set_unit" style="width:60px"
								value="{$form/disk/quota/set/unit}">
								<xsl:for-each select="$units/unit">
									<ui:list-item id="{@id}" title="{@title}"/>
								</xsl:for-each>
							</ui:cell-list>
							<ui:cell cell-width="100%"/>
						</ui:row>
						<!-- /Set Quota -->
						<!-- Add Quota -->
						<ui:row>
							<ui:cell-radio name="quota" value="add" id="quota_add">
								<xsl:if test="$form/disk/quota/method='add'">
									<xsl:attribute name="checked">true</xsl:attribute>
								</xsl:if>
								<ui:control-slave>quota_add_value</ui:control-slave>
								<ui:control-slave>quota_add_unit</ui:control-slave>
								<xsl:copy-of select="$set-off"/>
								<xsl:copy-of select="$dec-off"/>
								<label for="quota_add">
									<sw:text>Increase Disk Quota by</sw:text>
								</label>
							</ui:cell-radio>
							<ui:cell-input width="20" maxlength="20" name="quota_add_value" id="quota_add_value"
								value="{$form/disk/quota/add/value}"/>
							<ui:cell-list value="{$form/disk/quota/add/unit}" name="quota_add_unit"
								id="quota_add_unit" style="width:60px">
								<xsl:for-each select="$units/unit">
									<ui:list-item id="{@id}" title="{@title}"/>
								</xsl:for-each>
							</ui:cell-list>
							<ui:cell cell-width="100%"/>
						</ui:row>
						<!-- /Add Quota -->
						<!-- Decrease Quota -->
						<ui:row>
							<ui:cell-radio name="quota" value="dec" id="quota_dec">
								<xsl:if test="$form/disk/quota/method='dec'">
									<xsl:attribute name="checked">true</xsl:attribute>
								</xsl:if>
								<ui:control-slave>quota_dec_value</ui:control-slave>
								<ui:control-slave>quota_dec_unit</ui:control-slave>
								<xsl:copy-of select="$set-off"/>
								<xsl:copy-of select="$add-off"/>
								<label for="quota_dec">
									<sw:text>Decrease Disk Quota by</sw:text>
								</label>
							</ui:cell-radio>
							<ui:cell-input width="20" maxlength="20" name="quota_dec_value" id="quota_dec_value"
								value="{$form/disk/quota/dec/value}"/>
							<ui:cell-list value="{form/disk/quota/dec/unit}" name="quota_dec_unit"
								id="quota_dec_unit" style="width:60px">
								<xsl:for-each select="$units/unit">
									<ui:list-item id="{@id}" title="{@title}"/>
								</xsl:for-each>
							</ui:cell-list>
							<ui:cell cell-width="100%"/>
						</ui:row>
						<!-- /Decrease Quota -->
						<xsl:if test="$form/def/linux">
							<!-- Set Quota to Unlimited-->
							<ui:row>
								<ui:cell-radio name="quota" value="unlim" id="quota_unlim" colspan="3">
									<xsl:if test="$form/disk/quota/method='unlim'">
										<xsl:attribute name="checked">true</xsl:attribute>
									</xsl:if>
									<xsl:copy-of select="$set-off"/>
									<xsl:copy-of select="$add-off"/>
									<xsl:copy-of select="$dec-off"/>
									<label for="quota_unlim">
										<sw:text>Set unlimited disk quota</sw:text>
									</label>
								</ui:cell-radio>
								<ui:cell cell-width="100%"/>
							</ui:row>
							<!-- /Set Quota to Unlimited-->
							<!-- Do not change quota -->
							<ui:row>
								<ui:cell-radio name="quota" value="oldvalue" id="quota_oldvalue" colspan="3">
									<xsl:if test="$form/disk/quota/method='oldvalue'">
										<xsl:attribute name="checked">true</xsl:attribute>
									</xsl:if>
									<xsl:copy-of select="$set-off"/>
									<xsl:copy-of select="$add-off"/>
									<xsl:copy-of select="$dec-off"/>
									<label for="quota_oldvalue">
										<sw:text>Do not change the disk quota</sw:text>
									</label>
								</ui:cell-radio>
								<ui:cell cell-width="100%"/>
							</ui:row>
							<!-- /Do not change quota -->
						</xsl:if>
					</ui:rows>

					<xsl:if test="$form/def/linux">
						<ui:rows title="{sw:text('Change Containers Disk Inodes Limit')}">

							<xsl:variable name="off">
								<ui:control-slave inverse="true">inodes_newdelta_value</ui:control-slave>
								<ui:control-slave inverse="true">inodes_set_value</ui:control-slave>
							</xsl:variable>

							<!-- Calc with new delta  -->
							<ui:row>
								<ui:cell-radio name="inodes" value="newdelta" id="inodes_newdelta">
									<xsl:if
										test="$form/disk/inodes/method='newdelta' or not($form/disk/inodes/method)">
										<xsl:attribute name="checked">true</xsl:attribute>
									</xsl:if>
									<ui:control-slave>inodes_newdelta_value</ui:control-slave>
									<ui:control-slave inverse="true">inodes_set_value</ui:control-slave>
									<label for="inodes_newdelta">
										<sw:text>Calculate the disk inodes limit using the inodes per KB ratio</sw:text>
									</label>
								</ui:cell-radio>
								<ui:cell-input width="10" maxlength="20" name="inodes_newdelta_value"
									id="inodes_newdelta_value" value="{$form/disk/inodes/newdelta/value}"/>
								<ui:cell/>
								<ui:cell cell-width="100%"/>
							</ui:row>
							<!--<ui:row>
								<ui:cell offset="4">
									<span class="inactive"
									>
	      					inodes = diskquota(1kb) * density
	      					</span>
								</ui:cell>
							</ui:row>-->
							<!-- /Calc with new delta  -->
							<!-- Calc with old delta  -->
							<ui:row>
								<ui:cell-radio name="inodes" value="olddelta" id="inodes_olddelta">
									<xsl:if test="$form/disk/inodes/method='olddelta'">
										<xsl:attribute name="checked">true</xsl:attribute>
									</xsl:if>
									<xsl:copy-of select="$off"/>
									<label for="inodes_olddelta">
										<sw:text>Calculate the disk inodes limit keeping the current inodes per KB ratio</sw:text>
									</label>
								</ui:cell-radio>
							</ui:row>
							<!-- /Calc with old delta  -->
							<!-- Set new value  -->
							<ui:row>
								<ui:cell-radio name="inodes" value="set" id="inodes_set">
									<xsl:if test="$form/disk/inodes/method='set'">
										<xsl:attribute name="checked">true</xsl:attribute>
									</xsl:if>
									<ui:control-slave>inodes_set_value</ui:control-slave>
									<ui:control-slave inverse="true">inodes_newdelta_value</ui:control-slave>
									<label for="inodes_set">
										<sw:text>Set Disk Inodes Limit to</sw:text>
									</label>
								</ui:cell-radio>
								<ui:cell-input width="10" maxlength="20" name="inodes_set_value"
									id="inodes_set_value" value="{$form/disk/inodes/set/value}"/>
								<ui:cell/>
								<ui:cell cell-width="100%"/>
							</ui:row>
							<!-- /Set new value  -->
							<!-- Set old value to Unlimited -->
							<ui:row>
								<ui:cell-radio name="inodes" value="unlim" id="inodes_unlim" colspan="2">
									<xsl:if test="$form/disk/inodes/method='unlim'">
										<xsl:attribute name="checked">true</xsl:attribute>
									</xsl:if>
									<xsl:copy-of select="$off"/>
									<label for="inodes_unlim">
										<sw:text>Set unlimited disk inodes</sw:text>
									</label>
								</ui:cell-radio>
							</ui:row>
							<!-- /Set old value to Unlimited -->
							<!-- Leave old value  -->
							<ui:row>
								<ui:cell-radio name="inodes" value="oldvalue" id="inodes_oldvalue" colspan="2">
									<xsl:if test="$form/disk/inodes/method='oldvalue'">
										<xsl:attribute name="checked">true</xsl:attribute>
									</xsl:if>
									<xsl:copy-of select="$off"/>
									<label for="inodes_oldvalue">
										<sw:text>Do not change the disk inodes limit</sw:text>
									</label>
								</ui:cell-radio>
							</ui:row>
							<!-- /Leave old value  -->
						</ui:rows>
					</xsl:if>

					<ui:buttons>
						<xsl:call-template name="wiz:showButtons">
							<xsl:with-param name="submit-title" select="sw:text('Submit')"/>
							<xsl:with-param name="next-title" select="sw:text('Submit')"/>
						</xsl:call-template>
					</ui:buttons>

				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>

	<!-- Wizard, Step 'Upgrade VEs Applications' -->
	<xsl:template name="step_apps">
		<xsl:variable name="screen-icon" select="'setup'"/>

		<ui:screen id="{$screen-id}" title="{$screen-title}" icon="{$screen-icon}">

			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes">
					<sw:text>
	        	Here the Containers are checked if their OS and application versions are up-to-date.
	        </sw:text>
				</ui:description>
				<ui:form-get/>
			</ui:properties>

			<ui:content>
				<ui:hidden name="step" value="apps"/>
				<ui:block mode="view">

					<ui:raw>
						<textarea name="collector" id="collector" style="display:none;"/>
						<div id="progress">
							<br/>
							<img id="img_size" width="16" border="0" height="16"
								src="/{$theme}/icons/indicator.gif"
								/>
	      			&#160;<sw:text>Calculate updates...</sw:text>
							<br/>
							<br/>
							<script>
		      			function onLoad(){
									requestContent('/vz/cp/vzdir/infrman/envs/list-change-dynamic?func=upgrade-info'
									<xsl:for-each select="$form/env">
										+'&amp;ve=<xsl:value-of select="eid"/>'
									</xsl:for-each>
									,receiveData,'<xsl:value-of select="$ticket"/>',
									'<xsl:value-of select="$ticketid"/>');
								}
								function receiveData(req){
									var content = req.readyState==4?req.responseText:'';
									if(content!=''){
										var div_progress = document.getElementById('progress');
										div_progress.innerHTML = content;
									}
								}
							</script>
						</div>
					</ui:raw>

					<ui:buttons>
						<xsl:call-template name="wiz:showButtons">
							<xsl:with-param name="submit-title" select="sw:text('Update')"/>
							<xsl:with-param name="next-title" select="sw:text('Update')"/>
						</xsl:call-template>
					</ui:buttons>

				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>
	
	<!-- Wizard, Step 'Upgrade VEs Resources' -->
	<xsl:template name="step_res">
		<xsl:variable name="screen-icon" select="'setup'"/>

		<ui:screen id="{$screen-id}" title="{$screen-title}" icon="{$screen-icon}">

			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes">
					<sw:text>
	        	Here you can configure the Containers resources.
	        </sw:text>
				</ui:description>
				<ui:form-post/>
			</ui:properties>

			<ui:content>
				<ui:hidden name="step" value="res"/>
				<ui:block mode="edit" width="full">
				
					<!-- Prepare data -->
					<xsl:variable name="platform-ref" select="env:make-platform-ref($form/def/hn[1]/eid)"/>
					<xsl:variable name="qos-rtf">
						<xsl:call-template name="vzenv:conv-qos-data">
							<xsl:with-param name="platform-ref" select="$platform-ref"/>
							<xsl:with-param name="data" select="$form/res/data"/>
						</xsl:call-template>
					</xsl:variable>
					<xsl:variable name="qos" select="exsl:node-set($qos-rtf)/ui:qos-data"/>
					<!-- /Prepare data -->
					
					<!-- Show UI controls -->
					<xsl:call-template name="local:step-res-ui">
						<xsl:with-param name="qos" select="$qos"/>
					</xsl:call-template>
					<xsl:call-template name="local:step-res-js">
						<xsl:with-param name="qos" select="$qos"/>
					</xsl:call-template>
					<!-- /Show UI controls -->				

					<ui:buttons>
						<xsl:call-template name="wiz:showButtons">
							<xsl:with-param name="submit-title" select="sw:text('Update')"/>
							<xsl:with-param name="next-title" select="sw:text('Update')"/>
						</xsl:call-template>
					</ui:buttons>

				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>	

	<!-- Post UI controls for VE Resources step -->
	<xsl:template name="local:step-res-ui">
		<xsl:param name="qos"/>
		
		<xsl:variable name="data" select="$form/res/data"/>
				
		<!-- Process category -->
		<xsl:for-each select="$qos/ui:qos-category">
			<ui:rows title="{@title}" closed-text="{@closed-text}" 
				status="{@status}"
				status-def="{@status-def}"
			>
				<xsl:if test="@status-def!='1' or $qos/platform-linux">
					<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
				</xsl:if>
			
				<!-- Process category resources -->
				<xsl:for-each select="ui:qos-param">

					<xsl:variable name="res" select="."/>
					<xsl:variable name="id" select="@id"/>
					<xsl:variable name="real-id" select="@real-id"/>
					<xsl:variable name="res-data" select="$data/res[id=$real-id]"/>

					<xsl:variable name="cell-display-attrs-rtf">
						<cell cell-style="vertical-align:middle;">
							<xsl:if test="not($res-data/action!='')">
								<xsl:attribute name="div_display">none</xsl:attribute>
							</xsl:if>
						</cell>
					</xsl:variable>
					<xsl:variable name="cell-display-attrs" select="exsl:node-set($cell-display-attrs-rtf)/cell"/>
					
					<xsl:variable name="cell-unit-attrs-rtf">
						<cell>
							<xsl:copy-of select="$cell-display-attrs/@*"/>
						</cell>
					</xsl:variable>
					<xsl:variable name="cell-unit-attrs" select="exsl:node-set($cell-unit-attrs-rtf)/cell"/>

					<xsl:variable name="handle-soft-disabled" select="
						sw:if($qos/@show-soft-limit='true' and not(@soft-off='true') and not(@soft-min=@soft-max),'true','false')
					"/>
					<xsl:variable name="handle-hard-disabled" select="
						sw:if(not(@hard-off='true'),'true','false')
					"/>
					
					<!-- Show Category Header -->
					<xsl:if test="position()=1">
						<xsl:call-template name="local:show-res-cat-header">
							<xsl:with-param name="qos" select="$qos"/>
						</xsl:call-template>
					</xsl:if>
					<!-- /Show Category Header -->
					<!-- Show Resource -->
					<ui:row>						
						<!-- Show Resource ID  -->
						<ui:cell>
							<nobr>
								<a href="#none" onclick="switchRes('{$real-id}');return false;">
									<img src="/vz/skins/winxp.new/icons/arr_gt.gif" width="12" height="11" border="0" id="res_open_img_{$real-id}"/>
								</a>&#160;
								<xsl:value-of select="@real-id"/>
							</nobr>
						</ui:cell>
						<!-- Show Actions -->
						<ui:cell-list id="at_{$id}" value="{$res-data/action}" style="width:110px"
							onchange="resActionChanged('{$id}',{$handle-soft-disabled},{$handle-hard-disabled},'{sw:html-escape(@unlimited-label)}')"
						>
							<ui:list-item id="" title="{sw:text('Do not change')}" grayed="true"/>
							<ui:list-item id="increase" title="{sw:text('Increase by')}"/>
							<ui:list-item id="decrease" title="{sw:text('Decrease by')}"/>		
							<xsl:if test="@unlimited-control-type='checkbox' and @unlimited-type-src='unlimited'">
								<ui:list-item id="unlimited" title="{sw:text('Disable limit')}"/>				
							</xsl:if>
							<xsl:if test="@unlimited-control-type='checkbox' and @unlimited-type-src='disabled'">
								<ui:list-item id="unlimited" title="{sw:text('Disable accounting')}"/>				
							</xsl:if>
							<ui:list-item id="limited" title="{sw:text('Set to')}"/>																					
						</ui:cell-list>
						<!-- Show Soft Limit -->
						<xsl:if test="$qos/@show-soft-limit='true'">
							<xsl:choose>
								<xsl:when test="@soft-off='true'">
									<ui:cell align="center" div_id="sld_{$id}">
										<xsl:copy-of select="$cell-display-attrs/@*"/>
										<sw:text>n/a</sw:text>
									</ui:cell>	
								</xsl:when>
								<xsl:when test="@soft-min=@soft-max">
									<ui:cell-text div_id="sld_{$id}">
										<xsl:copy-of select="$cell-display-attrs/@*"/>									
									 	<xsl:value-of select="@soft-min"/>
									 	<input type="hidden" name="s_{$id}" value="{@soft-min}"/>										 	
									</ui:cell-text>
								</xsl:when>
								<xsl:otherwise>
									<ui:cell-input width="12" maxlength="20" id="s_{$id}" 
										tip="{@soft-tip}" div_id="sld_{$id}"
									>
										<xsl:copy-of select="$cell-display-attrs/@*"/>									
									  <xsl:choose>
									  	<xsl:when test="$res-data/action='unlimited' and @unlimited-control-type='checkbox'">
									  		<xsl:attribute name="disabled">true</xsl:attribute>
									  		<xsl:attribute name="value"><xsl:value-of select="@unlimited-label"/></xsl:attribute>
									  	</xsl:when>
									  	<xsl:otherwise>
									  		<xsl:attribute name="value"><xsl:value-of select="@soft"/></xsl:attribute>
									  	</xsl:otherwise>
									  </xsl:choose>
										<input type="hidden" id="slh_{$id}" value=""/>										  
									</ui:cell-input>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:if>
						<!-- Show Hard Limit -->
						<xsl:choose>
							<xsl:when test="@hard-off = 'true'">
								<ui:cell align="center" div_id="hld_{$id}">
									<xsl:copy-of select="$cell-display-attrs/@*"/>									
									<sw:text>n/a</sw:text>
								</ui:cell>								
							</xsl:when>
							<xsl:when test="@hard-min = @hard-max">
								<ui:cell-text tip="{@hard-tip}" align="center"
									 div_id="hld_{$id}"
								>
									<xsl:copy-of select="$cell-display-attrs/@*"/>		
								 	<sw:text>maximum</sw:text>
								 	<input type="hidden" name="h_{$id}" value="{@hard-min}"/>	
								</ui:cell-text>
							</xsl:when>
							<xsl:otherwise>
								<ui:cell-input width="12" maxlength="20" id="h_{$id}"
									tip="{@hard-tip}" div_id="hld_{$id}"
								>
									<xsl:copy-of select="$cell-display-attrs/@*"/>										
								  <xsl:choose>
								  	<xsl:when test="$res-data/action='unlimited' and @unlimited-control-type='checkbox'">
								  		<xsl:attribute name="disabled">true</xsl:attribute>
								  		<xsl:attribute name="value"><xsl:value-of select="@unlimited-label"/></xsl:attribute>
								  	</xsl:when>
								  	<xsl:otherwise>
								  		<xsl:attribute name="value"><xsl:value-of select="@hard"/></xsl:attribute>
								  	</xsl:otherwise>
								  </xsl:choose>
									<input type="hidden" id="hlh_{$id}" value=""/>										  								  
								</ui:cell-input>
							</xsl:otherwise>
						</xsl:choose>
						<!-- /Show Hard Limit -->		
						<!-- Unit -->
						<xsl:call-template name="vzenv:show-res-unit">
							<xsl:with-param name="id" select="$id"/>
							<xsl:with-param name="post-div" select="true()"/>
							<xsl:with-param name="cell-attrs" select="$cell-unit-attrs"/>
						</xsl:call-template>
						<!-- Description -->
						<ui:cell>
							<sw:text select="@short" domain="vzagent-vocabulary"/>
							<!-- Restart VE -->
							<xsl:if test="@alert-restart-id!=''">
								<input type="hidden" id="{@alert-restart-id}_{$id}" name="{@alert-restart-id}_{$id}" value="{sw:if(@restart-ve=1,1,0)}"/>
							</xsl:if>
							<!-- post current factor and current usage -->	           
							<xsl:if test="@factor-type!=''"> 
								<script type="text/javascript">
									var cf_<xsl:value-of select="$id"/>=<xsl:value-of select="@factor"/>;
									var cu_<xsl:value-of select="$id"/>='<xsl:value-of select="@current"/>';
								</script>
							</xsl:if>
						</ui:cell>
						<!-- Tools -->
						<ui:cell>
							<nobr>							
								<a style="cursor:hand; cursor:pointer" href="#none">
									<xsl:attribute name="onClick">showLong('<xsl:value-of select="@real-id"/>')</xsl:attribute>
									<img width="16" height="16" border="0"
										onmouseover="callTip('ve_qos_details',event)" onmouseout="callTip('')"
										src="/{$theme}/icons/help_16.gif"/>									
								</a>	
							</nobr>
						</ui:cell>
					</ui:row>
					<!-- /Show Resource -->
					<ui:row>
						<ui:cell colspan="7">
							<div id="div_res_stat_{$real-id}" 
								style="display:none;"
							>
							</div>
						</ui:cell>
					</ui:row>
				</xsl:for-each>
				<!-- /Process category resources -->
			</ui:rows>
		</xsl:for-each>
		<!-- /Process category -->
		
		<xsl:if test="$qos/platform-linux">
			<ui:rows title="{sw:text('Memory Configuration')}">
				<ui:row>
					<ui:cell-label><xsl:value-of select="sw:text('Memory Management Mode')"/></ui:cell-label>
					<ui:cell-list id="slm" style="width:300px" value="{$data/res/slm-mode}">
						<ui:list-item id="" title="{sw:text('Leave current mode unchanged')}"/>
						<ui:list-item disabled="true" title="{sw:text('-- Set new mode --')}"/>
						<xsl:for-each select="vz:get-slm-modes()">
							<ui:list-item id="{id}" title="{title}"/>
						</xsl:for-each>
					</ui:cell-list>
				</ui:row>
			</ui:rows>
		</xsl:if>
		
	</xsl:template>

	<xsl:template name="local:show-res-cat-header"> 
		<xsl:param name="qos"/>
		<!--|-->
		<ui:row type="head">
			<ui:cell hard-width="150">
				<sw:text>Resource</sw:text>
			</ui:cell>	
			<ui:cell align="center" hard-width="120">
				<sw:text>Action</sw:text>
			</ui:cell>	
			<xsl:if test="$qos/platform-linux">
				<ui:cell hard-width="90" align="center"><sw:text>Soft Limit</sw:text></ui:cell>
				<ui:cell hard-width="90" align="center"><sw:text>Hard Limit</sw:text></ui:cell>
			</xsl:if>
			<xsl:if test="$qos/platform-windows">
				<ui:cell hard-width="90" align="center"><sw:text>Limit</sw:text></ui:cell>
			</xsl:if>
			<ui:cell hard-width="50" align="center"><sw:text>Units</sw:text></ui:cell>
			<ui:cell cell-width="100%"><sw:text>Description</sw:text></ui:cell>
			<ui:cell hard-width="20" align="center"> </ui:cell>
		</ui:row>
 </xsl:template>

	
	<!-- Post JS-code for VE Resources step -->
	<xsl:template name="local:step-res-js">
		<ui:java-script>
			var currentResId='';
			function switchRes(resId){
				currentResId = resId;
				
				var divStat = document.getElementById('div_res_stat_' + resId);
				var wasVisible = divStat.style.display=='block';
				if(wasVisible){
					// Hide 
					divStat.style.display='none';
					// @Hide
				}else{
					// Show
					if(divStat.innerHTML==''){
						// Show at first time
						loadRes(resId,divStat);
					}
					divStat.style.display='block';
					// @Show
				}
				// Change open/close image
				document.getElementById('res_open_img_'+resId).src='/<xsl:value-of select="$theme"/>/icons/arr_'+(wasVisible?'gt':'opened')+'.gif';
			}
			
			function loadRes(resId,divStat){
				divStat.innerHTML = 
					'&#160;&#160;<img src="/{$theme}/icons/indicator.gif" width="16" height="16"/>' + '&#160;<sw:text>Loading the current Containers resources settings...</sw:text>';
				requestContent(
					'/vz/cp/vz/ves/list-change/res-dynamic?res_id='+resId
					,loadedRes
					,'<xsl:value-of select="$ticket"/>','<xsl:value-of select="$ticketid"/>');
			}
			
			function loadedRes(req){
				var content = req.readyState==4?req.responseText:'';
				if(content!=''){
					var content_nodes = content.split('||'); 	
					if(content_nodes.length!=3){
						// Uknown ID was received
						if(currentResId!=''){
							var div_content = document.getElementById('div_res_stat_'+currentResId);						
							div_content.innerHTML = '<sw:text>Error retrieving the information.</sw:text>';
						}
					}else{
						// Good content was recevived
						var resId = content_nodes[1];
						content= content_nodes[2];
						var div_content = document.getElementById('div_res_stat_'+resId);						
						div_content.innerHTML = content;
					}
				}
			}
					
			function resActionChanged(id,handle_soft_disabled,handle_hard_disabled,unlimited_label){
				var action_obj = document.getElementById('at_'+id);
				var action = action_obj.options[action_obj.selectedIndex].value;
				var show = action!='';
				// Unit Div
				showObjExt('ud_'+id,show);
				<xsl:if test="$form/def/linux">
					// Soft Limit Div
					showObjExt('sld_'+id,show);
				</xsl:if>
				// Hard Limit Div
				showObjExt('hld_'+id,show);
				// Enable Soft Limit
				<xsl:if test="$form/def/linux">
					if(handle_soft_disabled){
						var input = document.getElementById('s_'+id);					
						var cache = document.getElementById('slh_'+id);	
						if(input &amp;&amp; cache){
							if(action=='unlimited'){
								cache.value = input.value;
								input.disabled = true;
								input.value = unlimited_label;
							}else{
								input.disabled = false;					
								input.value = cache.value;						
							}
						}
					}
				</xsl:if>
				// Enable Hard Limit
				if(handle_hard_disabled){
					var input = document.getElementById('h_'+id);					
					var cache = document.getElementById('hlh_'+id);						
					if(input &amp;&amp; cache){
						if(action=='unlimited'){
							cache.value = input.value;
							input.disabled = true;
							input.value = unlimited_label;
						}else{
							input.disabled = false;					
							input.value = cache.value;						
						}
					}
				}
				// Change Unit state
				var unit_input = document.getElementById('m_'+id);			
				if(unit_input){
					if(action=='unlimited'){
						unit_input.disabled = true;
					}else{
						unit_input.disabled = false;					
					}
				}
			}
			// empty handler for vzenv:show-res-unit functionality 
			function changedFactor(id,value){
			}
			<![CDATA[
			function showLong(id){
				open_help('/vz/cp/help?topic=resources&a='+id);
			}
			]]>			
		</ui:java-script>
	</xsl:template>


	<!-- Wizard, Step 'Auto-upgrade the VEs ' -->
	<xsl:template name="step_autoupgrade">
		<xsl:variable name="screen-icon"	select="'env_reinstall'"/>

		<ui:screen id="{$screen-id}" icon="{$screen-icon}">

			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:form-get/>
			</ui:properties>

			<ui:content>
				<ui:hidden name="step" value="autoupgrade"/>
				<ui:block mode="view">

					<ui:rows title="{sw:text('Warning')}">
						<ui:row>
							<ui:cell-text colspan="2">
								<br/>
								<img src="/{$theme}/icons/alert_yellow.gif" width="16" height="16" border="0"
									/>&#160;
	      				<sw:text>
	      					This action will update the OS and application templates in all the selected Containers to the latest versions available on the respective Nodes. <br/><br/> It can affect the functionality of some software installed in the Containers. Please do not run this update unless you are sure it is really necessary.
	      				</sw:text>
								<br/><br/>
							</ui:cell-text>
						</ui:row>
					</ui:rows>

					<ui:rows title="{sw:text('Configure Updating')}" id="options"
						status="{$form/autoupgrade/options}"
						closed-text="{sw:text('Click to configure the updating procedure.')}">
						<ui:row>
							<ui:cell-check id="force" checked="{$form/autoupgrade/force}" close="false"
								colspan="2"/>
							<ui:cell open="false">
								<sw:text>Force software update (NOT RECOMMENDED)</sw:text>
							</ui:cell>
						</ui:row>
						<ui:row>
							<ui:cell-check id="start" checked="{$form/autoupgrade/start}" close="false"
								colspan="2"/>
							<ui:cell open="false">
								<sw:text>Start the stopped Containers</sw:text>
							</ui:cell>
						</ui:row>
					</ui:rows>

					<ui:rows title="{sw:text('Confirmation')}">
						<ui:row>
							<ui:cell-check id="confirm" checked="{$form/autoupgrade/confirm}" close="false"
								colspan="2"/>
							<ui:cell open="false">
								<sw:text>Yes, I want to update the Containers</sw:text>
							</ui:cell>
						</ui:row>
					</ui:rows>

					<ui:buttons>
						<xsl:call-template name="wiz:showButtons">
							<xsl:with-param name="submit-title" select="sw:text('Update')"/>
							<xsl:with-param name="next-title" select="sw:text('Update')"/>
						</xsl:call-template>
					</ui:buttons>

				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>



	<!-- main document handler -->
	<xsl:template mode="screen" match="/">
		<xsl:choose>
			<xsl:when test="count($form/def/platform)&gt;1">
				<xsl:if test="error:put(sw:text('You can configure Containers for only one platform at a time.'))"/>
				<ui:redirect path="last"/>
			</xsl:when>
			<xsl:when test="$step = 'start'">
				<xsl:call-template name="step_start"/>
			</xsl:when>
			<xsl:when test="$step = 'config'">
				<xsl:call-template name="step_config"/>
			</xsl:when>
			<xsl:when test="$step = 'apply'">
				<xsl:call-template name="step_apply"/>
			</xsl:when>
			<xsl:when test="$step = 'apply_qos'">
				<xsl:call-template name="step_apply_qos"/>
			</xsl:when>
			<xsl:when test="$step = 'apps'">
				<xsl:call-template name="step_apps"/>
			</xsl:when>
			<xsl:when test="$step = 'autoupgrade'">
				<xsl:call-template name="step_autoupgrade"/>
			</xsl:when>
			<xsl:when test="$step = 'disk'">
				<xsl:call-template name="step_disk"/>
			</xsl:when>
			<xsl:when test="$step = 'res'">
				<xsl:call-template name="step_res"/>
			</xsl:when>
			<xsl:when test="$step = 'add_apps'">
				<xsl:call-template name="step_add_apps"/>
			</xsl:when>
			<xsl:when test="$step = 'add_apps_review'">
				<xsl:call-template name="step_add_apps_review"/>
			</xsl:when>
			<xsl:when test="$step = 'del_apps'">
				<xsl:call-template name="step_del_apps"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="step_start"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<func:function name="local:reslimit2txt">
		<xsl:param name="limit"/>
		<xsl:param name="mode"/>

		<func:result select="format:res2str(format:int2bytes($limit,$mode,'no'),'',true)"/>

	</func:function>

	<func:function name="local:get-voc">
		<xsl:param name="env"/>
		<xsl:variable name="args">
			<category>quota</category>
		</xsl:variable>
		<func:result select="voc:get($args, env:make-platform-ref($env/hn-eid,$env/platform))"/>
	</func:function>

	<!-- UI modules -->
	<sw:include href="/lib/core/browse-filter-raw.xsl"/>
	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>

	<!-- System modules -->
	<sw:include href="/lib/common.xsl"/>


	<!-- VZA functionality modules -->
	<sw:include href="/lib/vt/env-quota.xsl"/>
	<sw:include href="/lib/vza/tem.xsl"/>
	<sw:include href="/lib/vza/vzapackagem.xsl"/>

	<sw:include href="/lib/vocabulary.xsl"/>

</xsl:stylesheet>
