<!--
		 Copyright (c) SWsoft, 1999-2007
		 All rights reserved.
   -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred func perms local"
	xmlns:func="http://exslt.org/functions" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl="http://exslt.org/common" xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:ui="http://www.swsoft.com/xsl/cp/ui" xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:perms="http://www.swsoft.com/xsl/cp/perms" xmlns:local="http://www.swsoft.com/xsl/cp/local">
	
	<sw:include href="/lib/sysdir/securman/perms-ui.xsl"/>
	<xsl:param name="access-denied" select="not(cred:check('vzcp.virtuozzo_group.security.roles'))"/>

	<!-- check permissions to show this page -->
	<xsl:template mode="screen" match="/">
		<xsl:if test="not($access-denied)">
			<xsl:variable name="env-eid" select="sw:ve-eid()"/>
			
			<ui:screen id="03.02.01.01.05">
				<ui:properties>
					<ui:description width="full">
						<sw:text>
							On this screen you can view a list of permissions, create a new permission, or delete an existing one. A permission is a role assigned to some user (group) and defining the set of operations this user (group) is allowed to perform in the Container context. If you wish to assign a role to a user or group for a group of Containers, create a folder under Logical View on the left Parallels Infrastructure Manager menu, add the Containers to this folder, and go to its Security tab.
						</sw:text>
					</ui:description>
					<ui:form-get/>
				</ui:properties>
				<ui:tab-bar id="vzve" current-tab="perms"/>			
				<ui:content>
					<xsl:call-template name="perms:show-obj-perms">
						<xsl:with-param name="screen-url" select="'/vzdir/infrman/envs/perms/index'"/>
						<xsl:with-param name="action-url"
							select="concat($baseurl,'/sysdir/securman/perms/obj-list-control')"/>
						<xsl:with-param name="item-url" select="/.."/>
						<xsl:with-param name="obj-id" select="$env-eid"/>
						<xsl:with-param name="obj-type" select="'ve.vz.vt'"/>
					</xsl:call-template>
				</ui:content>
			</ui:screen>
		</xsl:if>
	</xsl:template>


	<sw:include href="/lib/screen.xsl"/>

</xsl:stylesheet>
