<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->
<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred voc"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl="http://exslt.org/common"
  xmlns:sw="http://www.swsoft.com/xsl/cp"
  xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
	xmlns:cred  ="http://www.swsoft.com/xsl/cp/cred"
	xmlns:voc				="http://www.swsoft.com/xsl/cp/voc"
	xmlns:ve="http://www.swsoft.com/xsl/cp/ve"
  >

  <xsl:variable name="sched" select="sw:sesget('sched')"/>
  <xsl:variable name="setTransition">
    <xsl:if test="not(ve:context-transition()) and sw:sesget('sched')">
      <!-- we still have no update status from vzagent, set own -->
              
      <xsl:if test="sw:sesget('operation') = 'start_repair'">
        <xsl:value-of select="sw:envsettransition($env-trans/starting-repair)"/>
      </xsl:if>
      <xsl:if test="sw:sesget('operation') = 'stop_repair'">
        <xsl:value-of select="sw:envsettransition($env-trans/stopping-repair)"/>
      </xsl:if>
    </xsl:if>
  </xsl:variable>

  <xsl:template mode="screen" match="/">
  	<ui:screen id="03.02.01.11.03" icon="env_repair" bg="repair" cred="vzcp.env.manage.maintenance.repair_mode" security-obj-type="ve.vz.vt">    	
    <ui:properties>
      <ui:width value="fixed"/>
      <ui:description mandatory="yes">
<sw:text>
The repair mode is needed when your Container <b>cannot be started</b>. This mode means that a new Container is temporarily created from scratch with the same network and other parameters as the broken Container, and the root directory of the broken Container is mounted as <b>/repair</b> into the newly-created Container. <p/> In the repair mode, you should <b>connect to the new Container</b> via ssh using the network and login parameters of the broken Container, go to the /repair directory, and perform one of the following actions: <ul style="margin-top:10px;margin-bottom:10px;margin-left:30px"><li>Find the personal data that need to be saved and <b>copy it to a safe location</b> elsewhere. Do not copy your personal data directly into your new Container, as it will be deleted once you exit the repair mode.</li><li>Identify the source of the problem and <b>manually correct</b> it.</li></ul> After closing your ssh session, open this screen once again and click the Finish Repair button to exit the repair mode.
</sw:text>
      </ui:description>      
      <ui:form-get/>
    </ui:properties>
    
		<xsl:choose>
			<xsl:when test="$activeMode = 'vzcc'">
			</xsl:when>
			<xsl:when test="$activeMode = 'vzcp' or $activeMode = 'plesk'">
				<ui:tab-bar id="maintance" current-tab="repair"/>
			</xsl:when>
		</xsl:choose>

    <ui:content>
    	<ui:block>
    		
    		<ui:operation-progress/>
    		
    		<ui:buttons>
					<ui:button tip="run_repair" name="repair_ve">
						<xsl:if test="voc:check-operation('vzaenvm','repair')!='' or $sched">
							<xsl:attribute name="disabled">true</xsl:attribute>
						</xsl:if>
						<sw:text>Start Repair</sw:text>
					</ui:button>
      		<ui:button tip="end_repair" name="stop_repair_ve">
      			<xsl:if test="voc:check-operation('vzaenvm','stop_repair')!='' or $sched">
							<xsl:attribute name="disabled">true</xsl:attribute>
						</xsl:if>
      			<sw:text>Finish Repair</sw:text>
      		</ui:button>
	      </ui:buttons>
    		
    	</ui:block>
       
    </ui:content>  
    </ui:screen>
  </xsl:template>


	<sw:include href="/lib/vt/env-core.xsl"/>
  <sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/vocabulary.xsl"/>

</xsl:stylesheet>
