<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->
<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred vzenv"
  xmlns:xsl			="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl		="http://exslt.org/common"
  xmlns:sw			="http://www.swsoft.com/xsl/cp"
  xmlns:ui			="http://www.swsoft.com/xsl/cp/ui"
  xmlns:vzenv			="http://www.swsoft.com/xsl/cp/vzenv"
	xmlns:cred  	="http://www.swsoft.com/xsl/cp/cred"	
  >

	<sw:include href="/lib/cred.xsl"/>  
	<sw:include href="/lib/vz/vzenv-qos.xsl"/>
	<sw:include href="/lib/utils/format-resusage.xsl"/>

  <xsl:template mode="screen" match="/">
  	<xsl:variable name="eid" select="sw:ve-eid()"/>
  	<xsl:if test="sw:sesput('ve-resource-mode', 'all')" />

    <ui:screen id="03.02.01.14.01" icon="env_resources">
    	<xsl:if test="$activeMode != 'vzcc'">
    		<xsl:attribute name="title">
					<sw:text>
						Resources
					</sw:text>
				</xsl:attribute>
    	</xsl:if>
	    <ui:properties>
	      <ui:description width="max">
	        <sw:text>
	          On this screen you can see the container resources consumption overview.<br/>Please pay attention to the resources nearing their maximum.
	        </sw:text>
	      </ui:description>
	      <ui:form-get/>
	    </ui:properties>
	    <xsl:choose>
				<xsl:when test="$activeMode = 'vzcc'">
					<ui:tab-bar id="vzve" current-tab="res" current-subtab="overview"/>
				</xsl:when>
				<xsl:otherwise>
					<ui:tab-bar id="resources" current-tab="overview"/>					
				</xsl:otherwise>
			</xsl:choose>
			<ui:content>
				<xsl:apply-templates select="/packet/cookie/resources/group" mode="resource"/>
			
				<xsl:if test="$activeMode='vzcc' and cred:check-context('vzcp.env.manage.properties.preferences','ve.vz.vt')">
					<ui:block>
						<ui:buttons>
							<ui:button tip="change_qos_ext" sandclock="false" icon="env_resources" type="ok"
								submit-href="{$baseurl}/vzdir/infrman/envs/manage?tab=qos"
							>
								<sw:text>Configure</sw:text>
							</ui:button>
						</ui:buttons>
					</ui:block>
				</xsl:if>
					
			</ui:content>   
		</ui:screen>  
	</xsl:template>  
  
	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/show-resource.xsl"/>
	<sw:include href="/lib/meter.xsl"/>
	<sw:include href="/lib/vt/env-private.xsl"/>
	<sw:include href="/lib/vz/ubcs.xsl"/>	
	<sw:include href="/lib/vocabulary.xsl"/>				
  
</xsl:stylesheet>
