<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func wiz vzenv local cred voc"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl="http://exslt.org/common"
  xmlns:sw="http://www.swsoft.com/xsl/cp"
  xmlns:local="http://www.swsoft.com/xsl/cp/local"
  xmlns:error="http://www.swsoft.com/xsl/cp/error"
  xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz"
  xmlns:vzenv="http://www.swsoft.com/xsl/cp/vzenv"
  xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
  xmlns:func="http://exslt.org/functions"
	xmlns:cred  ="http://www.swsoft.com/xsl/cp/cred"
	xmlns:voc		="http://www.swsoft.com/xsl/cp/voc"
 >

  <xsl:param 		name="wiz_code"			select="'ve-edit-volume'"/>
	<xsl:variable name="step_data"		select="wiz:getStep()"/>
	<xsl:variable name="step"					select="$step_data/@id"/>
	<xsl:variable name="screenid"			select="$step_data/@screenid"/>
	<xsl:variable name="screen-icon"	select="'mount_device'"/>
	<xsl:variable name="path-id"			select="string(wiz:getSteps()/step[1]/@screenid)"/>
	
  <xsl:variable name="form" select="sw:sesget($wiz_data)"/>
  <!-- check permissions to show this page -->
	<xsl:param name="access-denied" select="not(cred:check-env('vzcp.env.manage.properties.hardware',sw:ve-eid()))"/>

  <!-- Reinstall Wizard, Step 'General Settings' -->
  <xsl:template name="step_gen">
  	<ui:screen path-id="{$path-id}" id="{$screenid}" icon="{$screen-icon}">
  		<xsl:attribute name="title">
				<sw:text>
					<xsl:with-param name="name" select="$form/point"/>
					Resize the %{name} volume
				</sw:text>
			</xsl:attribute>
  	
	    <ui:properties>
	      <ui:refresh-type>none</ui:refresh-type>      
	      <ui:form-get/>
	    </ui:properties>
    
	    <ui:content>
	      <ui:hidden name="step" value="gen"/>    
	      <ui:block mode="edit">

	   			<ui:rows>	   				
	   				<ui:row>
	   					<ui:cell-label>
		        		<sw:text>Old Size</sw:text>
		        	</ui:cell-label>
							<ui:cell-text>
								<xsl:value-of select="$form/org/size"/>&#160;
								<xsl:value-of select="$form/org/size-unit-label"/>
							</ui:cell-text>
						</ui:row>		
						<ui:row>
	   					<ui:cell-label>
		        		<sw:text>New Size</sw:text>
		        	</ui:cell-label>
							<ui:cell-input id="size" width="15" maxlength="256" required="true" value="{$form/gen/size}" close="false">
								&#160;
							</ui:cell-input>
							<ui:cell-list id="size_unit" tip="ve_create_volume_size" width="10" value="{$form/gen/size-unit}" open="false">
								<ui:list-item id="1024" title="{sw:text('KB')}"/>
								<ui:list-item id="1048576" title="{sw:text('MB')}"/>
								<ui:list-item id="1073741824" title="{sw:text('GB')}"/>
							</ui:cell-list>
						</ui:row>				
					</ui:rows>
	
	        <ui:buttons>
	          <xsl:call-template name="wiz:showButtons">
	          	<xsl:with-param name="submit-title" select="sw:text('Resize')"/>
	          </xsl:call-template>
	        </ui:buttons>
	        
	     	</ui:block>
	    </ui:content>   
    </ui:screen>
  </xsl:template>
  

	<!-- main document handler -->
	<xsl:template mode="screen" match="/">
	
			<xsl:choose>
			
				<xsl:when test="$step = 'gen'">
					<xsl:call-template name="step_gen"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="step_gen"/>
				</xsl:otherwise>
				
			</xsl:choose>
		
	</xsl:template>
	
	<!-- UI modules -->	
	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>
	
	<!-- System modules -->
	<sw:include href="/lib/vocabulary.xsl"/>		
	<sw:include href="/lib/common.xsl"/>
	
	<!-- VZA functionality modules -->	
	<!-- none -->
	
</xsl:stylesheet>
