<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func wiz vzenv local vz cred voc"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl="http://exslt.org/common"
  xmlns:sw="http://www.swsoft.com/xsl/cp"
  xmlns:local="http://www.swsoft.com/xsl/cp/local"
  xmlns:error="http://www.swsoft.com/xsl/cp/error"
  xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz"
  xmlns:vz="http://www.swsoft.com/xsl/cp/vz"
	xmlns:env		="http://www.swsoft.com/xsl/cp/env"	  
  xmlns:vzenv="http://www.swsoft.com/xsl/cp/vzenv"
  xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
  xmlns:func="http://exslt.org/functions"
	xmlns:cred  ="http://www.swsoft.com/xsl/cp/cred"
	xmlns:voc		="http://www.swsoft.com/xsl/cp/voc"
 >

  <xsl:param 		name="wiz_code"				select="'ve-mount-image'"/>
	<xsl:variable name="step_data"		select="wiz:getStep()"/>
	<xsl:variable name="step"					select="$step_data/@id"/>
	<xsl:variable name="screenid"			select="$step_data/@screenid"/>
	<xsl:variable name="screen-title"	select="sw:text('Mount Disk Image')"/>
	<xsl:variable name="screen-icon"	select="'mount_image'"/>
	<xsl:variable name="path-id"			select="string(wiz:getSteps()/step[1]/@screenid)"/>
	
  <xsl:variable name="form" select="sw:sesget($wiz_data)"/>
  <!-- check permissions to show this page -->
	<xsl:param name="access-denied" select="not(cred:check-env('vzcp.env.manage.properties.hardware',$form/eid))"/>

  <!-- Reinstall Wizard, Step 'General Settings' -->
  <xsl:template name="step_gen">
  	<xsl:variable name="env-info" select="env:eid2info($form/eid)"/>
  
  	<ui:screen path-id="{$path-id}" id="{$screenid}" title="{$screen-title}" icon="{$screen-icon}">
  	
  	<!-- Load some VZ data -->  	
  	<!-- /Load some VZ data -->  	
  	
	<ui:properties>
		<ui:refresh-type>none</ui:refresh-type>
		<ui:description mandatory="yes">
			<sw:text>
				On this screen you can add a new disk volume to the Container by mounting an existing image file to an unoccupied drive letter inside the Container. The image file should be located on the current Hardware Node and have the .efd extension.
			</sw:text>
		</ui:description>	       
		<ui:form-get/>
	</ui:properties>
    
	<ui:content>
	      <ui:hidden name="step" value="gen"/>    
	      <ui:block mode="edit">

	   			<ui:rows>
	   				<ui:row>
	   					<ui:cell-label>
		        		<sw:text>Mount Point</sw:text>
		        	</ui:cell-label>
							<xsl:choose>
			        	<xsl:when test="$env-info/windows">
				        	<ui:cell-list id="point" required="true" width="10">
										<xsl:attribute name="value"><xsl:value-of select="$form/gen/point"/></xsl:attribute>
										<xsl:copy-of select="vz:ve-drive-selector($form/eid)"/>
									</ui:cell-list>
								</xsl:when>
								<xsl:when test="$env-info/linux">
									<ui:cell-input id="point" tip="ve_create_volume_point" maxlength="256" 
										required="true" value="{$form/gen/point}"
									/>
								</xsl:when>
							</xsl:choose>
						</ui:row>
	   				<ui:row>
	   					<ui:cell-label>
		        		<sw:text>Image Path</sw:text>
		        	</ui:cell-label>
							<ui:cell-input id="path" maxlength="256" width="50" required="true">
								<xsl:attribute name="value"><xsl:value-of select="$form/gen/path"/></xsl:attribute>
								&#160;&#160;<a href="#"
									onclick="open_details('{$baseurl}/vzdir/infrman/envs/files/selector-popup?mod=start&amp;dst-control=path&amp;base={$env-info/hn-eid}&amp;select-folders=false&amp;select-files=true',null,540,850);return false;"
								><sw:text>Select...</sw:text></a>								
							</ui:cell-input>
						</ui:row>
					</ui:rows>
	
	        <ui:buttons>
	          <xsl:call-template name="wiz:showButtons">
	          	<xsl:with-param name="submit-title" select="sw:text('Mount')"/>
	          	<xsl:with-param name="submit-tip" select="'submit_mount_image'"/>
			<xsl:with-param name="submit-sandclock" select="false()"/>
	          </xsl:call-template>
	        </ui:buttons>
	        
	     	</ui:block>
	    </ui:content>   
    </ui:screen>
  </xsl:template>
  

	<!-- main document handler -->
	<xsl:template mode="screen" match="/">
	
			<xsl:choose>
			
				<xsl:when test="$step = 'gen'">
					<xsl:call-template name="step_gen"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="step_gen"/>
				</xsl:otherwise>
				
			</xsl:choose>
		
	</xsl:template>
	
	<!-- UI modules -->	
	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>
	
	<!-- System modules -->
	<sw:include href="/lib/vocabulary.xsl"/>		
	<sw:include href="/lib/common.xsl"/>
	
	<!-- VZ functionality modules -->	
	<sw:include href="/lib/vt/env-core.xsl"/>			
	<sw:include href="/lib/vz/devices.xsl"/>		
	
	<!-- VZA functionality modules -->	
	<sw:include href="/lib/vza/dev.xsl"/>		
	
</xsl:stylesheet>
