<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl sw func local cred"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl="http://exslt.org/common"
  xmlns:sw="http://www.swsoft.com/xsl/cp"
  xmlns:ui="http://www.swsoft.com/xsl/cp/ui"  
  xmlns:envm			="http://www.swsoft.com/xsl/cp/envm"  
  xmlns:env-samplem			="http://www.swsoft.com/xsl/cp/env-samplem"
  xmlns:local		="http://www.swsoft.com/xsl/cp/local"
  xmlns:error		="http://www.swsoft.com/xsl/cp/error"  
  xmlns:func		="http://exslt.org/functions"
	xmlns:cred		="http://www.swsoft.com/xsl/cp/cred"
>

 	<sw:include href="/lib/swa/env-samplem.xsl"/> 
 	<sw:include href="/lib/swa/envm.xsl"/> 

	
	<!-- check permissions to this page -->
	<xsl:variable name="cr"		select="cred:check('vzcp.envsamples')"/>

		<!-- We can receive template ID from URL or from session -->
		<xsl:variable name="id-get"		select="sw:base64-decode(sw:param('id'))"/>
		<xsl:variable name="id-session"		select="sw:sesget('envsample-id')"/>
	
  	<xsl:template match="/">
		<xsl:choose>
			<xsl:when test="sw:param('id') and not($cr)">	
				<!-- no cred or ID-->
				<ui:redirect path="last"/>
			</xsl:when>
      <xsl:otherwise>
      	<xsl:variable name="sample-id" select="sw:if($id-get!='',$id-get,$id-session)"/>
   			<xsl:variable name="sample" select="env-samplem:get-sample($sample-id)"/>   	
   			<xsl:variable name="sample-text" select="envm:config-virtual2natural($sample/env_config,$sample/vt_version)"/>  
      	
      	<xsl:choose>
      		<xsl:when test="$sample-text[self::error]">
      			<xsl:if test="error:put(sw:text('Cannot convert the sample to text.'),$sample-text/message)"/>
						<ui:redirect path="last"/>      			
      		</xsl:when>
      		<xsl:otherwise>      	
						<!-- ok, start downloading -->      	
						<ui:binary type="application/virtuozzo-config"  file-name="{$sample/name}.conf">
							<xsl:value-of disable-output-escaping="yes" select="sw:base64-decode($sample-text/body)"/>
						</ui:binary>
					</xsl:otherwise>
				</xsl:choose>
				
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>


  <!-- includes -->
  <sw:include href="/lib/cred.xsl"/>
  <sw:include href="/lib/common.xsl"/>

</xsl:stylesheet>
