<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw env vzenv exsl func wiz env envm tem cred hwm vz"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl	="http://exslt.org/common"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:error	="http://www.swsoft.com/xsl/cp/error"
  xmlns:wiz		="http://www.swsoft.com/xsl/cp/wiz"  
  xmlns:vz		="http://www.swsoft.com/xsl/cp/vz"
  xmlns:vzenv	="http://www.swsoft.com/xsl/cp/vzenv"
  xmlns:sample ="http://www.swsoft.com/xsl/cp/sample"
  xmlns:vzsample ="http://www.swsoft.com/xsl/cp/vzsample"
  xmlns:env		="http://www.swsoft.com/xsl/cp/env"
  xmlns:tem		="http://www.swsoft.com/xsl/cp/tem"
  xmlns:hwm		="http://www.swsoft.com/xsl/cp/hwm"
  xmlns:envm	="http://www.swsoft.com/xsl/cp/envm"
  xmlns:env-samplem	="http://www.swsoft.com/xsl/cp/env-samplem"
  xmlns:ui		="http://www.swsoft.com/xsl/cp/ui"
  xmlns:func	="http://exslt.org/functions"
	xmlns:cred	="http://www.swsoft.com/xsl/cp/cred"
	xmlns:voc		="http://www.swsoft.com/xsl/cp/voc"
	xmlns:vt				="http://www.swsoft.com/xsl/cp/vt"	
	xmlns:vzapackagem				="http://www.swsoft.com/xsl/cp/vzapackagem"	
 >
 
	<!-- Import -->	
	<!-- UI modules -->
	<sw:include href="/lib/wizard.xsl"/>

	<!-- System modules -->	
  <sw:include href="/lib/cred.xsl"/>
  <sw:include href="/lib/common.xsl"/>
  <sw:include href="/lib/vocabulary.xsl"/>				
		
	<!-- SWA functionality modules -->	
	<sw:include href="/lib/swa/env-samplem.xsl"/>
	<sw:include href="/lib/swa/envm.xsl"/>

	<!-- VZCC functionality modules -->	
	<sw:include href="/lib/vt/env-core.xsl"/>
	<sw:include	href="/lib/vt/core.xsl"/>	
	<sw:include	href="/lib/vz/core.xsl"/>	
	<sw:include	href="/lib/vz/vzenv-core.xsl"/>	
	<sw:include href="/lib/vz/vzenv-apps.xsl"/>
	<sw:include href="/lib/vz/vzenv-qos.xsl"/>
	<sw:include href="/lib/vz/vzenv-net.xsl"/>
	<sw:include	href="/lib/vz/vzenv-offline.xsl"/>
	<sw:include href="/lib/vz/vzenv-os.xsl"/>
	
	<sw:include href="/lib/vz/sample-net-ui.xsl"/>

	<!-- VZA functionality modules -->	
	<sw:include href="/lib/vz/apps.xsl"/>	
	<sw:include href="/lib/vza/tem.xsl"/>
	<sw:include href="/lib/vza/vzapackagem.xsl"/>
	<sw:include href="/lib/vza/hwm.xsl"/>
	<!-- /Import -->

	<!-- check permissions to show this page -->
  <xsl:variable name="cr-sample"				select="cred:check('vzcp.envsamples')"/>

  <xsl:param name="wiz_code" select="'envsamples-manage'"/>
  
	<xsl:variable name="step_data"	select="wiz:getStep()"/>
	<xsl:variable name="step"				select="$step_data/@id"/>
	<xsl:variable name="screenid"		select="$step_data/@screenid"/>
	<xsl:variable name="path-id"		select="string(wiz:getSteps()/step[@id = 'gen']/@screenid)"/>

  <xsl:variable name="form" select="sw:sesget($wiz_data)"/>
	<xsl:variable name="create" select="not($form/sample-id!='')"/>  

	<xsl:param name="access-denied" select="not($cr-sample)"/>

  <xsl:variable name="screen-title">
  	<xsl:choose>
  		<xsl:when test="$form/sample-id!=''">
  			<xsl:value-of select="$step_data/@title"/>
  		</xsl:when>
  		<xsl:otherwise>
				<sw:text>Create New Sample</sw:text>
  		</xsl:otherwise>
  	</xsl:choose>
  </xsl:variable>
      
  <!-- Wizard, Step 'Start' -->
  <xsl:template name="step_start">
  	<ui:screen id="{$screenid}">
  	
  	<!-- Load some VZ data -->  	  	
  	<xsl:variable name="sample_configs" select="env-samplem:list-samples('virtuozzo')"/>
  	<xsl:variable name="platforms" select="vt:platforms()/platform"/>
  	<xsl:variable name="env-title">
  		<xsl:choose>
  			<xsl:when test="not($form/src-select/env-eid) or $form/src-select/env-eid=''">
  			</xsl:when>
  			<xsl:otherwise>	  				  			
  				<xsl:variable name="env" select="env:get-env($form/src-select/env-eid)/env"/>
	  			<xsl:value-of select="env:env2title($env)"/>
	  		</xsl:otherwise>
	  	</xsl:choose>
  	</xsl:variable>
  	<!-- /Load some VZ data -->  	
  	
    <ui:properties>
    	<ui:form-get/>
      <ui:refresh-type>none</ui:refresh-type>
      <ui:description  mandatory="yes">
        <sw:text>
          Start creating the sample on the basis of either an existing sample or an existing Container.
        </sw:text>
      </ui:description>       
    </ui:properties>
    
    <ui:content>
      <ui:hidden name="step" value="start"/>    
      <ui:block mode="edit">
      	
	  		<!-- Prepare Data -->      		
	  		<xsl:variable name="src-sample-id" select="$form/src-select/sample-id"/>
		  	<!-- /Prepare Data -->
      		
    		<!-- Show Base Selector -->
    		<ui:rows title="{sw:text('Initial Configuration')}">
    			<!-- Show Sample -->
    			<ui:row>
    				<ui:cell-radio name="src_type" value="sample" id="src_type_sample" colspan="2">
    					<xsl:if test="$form/src-select/type='sample'">
    						<xsl:attribute name="checked">true</xsl:attribute>
    					</xsl:if>
    					<label for="src_type_sample">
    						<sw:text>Use an existing sample for initial configuration</sw:text>
    					</label>
    				</ui:cell-radio>    				
    			</ui:row>
					<!--|-->
    			<ui:row>
    				<ui:cell-text offset="3">
	        		<sw:text>Sample</sw:text>
	        	</ui:cell-text>
		        <ui:cell-list id="src_sample_id" value="{$src-sample-id}">		        	
		        	<xsl:if test="not($platforms)">
		        		<ui:list-item id="" title="{sw:text('No platforms available.')}"/>
		        	</xsl:if>
		        	<xsl:for-each select="$platforms">
		        		<xsl:variable name="platform-data" select="."/>
		        		<xsl:variable name="platform-samples" select="$sample_configs[sample:sample2platform(.)=$platform-data/@id]"/>		        		
			        	<xsl:if test="($platform-samples)">		        		
			        		<ui:list-item id="" disabled="true">
			        			<xsl:attribute name="title">
				        			<sw:text>
				        				<xsl:with-param name="platform" select="$platform-data/@title"/>
				        				-- Samples for %platform --
				        			</sw:text>
				        		</xsl:attribute>
			        		</ui:list-item>
						<xsl:for-each select="$platform-samples">
							<xsl:sort select="name"/>
							<ui:list-item id="{id}" title="{name}"/>
						</xsl:for-each>
								</xsl:if>
							</xsl:for-each>
						</ui:cell-list>
						<ui:cell-text cell-width="100%"/>
					</ui:row>      		
    			<!-- /Show Sample -->
    			<!-- Show Src Env -->
					<ui:row>
    				<ui:cell-radio name="src_type" value="env" id="src_type_env" colspan="2">
    					<xsl:if test="$form/src-select/type='env'">
    						<xsl:attribute name="checked">true</xsl:attribute>
    					</xsl:if>
    					<label for="src_type_env">
    						<sw:text>Use an existing Container for initial configuration</sw:text>      						
    					</label>
    				</ui:cell-radio>
    			</ui:row>
					<ui:row>
      		 	<ui:cell-text offset="3">
	        		<sw:text>Container</sw:text>
	        	</ui:cell-text>
	        	<ui:cell-selector id="src_env_eid" align="left" value="{$env-title}"
	        		code-value="{$form/src-select/env-eid}"
	        		link-tip="open_popup_ve_select" 
				      link-onclick="open_details('{$baseurl}/vt/envs/select-one-popup?parent-id=src_env_eid');return false;"
				      link-caption="{sw:text('Select...')}"
				    />
				    <ui:cell-text cell-width="100%"/>
					</ui:row>
					<!-- /Show Src Env -->
					<!-- Show Src Platform -->
					<!--
					<ui:row>
    				<ui:cell-radio name="src_type" value="zero" id="src_type_zero" colspan="2">
    					<xsl:if test="$form/src-select/type='zer'">
    						<xsl:attribute name="checked">true</xsl:attribute>
    					</xsl:if>
    					<label for="src_type_zero">
    						<sw:text>Create a sample for</sw:text>      						
    					</label>
    				</ui:cell-radio>
    			</ui:row>
					<ui:row>
      		 	<ui:cell-text offset="3">
	        		<sw:text>Platform</sw:text>
	        	</ui:cell-text>
	        	<ui:cell-list id="src_zero_platform" value="{$form/src-select/platform}">
							<xsl:for-each select="vt:platforms()/platform">
								<ui:list-item id="{@id}" title="{@title}"/>
							</xsl:for-each>
						</ui:cell-list>
						<ui:cell-text cell-width="100%"/>
					</ui:row>				
					-->
					<!-- /Show Src Env -->
				</ui:rows>

        <ui:buttons>
        	<xsl:call-template name="wiz:showButtons"/>
        </ui:buttons>
        
     	</ui:block>
    </ui:content>   
    </ui:screen>
  </xsl:template>

  <!-- Wizard, Step 'General Settings' -->
  <xsl:template name="step_gen">
  	<ui:screen id="{$screenid}" title="{$screen-title}">
  	
  	<!-- Load some VZ data -->  
  	<xsl:variable name="platform-linux" select="vt:is-platform-linux($form/platform)"/>	  	  	  	
  	<xsl:variable name="os_templates" select="vzenv:list-oses($form/platform)"/>  	
  	<xsl:variable name="env-title">
  		<xsl:choose>
  			<xsl:when test="not($form/gen/base-env-eid) or $form/gen/base-env-eid=''">
  			</xsl:when>
  			<xsl:otherwise>	  				  			
  				<xsl:variable name="env" select="env:get-env($form/gen/base-env-eid)/env"/>
	  			<xsl:value-of select="vzenv:env2title($env)"/>
	  		</xsl:otherwise>
	  	</xsl:choose>
  	</xsl:variable>
  	<!-- /Load some VZ data -->  	
  	
    <ui:properties>
    	<ui:form-get/>    
      <ui:refresh-type>none</ui:refresh-type>
      <ui:description  mandatory="yes">
        <sw:text>
          Configure the sample general settings.
        </sw:text>
      </ui:description>      
    </ui:properties>
    
		<xsl:if test="not($create)">
			<ui:tab-bar id="sample" current-tab="gen"/>
		</xsl:if>
    <ui:content>
      <ui:hidden name="step" value="gen"/>    
      <ui:block mode="edit">
      	
      	
      	<xsl:variable name="name-pattern" select="voc:get-pattern(
      		env:make-platform-ref('',$form/platform)
      	,'pattern.vesampleconfig')" />
      	
   			<ui:rows title="{sw:text('General')}">
   				<ui:row>
   					<ui:cell-label>
	        		<sw:text>Name</sw:text>
	        	</ui:cell-label>
						<ui:cell-input id="name" maxlength="{$name-pattern/max}" required="true"> 
							<xsl:attribute name="value"><xsl:value-of select="$form/gen/name"/></xsl:attribute>
						</ui:cell-input>
					</ui:row>
   				<ui:row>
   					<ui:cell-label valign="top">
	        		<sw:text>Description</sw:text>
	        	</ui:cell-label>
						<ui:cell-inputblock id="comment" maxlength="10000" rows="5">
							<xsl:value-of select="$form/gen/comment"/>
						</ui:cell-inputblock>
					</ui:row>
					
					<xsl:variable name="old-win-name" select="vz:get-old-win-os-name()"/>
					<xsl:if test="$form/os_template/name!='' and (not($os_templates[name=$form/os_template/name]) and ($form/os_template/name != $old-win-name))">
						<xsl:variable name="warn">
							<sw:text>
								<xsl:with-param name="os_name" select="$form/os_template/name"/>
								Warning! The Container sample specifies an OS, %{os_name}, which is not installed on the Hardware Node. Please select another OS.
							</sw:text>
						</xsl:variable>
						<xsl:if test="error:put($warn,'','os_template_name')"/>
					</xsl:if>
					<ui:row>
													
						<xsl:variable name="setup">
							<xsl:copy-of select="$form/os_template"/>
							<os_templates><xsl:copy-of select="$os_templates"/></os_templates>
							<show_empty_ver/>
							<init_on_start/>
							<empty_os_text><sw:text>Not specified</sw:text></empty_os_text>
							<xsl:choose>
								<xsl:when test="not($create) and $platform-linux">
									<change-os-js>
										alert('<xsl:value-of select="sw:html-escape(sw:text('Attention! The application set will be reset after the OS changes.'),'escape-quote')"/>');
									</change-os-js>
								</xsl:when>
							</xsl:choose>
						</xsl:variable>
						<xsl:copy-of select="vzenv:show-os(exsl:node-set($setup))"/>
						
					</ui:row>

					
				</ui:rows>
				
				<!-- Advanced -->				
				<ui:rows title="{sw:text('Advanced')}" id="show_adv" 
					status="{$form/gen/show_adv}"
					status-def="{sw:if($form/sample-id!='',1,0)}" closed-text="{sw:text('Click to show the advanced settings.')}"
				>
					<ui:row id="adv_block_3">
						<ui:cell-check id="start_after_boot" close="false" colspan="2">
							<xsl:if test="$form/gen/start_after_boot=1">
								<xsl:attribute name="checked">true</xsl:attribute>
							</xsl:if>         
						</ui:cell-check>
						<ui:cell open="false">
							<sw:text>Start the Container on the Hardware Node boot</sw:text>
						</ui:cell>
					</ui:row>

				</ui:rows>
				<!-- /Advanced -->

				<!-- 0ffline management control -->
				<xsl:copy-of select="vzenv:show-offline-selector($form,'predefined')"/>

        <ui:buttons>
        	<xsl:call-template name="wiz:showButtons"/>
        </ui:buttons>
        
     	</ui:block>
    </ui:content>   
    </ui:screen>
  </xsl:template>
  
  
  <!-- Reinstall Wizard, Step 'Custom Settings' -->
  <xsl:template name="step_qos">
  
  	<!-- Load some VZ data -->
  	<xsl:variable name="qos-warns-src">
			<xsl:if test="sw:param('validate') and error:is-empty()">
				<xsl:call-template name="sw:validateQoS">
					<xsl:with-param name="hn-eid" select="sw:master-eid()"/><!-- TODO: send packet to right node -->
					<xsl:with-param name="data" select="$form/qos"/>
				</xsl:call-template>
			</xsl:if>
		</xsl:variable>				  	  			
  	<xsl:variable name="qos-warns" select="exsl:node-set($qos-warns-src)"/>
  	<xsl:if test="$qos-warns/packet/data/error/code">
  		<xsl:if test="error:put(sw:text('The resources validation has failed.'),$qos-warns/packet/data/error/message)"/>
  	</xsl:if>  	
  	<!-- /Load some VZ data -->  
  
  	<ui:screen id="{$screenid}">
  	
  	<!-- Set new OSTemplate from Custom Config -->
    <ui:properties>
			<ui:form-post/>    
    	<ui:refresh-type>none</ui:refresh-type>
      <ui:description mandatory="yes" width="full">
        <sw:text>
          Customize resource settings.
        </sw:text>
      </ui:description>      
    </ui:properties>
    
    
    	<xsl:if test="not($create)">
			<ui:tab-bar id="sample" current-tab="qos"/>
		</xsl:if>

    <ui:content>
      <ui:hidden name="step" value="qos"/>    
      
    	<!-- Show QoS warnings-->
			<xsl:call-template name="sw:getQoSValidateResults">
				<xsl:with-param name="qos" select="$form/qos"/>
				<xsl:with-param name="qos-warns" select="$qos-warns"/>
			</xsl:call-template>				
			
      <ui:block mode="edit" width="full">
      	
				<xsl:call-template name="vzenv:edit-qos">
					<xsl:with-param name="platform-ref" select="env:make-platform-ref('',$form/platform)"/>
					<xsl:with-param name="data" select="$form/qos"/>
					<xsl:with-param name="qos-warns" select="$qos-warns/packet/data/vzaenvm/validation"/>
					<xsl:with-param name="warn-restart" select="false()"/>
				</xsl:call-template>
        <ui:buttons>
        	<xsl:call-template name="wiz:showButtons">
						<xsl:with-param name="buttons-ext">
							<xsl:if test="vt:is-platform-linux($form/platform)">
								<xsl:if test="vt:is-platform-linux(vt:local-platform())"> <!-- TODO: remove this check after bug 80366 -->
									<ui:button tip="ve_qos_validate" name="validate" sandclock="true"><sw:text>Validate</sw:text></ui:button>
								</xsl:if>
							</xsl:if>
						</xsl:with-param>
					</xsl:call-template>
        </ui:buttons>
     </ui:block>
    </ui:content>   
    </ui:screen>
  </xsl:template>  
  
  
  <!-- Wizard, Step 'Applications' -->
  <xsl:template name="step_apps">

  	<ui:screen id="{$screenid}" >
  	<!-- Load some VZ data -->
  	<!-- /Load some VZ data -->  	
    <ui:properties> 
     	<ui:form-get/> 
    	<ui:refresh-type>none</ui:refresh-type>
      <ui:description  mandatory="yes" width="max">
        <sw:text>
          Select applications.
        </sw:text>
      </ui:description>      
    </ui:properties>
    
    <xsl:if test="not($create)">
			<ui:tab-bar id="sample" current-tab="apps"/>
		</xsl:if>
		
    <ui:content>
      <ui:hidden name="step" value="apps"/>    
      <ui:block mode="edit" width="max">
      	<xsl:choose>
      		<xsl:when test="$form/os_template/name!=''">
      			<xsl:variable name="setup">
      				<xsl:if test="vt:is-platform-linux($form/platform)">
      					<ui:linux/>
      				</xsl:if>
		      		<ui:show-empty-ver/>
		      		<ui:tips>
		      			<ui:check-add>select_tmpl_add_app</ui:check-add>
		      			<ui:check-remove>select_tmpl_remove_app</ui:check-remove>
		      			<ui:add>click_tmpl_add_app</ui:add>
		      			<ui:remove>click_tmpl_remove_app</ui:remove>
		      		</ui:tips>
		      		<ui:captions>
		      			<ui:available><sw:text>Available Applications</sw:text></ui:available>
		      			<ui:selected><sw:text>Included Applications</sw:text></ui:selected>
		      			<ui:no-available><sw:text>No applications available.</sw:text></ui:no-available>
		      			<ui:no-selected><sw:text>No selected application.</sw:text></ui:no-selected>
		      		</ui:captions>
		      	</xsl:variable>
        		<xsl:copy-of select="vzenv:prepare-sample-apps($form/apps,$form/os_template,exsl:node-set($setup), $form/platform)"/>
        	</xsl:when>
        	<xsl:otherwise>
        		<ui:rows>
							<ui:row>
								<ui:cell>
									<sw:text>
										Application management is disabled because no OS is specified in the Container sample.
									</sw:text>
								</ui:cell>
							</ui:row>
						</ui:rows>	
        	</xsl:otherwise>
        </xsl:choose>
        <ui:buttons>
        	<xsl:call-template name="wiz:showButtons"/>
        </ui:buttons>
     </ui:block>
    </ui:content>   
    </ui:screen>
  </xsl:template>  
	
	<!-- Wizard, Step 'Network' -->
	<xsl:template name="step_net">
	
		<ui:screen id="{$screenid}">

			<ui:properties>    
	    	<ui:form-get/>			
			</ui:properties>
			
			<xsl:if test="not($create)">
				<ui:tab-bar id="sample" current-tab="net"/>
			</xsl:if>
			
			<ui:content>
				<ui:hidden name="step" value="net"/>    
				<ui:block mode="edit">

					<xsl:call-template name="vzsample:edit-net">
						<xsl:with-param name="net" select="$form/net"/>
					</xsl:call-template>
					
					<ui:buttons>
						<xsl:call-template name="wiz:showButtons"/>
					</ui:buttons>
					
				</ui:block>
			</ui:content>
			
		</ui:screen>
	</xsl:template>  
	
	<!-- Wizard, Step 'Final conformation' -->
	<xsl:template name="step_review">
		<ui:screen id="{$screenid}">
			<ui:properties>
	    	<ui:form-get/>	
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes">
					<table cellpadding="0" cellspacing="0" border="0">
						<tr>
							<td valign="top">
								<sw:text>
									Please review the new template configuration.
								</sw:text>
							</td>
						</tr>
					</table>
				</ui:description>      
			</ui:properties>
			<ui:content>
				<xsl:variable name="templates" select="vzapackagem:get-env-config-templates($form)"/>
				<xsl:variable name="os" select="$templates[vzapackagem:is-os(.)][1]"/>
				<xsl:variable name="apps" select="$templates[not(vzapackagem:is-os(.))]"/>
				
				<ui:hidden name="step" value="review"/>    
				<ui:block>
					<ui:rows title="{sw:text('Configuration')}">
						<ui:row>
							<ui:cell-label><sw:text>Name</sw:text></ui:cell-label>
							<ui:cell-value><xsl:value-of select="$form/gen/name"/></ui:cell-value>
						</ui:row>     
						<ui:row>
							<ui:cell-label><sw:text>Description</sw:text></ui:cell-label>
							<ui:cell-value><xsl:value-of select="$form/gen/comment"/></ui:cell-value>
						</ui:row>
						<ui:row>
							
							<ui:cell-label><sw:text>OS template</sw:text></ui:cell-label>
							<ui:cell-value>
								<xsl:call-template name="vzenv:get-os-tmpl-label">
									<xsl:with-param name="os" select="$os"/>
									<xsl:with-param name="empty-message" select="sw:text('Any')"/>
								</xsl:call-template>
							</ui:cell-value>
						</ui:row>	        
						<xsl:copy-of select="vzenv:view-slm-mode($form/platform,$form/qos/slm-mode)"/>					
						<ui:row>
							<ui:cell-label><sw:text>Start the Container on the Hardware Node boot</sw:text></ui:cell-label>
							<xsl:choose>
								<xsl:when test="$form/gen/start_after_boot!='1'">
									<ui:cell-value>No</ui:cell-value>
								</xsl:when>
								<xsl:otherwise>
									<ui:cell-value>Yes</ui:cell-value>
								</xsl:otherwise>
							</xsl:choose>
						</ui:row>
						<xsl:if test="$form/gen/offline_type != 'default'">
							<ui:row>
								<ui:cell-label><sw:text>Offline management</sw:text></ui:cell-label>
								<ui:cell-value>
									<xsl:choose>
										<xsl:when test="($form/gen/offline_type != 'default') and ($form/gen/offline_type != 'custom')">
											<sw:text>Disabled</sw:text>
										</xsl:when>
										<xsl:when test="$form/gen/offline_type = 'custom'">
											<sw:text>enabled for the following services:</sw:text>
											<xsl:for-each select="$form/def/all_offline_service/service">
												<xsl:if test="$form/gen/selected_offline_service/value = string(id)">
													<br/><xsl:value-of select="string(id)"/>
												</xsl:if>
											</xsl:for-each>										
										</xsl:when>
									</xsl:choose>
								</ui:cell-value>
							</ui:row>
						</xsl:if>
					</ui:rows>
					
					<!-- Show QoS -->
					<xsl:call-template name="vzenv:review-qos">
						<xsl:with-param name="hn-eid" select="sw:master-eid()"/><!-- TODO: send packet to right node -->					
						<xsl:with-param name="platform-ref" select="env:make-platform-ref('',$form/platform)"/>
						<xsl:with-param name="all-qos" select="$form/qos"/>
						<xsl:with-param name="validate" select="vt:is-platform-linux(vt:local-platform())"/><!-- TODO: remove this check after bug 80366 -->
					</xsl:call-template>	
						
					<ui:rows title="{sw:text('Applications')}">
						<xsl:choose>
							<xsl:when test="$apps">			
								<xsl:for-each select="$apps">
									<xsl:sort select="sw:uc(name)"/>
									<ui:row>
										<ui:cell>
											<xsl:call-template name="vzenv:get-app-tmpl-label">
												<xsl:with-param name="app" select="."/>
											</xsl:call-template>
										</ui:cell>
									</ui:row>
								</xsl:for-each>
							</xsl:when>
							<xsl:otherwise>
								<ui:row>
									<ui:cell>
										<sw:text>No applications included.</sw:text>
									</ui:cell>
								</ui:row>
							</xsl:otherwise>
						</xsl:choose>
					</ui:rows>
					
					<xsl:call-template name="vzsample:view-net">
						<xsl:with-param name="net" select="$form/net"/>
					</xsl:call-template>
	
					<!-- Show buttons -->
					<ui:buttons>
						<xsl:call-template name="wiz:showButtons"/>
					</ui:buttons>
				</ui:block>
			</ui:content>  
		</ui:screen>       
	</xsl:template>

	<!-- main document handler -->
	<xsl:template mode="screen" match="/">
	
			<xsl:choose>
				<xsl:when test="$step = 'start'">	
					<xsl:call-template name="step_start"/>
				</xsl:when>
				<xsl:when test="$step = 'qos'">
					<xsl:call-template name="step_qos"/>
				</xsl:when>
				<xsl:when test="$step = 'review'">
					<xsl:call-template name="step_review"/>
				</xsl:when>
				<xsl:when test="$step = 'apps'">
					<xsl:call-template name="step_apps"/>
				</xsl:when>
				<xsl:when test="$step = 'net'">
					<xsl:call-template name="step_net"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="step_gen"/>
				</xsl:otherwise>
				
			</xsl:choose>
		
	</xsl:template>
	
	<!-- Includes -->
	<sw:include href="/lib/screen.xsl"/>
	<!-- /Includes -->
	
</xsl:stylesheet>
