<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred env env-samplem vz"
  xmlns:xsl				="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl			="http://exslt.org/common"
  xmlns:sw				="http://www.swsoft.com/xsl/cp"
  xmlns:ui				="http://www.swsoft.com/xsl/cp/ui"  
  xmlns:vzenv			="http://www.swsoft.com/xsl/cp/vzenv"  
  xmlns:sample 		="http://www.swsoft.com/xsl/cp/sample"
  xmlns:vzsample 		="http://www.swsoft.com/xsl/cp/vzsample"  
  xmlns:env-samplem		="http://www.swsoft.com/xsl/cp/env-samplem"
	xmlns:cred  		="http://www.swsoft.com/xsl/cp/cred"
	xmlns:vt				="http://www.swsoft.com/xsl/cp/vt"
	xmlns:vz				="http://www.swsoft.com/xsl/cp/vz"
	xmlns:env				="http://www.swsoft.com/xsl/cp/env"
	xmlns:vzapackagem			="http://www.swsoft.com/xsl/cp/vzapackagem"
>
	
	<sw:include href="/lib/vt/core.xsl"/>
	<sw:include href="/lib/vt/env-core.xsl"/>	
	<sw:include href="/lib/vz/core.xsl"/>
	<sw:include href="/lib/vz/vzenv-core.xsl"/>
	<sw:include href="/lib/vz/vzenv-apps.xsl"/>
	<sw:include href="/lib/swa/env-samplem.xsl"/>   
	<sw:include href="/lib/vz/sample-net-ui.xsl"/>
	<sw:include href="/lib/vza/vzapackagem.xsl"/>


  <xsl:template mode="screen" match="/">
 		<xsl:variable name="sample-id" 	select="sw:sesget('envsample-id')"/>  
  	<xsl:variable name="sample" select="env-samplem:get-sample($sample-id)"/>
  	<xsl:if test="sw:sesput('envsample-name',$sample/name)"/>
  	<xsl:variable name="net-rtf">
	  	<xsl:call-template name="vzsample:config2net">
	  		<xsl:with-param name="config" select="$sample"/>
	  	</xsl:call-template>
  	</xsl:variable>
  		
  	<xsl:variable name="templates" select="vzapackagem:get-env-config-templates($sample/env_config)"/>
		<xsl:variable name="os" select="$templates[vzapackagem:is-os(.)][1]"/>    	
		<xsl:variable name="apps" select="$templates[name!='' and not(vzapackagem:is-os(.))]"/>    	
		<xsl:variable name="sample-platform" select="sample:sample2platform($sample)"/>
  	
    <ui:screen id="03.02.01.23.01">
      <ui:properties>
	    	<ui:form-get/>      
      	<ui:width value="fixed"/>
      </ui:properties>

			<ui:tab-bar id="sample" current-tab="summary"/>

      <ui:content>
        <ui:block>
					
					<ui:rows title="{sw:text('Sample Summary')}">										
						<ui:row>
							<ui:cell-label><sw:text>Name</sw:text></ui:cell-label>
							<ui:cell><xsl:value-of select="$sample/name"/></ui:cell>
						</ui:row>												
						<ui:row>
							<ui:cell-label><sw:text>Description</sw:text></ui:cell-label>
							<ui:cell><xsl:value-of select="sw:base64-decode($sample/comment)"/></ui:cell>
						</ui:row>
						<ui:row>
							<ui:cell-label><sw:text>Platform</sw:text></ui:cell-label>
							<ui:cell-text>
								<ui:platform-os>
									<xsl:value-of select="$sample-platform"/>
								</ui:platform-os>
								<xsl:value-of select="vt:platform2title($sample-platform)"/>
							</ui:cell-text>
						</ui:row>
						<ui:row>
							<ui:cell-label><sw:text>OS Template</sw:text></ui:cell-label>
							<ui:cell-value>
								<xsl:call-template name="vzenv:get-os-tmpl-label">
									<xsl:with-param name="os" select="$os"/>
									<xsl:with-param name="enabled" select="cred:check('vzcp.template')"/>
									<xsl:with-param name="empty-message" select="sw:text('Any')"/>
								</xsl:call-template>
							</ui:cell-value>
						</ui:row>
						<xsl:if test="vt:is-platform-linux($sample-platform)">
							<ui:row>
								<ui:cell-label><sw:text>Memory Management Mode</sw:text></ui:cell-label>
								<ui:cell-value>
									<xsl:variable name="slm-modes" select="vz:get-slm-modes()"/>
									<xsl:variable name="slm-selected" select="sw:if($slm-modes/id = $sample/env_config/slm_mode,$sample/env_config/slm_mode,'ubc')"/>
									<xsl:value-of select="$slm-modes[id = $slm-selected]/title"/>
								</ui:cell-value>
							</ui:row>   
						</xsl:if>
						<ui:row>
							<ui:cell-label><sw:text>Applications Included</sw:text></ui:cell-label>
							<ui:cell-value>
								<xsl:choose>
									<xsl:when test="$apps">
										<xsl:call-template name="vzenv:view-apps-list">
											<xsl:with-param name="apps" select="$apps"/>
											<xsl:with-param name="enabled" select="cred:check('vzcp.template')"/>
										</xsl:call-template>
									</xsl:when>
									<xsl:otherwise>
										<sw:text>None</sw:text>
									</xsl:otherwise>
								</xsl:choose>
							</ui:cell-value>
						</ui:row>          
					</ui:rows>	
					
					<xsl:call-template name="vzsample:view-net">
						<xsl:with-param name="net" select="exsl:node-set($net-rtf)"/>
					</xsl:call-template>
					
				</ui:block>
      </ui:content>
    </ui:screen>    
  </xsl:template>

  <sw:include href="/lib/screen.xsl"/>
  
	<sw:include href="/lib/vz/apps.xsl"/>	

</xsl:stylesheet>
