<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func wiz cred hwm show form"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp" xmlns:error="http://www.swsoft.com/xsl/cp/error"
	xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz" xmlns:hwm="http://www.swsoft.com/xsl/cp/hwm"
	xmlns:ui="http://www.swsoft.com/xsl/cp/ui" xmlns:form="http://www.swsoft.com/xsl/cp/form"
	xmlns:func="http://exslt.org/functions" xmlns:show="http://www.swsoft.com/xsl/cp/show"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:traffic="http://www.swsoft.com/xsl/cp/traffic"	
>

	<!-- check permissions to show this page -->
	<xsl:variable name="cred" select="cred:check-hw('vzcp.hn.manage.config.network',sw:hn-eid())"/>
	<xsl:param name="wiz_code" select="'vznet_accounting'"/>
	<xsl:variable name="step_data" select="wiz:getStep()"/>
	<xsl:variable name="step" select="$step_data/@id"/>
	<xsl:variable name="path-id" select="string(wiz:getSteps()/step[1]/@screen-id)"/>
	<xsl:param name="access-denied" select="not($cred)"/>
	<xsl:variable name="form" select="sw:sesget($wiz_data)"/>

	<!-- Wizard, General Step  -->
	<xsl:template name="step_config">
		<ui:screen path-id="{$path-id}" id="{$step_data/@screen-id}" title="{$step_data/@screen-title}"
			icon="{$step_data/@screen-icon}">
			<ui:properties>
				<ui:description mandatory="yes" width="max">
					<sw:text>Use the following guidelines to configure the traffic accounting.</sw:text>
					<ul>
						<li>
							<sw:text>You can assign multiple networks for a class.</sw:text>
						</li>
						<li>
							<sw:text>
								<xsl:with-param name="min-class" select="$min-class-id"/>
								<xsl:with-param name="max-class" select="$max-class-id"/>
								You can define network classes ranging from %{min-class} to %{max-class}.
							</sw:text>
						</li>
					</ul>
				</ui:description>
				<ui:no-refresh/>
				<ui:form-get/>
			</ui:properties>
			<ui:content>
				<ui:hidden name="step" value="config"/>
				<ui:block width="max">
					<ui:rows separate-tables="true" title="{sw:text('Traffic Accounting Classes')}">
						<xsl:copy-of select="traffic:show-hw-interface-ranges($form/config/range)"/>
					</ui:rows>
					<ui:buttons>
						<xsl:call-template name="wiz:showButtons"/>
					</ui:buttons>
				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>

	<!-- main document handler -->
	<xsl:template mode="screen" match="/">
		<xsl:call-template name="step_config"/>
	</xsl:template>

	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>

	<sw:include href="/lib/vocabulary.xsl"/>
	<sw:include href="/lib/vza/hwm.xsl"/>
	<sw:include href="/lib/vz/vznet.xsl"/>
	<sw:include href="/lib/traffic.xsl"/>

</xsl:stylesheet>
