<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0"
	extension-element-prefixes="sw exsl func wiz cred hwm"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:error="http://www.swsoft.com/xsl/cp/error"
	xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz"
	xmlns:hwm="http://www.swsoft.com/xsl/cp/hwm"
	xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
	xmlns:func="http://exslt.org/functions"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
>

	<xsl:param name="wiz_code" select="'hw-config-network'"/>

	<xsl:variable name="step_data" select="wiz:getStep()"/>
	<xsl:variable name="step" select="$step_data/@id"/>
	<xsl:variable name="path-id" select="string(wiz:getSteps()/step[1]/@screen-id)"/>

	<xsl:param name="access-denied" 
		select="not(cred:check-hw('vzcp.hn.manage.config.email',sw:hn-eid()))"/>

	<xsl:variable name="form" select="sw:sesget($wiz_data)"/>

	<!-- Wizard, General Step  -->
	<xsl:template name="step_gen">
		<ui:screen id="{$step_data/@screen-id}">

			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:form-get/>
			</ui:properties>
			<ui:content>
				<ui:hidden name="step" value="gen"/>
				<ui:block mode="edit">
				
					<ui:rows title="{sw:text('Email Proxy')}">
						<ui:row>
							<ui:cell-label>
								<sw:text>SMTP Relay Server IP Address</sw:text>
							</ui:cell-label>
							<ui:cell-input id="relay" maxlength="15" value="{$form/mailer/relay}"/>
						</ui:row>
					</ui:rows>

					<xsl:if test="$form/hn/linux 
						and cred:check-hw('vzcp.hn.manage.config.network',sw:hn-eid())">
						<ui:rows title="{sw:text('Proxy Settings')}">
							<ui:row>
								<ui:cell-label>
									<sw:text>Proxy Server</sw:text>
								</ui:cell-label>
								<ui:cell-input id="proxy_address" maxlength="256" value="{$form/proxy/proxy_address}"/>
							</ui:row>
							<ui:row>
								<ui:cell/>
								<ui:cell-text>
									<ui:text-disabled><sw:text>Proxy server URL - [protocol://]&amp;lt;host&amp;gt;[:port]</sw:text></ui:text-disabled>
								</ui:cell-text>
							</ui:row>
						</ui:rows>
					</xsl:if>

					<ui:buttons>
						<xsl:call-template name="wiz:showButtons"/>
					</ui:buttons>

				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>


	<!-- main document handler -->
	<xsl:template mode="screen" match="/">

		<xsl:choose>
			<xsl:when test="$step = 'gen'">
				<xsl:call-template name="step_gen"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="step_gen"/>
			</xsl:otherwise>

		</xsl:choose>

	</xsl:template>

	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>

	<sw:include href="/lib/vocabulary.xsl"/>
	<sw:include href="/lib/vza/hwm.xsl"/>

</xsl:stylesheet>
