 <!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred wiz"
  xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl	="http://exslt.org/common"
  xmlns:sw		="http://www.swsoft.com/xsl/cp"
  xmlns:ui	="http://www.swsoft.com/xsl/cp/ui"
	xmlns:cred  ="http://www.swsoft.com/xsl/cp/cred"
	xmlns:wiz   ="http://www.swsoft.com/xsl/cp/wiz"
  >

  <xsl:param name="wiz_code" select="'reboot-hw'"/>
	<xsl:variable name="step_data"  select="wiz:getStep()"/>
  <xsl:variable name="step"       select="$step_data/@id"/>
  <xsl:variable name="step-cred"	select="$step_data/@cred"/>
  <xsl:variable name="screen-id"   select="$step_data/@screenid"/>

  <xsl:variable name="form" select="sw:sesget($wiz_data)"/>

	<!-- check detail permissions to screen -->
	<xsl:param name="access-denied" 
		select="not(cred:check-context('vzcp.hn.reboot','hn.vz.vt'))"/>

	<!-- reboot  Wizard, Step 'reboot' -->
	<xsl:template name="step_reboot">
		<ui:screen id="{$screen-id}">
			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:form-get/>
			</ui:properties>      
			<ui:content>
				<ui:block>
					<ui:alert>
						<sw:text>
							ATTENTION ! <br/> After you press the "Reboot" button, the Hardware Node will be rebooted. <br/> It takes about 3-5 minutes to reboot the Node. During this time, it will be unavailable. <br/>
						</sw:text>
					</ui:alert>
					<ui:hidden name="step" value="reboot"/>
					<ui:buttons>
						<xsl:call-template name="wiz:showButtons">
							<xsl:with-param name="submit-title"><sw:text>Reboot</sw:text></xsl:with-param>
							<xsl:with-param name="submit-tip">click_2_reboot_hw</xsl:with-param>
						</xsl:call-template>
					</ui:buttons>
				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>  

  <!-- main document handler -->
	<xsl:template mode="screen" match="/">
		<xsl:choose>
			<xsl:when test="$step = 'reboot'">
				<xsl:call-template name="step_reboot"/>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
                                      
	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>

</xsl:stylesheet>
