<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
>

	<sw:include href="/lib/utils/format-resusage.xsl"/>

	<!-- check detail permissions to req -->
	<xsl:param name="access-denied" select="not(cred:check-hw('vzcp.hn.view',sw:hn-eid()))"/>

	<xsl:template mode="screen" match="/">
		<ui:screen id="03.02.01.27.02" bg="resource">
			<ui:properties>
				<ui:description width="max">
					<sw:text>
          The Hardware Node resources overview.
        </sw:text>
				</ui:description>
				<ui:form-get/>
			</ui:properties>
			<ui:tab-bar id="vzhn" current-tab="res" current-subtab="overview"/>

			<ui:content>
				<ui:summary-cols>
					<ui:summary-col>
						<xsl:apply-templates select="/packet/cookie/resources/group[id = 'cpu']" mode="resource"/>
						<xsl:apply-templates select="/packet/cookie/resources/group[id !='cpu' and id != 'system']"
							mode="resource"/>
					</ui:summary-col>
					<ui:summary-col>
						<ui:summary-placeholder/>
					</ui:summary-col>
				</ui:summary-cols>
			</ui:content>
		</ui:screen>
	</xsl:template>

	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/meter.xsl"/>
	<sw:include href="/lib/show-resource.xsl"/>

</xsl:stylesheet>
