<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func cred tbs wiz"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl="http://exslt.org/common"
	xmlns:func="http://exslt.org/functions"
	xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz"
	xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
	xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:tbs="http://www.swsoft.com/xsl/cp/tbs"
	xmlns:show="http://www.swsoft.com/xsl/cp/show"
	xmlns:local="http://www.swsoft.com/xsl/cp/local"
	xmlns:error="http://www.swsoft.com/xsl/cp/error"
>

	<xsl:param name="wiz_code" select="'support_key'"/>
	<xsl:variable name="step_data" select="wiz:getStep()"/>
	<xsl:variable name="step" select="$step_data/@id"/>
	<xsl:variable name="step-cred" select="$step_data/@cred"/>
	<xsl:variable name="screen-id" select="$step_data/@screen-id"/>
	<xsl:variable name="path-id" select="string(wiz:getSteps()/step[1]/@screen-id)"/>

	<xsl:variable name="form" select="sw:sesget($wiz_data)"/>

	<!-- check detail permissions to screen -->
	<xsl:param name="access-denied"
		select="$step-cred!='' and not(cred:check-context($step-cred,$step_data/@security-obj-type))"/>

	<xsl:template name="step_install">
		<ui:screen path-id="{$path-id}" id="{$screen-id}" title="{sw:text('Install New Certificate')}" icon="license">
			<ui:properties>
				<ui:form-post/>
				<ui:description>
					<sw:text>There you can install a new certificate.</sw:text>
				</ui:description>
			</ui:properties>

			<ui:content>
				<ui:hidden name="step" value="install"/>

				<ui:block mode="edit">
					<ui:rows>
						<ui:row>
							<ui:cell colspan="2">
								<sw:text>
									Select the file with a certificate.
								</sw:text>
							</ui:cell>
							<xsl:variable name="error-show" select="sw:if(error:has-errors(),'no','yes')"/>
							<xsl:choose>
								<xsl:when test="error:is-empty()">
									<ui:cell-file id="key_file"/>
								</xsl:when>
								<xsl:otherwise>
									<ui:cell-file id="key_file"/>
								</xsl:otherwise>
							</xsl:choose>
						</ui:row>
					</ui:rows>
					<ui:buttons>
						<xsl:call-template name="wiz:showButtons"/>
					</ui:buttons>

				</ui:block>
			</ui:content>

		</ui:screen>
	</xsl:template>

	<!-- main document handler -->
	<xsl:template mode="screen" match="/">
		<xsl:choose>
			<xsl:when test="$step = 'request'">
				<xsl:call-template name="step_request"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="step_install"/>
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

	<sw:include href="/lib/vza/hwm.xsl"/>
	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>

</xsl:stylesheet>
