<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
    extension-element-prefixes="sw exsl cred wiz vznet" xmlns:exsl="http://exslt.org/common"
    xmlns:sw="http://www.swsoft.com/xsl/cp" xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
    xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz" xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
    xmlns:vznet="http://www.swsoft.com/xsl/cp/vznet">

	<sw:include href="/lib/cred.xsl"/>
    <sw:include href="/lib/vz/vznet-ui.xsl"/>

    <xsl:param name="wiz_code" select="'netswitch-config'"/>
    <xsl:variable name="step_data" select="wiz:getStep()"/>
    <xsl:variable name="step" select="$step_data/@id"/>
    <xsl:variable name="form" select="sw:sesget($wiz_data)"/>

    <xsl:template name="step_gen">
        <ui:screen id="{$step_data/@screen-id}">
        	<ui:tab-bar id="vzhn" current-tab="network" current-subtab="switches"/>
            <ui:properties>
                <ui:refresh-type>none</ui:refresh-type>
                <ui:description mandatory="yes">
                    <sw:text> Here you can configure the selected network bridge. </sw:text>
                </ui:description>
                <ui:form-get/>
            </ui:properties>
            <ui:content>
                <ui:hidden name="step" value="gen"/>
                <ui:hidden name="switch_id" value="{$form/gen/net_device/id}"/>
                <ui:block mode="edit">
                    <ui:rows title="{sw:text('General')}">
                        <ui:row>
                            <ui:cell-label>
                                <sw:text>Viruial Network</sw:text>
                            </ui:cell-label>
                            <xsl:copy-of select="vznet:ui-networks-list($form)"/>
                        </ui:row>
                    </ui:rows>
                    <ui:buttons>
                        <xsl:call-template name="wiz:showButtons"/>
                    </ui:buttons>
                </ui:block>
            </ui:content>
        </ui:screen>
    </xsl:template>

	<xsl:template mode="screen" match="/">
		<sw:noauth-redirect select="not(cred:check-hw('vzcp.hn.manage.config.network', sw:hn-eid()))"/>
        <xsl:choose>
            <xsl:when test="$step = 'gen'">
                <xsl:call-template name="step_gen"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:call-template name="step_gen"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <sw:include href="/lib/screen.xsl"/>
    <sw:include href="/lib/wizard.xsl"/>
</xsl:stylesheet>
