<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	extension-element-prefixes="sw exsl cred wiz vznet" xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp" xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
	xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz" xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:vznet="http://www.swsoft.com/xsl/cp/vznet">

	<sw:include href="/lib/vz/vznet-ui.xsl"/>

	<xsl:param name="wiz_code" select="'vlan-add'"/>
	<xsl:variable name="step_data" select="wiz:getStep()"/>
	<xsl:variable name="step" select="$step_data/@id"/>
	<xsl:variable name="form" select="sw:sesget($wiz_data)"/>

	<xsl:template name="step_gen">
		<ui:screen id="{$step_data/@screen-id}" icon="vlan">
			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:form-get/>
			</ui:properties>
			<ui:content>
				<ui:hidden name="step" value="gen"/>
				<ui:block mode="edit">
					<ui:rows title="{sw:text('General Settings')}">
						<ui:row>
							<ui:cell-label>
								<sw:text>VLAN Tag</sw:text>
							</ui:cell-label>
							<ui:cell-input id="vlan_id" width="5" required="true"
								value="{$form/gen/net_device/vlan_id}"/>
						</ui:row>
						<ui:row>
							<ui:cell/>
							<ui:cell-text>
								<ui:text-disabled>
									<sw:text>A VLAN tag must be an integer in the 2-4094 range.</sw:text>
								</ui:text-disabled>
							</ui:cell-text>
						</ui:row>
						<ui:row>
							<ui:cell-label>
								<sw:text>Base interface</sw:text>
							</ui:cell-label>
							<ui:cell-list id="base_device_id" value="{$form/gen/base_device_id}">
								<xsl:for-each select="$form/static/adaptors/*">
									<xsl:sort select="id"/>
									<ui:list-item id="{string(id)}">
										<xsl:attribute name="title">
											<xsl:value-of select="id"/>
										</xsl:attribute>
									</ui:list-item>
								</xsl:for-each>
							</ui:cell-list>
						</ui:row>
						<xsl:call-template name="vznet:new-virtual-network">
							<xsl:with-param name="data" select="$form"/>
						</xsl:call-template>
					</ui:rows>
					<ui:buttons>
						<xsl:call-template name="wiz:showButtons"/>
					</ui:buttons>
				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>

	<xsl:template mode="screen" match="/">
		<xsl:choose>
			<xsl:when test="$step = 'gen'">
				<xsl:call-template name="step_gen"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="step_gen"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>
</xsl:stylesheet>
