<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	extension-element-prefixes="sw exsl cred wiz"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp" xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
	xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz" xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:vznet="http://www.swsoft.com/xsl/cp/vznet">

	<sw:include href="/lib/vz/vznet-core.xsl"/>
	<sw:include href="/lib/vz/vznet-ui.xsl"/>

	<xsl:param name="wiz_code" select="'vn-connect'"/>
	<xsl:variable name="step_data" select="wiz:getStep()"/>
	<xsl:variable name="step" select="$step_data/@id"/>
	<xsl:variable name="form" select="sw:sesget($wiz_data)"/>

	<xsl:variable name="all-interfaces" select="vznet:list-devices(sw:hn-eid(),/..)"/>
	<xsl:variable name="interfaces"
		select="$all-interfaces[sw:split(@xsi:type,':')[last()] = 'net_nicType' or sw:split(@xsi:type,':')[last()] = 'net_vlanType']"/>

	<xsl:template name="step_gen">
		<ui:screen id="{$step_data/@screen-id}" icon="network_config">
			<ui:properties>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes">
					<sw:text> Here you can configure the selected virtual network. </sw:text>
				</ui:description>
				<ui:form-get/>
			</ui:properties>
			<ui:content>
				<ui:hidden name="step" value="gen"/>
				<ui:block mode="edit">
					<xsl:copy-of select="vznet:ui-vn-connection-form($form)"/>
					<ui:buttons>
						<xsl:call-template name="wiz:showButtons"/>
					</ui:buttons>
				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>

	<xsl:template mode="screen" match="/">
		<xsl:choose>
			<xsl:when test="$step = 'gen'">
				<xsl:call-template name="step_gen"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="step_gen"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>
</xsl:stylesheet>
