<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred ips"
  xmlns:xsl				="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl			="http://exslt.org/common"
  xmlns:sw				="http://www.swsoft.com/xsl/cp"
  xmlns:ui			="http://www.swsoft.com/xsl/cp/ui"   
  xmlns:local			="http://www.swsoft.com/xsl/cp/local"   
  xmlns:browse		="http://www.swsoft.com/xsl/cp/browse"   
	xmlns:cred			="http://www.swsoft.com/xsl/cp/cred"
	xmlns:ips				="http://www.swsoft.com/xsl/cp/ips"
  >

	<sw:include href="/lib/cred.xsl"/> 
 	<sw:include href="/lib/core/browse-filter-raw.xsl"/> 
  <sw:include href="../../../../lib/vz/ips.xsl"/>

	<xsl:param name="access-denied" select="not(cred:check('vzcp.virtuozzo_group.network.ippools'))"/>

  <xsl:template mode="screen" match="/">       
    
    <xsl:variable name="ranges" select="ips:ranges()"/>    			
   	<xsl:variable name="all-used" select="ips:all-used($ranges,true())"/>		
    
    <xsl:variable name="filter_init_">
			<xsl:call-template name="browse:init-filter">
				<xsl:with-param name="browse">
					<ui:browse-setup id="ip-pool-ranges" url="/vzdir/infrman/ipranges/allocated" 
						item-url="/vzdir/infrman/envs/env"
					/>
	        <ui:cols sorting-col="ip">
	        	<ui:column id="ip" align="right" show-url="yes" data-type="str" title="{sw:text('IP Address')}" filter="auto"/>
	        	<ui:column id="id" nav-type="id" hidden="yes"/>
	        	<ui:column id="title" nav-type="title" title="{sw:text('Container Name')}" filter="auto"/>
	        	<!--
	        		<ui:column id="hw-ip" data-type="ip" title="{sw:text('HN IP Address')}" filter="auto"/>
	        	-->
	        </ui:cols>
				</xsl:with-param>
			</xsl:call-template>
    </xsl:variable>
    
    <xsl:variable name="filter">
    	<xsl:call-template name="browse:fill-filter">
				<xsl:with-param name="filter" select="exsl:node-set($filter_init_)"/>
				<xsl:with-param name="rows">					
	        <ui:browse-rows>
	        	<xsl:for-each select="$all-used/ip">
	            <ui:row>
	              <id>
									<xsl:value-of select="@ve-eid"/>
								</id>
								<title>
									<xsl:value-of select="@ve-title"/>
								</title>
								<hw>
									<xsl:value-of select="@hw-id"/>
								</hw>
								<ip>
									<xsl:value-of select="@value"/>
								</ip>							
	            </ui:row>
	          </xsl:for-each> 	        
        	</ui:browse-rows>
        </xsl:with-param>    
			</xsl:call-template>
    </xsl:variable>

		<ui:screen id="03.02.01.37.03">

	    <ui:properties>
	      <ui:form-get/>
	      <ui:description>  
	        <sw:text>On this screen you can see all the IP addresses leased from the IP address pool and assigned to Containers.</sw:text>
	      </ui:description>  
	    </ui:properties>

			<ui:tab-bar id="setup.net" current-tab="ips" current-subtab="allocated"/>
    	<ui:content>

				<ui:block>
				
					<ui:browse>
						<xsl:attribute name="title"><sw:text>Allocated Ranges</sw:text></xsl:attribute>
						
						<ui:filter>
							<xsl:copy-of select="$filter"/>
						</ui:filter>       
						       
			      <!-- form definition for other controls -->
			
			      <ui:browse-empty-msg>
			        <sw:text>No allocated IP addresses.</sw:text>
			      </ui:browse-empty-msg>
	
	      	</ui:browse>
      	</ui:block>
    	</ui:content>          
		</ui:screen>
	</xsl:template>  


  <sw:include href="../../../../lib/screen.xsl"/>
  
</xsl:stylesheet>
