<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func wiz cred"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl="http://exslt.org/common"
  xmlns:sw="http://www.swsoft.com/xsl/cp"
  xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz"
  xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
  xmlns:func="http://exslt.org/functions"
	xmlns:cred  ="http://www.swsoft.com/xsl/cp/cred"
 >
 
	<sw:include href="/lib/wizard.xsl"/>
	<sw:include href="/lib/vocabulary.xsl"/>			

  <!-- check permissions to show this page -->
	<xsl:variable name="cr-add" select="cred:check('vzcp.virtuozzo_group.network.ippools')"/>
	<xsl:variable name="cr-edit" select="$cr-add"/>

	<xsl:param name="wiz_code" select="'ip-range'"/>
  
	<xsl:variable name="step_data"			select="wiz:getStep()"/>
	<xsl:variable name="step"				select="$step_data/@id"/>
	<xsl:variable name="screenid"			select="$step_data/@screenid"/>
	<xsl:variable name="path-id"			select="string(wiz:getSteps()/step[@id = 'gen']/@screenid)"/>
	<xsl:variable name="access-denied-add"	select="not($cr-add)"/>
	<xsl:variable name="access-denied-edit" select="not($cr-edit)"/>
	<xsl:variable name="form" 				select="sw:sesget($wiz_data)"/>
	<xsl:variable name="create" 			select="not($form/range_id!='')"/>  
	<xsl:variable name="screen-icon"		select="'networkadapter'"/>	
	<xsl:param name="access-denied" select="sw:if($form/range_id!='',$access-denied-edit,$access-denied-add)"/>
	  
<!-- Wizard, Step 'General Settings' -->
<xsl:template name="step_gen">
  	<ui:screen id="{$screenid}" icon="{$screen-icon}">
  	
    <ui:properties>
      <ui:form-get/>
      <ui:refresh-type>none</ui:refresh-type>
    </ui:properties>
    
    <ui:content>
      <ui:hidden name="step" value="gen"/>    
      <ui:block mode="edit">
   			<ui:rows title="{sw:text('General')}">
   				<ui:row>
   					<ui:cell-radio name="choice" id="choice_range" value="range" colspan="2" close="false">
   						<xsl:if test="$form/gen/choice='range'">
   							<xsl:attribute name="checked">true</xsl:attribute>
   						</xsl:if>
	        	</ui:cell-radio>
						<ui:cell open="false">
							<sw:text>Specify range</sw:text>
						</ui:cell>
					</ui:row>
   				<ui:row>
   					<ui:cell-label offset="2">
	        		<sw:text>First IP Address</sw:text>
	        	</ui:cell-label>
						<ui:cell-input id="first" maxlength="15" width="20" show-aster="true">
							<xsl:attribute name="value"><xsl:value-of select="$form/gen/first"/></xsl:attribute>
							<xsl:attribute name="onfocus">document.getElementById('choice_range').checked=true;</xsl:attribute>
						</ui:cell-input>
					</ui:row>
   				<ui:row>
   					<ui:cell-label offset="2">
	        		<sw:text>Last IP Address</sw:text>
	        	</ui:cell-label>
						<ui:cell-input id="last" maxlength="15" width="20"  show-aster="true">
							<xsl:attribute name="value"><xsl:value-of select="$form/gen/last"/></xsl:attribute>
							<xsl:attribute name="onfocus">document.getElementById('choice_range').checked=true;</xsl:attribute>
						</ui:cell-input>
					</ui:row>
					
					<ui:row>
   					<ui:cell-radio name="choice" id="choice_count" value="count" colspan="2" close="false">
   						<xsl:if test="$form/gen/choice='count'">
   							<xsl:attribute name="checked">true</xsl:attribute>
   						</xsl:if>
	        	</ui:cell-radio>
						<ui:cell open="false">
							<sw:text>Specify count</sw:text>
						</ui:cell>
					</ui:row>
   				<ui:row>
   					<ui:cell-label offset="2">
	        		<sw:text>First IP Address</sw:text>
	        	</ui:cell-label>
						<ui:cell-input id="count_first" maxlength="15" width="20" show-aster="true">
							<xsl:attribute name="value"><xsl:value-of select="$form/gen/count_first"/></xsl:attribute>
							<xsl:attribute name="onfocus">document.getElementById('choice_count').checked=true;</xsl:attribute>
						</ui:cell-input>
					</ui:row>
					<ui:row>
   					<ui:cell-label offset="2">
	        		<sw:text>IP Addresses Number</sw:text>
	        	</ui:cell-label>
						<ui:cell-input id="count" maxlength="15" show-aster="true">
							<xsl:attribute name="value"><xsl:value-of select="$form/gen/count"/></xsl:attribute>
							<xsl:attribute name="onfocus">document.getElementById('choice_count').checked=true;</xsl:attribute>
						</ui:cell-input>
					</ui:row>
										
				</ui:rows>
			
        <ui:buttons>
        	<xsl:call-template name="wiz:showButtons"/>
        </ui:buttons>
        
     	</ui:block>
    </ui:content>   
    </ui:screen>
  </xsl:template>
  
  
 
	<!-- main document handler -->
	<xsl:template mode="screen" match="/">
	
			<xsl:choose>
			
				<xsl:when test="$step = 'gen'">
					<xsl:call-template name="step_gen"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="step_gen"/>
				</xsl:otherwise>
				
			</xsl:choose>
		
	</xsl:template>
	
	
	<sw:include href="/lib/screen.xsl"/>	
	
</xsl:stylesheet>
