<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	extension-element-prefixes="sw exsl cred wiz" xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp" xmlns:ui="http://www.swsoft.com/xsl/cp/ui"
	xmlns:wiz="http://www.swsoft.com/xsl/cp/wiz" xmlns:cred="http://www.swsoft.com/xsl/cp/cred">

	<xsl:param name="wiz_code" select="'network-manage'"/>
	<xsl:variable name="step_data" select="wiz:getStep()"/>
	<xsl:variable name="step" select="$step_data/@id"/>
	<xsl:variable name="form" select="sw:sesget($wiz_data)"/>

	<xsl:template name="step_gen">
		<ui:screen id="{$step_data/@screen-id}">
			<ui:properties>
				<ui:form-get/>
				<ui:refresh-type>none</ui:refresh-type>
				<ui:description mandatory="yes">
					<sw:text> Here you can configure the selected virtual network. </sw:text>
				</ui:description>
			</ui:properties>
			<ui:content>
				<ui:hidden name="step" value="gen"/>
				<ui:block mode="edit">
					<ui:rows title="{sw:text('General')}">
						<ui:row>
							<ui:cell-label>
								<sw:text>Virtual Network Name</sw:text>
							</ui:cell-label>
							<ui:cell-text>
								<xsl:value-of select="$form/static/network_id"/>
							</ui:cell-text>
						</ui:row>
						<ui:row>
							<ui:cell-label valign="top">
								<sw:text>Description</sw:text>
							</ui:cell-label>
							<ui:cell-inputblock id="description" maxlength="10000" rows="5">
								<xsl:value-of select="$form/gen/description"/>
							</ui:cell-inputblock>
						</ui:row>
					</ui:rows>
					<ui:buttons>
						<xsl:call-template name="wiz:showButtons"/>
					</ui:buttons>
				</ui:block>
			</ui:content>
		</ui:screen>
	</xsl:template>

	<xsl:template mode="screen" match="/">
		<xsl:choose>
			<xsl:when test="$step = 'gen'">
				<xsl:call-template name="step_gen"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="step_gen"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/wizard.xsl"/>
</xsl:stylesheet>
