<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred local"
	xmlns:xsl		="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl		="http://exslt.org/common"
	xmlns:sw		="http://www.swsoft.com/xsl/cp"
	xmlns:ui		="http://www.swsoft.com/xsl/cp/ui"   
	xmlns:browse	="http://www.swsoft.com/xsl/cp/browse"   
	xmlns:cred		="http://www.swsoft.com/xsl/cp/cred"
	xmlns:vzapackagem	="http://www.swsoft.com/xsl/cp/vzapackagem"
	xmlns:local		="http://www.swsoft.com/xsl/cp/local"	
	xmlns:vt		="http://www.swsoft.com/xsl/cp/vt"	
	xmlns:templates	="http://www.swsoft.com/xsl/cp/templates">
 
	<sw:include href="/lib/screen.xsl"/>
	<sw:include href="/lib/vza/vzapackagem.xsl"/>
	<sw:include href="/lib/vzdir/infrman/templates/browse.xsl"/>
	
	<!-- Prepare listing type -->
	<xsl:variable name="app-list-type" select="sw:sesget('app-list-type')" />
	<xsl:variable name="pkg-type" select="sw:sesget('app-pkg-type')"/>
	<xsl:variable name="app-id" select="sw:sesget('app-id')" />
	<xsl:variable name="hn-eid" select="sw:sesget('app-hn-eid')" />

	<!-- Prepare Credentions -->
	<xsl:variable name="cr-manage" select="cred:check-hw('vzcp.template', $hn-eid)"/>
	<xsl:variable name="cr-ve-list"		select="$cr-manage and $activeMode = 'vzcc'"/>

	<!-- no base detail - no access to screen -->
	<xsl:param name="access-denied" 		select="not($cr-ve-list)"/>

	<xsl:template mode="screen" match="/">
		<xsl:variable name="pkg" select="/packet/package"/>

		<ui:screen id="{sw:if($app-list-type='os','03.02.01.39.03','03.02.01.39.04')}"
			icon="{sw:if($app-list-type='app','app_tmpl','os_tmpl')}">

			<ui:properties>	
				<ui:refresh-type>GET</ui:refresh-type>
				<ui:form-get/>
				<ui:description width="full">
					<xsl:choose>
						<xsl:when test="not(string($pkg/description)='')">
							<xsl:value-of select="$pkg/description" />
						</xsl:when>
						<xsl:when test="$app-list-type='app'">
							<sw:text>Application template.</sw:text>
						</xsl:when>
						<xsl:otherwise>
							<sw:text>OS template.</sw:text>
						</xsl:otherwise>
					</xsl:choose>
				</ui:description>
			</ui:properties>

			<xsl:choose>
				<xsl:when test="vt:is-platform-linux(sw:lc($pkg/os/platform))">
					<ui:tab-bar id="group-app-linux" current-tab="gen"/>
				</xsl:when>
				<xsl:otherwise>
					<ui:tab-bar id="group-app-windows" current-tab="gen"/>
				</xsl:otherwise>
			</xsl:choose>

			<ui:content>
				<ui:hidden name="app-id" value="{sw:base64-encode(vzapackagem:generate-id($app-id))}"/>
				<xsl:choose>
					<!-- Error occurred or no data-->
					<xsl:when test="not($pkg) or /packet/errors/error">
						<xsl:call-template name="templates:show-error">
							<xsl:with-param name="error" select="/packet/errors/error" />
						</xsl:call-template>
					</xsl:when>
					<!-- /Error occurred or no data-->
					<!-- Received data  -->
					<xsl:otherwise>
						<xsl:call-template name="templates:show-summary-block">
							<xsl:with-param name="pkg" select="$pkg"/>
						</xsl:call-template>

						<xsl:call-template name="templates:list-hns">
							<xsl:with-param name="url" select="'/vzdir/infrman/templates/ez/group-app'" />
							<xsl:with-param name="app-id" select="$app-id" />
							<xsl:with-param name="actions" select="'list-control'" />
						</xsl:call-template>
					</xsl:otherwise>
					<!-- /Received data-->
				</xsl:choose>
			</ui:content>
		</ui:screen>
	</xsl:template>
  
</xsl:stylesheet>
