<!--
  Copyright (c) SWsoft, 1999-2007
  All rights reserved.
  -->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl cred update dynamic local func"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:exsl="http://exslt.org/common"
	xmlns:func="http://exslt.org/functions" xmlns:sw="http://www.swsoft.com/xsl/cp"
	xmlns:ui="http://www.swsoft.com/xsl/cp/ui" xmlns:dynamic="http://www.swsoft.com/xsl/cp/dynamic"
	xmlns:update="http://www.swsoft.com/xsl/cp/update" xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:local="http://www.swsoft.com/xsl/cp/local" xmlns:error="http://www.swsoft.com/xsl/cp/error"
	xmlns:html="http://www.swsoft.com/xsl/cp/html"
>

	<sw:include href="/layout/lib/html.xsl"/>

	<!-- check permissions to show this page -->

	<xsl:template mode="screen" match="/">
		<xsl:choose>
			<xsl:when test="cred:check-hw('vzcp.hn.manage.update', sw:hn-eid())">
				<xsl:call-template name="dynamic:create-ajax-handler">
					<xsl:with-param name="request-handler" select="'local:test-connection'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<func:function name="local:test-connection">
		<xsl:variable name="config" select="update:get-config(sw:hn-eid())"/>
		<xsl:variable name="res">
			<repo>
				<info>
					<sw:text>Virtuozzo updates</sw:text>
				</info>
				<xsl:copy-of select="update:get-errors(update:list($update:types/system))"/>
			</repo>
			<repo>
				<info>
					<sw:text>Templates updates</sw:text>
				</info>
				<xsl:copy-of select="update:get-errors(update:list-templates())"/>
			</repo>
		</xsl:variable>
		<xsl:variable name="repos" select="exsl:node-set($res)/repo"/>

		<func:result>
			<result>
				<div style="padding-left:5%;">
					<xsl:for-each select="$repos">
						<div><img src="/{$theme}/icons/alert_{sw:if(error, 'red', 'green')}.gif" />&#160;<xsl:value-of select="info"/>&#160;
						<xsl:if test="error">
								<ui:raw>
									<xsl:call-template name="dynamic:error-reporter">
										<xsl:with-param name="errors" select="error"/>
										<xsl:with-param name="open" select="sw:text('Show Error Details')"/>
										<xsl:with-param name="hide" select="sw:text('Hide Error Details')"/>
										<xsl:with-param name="message" select="false()"/>
									</xsl:call-template>
								</ui:raw>
						</xsl:if>
						</div>
					</xsl:for-each>
				</div>
			</result>
			<status>
				<xsl:choose>
					<xsl:when test="$repos[error]">error</xsl:when>
					<xsl:otherwise>found</xsl:otherwise>
				</xsl:choose>
			</status>
		</func:result>
	</func:function>
	
	<sw:include href="/lib/cred.xsl"/>
	<sw:include href="/lib/screen.xsl" />
	<sw:include href="/lib/update.xsl" />
	<sw:include href="/lib/vocabulary.xsl" />
	<sw:include href="/lib/dynamic.xsl" />

</xsl:stylesheet>
