<!--
	Copyright (c) SWsoft, 1999-2007
	All rights reserved.
-->

<xsl:stylesheet version="1.0" extension-element-prefixes="sw exsl func cred browse local task"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:exsl="http://exslt.org/common"
	xmlns:sw="http://www.swsoft.com/xsl/cp" xmlns:error="http://www.swsoft.com/xsl/cp/error"
	xmlns:ui="http://www.swsoft.com/xsl/cp/ui" xmlns:browse="http://www.swsoft.com/xsl/cp/browse"
	xmlns:task="http://www.swsoft.com/xsl/cp/task" xmlns:local="http://www.swsoft.com/xsl/cp/local"
	xmlns:func="http://exslt.org/functions" xmlns:cred="http://www.swsoft.com/xsl/cp/cred"
	xmlns:dynamic="http://www.swsoft.com/xsl/cp/dynamic">

	<!-- check permissions to show this page -->
	<xsl:variable name="cred" select="cred:check-hw('vzcp.hn.manage.update', sw:hn-eid())"/>
	<xsl:param name="access-denied" select="not($cred)" />

	<xsl:template name="updates">
		<xsl:variable name="task-id" select="sw:param('id')" />
		<xsl:variable name="task" select="task:get($task-id)" />
		
		<ui:body-screen>
			<ui:content>
				<ui:raw>
					:STATUS:<xsl:value-of select="$task[last()]/status" />:MESSAGE:
					<xsl:for-each select="$task">
						<xsl:call-template name="dynamic:describe-task">
							<xsl:with-param name="task" select="." />
							<xsl:with-param name="last" select="position()=last()" />
						</xsl:call-template>
					</xsl:for-each>
				</ui:raw>
			</ui:content>
		</ui:body-screen>
	</xsl:template>

	<!-- main document handler -->
	<xsl:template mode="screen" match="/">
		<xsl:call-template name="updates" />
	</xsl:template>

	<sw:include href="/lib/screen.xsl" />
	<sw:include href="/lib/dynamic.xsl"/>
	<sw:include href="/lib/swa/op_log.xsl" />
	<sw:include href="/layout/ext-tasks.xsl" />
</xsl:stylesheet>

